local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Recipe = GLOBAL.Recipe
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
local State = GLOBAL.State
local SpawnPrefab = GLOBAL.SpawnPrefab
local TimeEvent = GLOBAL.TimeEvent
local FRAMES = GLOBAL.FRAMES
local TheInput = GLOBAL.TheInput
local Vector3 = GLOBAL.Vector3
local FindEntity =GLOBAL.FindEntity
local TUNING = GLOBAL.TUNING
local GetPlayer = GLOBAL.GetPlayer
local GetWorld = GLOBAL.GetWorld
local GetClock = GLOBAL.GetClock
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local GROUND = GLOBAL.GROUND
local EventHandler = GLOBAL.EventHandler
local ActionHandler = GLOBAL.ActionHandler
local Armor = require "components/armor"
local Health = require "components/health"
local Combat = require "components/combat"
local SGWilson=require "stategraphs/SGwilson"
local ModsScreen = require "screens/modsscreen"
local TosoScreen2 = require "screens/sswordscreen_pellets"--丹药屏幕
local Builder = require "components/builder"

require "actions"
require "components/playercontroller"
--调用猪哥的函数
--require "wiliya_lib"

--加载项
modimport ("scripts/difficulty_monsters.lua")--怪物难度设置现在知道了。可以干好多事情。

modimport("scripts/strings_ch.lua")
--飞镖攻击
--modimport("scripts/actions.lua")


TUNING.DIFFICULTY = (GetModConfigData("difficult")+1)/2
TUNING.ZHUISHAJULI = GetModConfigData("jianghuzhuishajuli")
--TUNING.DIFFICULTY = GetModConfigData("difficult")
TUNING.SDLC = 0
TUNING.XIU = 0
--攻击频率
TUNING.ARM_ATKSPEED = GetModConfigData("arm_atkspeed")
--护甲
--TUNING.ARM_ARMOR = GetModConfigData("arm_armor")
TUNING.ARM_ARMOR = 0.8
--人形怪技能伤害
TUNING.ARM_RPGDAMAGE = GetModConfigData("arm_rpgdamage")
--修炼速度
TUNING.PRACTICE_SPEED = GetModConfigData("practice_speed")
--月牙的闪避方向
TUNING.XUYING_DIRECTION = GetModConfigData("xuying_direction")
--爱无限是否破坏
TUNING.AIWUXIANKANSHU = GetModConfigData("aiwuxiankanshu")
--怪物血量成长
TUNING.ARM_HEALTHUP = GetModConfigData("arm_healthup")
--灵根设置 
TUNING.PLAYER_LINGGEN = GetModConfigData("player_linggen")
--丹药简介  更改
TUNING.DANKANGLENG = "抗冷丹"
TUNING.DANKANGRE = "抗热丹"
TUNING.DANKANGLENGINTRO = "功能：当温度低于一定值时，自动回复体温\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【萤火虫*1】\n第四格【空】\n特殊条件：无"
TUNING.DANKANGREINTRO = "功能：当温度高于一定值时，自动降低体温\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【冰*5】\n第四格【空】\n特殊条件：无"
PrefabFiles = {
	"ssword",
	"sword_4",
	"xukong",
	--"sheath_packim",
	--"kid_eyebone",
	"ssword_fx",
	"gujianrain",
	"display_build_range",
	
	"moose_nest_fx",
	"armor_ssword",--身体
	"armor2_ssword",--头
	"ancient_gem",
	"ssword_portablecookpot",
	"prj_gongjian",
	"ssword_bowm",
	


	"hulu",
	"hulu1",
	"yaoshui",
	"san",
	"chuizi",
	"chunhuideng",
	"futou",
	"sswalkingstick",
	--读书收集
	"shouhuo",
	
    --敌对
	--boss
    "boss_sesshoumaru",
	
	"arm_qingxue",
	"arm_bro",--2
	"arm_zouwei_bro",--4
	"arm_bro3",--3
	"arm_yuancheng_bro",--7
	"arm_merm1",
	"arm_hound",
	"arm_scorpion",
    "arm_dragoon",
    "arm_mossling",
    "arm_krampus",
	"arm_spider",
	"arm_warly",	--12
	"arm_birchnutdrake",
	"arm_wes",--11
	"arm_webber",--5
	"assasin_sshw", --14
	--"arm_spat",	
	"arm_willow",--8
	"arm_wickerbottom",	--15
	"arm_bro5", --13
	"monster_fx",	
	"arm_treeguard",	
	"arm_woodlegs",	--9
	"arm_zhumei",	--10
	"arm_wilbur",  --6
	"arm_perd",	
	"arm_worm",	
	
--新增
	"zg_fx_truefire",	

	"arm_meilaoban",	

	--远古
	"boss_knight",	
	"boss_hound",	
	"boss_nightmarecreature",	
	"boss_krampus",	
	"boss_tigershark",	
	"boss_rocky",	
	"boss_spiderqueen",	
	
	
	
	
	
	
	--友好生物
	"assasin_person",
	"pod",
	"kid_eyebone",	


	"rpg_projectile",
	"firestaff2",	
	
	"ssword_boat",	
	"jianling",
	"jianling2",
	"zhaohunfan",
	"ssdeco_ruins_well",
	"ss_mandrakehouse",
	"ssplayerhouse_city",
	"gate",	
	"jianzhong",
	"ss_pool",
	"zhongxin",
	"toso_ludengleft",
	"toso_ludengright",	
	
	--植物
	"flower_1",	
	"flower_seed",
	"flower_hua",	
	"fengye",	
	"jiucai",	
	"toso_lingcao_flower",
	
	
	
	"jiucaijidan",

	"pellets",
	"toso_danlu",
	"bamboobush2",
	"dug_bamboobush",
	"toso_lingcao",
	"toso_yinhua",	
	"toso_zhizi",	
	"toso_zijinshu",
	"toso_fengyecao",
	"toso_lvyinghua",
	"toso_lvyincao",
	"toso_jiucai",
	
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/ssword.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/ssword.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/ssword.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/ssword.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/ssword_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/ssword_silho.xml" ),

    Asset( "IMAGE", "bigportraits/ssword.tex" ),
    Asset( "ATLAS", "bigportraits/ssword.xml" ),
	
	Asset( "IMAGE", "images/map_icons/ssword.tex" ),
	Asset( "ATLAS", "images/map_icons/ssword.xml" ),
	
	Asset( "IMAGE", "images/ssowrdtabs/ssword_tab.tex"),
	Asset( "ATLAS", "images/ssowrdtabs/ssword_tab.xml"),
--制作兰
	Asset("ATLAS", "images/inventoryimages/ancient_gem.xml"),
    Asset("IMAGE", "images/inventoryimages/ancient_gem.tex"),	
	
	Asset("ATLAS", "images/inventoryimages/amor2_ssword.xml"),
    Asset("IMAGE", "images/inventoryimages/amor2_ssword.tex"),

	Asset("ATLAS", "images/inventoryimages/san.xml"),
    Asset("IMAGE", "images/inventoryimages/san.tex"),
	
	Asset("ATLAS", "images/inventoryimages/zhaohunfan_item.xml"),
    Asset("IMAGE", "images/inventoryimages/zhaohunfan_item.tex"),
	
		Asset("ATLAS", "images/inventoryimages/cookpotssword_item.xml"),
		Asset("IMAGE", "images/inventoryimages/cookpotssword_item.tex"),
		--头甲
		Asset("ATLAS", "images/inventoryimages/hat_ruineye.xml"),
		Asset("IMAGE", "images/inventoryimages/hat_ruineye.tex"),		
		--井
		Asset("ATLAS", "images/inventoryimages/deco_ruins_well.xml"),
		Asset("IMAGE", "images/inventoryimages/deco_ruins_well.tex"),	
		--曼德拉
		Asset("ATLAS", "images/inventoryimages/ssmandrakehouse.xml"),
		Asset("IMAGE", "images/inventoryimages/ssmandrakehouse.tex"),	

		Asset("ATLAS", "images/inventoryimages/ss_pool.xml"),
		Asset("IMAGE", "images/inventoryimages/ss_pool.tex"),			
	
	--敌对人物地图显示
	Asset( "IMAGE", "images/map_icons/arm_bro2.tex" ),
	Asset( "ATLAS", "images/map_icons/arm_bro2.xml" ),
	Asset( "IMAGE", "images/map_icons/arm_qingxue.tex" ),
	Asset( "ATLAS", "images/map_icons/arm_qingxue.xml" ),
	Asset( "IMAGE", "images/map_icons/sword_3.tex" ),
	Asset( "ATLAS", "images/map_icons/sword_3.xml" ),

	Asset( "IMAGE", "images/map_icons/arm_animal.tex" ),
	Asset( "ATLAS", "images/map_icons/arm_animal.xml" ),
	Asset( "IMAGE", "images/map_icons/arm_person.tex" ),
	Asset( "ATLAS", "images/map_icons/arm_person.xml" ),
	Asset( "IMAGE", "images/map_icons/arm_boss.tex" ),
	Asset( "ATLAS", "images/map_icons/arm_boss.xml" ),
--boss
	Asset( "IMAGE", "images/map_icons/sheath.tex" ),
	Asset( "ATLAS", "images/map_icons/sheath.xml" ),
	
	
	--物品地图
	Asset( "IMAGE", "images/map_icons/amor2_ssword.tex" ),
	Asset( "ATLAS", "images/map_icons/amor2_ssword.xml" ),	
	Asset( "IMAGE", "images/map_icons/hat_ruineye.tex" ),
	Asset( "ATLAS", "images/map_icons/hat_ruineye.xml" ),
	Asset( "IMAGE", "images/map_icons/cookpotssword_item.tex" ),
	Asset( "ATLAS", "images/map_icons/cookpotssword_item.xml" ),	
	Asset( "IMAGE", "images/map_icons/san.tex" ),
	Asset( "ATLAS", "images/map_icons/san.xml" ),	

	
--	
	--屏幕
	Asset("IMAGE", "images/images_ui/UI_total.tex" ),
	Asset("ATLAS", "images/images_ui/UI_total.xml" ),
	
	Asset("IMAGE", "images/images_ui/UI_total_two.tex" ),
	Asset("ATLAS", "images/images_ui/UI_total_two.xml" ),

	Asset("IMAGE", "images/images_ui/UI_dialog.tex" ),
	Asset("ATLAS", "images/images_ui/UI_dialog.xml" ),
	--打坐动作
    Asset( "ANIM", "anim/player_emotes_sit.zip" ),
	
	--加给widgets用

	Asset("ANIM", "anim/shaqi.zip"),
	
	--弓箭动作
    Asset( "ANIM", "anim/zbow_attack.zip" ),
	
	--音效、
	Asset( "SOUND" , "sound/ds_toso_skill.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/ds_toso_skill.fev" ),
	


}


--生成物品
function wy_spawn(inst, other, offset, mode, scale, phys, sound, fn_tar, fn_inst)

	if not inst then return end
	--local mode = mode or 0
	local tar
	
	if type(other) == "string" then
		tar = SpawnPrefab(other)
	elseif type(other) == "table" then
	
		--获取权重
		local weight = 0
		for k,v in pairs(other) do
			weight = weight + v
		end
		
		--选取物体
		local t = 0
		local ran = math.random()
		for k,v in pairs(other) do
			t = t + v
			if ran <= t/weight then
				tar = SpawnPrefab(k)
				break
			end
		end
	else
		return
	end
	
	if not tar then return end
		
	--物体的父子位置关系
	if mode == 1 then
		
		tar.entity:SetParent(inst.entity)
		if type(offset) == "table" then
			tar.Transform:SetPosition(offset[1],offset[2],offset[3])
		else
			tar.Transform:SetPosition(0,0,0)
		end
	
	--Follow Symbol的关系
	elseif type(mode) == "string" then
		
		tar.entity:SetParent(inst.entity)
		tar.entity:AddFollower()
		if type(offset) == "table" then
			tar.Follower:FollowSymbol(inst.GUID, mode, offset[1],offset[2],offset[3])
		else
			tar.Follower:FollowSymbol(inst.GUID, mode, 0,0,0)
		end
	
	--普通生成模式
	else
		local x,y,z = inst.Transform:GetWorldPosition()
		local x1,y1,z1 = x,y,z
		if type(offset) == "table" then
			x1,y1,z1 = x+offset[1], y+offset[2], z+offset[3]
		end
		tar.Transform:SetPosition(x1,y1,z1)
	end
	
	--新事物的体积,多用于调试特效
	if scale then
		tar.Transform:SetScale(scale,scale,scale)
	end
	
	--新事物飞出的速度,多用于弹道类物体,也可用于掉落物
	if type(phys) == "table" and tar.Physics then

		--获取方向, 以自己为起点的方向
		if phys[1] then
			local angle = tar:GetAngleToPoint( phys[1]:Get() )	
			
			--偏离角度
			local angel_d = phys[2] or 0
			angle = angle + angel_d
			
			--获得最终面向角度
			while (angle < 0) do
				angle = angle + 360
			end
			while (angle >= 360) do
				angle = angle - 360
			end
			
			--设置最终面向
			tar.Transform:SetRotation(angle)
		end
		
		--获取速度, 如果速度小于0则倒退方向运行
		local vel = phys[3]
		if vel then
			tar.Physics:SetMotorVelOverride(vel[1],vel[2],vel[3])
		end
		
	end
	
	--新事物的音效,用于生成时的声音效果
	if type(sound) == "table" then
		if not tar.SoundEmitter then
			tar.entity:AddSoundEmitter()
		end
		tar:DoTaskInTime(sound[2] or 0, function()
			tar.SoundEmitter:PlaySound(sound[1])
		end)
	elseif type(sound) == "string" then
		if not tar.SoundEmitter then
			tar.entity:AddSoundEmitter()
			tar.SoundEmitter:PlaySound(sound)
		end
	end
	
	-------------------------------------------一般情况是用不着的----------------
	--新事物的其他初始化
	if type(fn_tar) == "function" then
		fn_tar(tar)
	end
	
	--旧事物的操作
	if type(fn_inst) == "function" then
		fn_inst(inst)
	end

	return tar
end



--——————————————————全局数值TUNING————————————————————————————
--————————————————————为了能够方便地切换中英文，应该注意集中有关字符串的使用————————————
--TUNING.SSWORD_HUNGERRATE = GetModConfigData("ssword_Hunger")
TUNING.SSWORD_STARTHP = GetModConfigData("Initial three")
TUNING.TOSO_NEEDEXP = GetModConfigData("jianghuzhuisha")
--TUNING.TOSO_KEY9 = GetModConfigData("level")
TUNING.TOSO_KEY5 = GetModConfigData("commandaxiang")
TUNING.TOSO_KEY11 = GetModConfigData("xuying")
TUNING.TOSO_KEY12 = GetModConfigData("jineng")
TUNING.TOSO_KEY13 = GetModConfigData("zhaohuanshanggu")
TUNING.TOSO_KEY14 = GetModConfigData("xiulian")
TUNING.TOSO_KEY15 = GetModConfigData("shuxing")
--世界树的传送给
TUNING.TOSO_KEY16 = GetModConfigData("shijieshutrans")

local Lang = GetModConfigData("Lang")--语言设置
if Lang == 1 then--英文
	--modimport ("scripts/Strings_toso_en.lua")
    STRINGS.CHARACTERS.SSWORD = require "speech_sheath_en"
	--require "Strings_toso_en"
else--中文
	--modimport ("scripts/Strings_toso_ch.lua")
    STRINGS.CHARACTERS.SSWORD = require "speech_sheath_ch"
	--require "Strings_toso_ch"
end

--——————————————————添加物品交易组件————————————————————————————
function Addtradableprefab(inst)
	if not inst.components.tradable then
		inst:AddComponent("tradable")
    end
	if inst.components.stackable then
	inst.components.stackable.maxsize = 1000
    end
	
end
AddPrefabPostInit("nightmarefuel", Addtradableprefab)
AddPrefabPostInit("goldnugget", Addtradableprefab)
AddPrefabPostInit("oinc", Addtradableprefab)
AddPrefabPostInit("thulecite", Addtradableprefab)

--STRINGS.TABS.SSWORDTAB = "SSWORD"
--RECIPETABS['SSWORDTAB'] = {str = "SSWORDTAB", sort=99, icon = "ssword_tab.tex", icon_atlas = "images/ssowrdtabs/ssword_tab.xml"}

function RepicPostInit(inst)

	--头甲
	    --if TUNING.SDLC == 1 then
	    local armor2_ssword = Recipe("armor2_ssword", { Ingredient("ruinshat", 1), Ingredient("livinglog", 2) }, RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.ROG)
        armor2_ssword.atlas = "images/inventoryimages/hat_ruineye.xml"
		armor2_ssword.image = "hat_ruineye.tex"

	    local armor2_ssword2 = Recipe("armor2_ssword", { Ingredient("ruinshat", 1), Ingredient("livinglog", 2) }, RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED)
        armor2_ssword2.atlas = "images/inventoryimages/hat_ruineye.xml"
		armor2_ssword2.image = "hat_ruineye.tex"
		
	    local armor2_ssword3 = Recipe("armor2_ssword", { Ingredient("snake_bone", 10), Ingredient("livinglog", 2) }, RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.COMMON)
        armor2_ssword3.atlas = "images/inventoryimages/hat_ruineye.xml"
		armor2_ssword3.image = "hat_ruineye.tex"


		
	--头甲
	    local armor_ssword = Recipe("armor_ssword", { Ingredient("nitre", 10), Ingredient("livinglog", 2) }, RECIPETABS.WAR, TECH.NONE)
        armor_ssword.atlas = "images/inventoryimages/amor2_ssword.xml"
		armor_ssword.image = "amor2_ssword.tex"	
--伞
	    --local san = Recipe("san", { Ingredient("deerclops_eyeball", 1), Ingredient("livinglog", 10) }, RECIPETABS.WAR, TECH.NONE)
        --san.atlas = "images/inventoryimages/san.xml"
		--san.image = "san.tex"	
	
	    local zhaohunfan_item = Recipe("zhaohunfan_item", { Ingredient("boneshard", 10), Ingredient("livinglog", 2) }, RECIPETABS.WAR, TECH.NONE)
        zhaohunfan_item.atlas = "images/inventoryimages/zhaohunfan_item.xml"
		zhaohunfan_item.image = "zhaohunfan_item.tex"	

	--花
	    local flower_seed = Recipe("flower_seed", { Ingredient("petals_evil", 1), Ingredient("poop", 2) }, RECIPETABS.WAR, TECH.NONE)
        flower_seed.atlas = "images/inventoryimages/flower_seed.xml"
		flower_seed.image = "flower_seed.tex"

	--花
	    local dug_bamboobush = Recipe("dug_bamboobush", { Ingredient("bamboo", 10) }, RECIPETABS.WAR, TECH.NONE)
        dug_bamboobush.atlas = "images/inventoryimages/bamboobush.xml"
		dug_bamboobush.image = "bamboobush.tex"		

	    local toso_jiucai_item = Recipe("toso_jiucai_item", { Ingredient("flower_hua", 20,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_jiucai_item.atlas = "images/inventoryimages/toso_jiucai.xml"
		toso_jiucai_item.image = "toso_jiucai.tex"	
		
	    local toso_zijinshu_item = Recipe("toso_zijinshu_item", { Ingredient("flower_hua", 20,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_zijinshu_item.atlas = "images/inventoryimages/toso_zijinshu.xml"
		toso_zijinshu_item.image = "toso_zijinshu.tex"	

	    local toso_zhizi_item = Recipe("toso_zhizi_item", { Ingredient("flower_hua", 20,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_zhizi_item.atlas = "images/inventoryimages/toso_zhizi.xml"
		toso_zhizi_item.image = "toso_zhizi.tex"

	    local toso_fengyecao_item = Recipe("toso_fengyecao_item", { Ingredient("flower_hua", 20,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_fengyecao_item.atlas = "images/inventoryimages/toso_fengyecao.xml"
		toso_fengyecao_item.image = "toso_fengyecao.tex"
		
	    local toso_lvyinghua_item = Recipe("toso_lvyinghua_item", { Ingredient("flower_hua", 20,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_lvyinghua_item.atlas = "images/inventoryimages/toso_lvyinghua.xml"
		toso_lvyinghua_item.image = "toso_lvyinghua.tex"
		
	    local toso_lvyincao_item = Recipe("toso_lvyincao_item", { Ingredient("flower_hua", 20,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_lvyincao_item.atlas = "images/inventoryimages/toso_lvyincao.xml"
		toso_lvyincao_item.image = "toso_lvyincao.tex"
		
	    local toso_ludengleft_item = Recipe("toso_ludengleft_item", { Ingredient("flower_hua", 60,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_ludengleft_item.atlas = "images/inventoryimages/toso_ludeng.xml"
		toso_ludengleft_item.image = "toso_ludeng.tex"
		
	    local toso_ludengright_item = Recipe("toso_ludengright_item", { Ingredient("flower_hua", 60,"images/inventoryimages/flower_hua.xml","flower_hua.tex") }, RECIPETABS.WAR, TECH.NONE)
        toso_ludengright_item.atlas = "images/inventoryimages/toso_ludeng.xml"
		toso_ludengright_item.image = "toso_ludeng.tex"
		
		local zhongxin = GLOBAL.Recipe("zhongxin", {Ingredient("livinglog", 10), Ingredient("charcoal", 2), Ingredient("gears", 10)}, RECIPETABS.WAR, {SCIENCE = 0}, nil, "zhongxin_placer" )
		zhongxin.atlas = "images/inventoryimages/zhongxin.xml"
		zhongxin.image = "zhongxin.tex"
		
		local chunhuideng = GLOBAL.Recipe("chunhuideng", {Ingredient("fengye", 6,"images/inventoryimages/fengye.xml","fengye.tex"), Ingredient("flower_hua", 10,"images/inventoryimages/flower_hua.xml","flower_hua.tex"), Ingredient("ice", 10)}, RECIPETABS.WAR, TECH.NONE)
		chunhuideng.atlas = "images/inventoryimages/chunhuideng.xml"
		chunhuideng.image = "chunhuideng.tex"		

	--门		
		local gate = Recipe("gate", {Ingredient("livinglog", 2), Ingredient("charcoal", 2), Ingredient("purplegem", 2)}, RECIPETABS.WAR, {SCIENCE = 0}, nil, "gate_placer" )
		gate.atlas = "images/inventoryimages/gate.xml"
		gate.image = "gate.tex"		

	--剑冢		
		local jianzhong = GLOBAL.Recipe("jianzhong", {Ingredient("livinglog", 2), Ingredient("charcoal", 2), Ingredient("gears", 4)}, RECIPETABS.WAR, {SCIENCE = 0}, nil, "jianzhong_placer" )
		jianzhong.atlas = "images/inventoryimages/jianzhong.xml"
		jianzhong.image = "jianzhong.tex"

	--shouhuo
		local shouhuo = GLOBAL.Recipe("shouhuo", {Ingredient("livinglog", 4), Ingredient("nightmarefuel", 10)}, RECIPETABS.WAR, TECH.NONE )
		shouhuo.atlas = "images/inventoryimages/miji.xml"
		shouhuo.image = "miji.tex"	

		--local kid_eyebone = GLOBAL.Recipe("kid_eyebone", {Ingredient("sswalkingstick", 1,"images/inventoryimages/sswalkingstick.xml","sswalkingstick.tex"), Ingredient("flower_hua", 100), Ingredient("nightmarefuel", 100)}, RECIPETABS.WAR, TECH.NONE )
		--kid_eyebone.atlas = "images/inventoryimages/kid_eyebone.xml"
		--kid_eyebone.image = "kid_eyebone.tex"
		
	    --local ancient_gem = Recipe("ancient_gem", { Ingredient("livinglog", 10), Ingredient("greengem", 2) }, RECIPETABS.WAR, TECH.NONE)
        --ancient_gem.atlas = "images/inventoryimages/ancient_gem.xml"
		--ancient_gem.image = "ancient_gem.tex"

		
	    local redgem = Recipe("redgem", { Ingredient("goldnugget", 20) }, RECIPETABS.WAR, TECH.NONE)	
	    --local bluegem = Recipe("bluegem", { Ingredient("goldnugget", 10) }, RECIPETABS.WAR, TECH.NONE)
		--local purplegem = Recipe("purplegem", { Ingredient("goldnugget", 10) }, RECIPETABS.WAR, TECH.NONE)
		--local greengem = Recipe("greengem", { Ingredient("goldnugget", 10) }, RECIPETABS.WAR, TECH.NONE)
		--local orangegem = Recipe("orangegem", { Ingredient("goldnugget", 10) }, RECIPETABS.WAR, TECH.NONE)
		--local yellowgem = Recipe("yellowgem", { Ingredient("goldnugget", 10) }, RECIPETABS.WAR, TECH.NONE)
		
		local base_portablecookpot_item = Recipe("base_portablecookpot_item", {Ingredient("goldnugget", 10)}, RECIPETABS.WAR,  TECH.NONE)
        base_portablecookpot_item.atlas = "images/inventoryimages/cookpotssword_item.xml"
		base_portablecookpot_item.image = "cookpotssword_item.tex"
		
	--移动丹炉
	    local toso_danlu_item = Recipe("toso_danlu_item", { Ingredient("livinglog", 1), Ingredient("redgem", 2), Ingredient("papyrus", 2) }, RECIPETABS.WAR, TECH.NONE)
        toso_danlu_item.atlas = "images/inventoryimages/toso_danlu_item.xml"
		toso_danlu_item.image = "toso_danlu_item.tex"
		
		local ssdeco_ruins_fountain = GLOBAL.Recipe("ssdeco_ruins_fountain", {Ingredient("livinglog", 2), Ingredient("cutstone", 10), Ingredient("papyrus", 2)}, GLOBAL.RECIPETABS.WAR, {SCIENCE = 0}, nil, "ssdeco_ruins_fountain_placer" )
		ssdeco_ruins_fountain.atlas = "images/inventoryimages/deco_ruins_well.xml"
		ssdeco_ruins_fountain.image = "deco_ruins_well.tex"
		
		local ssdeco_ruins_endswell = GLOBAL.Recipe("ssdeco_ruins_endswell", {Ingredient("livinglog", 2), Ingredient("nightmare_timepiece", 1), Ingredient("papyrus", 2)}, GLOBAL.RECIPETABS.WAR, {SCIENCE = 0}, nil, "ssdeco_ruins_endswell_placer" )
		ssdeco_ruins_endswell.atlas = "images/inventoryimages/deco_ruins_well.xml"
		ssdeco_ruins_endswell.image = "deco_ruins_well.tex"
		
		--local ssmandrakehouse = GLOBAL.Recipe("ssmandrakehouse", {Ingredient("livinglog", 2), Ingredient("charcoal", 2), Ingredient("gears", 4)}, GLOBAL.RECIPETABS.WAR, {SCIENCE = 0}, nil, "ssmandrakehouse_placer" )
		--ssmandrakehouse.atlas = "images/inventoryimages/ssmandrakehouse.xml"   --ssmandrakehouse   --记得改哟
		--ssmandrakehouse.image = "ssmandrakehouse.tex"

		local ss_pool = GLOBAL.Recipe("ss_pool", {Ingredient("cutstone", 10), Ingredient("bamboo", 10), Ingredient("goldnugget", 50)}, GLOBAL.RECIPETABS.WAR, {SCIENCE = 0}, nil, "ss_pool_placer" )
		ss_pool.atlas = "images/inventoryimages/ss_pool.xml"   --ssmandrakehouse
		ss_pool.image = "ss_pool.tex"	

		
		local ssplayerhouse_city = GLOBAL.Recipe("ssplayerhouse_city", {Ingredient("boards", 4), Ingredient("charcoal", 2), Ingredient("goldnugget", 20)}, GLOBAL.RECIPETABS.WAR, {SCIENCE = 0}, nil, "ssmandrakehouse_placer" )
		ssplayerhouse_city.atlas = "images/inventoryimages/ssmandrakehouse.xml"   --ssmandrakehouse
		ssplayerhouse_city.image = "ssmandrakehouse.tex"		


        local livinglog = GLOBAL.Recipe("livinglog", {Ingredient("log", 40) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.COMMON, nil,nil,nil,1)
		
        local nightmarefuel = GLOBAL.Recipe("nightmarefuel", {Ingredient("livinglog", 1) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.COMMON, nil,nil,nil,2)		
		
        local oinc = GLOBAL.Recipe("oinc", {Ingredient("goldnugget", 1) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.COMMON, nil,nil,nil,5)	
		
		--local oinc10 = GLOBAL.Recipe("oinc10", {Ingredient("oinc", 10) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.COMMON, nil,nil,nil,1)

		--local oinc100 = GLOBAL.Recipe("oinc100", {Ingredient("oinc", 100) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.COMMON, nil,nil,nil,1)
		


---
local ssconstruction_permit = GLOBAL.Recipe("construction_permit", {Ingredient("oinc", 50) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.ROG, nil,nil,nil,1)
local ssboatrepairkit = GLOBAL.Recipe("boatrepairkit", {Ingredient("boards", 2), Ingredient("stinger", 2), Ingredient("rope", 2) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.ROG)

local ssconstruction_permit = GLOBAL.Recipe("construction_permit", {Ingredient("oinc", 50) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, nil,nil,nil,1)
local ssboatrepairkit = GLOBAL.Recipe("boatrepairkit", {Ingredient("boards", 2), Ingredient("stinger", 2), Ingredient("rope", 2) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED)

--local ssconstruction_permit = GLOBAL.Recipe("construction_permit", {Ingredient("oinc", 50) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.VANILLA, nil,nil,nil,1)
--local ssboatrepairkit = GLOBAL.Recipe("boatrepairkit", {Ingredient("boards", 2), Ingredient("stinger", 2), Ingredient("rope", 2) }, GLOBAL.RECIPETABS.WAR, TECH.NONE, GLOBAL.RECIPE_GAME_TYPE.VANILLA)

		
end


AddPlayerPostInit(function(inst) 
if inst.components.combat == nil then 
return 
end 
local old_start = inst.components.combat.StartAttack function inst.components.combat:StartAttack()
old_start(self) 
if self.target then  
local weapon = self:GetWeapon()  
if weapon and weapon.components.weapon and weapon.components.weapon.blinking then 
local distance = math.sqrt(self.inst:GetDistanceSqToInst(self.target)) 
local hitrange = weapon.components.weapon.hitrange 
if distance > hitrange then 
local smoke1 = SpawnPrefab("collapse_small") 
local smoke2 = SpawnPrefab("collapse_small") 
local sx, sy, sz = self.inst.Transform:GetWorldPosition() 
smoke1.Transform:SetPosition(sx, sy, sz) 
local fx, fy, fz = self.target.Transform:GetWorldPosition() 
local q = (distance - hitrange + 0.2) / distance local dx = sx - q * (sx - fx) local dy = sy - q * (sy - fy) 
local dz = sz - q * (sz - fz) inst.Transform:SetPosition(dx, dy, dz) 
smoke2.Transform:SetPosition(dx, dy, dz) 
if TUNING.SDLC ==2 or TUNING.SDLC ==3 then 
if inst:GetIsOnWater() then 
inst:DoTaskInTime(0.6, function() 
inst.Transform:SetPosition(sx, sy, sz) 
end) 
end 
end 
end 
end 
end 
end 
end) 

------------加入cast---------------
local SSWORDCAST = GLOBAL.Action({},10, false, true, 36)
SSWORDCAST.str = "cast"
SSWORDCAST.id = "SSWORDCAST"
SSWORDCAST.fn = function(act)
	--if GetPlayer():HasTag("huoqiang") or GetPlayer():HasTag("baofengxue") then
        --return GetPlayer().components.sswordcast:areaskill(GetPlayer())
	--end
end

local SSWORDATTACK = ACTIONS.ATTACK.fn
ACTIONS.ATTACK.fn = function(act)
	if act.target.components.combat and not act.target.prefab ~= "myfriend" and not act.target:HasTag("wall") and not act.target.prefab ~= "assasin_person" and not act.target.prefab ~= "jianhun" and not act.target.prefab ~= "jianhun2" then
		act.doer.components.combat:SetTarget(act.target)
		return SSWORDATTACK(act)
	end
end
--and not v:HasTag("bird")
------------------------------------------------------------STATEGRAPHES-----------------------------------------------------------------------------
--跳跃定义数值
local JUMP_SPEED = 75
local JUMP_LAND_OFFSET = 3
	
--跳跃动画
SGWilson.states["tosojump"] = GLOBAL.State {
        name = "tosojump",
        tags = {"busy", "specialattack", "nointerrupt", "nomorph","ssjump","not_hit_stunned"},

        onenter = function(inst)
		    --防止被打断
		    --inst.missatk = true
			--inst.skillon = false
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("give")
            inst.AnimState:PushAnimation("jump", true)
        end,

        timeline =
        {
            -- TimeEvent(0*FRAMES, function(inst)
            --     inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
            -- end),

            TimeEvent(23*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/jump_attack")
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/roar")
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/launch_land")
	            inst.components.locomotor.disable = true
	            inst.Physics:SetMotorVelOverride(0,JUMP_SPEED,0)
    		end),

            TimeEvent(38*FRAMES, function(inst)
                --local tar = inst:GetTarget()

                --if tar and not inst:GroundTypesMatch(tar) then
                    --inst:MakeWater() --GoToWaterState
                --end

                inst.sg:GoToState("tosofallwarn")
            end)
        },
    }

SGWilson.states["tosofallwarn"] = GLOBAL.State {
        name = "tosofallwarn",
        tags = {"busy", "specialattack", "nointerrupt", "nomorph","ssjump","not_hit_stunned"},

        onenter = function(inst)
            inst.sg:SetTimeout(34*FRAMES)

            inst.Physics:Stop()

            --local tar = inst:GetTarget()
            --local pos = tar or inst:GetPosition()

            --pos.y = 45
            inst.Transform:SetPosition(inst:GetPosition():Get())

            local shadow = SpawnPrefab("tigersharkshadow")
            shadow:Ground_Fall()
            local heading = 50--TheCamera:GetHeading()
            local rotation = 180 - heading

            if inst.AnimState:GetCurrentFacing() == FACING_LEFT then
                rotation = rotation + 180
            end

            if rotation < 0 then
                rotation = rotation + 360
            end

            shadow.Transform:SetRotation(rotation)
            local x,y,z = inst:GetPosition():Get()
            shadow.Transform:SetPosition(x,0,z)
        end,

        ontimeout = function(inst)
            inst:Show()

            if inst:GetIsOnWater() then
                --inst:MakeWater()
                --local pos = inst:GetPosition()
                --pos.y = 45
                inst.Transform:SetPosition(inst:GetPosition():Get())
            end

            inst.sg:GoToState("tosofall")
        end,
    }
	
SGWilson.states["tosofall"] = GLOBAL.State {
        name = "tosofall",
        tags = {"busy", "specialattack", "nointerrupt", "nomorph","ssjump","not_hit_stunned"},

        onenter = function(inst)
            --ChangeToCharacterPhysics(inst)
	        inst.components.locomotor.disable = true
            inst.Physics:SetMotorVel(0,-JUMP_SPEED,0)
            inst.AnimState:PlayAnimation("pickaxe_loop", true)
            inst.Physics:SetCollides(false)
            inst.sg:SetTimeout(JUMP_SPEED/45 + 0.2)
            inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/dive_attack")
        end,

        timeline =
        {
            TimeEvent(20*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/roar") end)
        },

        ontimeout = function(inst)
            local pt = Point(inst.Transform:GetWorldPosition())
            local vx, vy, vz = inst.Physics:GetMotorVel()
            if pt.y <= .1 then
                pt.y = 0
                inst.Physics:Stop()
                inst.Physics:Teleport(pt.x,pt.y,pt.z)
                inst.CanFly = false
                inst.Physics:SetCollides(true)
                inst.sg:GoToState("tosofallpost")
            end
        end,

        onupdate = function(inst)
            inst.Physics:SetMotorVel(0,-JUMP_SPEED,0)
            local pt = Point(inst.Transform:GetWorldPosition())
            if pt.y <= .1 then
                pt.y = 0
                inst.Physics:Stop()
                inst.Physics:Teleport(pt.x,pt.y,pt.z)
                inst.CanFly = false
                inst.Physics:SetCollides(true)
                inst.sg:GoToState("tosofallpost")
            end
        end,
    }
	
SGWilson.states["tosofallpost"] = GLOBAL.State {
        name = "tosofallpost",
        tags = {"busy", "specialattack","ssjump"},

        onenter = function(inst)
		    --加入位置

		    local x,y,z = inst.Transform:GetWorldPosition()
            inst.Physics:Stop()
            inst.components.locomotor.disable = false
            inst.AnimState:PlayAnimation("chop_loop")
            --inst.components.groundpounder:GroundPound()

		--加入一个特效	
		local fxhuo = SpawnPrefab("dilie_toso")
		fxhuo.Transform:SetScale(1.4, 1.4, 1.4)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
			--替换为自己的特效
			local fx = SpawnPrefab("groundpoundring_fx") --触发特效
		    local scale = 0.8
		    fx.Transform:SetScale(scale,scale,scale)
		    fx.Transform:SetPosition(x,y,z)
            --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
			inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/toso_feitian")
			--加入雷电
			SpawnPrefab("lightning").Transform:SetPosition(inst:GetPosition():Get())
--伤害程序
	--local weapon =  inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
	--local weapondmg = 20
	--if weapon and weapon.components.weapon.damage then
		--weapondmg = weapon.components.weapon.damage
	--end
	local pt = Vector3(inst.Transform:GetWorldPosition())
	local plus_dmg = TUNING.ARM_RPGDAMAGE*20 + inst.level*200 
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, inst.level/10+15)
    for k,v in pairs(ents) do
	if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("ssword") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("companion") and not v:HasTag("toso_helper") then

		if v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then 
		
	local x, y, z = v.Transform:GetWorldPosition()
	local fx = SpawnPrefab("moose_nest_fx")
	fx.Transform:SetPosition(x, y, z)
		--if v.components.freezable and v.components.freezable.coldness > 0 then
	    if GLOBAL.GetSeasonManager() and GLOBAL.GetSeasonManager():IsRaining() then
		v.components.combat:GetAttacked(inst, plus_dmg*2) 
		else
		v.components.combat:GetAttacked(inst, plus_dmg) 
		end
		end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
		
		
--冰冻程序								
	if v.components.sleeper and v.components.sleeper:IsAsleep() then
        v.components.sleeper:WakeUp()
    end
    if v.components.burnable then
        if v.components.burnable:IsBurning() then
            v.components.burnable:Extinguish()
        elseif v.components.burnable:IsSmoldering() then
            v.components.burnable:SmotherSmolder()
        end
    end

    --if v.components.combat then
        --v.components.combat:SuggestTarget(attacker)
    --end

    --if v.sg and not v.sg:HasStateTag("frozen") then
        --v:PushEvent("attacked", {attacker = attacker, damage = 0})
    --end
	--冰		 
	if not inst or not v then 
	return end
	
    local numFX = math.random(5,10)
    local pos = inst:GetPosition()
    local targetPos = v:GetPosition()
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = inst:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        inst:DoTaskInTime(math.random() * 0.25, function(inst)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = 0.5
                local z = 0.5
                local offset = (vec * math.random(dist * 0.25, dist)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
            end
        end)
    end
	
	--v.components.health:DoDelta(- 10 - inst.level)
if not v:HasTag("ant") and not v:HasTag("insect") then	
    if v.components.freezable then
        --v.components.freezable:AddColdness(3)
        --v .components.freezable:SpawnShatterFX()
    end
end
--冰冻程序结束	
    inst.components.sswordcast:siwangfanzhao_attack(inst)
		
end
end

--伤害程序结束
        end,

        onexit = function(inst)
            --inst.components.health:SetInvincible(false)
            inst:Show()
			--防止被打断

		    --inst:DoTaskInTime(1, function()
		    --inst.missatk = false	
		    --end)
		    --inst.skillon = true
        end,

        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    }
	

-----

AddStategraphState("wilsonboating", 
    State{
        name = "attack",
        tags = {"attack", "notalking", "abouttoattack", "busy", "boating"},
        
        onenter = function(inst)
            --print(debugstack())
            --inst.components.driver:SplitFromVehicle()
            local weapon = inst.components.combat:GetWeapon()
            local otherequipped = inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)

            if (weapon and weapon:HasTag("gun")) or (otherequipped and otherequipped:HasTag("gun")) then
                inst.sg:GoToState("shoot")
                return
            end

            if weapon then
				if weapon:HasTag("gongjian") then
				inst.AnimState:PlayAnimation("bow_attack")			

				else
                inst.AnimState:PlayAnimation("atk")

				end

                if weapon:HasTag("icestaff") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_icestaff")
                elseif weapon:HasTag("shadow") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
                elseif weapon:HasTag("firestaff") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_firestaff")
                elseif weapon:HasTag("cutlass") then
                    inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")
                elseif weapon:HasTag("pegleg") then
                    inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/pegleg_weapon")
                else
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
                end
            elseif otherequipped and (otherequipped:HasTag("light") or otherequipped:HasTag("nopunch")) then
                inst.AnimState:PlayAnimation("atk")
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
            else
                inst.sg.statemem.slow = true
                inst.AnimState:PlayAnimation("punch")
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            end
            
            if inst.components.combat.target then
                inst.components.combat:BattleCry()
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.components.locomotor:Stop()
            
        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),
            TimeEvent(12*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("busy")
            end),               
            TimeEvent(13*FRAMES, function(inst)
                if not inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),
            TimeEvent(24*FRAMES, function(inst)
                if inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),
            
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    }
)
-----

--动作
--攻击动画
SGWilson.states["attack"] = GLOBAL.State {
        name = "attack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst)
			--print(debugstack())

            local weapon = inst.components.combat:GetWeapon()
            local otherequipped = inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)

            if (weapon and weapon:HasTag("gun")) or (otherequipped and otherequipped:HasTag("gun")) then
                inst.sg:GoToState("shoot")
                return
            end

            if weapon then
			


				if weapon:HasTag("gongjian") then
				inst.AnimState:PlayAnimation("bow_attack")			
			    --elseif math.random() <= 0.3 then
				else
                inst.AnimState:PlayAnimation("atk")
				--inst.AnimState:PlayAnimation("item_in")
				--elseif math.random() > 0.3 and math.random() <= 0.6 then
				--inst.AnimState:PlayAnimation("pickaxe_loop")
				--else
				--inst.AnimState:PlayAnimation("chop_loop")
				end
				if weapon:HasTag("icestaff") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_icestaff")
				elseif weapon:HasTag("shadow") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
                elseif weapon:HasTag("firestaff") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_firestaff")
                elseif weapon:HasTag("cutlass") then
                    inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")
                elseif weapon:HasTag("pegleg") then
                    inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/pegleg_weapon")
                else
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
                end
            elseif otherequipped and (otherequipped:HasTag("light") or otherequipped:HasTag("nopunch")) then
                inst.AnimState:PlayAnimation("atk")
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
            else
				inst.sg.statemem.slow = true
                inst.AnimState:PlayAnimation("atk")
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            end
            
            if inst.components.combat.target then
                inst.components.combat:BattleCry()
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.components.locomotor:Stop()
			--if inst:HasTag("banyuewandao") then inst.AnimState:PlayAnimation("chop_loop") inst.components.hunger:DoDelta(-1) end
            
        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) 
			inst.sg:RemoveStateTag("abouttoattack") 
			end),
			
            TimeEvent(10*FRAMES, function(inst)  			
			if inst.combo and inst.combo <= 8 then 
			inst.combo = inst.combo +1  
			--inst.sg.statemem.target.components.combat:GetAttacked(inst, 51+2*inst.level) 
			end			
			end),			

            TimeEvent(12*FRAMES, function(inst) 
				inst.sg:RemoveStateTag("busy")
			end),				
            TimeEvent(13*FRAMES, function(inst)
				if not inst.sg.statemem.slow then
					inst.sg:RemoveStateTag("attack")
				end
            end),
            TimeEvent(24*FRAMES, function(inst)
				if inst.sg.statemem.slow then
					inst.sg:RemoveStateTag("attack")
				end
            end),
            
            
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    }

--技能动画
SGWilson.states["sanqianyuezhan"] = GLOBAL.State {

        name = "sanqianyuezhan",
        tags = {"busy", "skill", "nointerrupt", "nomorph","not_hit_stunned"},
		
		onenter = function(inst)
		    --inst.ss_isInvincible = inst.components.health.invincible   --记录原来的无敌状态 防止误清
            --inst.components.health:SetInvincible(true)  --传送期间生命值无敌
            inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			
			inst.AnimState:PlayAnimation("powerup")
			--inst.AnimState:PushAnimation("atk", false)
            inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")			
			inst.AnimState:PushAnimation("chop_loop", false)
			inst.sg:SetTimeout(6)
			
        end,
		
		ontimeout = function(inst)
			inst.sg:GoToState("idle")
		end,
		
		timeline = 
		{
			--跳起结束
			TimeEvent(36*FRAMES, function(inst)
				--inst.SoundEmitter:PlaySound("zg_ch1_zoro/zg_ch1_zoro/fannao")
				if inst.components.talker then
					inst.components.talker:Say("我的剑刃早已孤寂")
				end
			end),
			
			--发动
			TimeEvent(45*FRAMES, function(inst)
			
				--旋风状态实体攻击
				--inst["zg_inh_anti_physics"] = .95
			
				--锁定前进方向
				--local pt = Vector3(TheInput:GetWorldPosition():Get())
				--local pos = Point(caster.Transform:GetWorldPosition())
			--if inst.components.combat.target then
			--inst._target_pos = inst.components.combat.target:GetPosition()
		--向鼠标方向前进--inst._target_pos = TheInput:GetWorldPosition()
					inst._target_pos = Point(inst.Transform:GetWorldPosition())
			--end
				
				----向前推进的单位向量
				local vec
				if inst._target_pos then
					vec = inst._target_pos - inst:GetPosition()
					vec = vec:Normalize()
				else
					local theta = - inst.Transform:GetRotation()
					vec = Vector3( math.cos(theta), 0, math.sin(theta) )
				end
				
				----比伐木工过之而无不及
				if vec and inst._spintask == nil then
				
					----开始旋转
					local period = 1/30
					local velocity = inst.components.locomotor.runspeed or 4
					local w = 360 * 8
					inst._spintick = 0
					inst._spintask = inst:DoPeriodicTask( period, function()
					
						----动画
						inst.AnimState:SetPercent("chop_loop", 0.078 + math.random() * 0.078)	--手伸最长时
						
						----持续前进
						local pos = inst:GetPosition()
						inst.Transform:SetPosition( (pos + vec * period * velocity):Get() )
						
						----持续旋转
						local rot = inst.Transform:GetRotation()
						rot = rot + period * w
						while rot > 360 do
							rot = rot - 360
						end
						inst.Transform:SetRotation( rot )
						
						----判定伤害, 转一圈就是一次伤害
						local ticknum = math.ceil( 360/ w / period )
						if ticknum > 0 and inst._spintick % ticknum == 0 then
							
							----范围攻击
							local pt = inst:GetPosition()
							local r = 3
							local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","companion","ssword"})
							for k,v in pairs(ents) do
								if v and v.components.health and not v.components.health:IsDead() and v.components.combat then	
									v.components.combat:GetAttacked(inst, TUNING.ARM_RPGDAMAGE + 2*inst.level)
									if not v:HasTag("toso_armboss") then--对boss无效
									if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
									end
									
								end
							end
							
							----释放半月
							local moon = SpawnPrefab("sanqianyueren")
							inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/tornado", "spinLoop")
							if moon then
								moon.Transform:SetPosition(pt.x, pt.y, pt.z)
								moon.Transform:SetRotation( math.random() * 360 )
								moon.Physics:SetMotorVelOverride(13, 0, 0)
							end
							
						end
						inst._spintick = inst._spintick + 1
						
						
					end)
					
				end
				
			end),
		},
		
		events=
		{
			EventHandler("animqueueover", function(inst) 
			inst.sg:GoToState("idle") 
			

			
			end),
		},
		
		onexit = function(inst)
		
			if inst._spintask then
				inst._spintask:Cancel()
				inst._spintask = nil
				
			end
	        --inst:DoTaskInTime(0.8, function()--给玩家玩应时间，节能结束
			--if not inst.ss_isInvincible then
                --inst.components.health:SetInvincible(false)
            --end	
			
			--end)
			inst.SoundEmitter:KillSound("spinLoop")
			--
			--inst["zg_inh_anti_physics"] = inst.mem_anti_physics or .5
			--技能结束
			--inst.canpound2 = false
			--if not inst.components.timer:TimerExists("pound2") then
				--inst.components.timer:StartTimer("pound2", 12.5)
			--end
		end


    }
--爱无限
SGWilson.states["hengsao_fx"] = GLOBAL.State {	

        name = "hengsao_fx",
        tags = {"busy", "skill", "nointerrupt", "nomorph","not_hit_stunned"},
		
		onenter = function(inst)
		    inst.components.playercontroller:Enable(false)
            inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			                    --面向对方
                    local pos = TheInput:GetWorldPosition()
                    if pos then
                        inst:ForceFacePoint(pos:Get())
                    end
			--inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("chop_loop", false)
			--inst.SoundEmitter:PlaySound("zg_ch3_mihawk/zg_ch3_mihawk/call")
			if inst.components.talker then
				inst.components.talker:Say("爱无限")
			end
			--释放技能
				--inst.SoundEmitter:PlaySound("zg_ch3_mihawk/zg_ch3_mihawk/jq")
				inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/ribs/green")
				--local pos = tw_getforwardpos(inst, 1)
				local pos = TheInput:GetWorldPosition()
				local s=2
				local speed=5
				local yspeed=1
				for k=0,2 do
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,0,{speed,yspeed*k,0}})
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,-10,{speed,yspeed*k,0}})
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,10,{speed,yspeed*k,0}})
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,-20,{speed,yspeed*k,0}})
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,20,{speed,yspeed*k,0}})
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,-30,{speed,yspeed*k,0}})
					wy_spawn(inst,"hengsao_fx",nil,nil,s,{pos,30,{speed,yspeed*k,0}})
				end

		
		inst.sg:SetTimeout(0.5)			
        end,
        ontimeout = function(inst)
			inst.components.playercontroller:Enable(true)
			inst.sg:GoToState("idle")
        end,
    }


	
--由莲剑法
SGWilson.states["swordkill_fx"] = GLOBAL.State {	
		name = "swordkill_fx",
		tags = {"busy", "pound", "nointerrupt", "nomorph","not_hit_stunned"},

		onenter = function(inst)
		    inst.components.playercontroller:Enable(false)
			--inst.components.locomotor:StopMoving()
			--inst.Physics:Stop()
			
			--inst.AnimState:PlayAnimation("powerup")
			--inst.AnimState:PushAnimation("emote_hands")
			inst.AnimState:PushAnimation("chop_loop", false)
		local pt = TheInput:GetWorldPosition()
		local period = .1
	    inst._tick = 0				
		if inst and inst.task_chixu then inst.task_chixu:Cancel() inst.task_chixu = nil end
		inst.task_chixu = inst:DoPeriodicTask(period, function()
        --inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/items/weapon/corkbat") 
        inst.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")	
		--发射
		local rot = inst.Transform:GetRotation()
		rot = rot + inst._tick * 360 / (1/period)
		while (rot > 360) do
			rot = rot - 360
		end
		inst._tick = inst._tick + 1		
         local toso_leiting = SpawnPrefab("liehuodaofa_toso")
	     toso_leiting.Transform:SetScale(1, 1, 1)
	     toso_leiting.Transform:SetPosition(pt.x, pt.y, pt.z)
		local fx = SpawnPrefab("swordwind2")
		if fx then
			fx.Transform:SetPosition( pt:Get() )
			fx.Transform:SetRotation( rot )
			fx.Physics:SetMotorVelOverride(15, 0, 0)
		end
	
		end)

		inst:DoTaskInTime(3, function()
		if inst and inst.task_chixu then inst.task_chixu:Cancel() inst.task_chixu = nil end
		end)
		
		inst.sg:SetTimeout(0.5)			
        end,
        ontimeout = function(inst)
			inst.components.playercontroller:Enable(true)
			inst.sg:GoToState("idle")
        end,


}


--旋风
SGWilson.states["sswindatk"] = GLOBAL.State {	
		name = "sswindatk",
		tags = {"busy", "pound", "nointerrupt", "nomorph","not_hit_stunned"},

		onenter = function(inst)
			--inst.components.locomotor:StopMoving()
			--inst.Physics:Stop()
			
			--inst.AnimState:PlayAnimation("powerup")
			--inst.AnimState:PushAnimation("emote_hands")
			--inst.AnimState:PushAnimation("powerdown", false)
			inst.AnimState:PushAnimation("chop_loop")
			
			inst.SoundEmitter:PlaySound("dontstarve/creatures/chester/raise")
            inst.SoundEmitter:PlaySound("dontstarve/creatures/chester/pop")				
				local pt = inst:GetPosition()
				
				--生成冰旋风
				local fx = SpawnPrefab("sswind")
				if fx then
					fx.Transform:SetPosition( pt:Get() )
					--冰旋风推进
					--if inst.components.combat and inst.components.combat.target then
						fx.Transform:SetRotation( inst:GetAngleToPoint( TheInput:GetWorldPosition():Get() ) )
					--else
						--fx.Transform:SetRotation( inst.Transform:GetRotation() )
					--end
					fx.Physics:SetMotorVelOverride(15, 0, 0)
				end		
		
		
		inst.sg:SetTimeout(0.5)	
	
		end,


        ontimeout = function(inst)
			inst.sg:GoToState("idle")
        end,


}

--快速攻击动画
SGWilson.states["quick_attack"] = GLOBAL.State {
        name = "quick_attack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst)
			--print(debugstack())

            local weapon = inst.components.combat:GetWeapon()
            local otherequipped = inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)

            if (weapon and weapon:HasTag("gun")) or (otherequipped and otherequipped:HasTag("gun")) then
                inst.sg:GoToState("shoot")
                return
            end

            if weapon then
			


				if weapon:HasTag("gongjian") then
				inst.AnimState:PlayAnimation("bow_attack")			
			    --elseif math.random() <= 0.3 then
				else
                inst.AnimState:PlayAnimation("atk")
				--inst.AnimState:PlayAnimation("item_in")
				--elseif math.random() > 0.3 and math.random() <= 0.6 then
				--inst.AnimState:PlayAnimation("pickaxe_loop")
				--else
				--inst.AnimState:PlayAnimation("chop_loop")
				end
				if weapon:HasTag("icestaff") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_icestaff")
				elseif weapon:HasTag("shadow") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
                elseif weapon:HasTag("firestaff") then
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_firestaff")
                elseif weapon:HasTag("cutlass") then
                    inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")
                elseif weapon:HasTag("pegleg") then
                    inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/pegleg_weapon")
                else
                    inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
                end
            elseif otherequipped and (otherequipped:HasTag("light") or otherequipped:HasTag("nopunch")) then
                inst.AnimState:PlayAnimation("atk")
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
            else
				inst.sg.statemem.slow = true
                inst.AnimState:PlayAnimation("atk")
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            end
            
            if inst.components.combat.target then
                inst.components.combat:BattleCry()
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.components.locomotor:Stop()
			--if inst:HasTag("banyuewandao") then inst.AnimState:PlayAnimation("chop_loop") inst.components.hunger:DoDelta(-1) end
            
        end,
        
        timeline=
        {


            TimeEvent(2 * FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),			
            TimeEvent(3 * FRAMES, function(inst)
				inst.sg:RemoveStateTag("busy")
            end),
            TimeEvent(4 * FRAMES, function(inst)
				if not inst.sg.statemem.slow then
					inst.sg:RemoveStateTag("attack")
				end
            end),
			
            TimeEvent(6 * FRAMES, function(inst)
				if inst.sg.statemem.slow then
					inst.sg:RemoveStateTag("attack")
				end
            end),
            
            
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    }

--参考翼语快速采集

SGWilson.states["quick_harvest"] = State {
	name = "quick_harvest",
	tags = {"doing", "busy"},
	onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("pickup")

            inst.sg.statemem.action = inst.bufferedaction
            inst.sg:SetTimeout(5 * FRAMES)
	end,
	ontimeout = function(inst)
		inst:PerformBufferedAction()
	end,
	timeline = 
	{
            TimeEvent(2 * FRAMES, function(inst)
                inst.sg:RemoveStateTag("busy")
            end),
            TimeEvent(3 * FRAMES, function(inst)
                inst:PerformBufferedAction()
            end),
	},
	events = {
	    EventHandler("animover", function(inst)
		inst.sg:GoToState("idle") 
	    end ),
	},
	

	
	
}

--快速动作吃
SGWilson.states["quick_eat"] = State {
	name = "quick_eat",
	tags = {"doing", "busy"},
	onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("eat")

            inst.sg.statemem.action = inst.bufferedaction
            inst.sg:SetTimeout(5 * FRAMES)
	end,
	ontimeout = function(inst)
		inst:PerformBufferedAction()
	end,
	timeline = 
	{
            TimeEvent(2 * FRAMES, function(inst)
                inst.sg:RemoveStateTag("busy")
            end),
            TimeEvent(3 * FRAMES, function(inst)
                inst:PerformBufferedAction()
            end),
	},
	events = {
	    EventHandler("animover", function(inst)
		inst.sg:GoToState("idle") 
	    end ),
	},
	

	
	
}


--晕倒动作
SGWilson.states["passout"] = State {
        name = "passout",

        onenter = function(inst)
            inst.components.playercontroller:Enable(false)
            inst.AnimState:PlayAnimation("wakeup")
            --inst.components.health:SetInvincible(true)
        end,
        
        onexit = function(inst)
            inst.components.playercontroller:Enable(true)
            --inst.components.health:SetInvincible(false)
        end,
        
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },

}

SGWilson.actionhandlers[ACTIONS.HARVEST]=ActionHandler(ACTIONS.HARVEST,
	function(inst, action)
	local p = GetPlayer()

            if p.level >= 5 
			and (action.target.components.stewer or action.target.components.dryer) then	
	
		    return "quick_harvest"


			
			else
			return "dolongaction"	
		
			end


	


end)

SGWilson.actionhandlers[ACTIONS.PICK]=ActionHandler(ACTIONS.PICK,
	function(inst, action)
	local p = GetPlayer()
	local weapon =  p.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
	if action.target.components.pickable then
		--if weapon and (weapon.prefab == "surfboard_item_toso" or weapon.prefab == "sword_4")--and p.components.fa_bufftimers
		--and (action.target.prefab == "grass" or action.target.prefab == "reeds" or action.target.prefab == "fa_wheat"
		--or action.target.prefab == "sapling" or action.target.prefab == "wheat_planted") then
    if p.level >= 5 
	--动作对象
	and (action.target.prefab == "grass" --草
	or action.target.prefab == "reeds" --芦苇
	or action.target.prefab == "fa_wheat" 
	or action.target.prefab == "carrot_planted"--长在地上的胡萝卜
	or action.target.prefab == "sapling" --树枝
	or action.target.prefab == "berrybush" --浆果灌木丛	
	or action.target.prefab == "berrybush2" --浆果灌木丛2	
	or action.target.prefab == "cave_fern" --蕨类植物
	or action.target.prefab == "flower_cave" --荧光草（单朵）
	or action.target.prefab == "flower_cave_double" --荧光草（单朵）
	or action.target.prefab == "flower_cave_triple" --荧光草（单朵）
	or action.target.prefab == "tumbleweed" --滚草
	or action.target.prefab == "cactus" --仙人掌
	or action.target.prefab == "tumbleweed" --风滚草
	or action.target.prefab == "red_mushroom" --蘑菇
	or action.target.prefab == "green_mushroom" --蘑菇
	or action.target.prefab == "blue_mushroom" --蘑菇
	or action.target.prefab == "cave_banana_tree" --香蕉树
	or action.target.prefab == "coffeebush" --咖啡
	or action.target.prefab == "flower_1" --灵花
	or action.target.prefab == "bamboobush" --竹子
	or action.target.prefab == "plant_pumpkin" --作物
	or action.target.prefab == "wheat_planted")then
			--action.doer:DoTaskInTime(.5, function() weapon.components.fueled:DoDelta(-20000) end)
			return "quick_harvest"
		elseif action.target.components.pickable.quickpick then
			return "doshortaction"
		else
			return "dolongaction"
		end
		--act.target.components.pickable:Pick(act.doer)
		action.target.components.pickable:Pick(act.doer)		
		return true
	end
end)
--[[
SGWilson.actionhandlers[ACTIONS.EAT]=ActionHandler(ACTIONS.EAT,
        function(inst, action)
			local p = GetPlayer()
            if inst.sg:HasStateTag("busy") then
                return nil
            end
            local obj = action.target or action.invobject
            if not (obj and obj.components.edible) then
                return nil
            end

            if p.level >= 5 then
                return "quick_eat"            
            elseif obj.components.edible.foodtype == "MEAT" then
                return "eat"
            else
                return "quickeat"
            end
        --end
end)
]]

SGWilson.actionhandlers[ACTIONS.COOK]=ActionHandler(ACTIONS.COOK,
        function(inst, action)
		local p = GetPlayer()
        if p.level >= 5 then
                return "quick_harvest"
        else
                return "dolongaction"		
        end
end)

SGWilson.actionhandlers[ACTIONS.GIVE]=ActionHandler(ACTIONS.GIVE,
        function(inst, action)
					local p = GetPlayer()
        if p.level >= 5 then
                return "quick_harvest"
	    else 
                return "give"
        end
end)

SGWilson.actionhandlers[ACTIONS.BUILD]=ActionHandler(ACTIONS.BUILD,
        function(inst, action)
					local p = GetPlayer()
		
            if p.level >= 5 then
                return "quick_harvest"			
            elseif action.recipe and action.recipe == "livinglog" and action.doer and action.doer.prefab == "wormwood" then
                return "form_log"
            else            
                return "dolongaction"
            end

end)

--暴露重要材料的位置
--巨人国
	AddPrefabPostInit("livingtree", function(inst)
inst:AddTag("livingtree")
	end)
--海难
	AddPrefabPostInit("livingjungletree", function(inst)
inst:AddTag("livingjungletree")
	end)





--兼容海难
AddSimPostInit(function(inst)
	local p = GetPlayer()
	--tosoPostInit(inst)
	GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_ACTION, function(down)
    local pt = p:GetPosition()
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 30)
	local weapon =  p.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
	    for k,v in pairs(ents) do

		if v and v.prefab == "yiyuwaxwell_boat" then
			v:RemoveComponent("drivable")
		end
		end
	end)
--暴露重要材料的位置

--巨人国
		--if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then
			if GLOBAL.TheSim:FindFirstEntityWithTag("livingtree") then			
				--local doer = player
				local target = GLOBAL.TheSim:FindFirstEntityWithTag("livingtree")			
				local x, y, z = target.Transform:GetWorldPosition()			
					p:DoTaskInTime(0, function()
					GLOBAL.GetWorld().minimap.MiniMap:ShowArea(x, y, z, 19)
				end)
			end
		--end
--海难
		--if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then
			if GLOBAL.TheSim:FindFirstEntityWithTag("livingjungletree") then			
				--local doer = player
				local target = GLOBAL.TheSim:FindFirstEntityWithTag("livingjungletree")			
				local x, y, z = target.Transform:GetWorldPosition()			
					p:DoTaskInTime(0, function()
					GLOBAL.GetWorld().minimap.MiniMap:ShowArea(x, y, z, 19)
				end)
			end
		--end
		
		


end)


AddComponentPostInit("builder", function(self)
	local pl = GetPlayer()
	local old_MakeRecipe = self.MakeRecipe
	self.MakeRecipe = function(self,recipe, pt, rot, onsuccess, modifydata)
		if recipe.name == "kid_eyebone" and pl.tososacknum then
			if pl.tososacknum < 2 then
				local tososacknum = _G.c_countprefabs("kid_eyebone", true) or 0
				pl.tososacknum = tososacknum
			end
			if pl.tososacknum >= 2 then
				GetPlayer().components.talker:Say("不可制做2个以上")
				return false
			end
			print(GetPlayer().tososacknum)
		end
		old_MakeRecipe(self,recipe, pt, rot, onsuccess, modifydata)
	end
end)

--UI煞气
local shaqi = require("widgets/shaqi")
local function Addshaqi(self) 
	if self.owner and self.owner:HasTag("ssword") then
		self.shaqi = self.status:AddChild(shaqi(self.owner))	
		--self.shaqi:SetPosition(-80,-40,0)
		self.shaqi:SetPosition(-120,23,0)
		self.shaqi:SetScale(1,1,1)	
	end
end

AddClassPostConstruct("widgets/controls", Addshaqi)

-- 地图显示
AddMinimapAtlas("images/map_icons/ssword.xml")
-- strings! Any "WOD" below would have to be replaced by the prefab name of your character.

-- The character select screen lines
-- note: these are lower-case character name
STRINGS.CHARACTER_TITLES.ssword = "剑是我的最高奥义"
STRINGS.CHARACTER_NAMES.ssword = "百里屠苏"  -- Note! This line is especially important as some parts of the game require
                                            -- the character to have a valid name.
STRINGS.CHARACTER_DESCRIPTIONS.ssword = "拥有一把上古神剑，右键目标可万军从中杀敌\n随机奖励技能，释放结束后自动切换下一个技能\n按T修炼，打怪升悬赏，获得修炼次数提高属性"
STRINGS.CHARACTER_QUOTES.ssword = "\"饥荒大陆的最强者是谁呢.\""

--

--

    --远古boss
	AddMinimapAtlas("images/map_icons/arm_boss.xml")	
	AddPrefabPostInit("boss_hound", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_knight", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_krampus", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_rocky", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_spiderqueen", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_tigershark", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_crawlingnightmare", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
	AddPrefabPostInit("boss_nightmarebeak", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_boss.tex")
	end)
    --人形怪
	AddMinimapAtlas("images/map_icons/arm_person.xml")
	--boss
	AddMinimapAtlas("images/map_icons/sheath.xml")
	AddPrefabPostInit("boss_sesshoumaru", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("sheath.tex")
	end)
	
	AddPrefabPostInit("arm_qingxue", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_bro", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_zouwei_bro", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_bro3", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_yuancheng_bro", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_warly", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_wes", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_webber", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("assasin_sshw", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_willow", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_wickerbottom", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_bro5", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_woodlegs", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_zhumei", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_wilbur", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	AddPrefabPostInit("arm_meilaoban", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_person.tex")
	end)
	
	--人形生物
	AddMinimapAtlas("images/map_icons/arm_animal.xml")
	AddPrefabPostInit("arm_merm1", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_hound", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_scorpion", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_dragoon", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_mossling", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_krampus", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_spider_warrior", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_treeguard", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	AddPrefabPostInit("arm_perd", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("arm_animal.tex")
	end)
	
	--物品
	AddMinimapAtlas("images/map_icons/hulu.xml")
	AddMinimapAtlas("images/map_icons/sword_3.xml")
	AddMinimapAtlas("images/map_icons/amor2_ssword.xml")
	AddMinimapAtlas("images/map_icons/hat_ruineye.xml")
	AddMinimapAtlas("images/map_icons/cookpotssword_item.xml")
	AddMinimapAtlas("images/inventoryimages/jianzhong.xml")
	
	AddPrefabPostInit("hulu1", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("hulu.tex")
	end)
	AddPrefabPostInit("toso_surfboard", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("sword_3.tex")
	end)
	AddPrefabPostInit("armor_ssword", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("amor2_ssword.tex")
	end)
	AddPrefabPostInit("armor2_ssword", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("hat_ruineye.tex")
	end)
	AddPrefabPostInit("base_portablecookpot", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("cookpotssword_item.tex")
	end)
	AddPrefabPostInit("jianzhong", function(inst)
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("jianzhong.tex")
	end)
	
--[[

AddPrefabPostInit("arm_bro", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_zhumei", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_woodlegs", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_bro3", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_qingxue", AddMap)
AddMinimapAtlas("images/map_icons/arm_qingxue.xml")
AddPrefabPostInit("arm_yuancheng_bro", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")


AddPrefabPostInit("arm_warly", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_wes", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_webber", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("assasin_sshw", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
--AddPrefabPostInit("arm_spat", AddMap)
--AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_willow", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_wickerbottom", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_bro5", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("arm_zouwei_bro", AddMap)
AddMinimapAtlas("images/map_icons/arm_bro2.xml")
AddPrefabPostInit("surfboard_item_toso", AddMap)
AddMinimapAtlas("images/map_icons/sword_3.xml")
AddPrefabPostInit("toso_surfboard", AddMap)
AddMinimapAtlas("images/map_icons/sword_3.xml")
AddPrefabPostInit("armor_ssword", AddMap)
AddMinimapAtlas("images/map_icons/amor2_ssword.xml")


--AddPrefabPostInit("arm_dragoon", AddMap)
--AddMinimapAtlas("images/map_icons/arm_bro2.xml")
--AddPrefabPostInit("arm_hound", AddMap)
--AddMinimapAtlas("images/map_icons/arm_bro2.xml")
--AddPrefabPostInit("arm_krampus", AddMap)
--AddMinimapAtlas("images/map_icons/arm_bro2.xml")

AddPrefabPostInit("hulu", AddMap)
AddMinimapAtlas("images/map_icons/hulu.xml")
]]

function PostInit(inst)
    --专属制作兰
	RepicPostInit(inst)
	if inst.components.keeponland then inst:RemoveComponent("keeponland") end
	if not inst.zhuoshao then inst.zhuoshao = 0 end
			--帮小妾保存的值
	if not inst.kidadddmg then inst.kidadddmg = 0 end


		
	
	if GLOBAL.SaveGameIndex:GetCurrentMode() == "porkland" then
		TUNING.SDLC = 3
	elseif GLOBAL.SaveGameIndex:GetCurrentMode() == "shipwrecked" or GLOBAL.SaveGameIndex:GetCurrentMode() == "volcano" then
		TUNING.SDLC = 2
	elseif GLOBAL.SaveGameIndex:GetCurrentMode() == "survival" or GLOBAL.SaveGameIndex:GetCurrentMode() == "cave" then
		TUNING.SDLC = 1
	end
--检测领域条件 
	if inst.level >= 35 then 
TUNING.DANKANGLENG = "闪避丹"
TUNING.DANKANGRE = "攻速丹"
TUNING.DANKANGLENGINTRO = "功能：增加格挡闪避几率\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【玲草的花*20】\n第三格【咖喱*2】\n第四格【空】\n特殊条件：角色35级食用有效"
TUNING.DANKANGREINTRO = "功能：提高攻速\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【电羊角*1】\n第三格【水果拼盘*5】\n第四格【空】\n特殊条件：角色35级食用有效"	

    else
TUNING.DANKANGLENG = "抗冷丹"
TUNING.DANKANGRE = "抗热丹"
TUNING.DANKANGLENGINTRO = "功能：当温度低于一定值时，自动回复体温\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【萤火虫*1】\n第四格【空】\n特殊条件：无"
TUNING.DANKANGREINTRO = "功能：当温度高于一定值时，自动降低体温\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【冰*5】\n第四格【空】\n特殊条件：无"
	end

end


--[[
--影闪
SGWilson.states["onikiri_gs_pre"] = GLOBAL.State {
        name = "onikiri_gs_pre",
        tags = { "doing", "busy", "nointerrupt", "nomorph","not_hit_stunned" },

        onenter = function(inst)
            inst.components.locomotor:Stop()
            local buff = inst:GetBufferedAction()
            if buff and buff.target and buff.target:IsValid() then
                if buff.target.components.combat and buff.target.components.combat:CanBeAttacked() then
                    --面向对方
                    local pos = buff.target:GetPosition()
                    if pos then
                        inst:ForceFacePoint(pos:Get())
						                    --inst.components.talker:Say("能到这")
                    end
                    --起手
                    inst.AnimState:PlayAnimation("atk")
                    SpawnPrefab("laser_explosion").Transform:SetPosition(inst:GetPosition():Get())
                else
                    --不能攻击
                    inst.components.talker:Say("不能攻击")
                    inst.sg:GoToState("idle")
                end
            else
                --你怎么进来的 滚
                inst.sg:GoToState("idle")
				inst.components.talker:Say("不能攻击2")
            end
        end,

        timeline =
        {
            TimeEvent(4 * FRAMES, function(inst)
                --呃 单机没这音效 先空着吧
                --inst.SoundEmitter:PlaySound("onikiri/DST/twirl_lava_weapons", nil, nil, true)
            end),
        },

        events =
        {
            EventHandler("onikiri_gs_attack", function(inst, data)
                inst.sg:GoToState("onikiri_gs_attack", data)
            end),
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() then
                    --if inst.AnimState:IsCurrentAnimation("atk") then
                        inst.AnimState:PlayAnimation("chop_loop")
                        inst:PerformBufferedAction()
                    --else
                        inst.sg:GoToState("idle")
                    --end
                end
            end),
            EventHandler("unequip", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    }


-- local function MakeFx(inst,weapon,pos)
    -- local data = inst.sg.statemem.data
    -- data.targetpos = data.target:IsValid() and data.target:GetPosition() or data.targetpos  --目标有效则重取坐标
    -- local maindata = {}
    -- maindata.doer = inst
    -- maindata.weapon = "onikiri_weapon_".. (inst.components.onikirisave.unlock[weapon] and weapon or "default")
    -- maindata.target = data.target
    -- maindata.targetpos = data.targetpos
    -- maindata.pos = data.targetpos + pos
    -- local mainfx = SpawnPrefab("onikiri_shadow")    --召唤分身
    -- mainfx:MainStart(maindata)
-- end
local function MakeFx2(inst,x,z)
    local data = inst.sg.statemem.data
    data.targetpos = data.target:IsValid() and data.target:GetPosition() or data.targetpos  --目标有效则重取坐标
    inst.Physics:Teleport(data.targetpos.x+x, 0, data.targetpos.z+z)
    inst:ForceFacePoint(data.targetpos:Get())
    inst.AnimState:PlayAnimation("bow_attack")
    --SpawnPrefab("onikiri_weapon_fx1"):Bind(data.target)  --根本看不见
    SpawnPrefab("laserhit"):SetTarget(data.target)
    local explosion = SpawnPrefab("laser_explosion")
    explosion.Transform:SetPosition(data.targetpos:Get())  
    explosion.Transform:SetScale(0.7,0.7,0.7)
end
  
SGWilson.states["onikiri_gs_attack"] = GLOBAL.State {
        name = "onikiri_gs_attack",
        tags = {"doing", "busy","nointerrupt","nomorph","not_hit_stunned" },

        onenter = function(inst, data)
            inst.sg:SetTimeout(3) --超时三秒防止卡死
            if data and data.target and
                data.target:IsValid()
                --and inst.AnimState:IsCurrentAnimation("chop_loop") 
				then
                --inst.onikiri_god = true     --攻击雷电等也会被丢弃
                inst.onikiri_isInvincible = inst.components.health.invincible   --记录原来的无敌状态 防止误清
                inst.components.health:SetInvincible(true)  --传送期间生命值无敌
                inst.AnimState:PlayAnimation("bow_attack",false)
                local pos = inst:GetPosition()
                local targetpos = data.target:GetPosition()
                if targetpos == pos then
                    targetpos = targetpos + Vector3(0.1,0,0.1)
                end
                data.targetpos = targetpos
                --记录当前位置
                inst.sg.statemem.oldpos = pos 
                local newpos = targetpos - pos
                newpos = newpos:GetNormalized() * 2  + newpos
                local telpos = newpos + pos --额外偏移2距离 到身后 去摆pose
                
                inst:ForceFacePoint(telpos:Get()) -- 面向最终方向
                --么得音效 先空着吧
                inst.Physics:Teleport(telpos.x, 0, telpos.z)
                --inst.components.onikirighostfire:use(3)
                inst.components.health:DoDelta(-1)
                --生成残影
                 for i=0,3,1 do
                    local fxpos = newpos*((i+1)/5)+ pos
                    local fxdata = {
                        doer = inst,
                        weapon = data.weapon.prefab,
                        pos  = fxpos ,
                        target = data.target,
                        telpos = telpos
                    }
                    --local fx = SpawnPrefab("onikiri_shadow")
                    --fx:FXStart(fxdata,i)
                end
                inst.sg.statemem.data = data    --记录当前数据
            else
            --Failed
            inst.sg:GoToState("idle", true)
            end
        end,

        timeline =
        {
            --残影版
            -- TimeEvent(11 * FRAMES, function(inst)   --11帧之后停止动画
                -- inst.AnimState:Pause()
                -- inst.entity:Hide(false)
            -- end),
            -- TimeEvent(12 * FRAMES, function(inst)   --第一分身 
                -- MakeFx(inst,"shizizhizi",Vector3(-4.5,0,-6))
            -- end),
            -- TimeEvent(22 * FRAMES, function(inst)   --第二分身 
                -- MakeFx(inst,"youqie",Vector3(0,0,7.5))
            -- end),
            -- TimeEvent(32 * FRAMES, function(inst)   --第三分身 
                -- MakeFx(inst,"ziqie",Vector3(4.5,0,-6))
            -- end),
            -- TimeEvent(66 * FRAMES, function(inst)   --66帧之后整个技能结
                -- inst.Physics:Teleport(inst.sg.statemem.oldpos:Get())
                -- inst.AnimState:PlayAnimation("idle",true)
                -- --结算伤害
                -- GHOSTSHADOW.Attack(inst,inst.sg.statemem.data.target)
                -- if inst.AnimState:AnimDone() then
                    -- inst.sg:GoToState("idle")
                -- end
            -- end),
            
            TimeEvent(11 * FRAMES, function(inst)   --二斩
                MakeFx2(inst,-0.5,-0.5)
            end),
            TimeEvent(22 * FRAMES, function(inst)   --三斩
                MakeFx2(inst,0,0.5)
            end),
            TimeEvent(33 * FRAMES, function(inst)   --四斩 
                MakeFx2(inst,0.5,0.5)
            end),
            TimeEvent(44 * FRAMES, function(inst)   --44帧之后整个技能结
                inst.Physics:Teleport(inst.sg.statemem.oldpos:Get())
                inst.AnimState:PlayAnimation("idle",true)
                --结算伤害
                GHOSTSHADOW.Attack(inst,inst.sg.statemem.data.target)
                inst.sg:GoToState("idle")
            end),
        },
        
        ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end,
        onexit = function(inst)
            -- inst.AnimState:Resume()
            -- inst.entity:Hide(false)
            --inst.onikiri_god = false
            if not inst.onikiri_isInvincible then
                inst.components.health:SetInvincible(false)
            end
            inst.Physics:Teleport(inst.sg.statemem.oldpos:Get())
        end,
    }

	--CASTSPELL = Action({mount_enabled=true},-1, false, true, 20),
--local CASTSPELL = GLOBAL.Action({mount_enabled=true},10, false, true, 20),

--AddAction(CASTSPELL)


local CASTSPELL = Action({mount_enabled=true},-1, false, true, 20)






----set up the action functions!


ACTIONS.CASTSPELL.strfn = function(act)
    local targ = act.invobject
    
    if targ and targ.components.spellcaster then
        return targ.components.spellcaster.actiontype
    end
end

ACTIONS.CASTSPELL.fn = function(act)
    --For use with magical staffs
    local staff = act.invobject or act.doer.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)

    if staff and staff.components.spellcaster and staff.components.spellcaster:CanCast(act.doer, act.target, act.pos) then
        staff.components.spellcaster:CastSpell(act.target, act.pos)
        return true
    end
end


local GHOSTSHADOW = Action({},-1,false,true,10)      --鬼影斩触发
GHOSTSHADOW.id = "GHOSTSHADOW"
GHOSTSHADOW.str = "鬼影斩"
GHOSTSHADOW.fn = function(act)
    if GHOSTSHADOW.CanCast(act.doer,act.target) then
        GHOSTSHADOW.Cast(act.doer,act.target)
    end
    return true
end
GHOSTSHADOW.CanCast = function(doer,target,right) 
        local weapon = doer.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
    if doer and target 
        and doer.components.shaqi and doer.components.shaqi:GetPercent() >= 0.2  --怒气大于等于3
        and not (doer.components.driver and doer.components.driverdriving)                 --不在船上
        and target.components.combat and target.components.health --and doer.components.combat:IsValidTarget(target)) --目标可攻击
		--and weapon.prefab  ~= "surfboard_item_toso"
        then
        return true
    end
end

GHOSTSHADOW.Cast = function(doer,target) 
    if GHOSTSHADOW.CanCast(doer,target) then
        local weapon = doer.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
		doer.components.talker:Say("OK") 
        doer:PushEvent("onikiri_gs_attack",{weapon = weapon,target=target})
    end
end



GHOSTSHADOW.Attack = function(doer,target)
    if target and target:IsValid() then
        local weapon = doer.components.combat:GetWeapon()
        --print(weapon)
        local damage = doer.components.combat:CalcDamage(target,weapon)
        --四次斩击伤害
        target.components.combat:GetAttacked(doer,damage,weapon)
        target.components.combat:GetAttacked(doer,damage,weapon)
        target.components.combat:GetAttacked(doer,damage,weapon)
        target.components.combat:GetAttacked(doer,damage,weapon)

    end
end
AddAction(GHOSTSHADOW)
AddStategraphActionHandler("wilson",GLOBAL.ActionHandler(ACTIONS.GHOSTSHADOW, "onikiri_gs_pre"))



--影闪
]]


--物品介绍--制作兰描述字数最多为九个


STRINGS.NAMES.ZHAOHUNFAN_ITEM = "助手召唤器"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ZHAOHUNFAN_ITEM = "快来充钱吧，一宝石等于一佣兵"
STRINGS.RECIPE_DESC.ZHAOHUNFAN_ITEM = "给宝石可以召唤助手"

STRINGS.NAMES.SURFBOARD_ITEM_TOSO = "上古神剑"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SURFBOARD_ITEM_TOSO = "传说这把剑杀过天"
STRINGS.RECIPE_DESC.SURFBOARD_ITEM_TOSO = "天之痕"

STRINGS.NAMES.ARM_QINGXUE = "温蒂"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_QINGXUE = "你是温蒂吗"
STRINGS.RECIPE_DESC.ARM_QINGXUE = "温蒂"

STRINGS.NAMES.ARM_BRO = "威尔逊"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_BRO = "威尔逊"
STRINGS.RECIPE_DESC.ARM_BRO = "威尔逊"

STRINGS.NAMES.ARM_YUANCHENG_BRO = "奇异机器人"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_YUANCHENG_BRO = "会发射电磁波炮"
STRINGS.RECIPE_DESC.ARM_YUANCHENG_BRO = "奇异机器人"

STRINGS.NAMES.ARM_ZOUWEI_BRO = "瓦琳娜"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_ZOUWEI_BRO = "攻击速度很快，很容易弹飞你的武器"
STRINGS.RECIPE_DESC.ARM_ZOUWEI_BRO = "瓦琳娜"

STRINGS.NAMES.ARM_BRO3 = "大力士"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_BRO3 = "携带大锤子，可能从天上袭击你"
STRINGS.RECIPE_DESC.ARM_BRO3 = "大力士"

STRINGS.NAMES.ARM_BRO5 = "战争女王"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_BRO5 = "饥荒战争大将军"
STRINGS.RECIPE_DESC.ARM_BRO5 = "战争女王"


STRINGS.NAMES.ARM_MERM1 = "鱼人领主"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_MERM1 = "鱼人领主"
STRINGS.RECIPE_DESC.ARM_MERM1 = "鱼人领主"

--STRINGS.NAMES.ARM_SPAT = "饥荒神兽"
--STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_SPAT = "饥荒守护神兽"
--STRINGS.RECIPE_DESC.ARM_SPAT = "饥荒神兽"

STRINGS.NAMES.ARM_WARLY = "大厨师"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WARLY = "回复能力超强"
STRINGS.RECIPE_DESC.ARM_WARLY = "大厨师"

STRINGS.NAMES.ARM_WEBBER = "蜘蛛将军"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WEBBER = "攻击有几率减速"
STRINGS.RECIPE_DESC.ARM_WEBBER = "蜘蛛将军"

STRINGS.NAMES.ARM_WES = "维斯将军"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WES = "攻击召唤小热"
STRINGS.RECIPE_DESC.ARM_WES = "维斯将军"

STRINGS.NAMES.ARM_WICKERBOTTOM = "饥荒大长老"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WICKERBOTTOM = "攻击带雷电真实伤害"
STRINGS.RECIPE_DESC.ARM_WICKERBOTTOM = "饥荒大长老"

STRINGS.NAMES.ARM_WILLOW = "饥荒火将军"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WILLOW = "攻击释放火焰伤害"
STRINGS.RECIPE_DESC.ARM_WILLOW = "饥荒火将军"

STRINGS.NAMES.ASSASIN_SSHW = "饥荒影将军"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ASSASIN_SSHW = "攻击隐身，并降低精神值"
STRINGS.RECIPE_DESC.ASSASIN_SSHW = "饥荒影将军"

STRINGS.NAMES.ARM_WOODLEGS = "饥荒大船长"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WOODLEGS = "饥荒大船长"
STRINGS.RECIPE_DESC.ARM_WOODLEGS = "饥荒大船长"

STRINGS.NAMES.ARM_ZHUMEI = "饥荒猪小妹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_ZHUMEI = "我可是村长的唯一继承人"
STRINGS.RECIPE_DESC.ARM_ZHUMEI = "饥荒猪小妹"

STRINGS.NAMES.ARM_WILBUR = "饥荒大皮皮"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_WILBUR = "饥荒大皮皮"
STRINGS.RECIPE_DESC.ARM_WILBUR = "饥荒大皮皮"

--超级保鲜葫芦
STRINGS.NAMES.HULU1 = "超级保鲜葫芦"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.HULU1 = "要吃就要吃最新鲜的"
STRINGS.RECIPE_DESC.HULU1 = "超级保鲜葫芦"

STRINGS.NAMES.YAOSHUI = "回复药水"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.YAOSHUI = "回复精神和生命值"
STRINGS.RECIPE_DESC.YAOSHUI = "回复精神和生命值"

STRINGS.NAMES.ARMOR_SSWORD = "上古战甲"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARMOR_SSWORD = "被攻击不会僵直哦"
STRINGS.RECIPE_DESC.ARMOR_SSWORD = "免除负面效果"

STRINGS.NAMES.ARMOR2_SSWORD = "上古头盔"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARMOR2_SSWORD = "冰冻对手，免疫火焰"
STRINGS.RECIPE_DESC.ARMOR2_SSWORD = "可发光，免疫火"

STRINGS.NAMES.ANCIENT_GEM = "远古遗迹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_GEM = "十分有用的遗迹"
STRINGS.RECIPE_DESC.ANCIENT_GEM = "不用去巨人国洞穴了"

STRINGS.NAMES.BASE_PORTABLECOOKPOT_ITEM = "便捷式煮锅"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BASE_PORTABLECOOKPOT_ITEM = "堪称古代黑科技"
STRINGS.RECIPE_DESC.BASE_PORTABLECOOKPOT_ITEM = "你要学会做饭！"

STRINGS.NAMES.SSDECO_RUINS_FOUNTAIN = "修炼许愿井"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSDECO_RUINS_FOUNTAIN = "我可以不用去遗迹了？？"
STRINGS.RECIPE_DESC.SSDECO_RUINS_FOUNTAIN = "许愿但是统统不答应"

STRINGS.NAMES.SSDECO_RUINS_ENDSWELL = "修炼终结井"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSDECO_RUINS_ENDSWELL = "我可以不用去遗迹了？？"
STRINGS.RECIPE_DESC.SSDECO_RUINS_ENDSWELL = "下遗迹找我挺难的吧"

STRINGS.NAMES.SSMANDRAKEHOUSE = "我造的曼德拉"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSMANDRAKEHOUSE = "我可以不用去遗迹了？？"
STRINGS.RECIPE_DESC.SSMANDRAKEHOUSE = "保护珍贵动物"

STRINGS.NAMES.SSPLAYERHOUSE_CITY = "栖息地"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSPLAYERHOUSE_CITY = "？？？"
STRINGS.RECIPE_DESC.SSPLAYERHOUSE_CITY = "这能成为我暂时的家"

STRINGS.NAMES.ARM_KRAMPUS = "超级坎普斯"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_KRAMPUS = "变异的坎普斯"
STRINGS.RECIPE_DESC.ARM_KRAMPUS = "超级坎普斯"


STRINGS.NAMES.GATE = "世界树"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GATE = "瞬间传送到这里"
STRINGS.RECIPE_DESC.GATE = "按键可以传送至这里哦"

STRINGS.NAMES.SSWORD_BOWM = "失落之弓"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSWORD_BOWM = "失落之弓"
STRINGS.RECIPE_DESC.SSWORD_BOWM = "失落之弓"

STRINGS.NAMES.JIANZHONG = "剑冢"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.JIANZHONG = "可以锻造上古神剑"
STRINGS.RECIPE_DESC.JIANZHONG = "可以锻造上古神剑"

STRINGS.NAMES.FLOWER_1 = "灵花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FLOWER_1 = "吃我可以回san"
STRINGS.RECIPE_DESC.FLOWER_1 = "炼丹必备材料"

STRINGS.NAMES.FLOWER_SEED = "灵花种子"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FLOWER_SEED = "似乎挺可爱"
STRINGS.RECIPE_DESC.FLOWER_SEED = "多种多得，炼丹必备"

STRINGS.NAMES.FLOWER_HUA = "灵花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FLOWER_HUA = "正在产生灵力"
STRINGS.RECIPE_DESC.FLOWER_HUA = "可美了"

STRINGS.NAMES.TOSO_DANLU_ITEM = "炼丹炉"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_DANLU_ITEM = "丹药在丹药谱里查看材料和方法哦"
STRINGS.RECIPE_DESC.TOSO_DANLU_ITEM = "炼制丹药提升属性"

STRINGS.NAMES.TOSO_DANLU = "炼丹炉"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_DANLU = "忘记材料请点击右下角头像"
STRINGS.RECIPE_DESC.TOSO_DANLU = "炼制丹药提升属性"

STRINGS.NAMES.PELLET_HUJIA = "护甲丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_HUJIA = "护甲丹"
STRINGS.RECIPE_DESC.PELLET_HUJIA = "护甲丹"

STRINGS.NAMES.PELLET_HUISAN = "回san丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_HUISAN = "回san丹"
STRINGS.RECIPE_DESC.PELLET_HUISAN = "回san丹"

STRINGS.NAMES.PELLET_SANWEI = "三维丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_SANWEI = "三维丹"
STRINGS.RECIPE_DESC.PELLET_SANWEI = "三维丹"

STRINGS.NAMES.PELLET_YISU = "移速丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_YISU = "移速丹"
STRINGS.RECIPE_DESC.PELLET_YISU = "移速丹"

STRINGS.NAMES.PELLET_BEIGONG = "倍攻丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_BEIGONG = "倍攻丹"
STRINGS.RECIPE_DESC.PELLET_BEIGONG = "倍攻丹"

STRINGS.NAMES.PELLET_NUQI = "怒气丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_NUQI = "怒气丹"
STRINGS.RECIPE_DESC.PELLET_NUQI = "怒气丹"

STRINGS.NAMES.PELLET_JIE = "辟谷丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_JIE = "辟谷丹"
STRINGS.RECIPE_DESC.PELLET_JIE = "辟谷丹"

STRINGS.NAMES.PELLET_SHANGHAI = "伤害丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_SHANGHAI = "伤害丹"
STRINGS.RECIPE_DESC.PELLET_SHANGHAI = "伤害丹"

STRINGS.NAMES.PELLET_KANGSHI = "暴击丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_KANGSHI = "暴击丹"
STRINGS.RECIPE_DESC.PELLET_KANGSHI = "暴击丹"

STRINGS.NAMES.PELLET_KANGLENG = "抗冷丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_KANGLENG = "抗冷丹"
STRINGS.RECIPE_DESC.PELLET_KANGLENG = "抗冷丹"

STRINGS.NAMES.PELLET_KANGRE = "抗热丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_KANGRE = "抗热丹"
STRINGS.RECIPE_DESC.PELLET_KANGRE = "抗热丹"

STRINGS.NAMES.PELLET_XIXUE = "噬血丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_XIXUE = "噬血丹"
STRINGS.RECIPE_DESC.PELLET_XIXUE = "噬血丹"

STRINGS.NAMES.PELLET_MEILI = "避世丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_MEILI = "魅力值要满了就吃一颗"
STRINGS.RECIPE_DESC.PELLET_MEILI = "避世丹"

STRINGS.NAMES.SS_POOL = "涌动源泉"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SS_POOL = "涌动源泉"
STRINGS.RECIPE_DESC.SS_POOL = "附近的植物快速生长"

STRINGS.NAMES.SAN = "天眼"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SAN = "装备后无敌，且免疫水"
STRINGS.RECIPE_DESC.SAN = "天眼"

STRINGS.NAMES.BAMBOOBUSH = "火烧竹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BAMBOOBUSH = "每天可摘一花瓣"
STRINGS.RECIPE_DESC.BAMBOOBUSH = "火烧竹"

STRINGS.NAMES.DUG_BAMBOOBUSH = "捡起来的火烧竹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DUG_BAMBOOBUSH = "每天可摘一花瓣"
STRINGS.RECIPE_DESC.DUG_BAMBOOBUSH = "捡起来的火烧竹"

STRINGS.NAMES.TOSO_FENGYECAO = "枫叶草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_FENGYECAO = "作物可以用来制作春回灯"
STRINGS.RECIPE_DESC.TOSO_FENGYECAO = "作物制作春回灯"

STRINGS.NAMES.TOSO_FENGYECAO_ITEM = "枫叶草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_FENGYECAO_ITEM = "作物可以用来制作春回灯"
STRINGS.RECIPE_DESC.TOSO_FENGYECAO_ITEM = "作物制作春回灯"

STRINGS.NAMES.TOSO_JIUCAI = "韭菜"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_JIUCAI = "可以在丹炉做韭菜鸡蛋"
STRINGS.RECIPE_DESC.TOSO_JIUCAI = "做韭菜鸡蛋"

STRINGS.NAMES.TOSO_JIUCAI_ITEM = "韭菜"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_JIUCAI_ITEM = "可以在丹炉做韭菜鸡蛋"
STRINGS.RECIPE_DESC.TOSO_JIUCAI_ITEM = "做韭菜鸡蛋"

STRINGS.NAMES.TOSO_LINGCAO = "玲草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LINGCAO = "玲草会长花"
STRINGS.RECIPE_DESC.TOSO_LINGCAO = "玲草会长花"

STRINGS.NAMES.TOSO_LINGCAO_ITEM = "玲草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LINGCAO_ITEM = "玲草会长花"
STRINGS.RECIPE_DESC.TOSO_LINGCAO_ITEM = "玲草会长花"

STRINGS.NAMES.TOSO_LUDENGLEFT = "路灯左"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LUDENGLEFT = "非常古风哦"
STRINGS.RECIPE_DESC.TOSO_LUDENGLEFT = "非常古风哦"

STRINGS.NAMES.TOSO_LUDENGLEFT_ITEM = "路灯左"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LUDENGLEFT_ITEM = "非常古风哦"
STRINGS.RECIPE_DESC.TOSO_LUDENGLEFT_ITEM = "非常古风哦"

STRINGS.NAMES.TOSO_LUDENGRIGHT = "路灯右"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LUDENGRIGHT = "非常古风哦"
STRINGS.RECIPE_DESC.TOSO_LUDENGRIGHT = "非常古风哦"

STRINGS.NAMES.TOSO_LUDENGRIGHT_ITEM = "路灯右"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LUDENGRIGHT_ITEM = "非常古风哦"
STRINGS.RECIPE_DESC.TOSO_LUDENGRIGHT_ITEM = "非常古风哦"

STRINGS.NAMES.TOSO_LVYINCAO = "绿银草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LVYINCAO = "绿银草"
STRINGS.RECIPE_DESC.TOSO_LVYINCAO = "绿银草"

STRINGS.NAMES.TOSO_LVYINCAO_ITEM = "绿银草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LVYINCAO_ITEM = "绿银草"
STRINGS.RECIPE_DESC.TOSO_LVYINCAO_ITEM = "绿银草"

STRINGS.NAMES.TOSO_LVYINGHUA = "绿莹花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LVYINGHUA = "绿莹花"
STRINGS.RECIPE_DESC.TOSO_LVYINGHUA = "绿莹花"

STRINGS.NAMES.TOSO_LVYINGHUA_ITEM = "绿莹花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LVYINGHUA_ITEM = "绿莹花"
STRINGS.RECIPE_DESC.TOSO_LVYINGHUA_ITEM = "绿莹花"

STRINGS.NAMES.TOSO_YINHUA = "茵花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_YINHUA = "茵花"
STRINGS.RECIPE_DESC.TOSO_YINHUA = "茵花"

STRINGS.NAMES.TOSO_YINHUA_ITEM = "茵花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_YINHUA_ITEM = "茵花"
STRINGS.RECIPE_DESC.TOSO_YINHUA_ITEM = "茵花"

STRINGS.NAMES.TOSO_ZHIZI = "栀子花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_ZHIZI = "栀子花"
STRINGS.RECIPE_DESC.TOSO_ZHIZI = "栀子花"

STRINGS.NAMES.TOSO_ZHIZI_ITEM = "栀子花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_ZHIZI_ITEM = "栀子花"
STRINGS.RECIPE_DESC.TOSO_ZHIZI_ITEM = "栀子花"

STRINGS.NAMES.TOSO_ZIJINSHU = "子矜树"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_ZIJINSHU = "掉落发光浆果哦"
STRINGS.RECIPE_DESC.TOSO_ZIJINSHU = "掉落发光浆果哦"

STRINGS.NAMES.TOSO_ZIJINSHU_ITEM = "子矜树"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_ZIJINSHU_ITEM = "掉落发光浆果哦"
STRINGS.RECIPE_DESC.TOSO_ZIJINSHU_ITEM = "掉落发光浆果哦"

STRINGS.NAMES.ZHONGXIN = "龙魂殿石板"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ZHONGXIN = "禁止装入活物"
STRINGS.RECIPE_DESC.ZHONGXIN = "可以装很多东西哦"

STRINGS.NAMES.JIUCAI = "摘下来的韭菜"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.JIUCAI = "拿去做韭菜鸡蛋哦"
STRINGS.RECIPE_DESC.JIUCAI = "摘下来的韭菜"

STRINGS.NAMES.FENGYE = "摘下来的枫叶草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FENGYE = "拿去做春回灯哦"
STRINGS.RECIPE_DESC.FENGYE = "摘下来的枫叶草"

STRINGS.NAMES.JIUCAIJIDAN = "韭菜鸡蛋"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.JIUCAIJIDAN = "很开胃"
STRINGS.RECIPE_DESC.JIUCAIJIDAN = "很开胃"

STRINGS.NAMES.CHUNHUIDENG = "春回灯"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.CHUNHUIDENG = "灭火神器，范围=灭火器，发光浆果添加燃料"
STRINGS.RECIPE_DESC.CHUNHUIDENG = "灭火神器"

STRINGS.NAMES.CHUIZI = "万古锤"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.CHUIZI = "无限耐久锤子"
STRINGS.RECIPE_DESC.CHUIZI = "万古锤"

STRINGS.NAMES.FUTOU = "开天斧"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FUTOU = "无限耐久工具"
STRINGS.RECIPE_DESC.FUTOU = "开天斧"

STRINGS.NAMES.SSWORD_BOWM2 = "无限失落之弓"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSWORD_BOWM2 = "无限失落之弓"
STRINGS.RECIPE_DESC.SSWORD_BOWM2 = "无限失落之弓"

STRINGS.NAMES.SWORD_4 = "灭神剑"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SWORD_4 = "灭神剑"
STRINGS.RECIPE_DESC.SWORD_4 = "灭神剑"

STRINGS.NAMES.SSWALKINGSTICK = "无限手杖"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SSWALKINGSTICK = "无限手杖"
STRINGS.RECIPE_DESC.SSWALKINGSTICK = "无限手杖"

STRINGS.NAMES.PELLET_GAIMIN = "改命丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_GAIMIN = "灵根瞬间满级"
STRINGS.RECIPE_DESC.PELLET_GAIMIN = "灵根瞬间满级"

STRINGS.NAMES.PELLET_SHANBI = "闪避丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_SHANBI = "闪避丹"
STRINGS.RECIPE_DESC.PELLET_SHANBI = "闪避丹"

STRINGS.NAMES.PELLET_ATKTIME = "攻速丹"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PELLET_ATKTIME = "攻速丹"
STRINGS.RECIPE_DESC.PELLET_ATKTIME = "攻速丹"

STRINGS.NAMES.TOSO_LINGCAO_FLOWER = "玲草的花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOSO_LINGCAO_FLOWER = "用于炼制闪避丹"
STRINGS.RECIPE_DESC.TOSO_LINGCAO_FLOWER = "用于炼制闪避丹"

STRINGS.NAMES.SHOUHUO = "收获秘籍"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SHOUHUO = "一键收获周围农作物"
STRINGS.RECIPE_DESC.SHOUHUO = "一键收获周围农作物"

STRINGS.NAMES.BOSS_SESSHOUMARU = "世界BOSS杀生丸"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BOSS_SESSHOUMARU = "顶级化神高手"
STRINGS.RECIPE_DESC.BOSS_SESSHOUMARU = "顶级化神高手"

STRINGS.NAMES.ARM_MEILAOBAN = "煤老板"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARM_MEILAOBAN = "煤老板"
STRINGS.RECIPE_DESC.ARM_MEILAOBAN = "煤老板"
-- You can also add any kind of custom dialogue that you would like. Don't forget to make
-- categores that don't exist yet using = {}
-- note: these are UPPER-CASE charcacter name



-- Let the game know Wod is a male, for proper pronouns during the end-game sequence.
-- Possible genders here are MALE, FEMALE, or ROBOT
table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "ssword")


AddModCharacter("ssword")
AddSimPostInit(function(inst) PostInit(inst) end)