require "class"
require "bufferedaction"


Action = Class(function(self, data, priority, instant, rmb, distance) 
    self.priority = priority or 0
    self.fn = function() return false end
    self.strfn = nil
    self.testfn = nil
    self.instant = instant or false
    self.rmb = rmb or nil
    self.distance = distance or nil
    self.mount_enabled = data.mount_enabled or false
end)

ACTIONS=
{

    CASTSPELL = Action({mount_enabled=true},3, false, true, 20),

}

for k,v in pairs(ACTIONS) do
    v.str = STRINGS.ACTIONS[k] or "ACTION"
    v.id = k
end

----set up the action functions!


ACTIONS.CASTSPELL.strfn = function(act)
    local targ = act.invobject
    
    if targ and targ.components.spellcaster then
        return targ.components.spellcaster.actiontype
    end
end

ACTIONS.CASTSPELL.fn = function(act)
    --For use with magical staffs
    local staff = act.invobject or act.doer.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)

    if staff and staff.components.spellcaster and staff.components.spellcaster:CanCast(act.doer, act.target, act.pos) then
        staff.components.spellcaster:CastSpell(act.target, act.pos)
        return true
    end
end
