local STRINGS = GLOBAL.STRINGS
local Recipe = GLOBAL.Recipe
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
local State = GLOBAL.State
local SpawnPrefab = GLOBAL.SpawnPrefab
local TimeEvent = GLOBAL.TimeEvent
local FRAMES = GLOBAL.FRAMES
local TheInput = GLOBAL.TheInput
local Vector3 = GLOBAL.Vector3
local FindEntity =GLOBAL.FindEntity
local TUNING = GLOBAL.TUNING
local GetPlayer = GLOBAL.GetPlayer
local GetWorld = GLOBAL.GetWorld
local GetClock = GLOBAL.GetClock
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local GROUND = GLOBAL.GROUND
local EventHandler = GLOBAL.EventHandler
local ActionHandler = GLOBAL.ActionHandler

local GHOSTSHADOW = GLOBAL.Action({},-1,false,true,10)      --鬼影斩触发
GHOSTSHADOW.id = "鬼影斩"
GHOSTSHADOW.str = "GHOSTSHADOW"
GHOSTSHADOW.fn = function(act)
    if GHOSTSHADOW.CanCast(act.doer,act.target) then
        GHOSTSHADOW.Cast(act.doer,act.target)
    end
    return true
end
GHOSTSHADOW.CanCast = function(doer,target,right) 
        local weapon = doer.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
    if doer and target 
        and doer.components.shaqi and doer.components.shaqi:GetPercent() >= 0.2  --怒气大于等于3
        and not (doer.components.driver and doer.components.driverdriving)                 --不在船上
        and target.components.onikiricombat and target.components.onikiricombat:CanBeAttacked() --目标可攻击
		and weapon.prefab  ~= "surfboard_item_toso"
        then
        return true
    end
end

GHOSTSHADOW.Cast = function(doer,target) 
    if GHOSTSHADOW.CanCast(doer,target) then
        local weapon = doer.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
        doer:PushEvent("onikiri_gs_attack",{weapon = weapon,target=target})
    end
end
GHOSTSHADOW.Attack = function(doer,target)
    if target and target:IsValid() then
        local weapon = doer.components.combat:GetWeapon()
        --print(weapon)
        local damage = doer.components.combat:CalcDamage(target,weapon)
        --四次斩击伤害
        target.components.combat:GetAttacked(doer,damage,weapon)
        target.components.combat:GetAttacked(doer,damage,weapon)
        target.components.combat:GetAttacked(doer,damage,weapon)
        target.components.combat:GetAttacked(doer,damage,weapon)

    end
end
AddAction(GHOSTSHADOW)
AddStategraphActionHandler("wilson",ActionHandler(ACTIONS.GHOSTSHADOW, "onikiri_gs_pre"))


AddStategraphState("wilson", 
    State{
        name = "onikiri_gs_pre",
        tags = { "doing", "busy", "nointerrupt", "nomorph","not_hit_stunned" },

        onenter = function(inst)
            inst.components.locomotor:Stop()
            local buff = inst:GetBufferedAction()
            if buff and buff.target and buff.target:IsValid() then
                if buff.target.components.combat and buff.target.components.combat:CanBeAttacked() then
                    --面向对方
                    local pos = buff.target:GetPosition()
                    if pos then
                        inst:ForceFacePoint(pos:Get())
						                    --inst.components.talker:Say("能到这")
                    end
                    --起手
                    inst.AnimState:PlayAnimation("atk")
                    SpawnPrefab("laser_explosion").Transform:SetPosition(inst:GetPosition():Get())
                else
                    --不能攻击
                    inst.components.talker:Say("不能攻击")
                    inst.sg:GoToState("idle")
                end
            else
                --你怎么进来的 滚
                inst.sg:GoToState("idle")
				inst.components.talker:Say("不能攻击2")
            end
        end,

        timeline =
        {
            TimeEvent(4 * FRAMES, function(inst)
                --呃 单机没这音效 先空着吧
                --inst.SoundEmitter:PlaySound("onikiri/DST/twirl_lava_weapons", nil, nil, true)
            end),
        },

        events =
        {
            EventHandler("onikiri_gs_attack", function(inst, data)
                inst.sg:GoToState("onikiri_gs_attack", data)
            end),
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() then
                    --if inst.AnimState:IsCurrentAnimation("atk") then
                        inst.AnimState:PlayAnimation("chop_loop")
                        inst:PerformBufferedAction()
                    --else
                        inst.sg:GoToState("idle")
                    --end
                end
            end),
            EventHandler("unequip", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    }
    )

-- local function MakeFx(inst,weapon,pos)
    -- local data = inst.sg.statemem.data
    -- data.targetpos = data.target:IsValid() and data.target:GetPosition() or data.targetpos  --目标有效则重取坐标
    -- local maindata = {}
    -- maindata.doer = inst
    -- maindata.weapon = "onikiri_weapon_".. (inst.components.onikirisave.unlock[weapon] and weapon or "default")
    -- maindata.target = data.target
    -- maindata.targetpos = data.targetpos
    -- maindata.pos = data.targetpos + pos
    -- local mainfx = SpawnPrefab("onikiri_shadow")    --召唤分身
    -- mainfx:MainStart(maindata)
-- end
local function MakeFx2(inst,x,z)
    local data = inst.sg.statemem.data
    data.targetpos = data.target:IsValid() and data.target:GetPosition() or data.targetpos  --目标有效则重取坐标
    inst.Physics:Teleport(data.targetpos.x+x, 0, data.targetpos.z+z)
    inst:ForceFacePoint(data.targetpos:Get())
    inst.AnimState:PlayAnimation("bow_attack")
    --SpawnPrefab("onikiri_weapon_fx1"):Bind(data.target)  --根本看不见
    SpawnPrefab("laserhit"):SetTarget(data.target)
    local explosion = SpawnPrefab("laser_explosion")
    explosion.Transform:SetPosition(data.targetpos:Get())  
    explosion.Transform:SetScale(0.7,0.7,0.7)
end
  
AddStategraphState("wilson",
    State{
        name = "onikiri_gs_attack",
        tags = {"doing", "busy","nointerrupt","nomorph","not_hit_stunned" },

        onenter = function(inst, data)
            inst.sg:SetTimeout(3) --超时三秒防止卡死
            if data and data.target and
                data.target:IsValid()
                --and inst.AnimState:IsCurrentAnimation("chop_loop") 
				then
                --inst.onikiri_god = true     --攻击雷电等也会被丢弃
                inst.onikiri_isInvincible = inst.components.health.invincible   --记录原来的无敌状态 防止误清
                inst.components.health:SetInvincible(true)  --传送期间生命值无敌
                inst.AnimState:PlayAnimation("bow_attack",false)
                local pos = inst:GetPosition()
                local targetpos = data.target:GetPosition()
                if targetpos == pos then
                    targetpos = targetpos + Vector3(0.1,0,0.1)
                end
                data.targetpos = targetpos
                --记录当前位置
                inst.sg.statemem.oldpos = pos 
                local newpos = targetpos - pos
                newpos = newpos:GetNormalized() * 2  + newpos
                local telpos = newpos + pos --额外偏移2距离 到身后 去摆pose
                
                inst:ForceFacePoint(telpos:Get()) -- 面向最终方向
                --么得音效 先空着吧
                inst.Physics:Teleport(telpos.x, 0, telpos.z)
                --inst.components.onikirighostfire:use(3)
                inst.components.health:DoDelta(-1)
                --生成残影
                 for i=0,3,1 do
                    local fxpos = newpos*((i+1)/5)+ pos
                    local fxdata = {
                        doer = inst,
                        weapon = data.weapon.prefab,
                        pos  = fxpos ,
                        target = data.target,
                        telpos = telpos
                    }
                    --local fx = SpawnPrefab("onikiri_shadow")
                    --fx:FXStart(fxdata,i)
                end
                inst.sg.statemem.data = data    --记录当前数据
            else
            --Failed
            inst.sg:GoToState("idle", true)
            end
        end,

        timeline =
        {
            --残影版
            -- TimeEvent(11 * FRAMES, function(inst)   --11帧之后停止动画
                -- inst.AnimState:Pause()
                -- inst.entity:Hide(false)
            -- end),
            -- TimeEvent(12 * FRAMES, function(inst)   --第一分身 
                -- MakeFx(inst,"shizizhizi",Vector3(-4.5,0,-6))
            -- end),
            -- TimeEvent(22 * FRAMES, function(inst)   --第二分身 
                -- MakeFx(inst,"youqie",Vector3(0,0,7.5))
            -- end),
            -- TimeEvent(32 * FRAMES, function(inst)   --第三分身 
                -- MakeFx(inst,"ziqie",Vector3(4.5,0,-6))
            -- end),
            -- TimeEvent(66 * FRAMES, function(inst)   --66帧之后整个技能结
                -- inst.Physics:Teleport(inst.sg.statemem.oldpos:Get())
                -- inst.AnimState:PlayAnimation("idle",true)
                -- --结算伤害
                -- GHOSTSHADOW.Attack(inst,inst.sg.statemem.data.target)
                -- if inst.AnimState:AnimDone() then
                    -- inst.sg:GoToState("idle")
                -- end
            -- end),
            
            TimeEvent(11 * FRAMES, function(inst)   --二斩
                MakeFx2(inst,-0.5,-0.5)
            end),
            TimeEvent(22 * FRAMES, function(inst)   --三斩
                MakeFx2(inst,0,0.5)
            end),
            TimeEvent(33 * FRAMES, function(inst)   --四斩 
                MakeFx2(inst,0.5,0.5)
            end),
            TimeEvent(44 * FRAMES, function(inst)   --44帧之后整个技能结
                inst.Physics:Teleport(inst.sg.statemem.oldpos:Get())
                inst.AnimState:PlayAnimation("idle",true)
                --结算伤害
                GHOSTSHADOW.Attack(inst,inst.sg.statemem.data.target)
                inst.sg:GoToState("idle")
            end),
        },
        
        ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end,
        onexit = function(inst)
            -- inst.AnimState:Resume()
            -- inst.entity:Hide(false)
            --inst.onikiri_god = false
            if not inst.onikiri_isInvincible then
                inst.components.health:SetInvincible(false)
            end
            inst.Physics:Teleport(inst.sg.statemem.oldpos:Get())
        end,
    }
)
    
