local assets =
{
    Asset("ANIM", "anim/hat_ruineye.zip"),
 	Asset("IMAGE","images/inventoryimages/hat_ruineye.tex"),
	Asset("ATLAS","images/inventoryimages/hat_ruineye.xml")
}

local prefabs =
{
	--"weevole_carapace",
}


--开关
local function unfoldit(inst)
local owner = inst.components.inventoryitem.owner
	if not inst.lighton then--and owner.level >=5
	
	inst.Light:Enable(true)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(0.7)
    inst.Light:SetColour(128/255,128/255,255/255)



		inst.lighton = true
	else

	inst.Light:Enable(false)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(0.7)
    inst.Light:SetColour(128/255,128/255,255/255)


		inst.lighton = false
	end
	
	inst.components.useableitem.inuse = false
end



---BLUE冰冻敌人
local function onequip_blue(inst, owner) 
        owner.AnimState:OverrideSymbol("swap_hat", "hat_ruineye", "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Hide("HAIR_HAT")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")
        
        owner.AnimState:Show("HEAD")
        owner.AnimState:Hide("HEAD_HAIR")
    --免疫火
    if owner.components.health then
        owner.components.health.fire_damage_scale = owner.components.health.fire_damage_scale - TUNING.ARMORDRAGONFLY_FIRE_RESIST
    end
	
    inst.freezefn = function(attacked, data)
        if data and data.attacker and data.attacker.components.freezable then
            data.attacker.components.freezable:AddColdness(0.67)
            data.attacker.components.freezable:SpawnShatterFX()
            --inst.components.fueled:DoDelta(-(inst.components.fueled.maxfuel * 0.03))
        end 
    end

    inst:ListenForEvent("attacked", inst.freezefn, owner)

    --if inst.components.fueled then
        --inst.components.fueled:StartConsuming()        
    --end

	
	inst.Light:Enable(false)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(0.7)
    inst.Light:SetColour(128/255,128/255,255/255)
	inst.lighton = false
	
	inst.components.useableitem.inuse = false
end

local function onunequip_blue(inst, owner) 
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAIR_HAT")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")

        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAIR")
        end

    inst:RemoveEventCallback("attacked", inst.freezefn, owner)

    if owner.components.health then
        owner.components.health.fire_damage_scale = owner.components.health.fire_damage_scale + TUNING.ARMORDRAGONFLY_FIRE_RESIST
    end

    --if inst.components.fueled then
        --inst.components.fueled:StopConsuming()        
    --end
	inst.Light:Enable(false)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(0.7)
    inst.Light:SetColour(128/255,128/255,255/255)
    inst.lighton = false
end

local function ontakefuel(inst)

    if inst.components.armor.condition and inst.components.armor.condition < 0 then
        inst.components.armor:SetCondition(0)

    end
	--inst.components.fueled:DoDelta(150)
    inst.components.armor:SetCondition( inst.components.armor.condition + 500*2*TUNING.DIFFICULTY )
    --GetPlayer().components.sanity:DoDelta(-TUNING.SANITY_TINY)
    GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/add_fuel")  
end




local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()    
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("ruinshat")
    inst.AnimState:SetBuild("hat_ruineye")
    inst.AnimState:PlayAnimation("anim")
	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "hat_ruineye.tex" )
	
	inst.entity:AddLight()
	inst.Light:Enable(false)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(0.7)
    inst.Light:SetColour(128/255,128/255,255/255)
	
	inst.lighton = false	
	

	MakeInventoryFloatable(inst, "idle_water", "anim")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    --inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/logarmour"
	inst.components.inventoryitem.imagename = "hat_ruineye"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/hat_ruineye.xml"

    inst:AddComponent("armor")
    inst.components.armor:InitCondition(1600*2*TUNING.DIFFICULTY, 0.6)
    inst.components.armor.dontremove = true
	
    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "NIGHTMARE"
    inst.components.fueled:InitializeFuelLevel(4 * TUNING.LARGE_FUEL)

    inst.components.fueled.ontakefuelfn = ontakefuel
    inst.components.fueled.accepting = true

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable:SetOnEquip( onequip_blue )
    inst.components.equippable:SetOnUnequip( onunequip_blue )
    --inst:AddComponent("heater")
    --inst.components.heater.iscooler = true
    --inst.components.heater.equippedheat = TUNING.BLUEGEM_COOLER
	
	inst:AddComponent("useableitem")
    inst.components.useableitem:SetOnUseFn(unfoldit)
	

    return inst
end

return Prefab("armor2_ssword", fn, assets)
