
local assets = 
{
	--Asset("ANIM", "anim/nz_damask.zip"),
	--Asset("ANIM", "anim/white_vortex_cloak_fx.zip"),
	Asset("ANIM", "anim/armor_vortex_cloak.zip"),
    Asset("ANIM", "anim/cloak_fx.zip"),
    Asset("MINIMAP_IMAGE", "armor_vortex_cloak"),
}

local function setsoundparam(inst)
    local param = Remap(inst.components.armor.condition, 0, inst.components.armor.maxcondition,0, 1 ) 
    print(param)
    --inst.SoundEmitter:SetParameter( "vortex", "intensity", param )
end

local function spawnwisp(owner)
    local wisp = SpawnPrefab("armorvortexcloak_fx")
    local x,y,z = owner.Transform:GetWorldPosition()
    wisp.Transform:SetPosition(x+math.random()*0.25 -0.25/2,y,z+math.random()*0.25 -0.25/2)    
end

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_body", "armor_vortex_cloak", "swap_body")  
    owner.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/equip_off")
    local function OnBlocked()
        if inst.components.armor.condition and inst.components.armor.condition > 0 then
            owner:AddChild(SpawnPrefab("vortex_cloak_fx"))                    
        end        
        setsoundparam(inst)
    end
    inst.OnBlocked = OnBlocked

  --  inst:ListenForEvent("blocked", inst.OnBlocked, owner) -- function(inst,data) OnBlocked(owner,inst) end
  --  inst:ListenForEvent("attacked", inst.OnBlocked, owner)      -- function(inst,data) OnBlocked(owner,inst) end
    inst:ListenForEvent("armorhit", inst.OnBlocked)

    owner:AddTag("not_hit_stunned")
    owner.components.inventory:SetOverflow(inst)
    inst.components.container:Open(owner)    
    inst.wisptask = inst:DoPeriodicTask(0.1,function() spawnwisp(owner) end)  

    inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/LP","vortex") 
    setsoundparam(inst)
    
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")  
    owner.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/equip_on")
    inst:RemoveEventCallback("armorhit", inst.OnBlocked)
    owner:RemoveTag("not_hit_stunned")
    owner.components.inventory:SetOverflow(nil)
    inst.components.container:Close(owner)    
    if inst.wisptask then
        inst.wisptask:Cancel()
        inst.wisptask= nil
    end

    inst.SoundEmitter:KillSound("vortex")
	
end

local slotpos = {}

for y = 0, 3 do
    table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
    table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end

local function ontakefuel(inst)
    if inst.components.armor.condition and inst.components.armor.condition < 0 then
        inst.components.armor:SetCondition(0)
    end
    inst.components.armor:SetCondition( math.min( inst.components.armor.condition + (inst.components.armor.maxcondition/20), inst.components.armor.maxcondition) )
    GetPlayer().components.sanity:DoDelta(-TUNING.SANITY_TINY)
    GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/add_fuel")  
end



local function Fx()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst.AnimState:SetBank('vortex_cloak_fx')
	inst.AnimState:SetBuild('white_vortex_cloak_fx')
	inst.AnimState:PlayAnimation('idle')

	inst.AnimState:SetMultColour(0.7,0,0,0.5) --粉

	inst:ListenForEvent('animover',inst.Remove)

	return inst
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst:AddTag('irreplaceable')

	inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("nz_damask.tex")

	MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle_water', 'idle')

	inst.AnimState:SetBank('nz_damask')
	inst.AnimState:SetBuild('nz_damask')
	inst.AnimState:PlayAnimation("idle")

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"


	inst:AddComponent("fueled")
	inst.components.fueled.accepting = true
	inst.components.fueled.fueltype = 'LILYPAD_FLOWER'
	inst.components.fueled:InitializeFuelLevel(100)

	local attacked_cool_down = 5*FRAMES
	inst:AddComponent('armor')
	inst.components.armor:InitCondition(1,1)
	inst.components.armor.last_take_damage_time = 0
	inst.components.armor.GetPercent = function(...)
		return inst.components.fueled:GetPercent()
	end
	inst.components.armor.TakeDamage = function(self,damage_amount,...)
		if damage_amount == 0 then
			return 0
		end
		if self.inst.components.fueled:IsEmpty() then
			return damage_amount
		end
		if GetTime()- self.last_take_damage_time <= attacked_cool_down then
			return 0
		else
			self.last_take_damage_time = GetTime()
			self.inst.components.fueled:DoDelta(-10)
			Fx().Transform:SetPosition(self.inst:GetPosition():Get())
			return 0
		end
	end

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	inst.components.equippable.walkspeedmult = 0.1
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)

	return inst
end
--'Sky Muddling Damask'
return Prefab('nz_damask',fn,assets)