require "brains/boss_krampusbrain"
require "stategraphs/SGboss_krampus"

local assets=
{
	Asset("ANIM", "anim/krampus_basic.zip"),
	Asset("ANIM", "anim/krampus_build.zip"),

    Asset("ANIM", "anim/krampus_hawaiian_basic.zip"),
    Asset("ANIM", "anim/krampus_hawaiian_build.zip"),

	Asset( "IMAGE", "images/map_icons/arm_bro2.tex" ),
	Asset( "ATLAS", "images/map_icons/arm_bro2.xml" ),

	Asset("SOUND", "sound/krampus.fsb"),
}

local prefabs =
{
	"charcoal",
	"monstermeat",
	"krampus_sack",
}

SetSharedLootTable( 'krampus',
{
    {'monstermeat',  1.0},
    {'charcoal',     1.0},
    {'charcoal',     1.0},
    {'krampus_sack', .1},
})

local function on_close(inst)
inst.krampus_lingyu = inst:DoPeriodicTask(10, function()
    --inst.sg:GoToState("steal")
			inst.SoundEmitter:PlaySound("dontstarve/creatures/krampus/growllong")
            inst.AnimState:PlayAnimation("steal_pre")
            inst.AnimState:PushAnimation("steal", false)

inst:DoTaskInTime(1.5, function() 
local player = GetPlayer()  
if not player.components.driver.vehicle then
player.sg:GoToState("electrocute")
end

end)

end)

end 

local function far(inst)

		if inst and inst.krampus_lingyu then inst.krampus_lingyu:Cancel() inst.krampus_lingyu = nil end


end

local function OnHitOther(inst, data)
    local other = data.target
    if other and other:HasTag("player") then
       other.sg:GoToState("passout")
    end
end

local function assasin_hunt(inst)
    --local dist = 40
    return FindEntity(inst, TUNING.ZHUISHAJULI, function(guy)
            return ( guy:HasTag("player") or guy:HasTag("yamche"))
			and not guy:HasTag("toso_arm")
			 and guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end)
		end

local function Onhunt(inst, target)
    return inst.components.combat:CanTarget(target) and not target:HasTag("toso_arm")
end

local function makebagfull(inst)
	inst.AnimState:Show("SACK")
	inst.AnimState:Hide("ARM")
end 

local function makebagempty(inst)
	inst.AnimState:Hide("SACK")
	inst.AnimState:Show("ARM")
end 

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
    --inst.components.combat:ShareTarget(data.attacker, SEE_DIST, function(dude) return dude:HasTag("hound") and not dude.components.health:IsDead() end, 5)
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local physics = inst.entity:AddPhysics()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 3, 1 )
    inst.Transform:SetFourFaced()
	inst.AnimState:Hide("ARM")
	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "krampus.tex" )
	
	inst:AddTag("scarytoprey")
	
    MakePoisonableCharacter(inst)
--两栖地 
    MakeAmphibiousCharacterPhysics(inst, 0, .5)

    inst:AddComponent("inventory")
    inst.components.inventory.ignorescangoincontainer = true

    if SaveGameIndex:IsModeShipwrecked() then
        anim:SetBank("krampus")
        anim:SetBuild("krampus_hawaiian_build")
    else 
        anim:SetBank("krampus")
        anim:SetBuild("krampus_build")
    end 
   

    anim:PlayAnimation("run_loop", true)
    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.runspeed = 30
    inst:SetStateGraph("SGboss_krampus")

    inst:AddTag("monster")
    inst:AddTag("hostile")
	--所有敌对人形怪
	inst:AddTag("groundpoundimmune")
	inst:AddTag("toso_arm")
    inst:AddTag("toso_armboss")	

    local brain = require "brains/boss_krampusbrain"
    inst:SetBrain(brain)
    
    MakeLargeBurnableCharacter(inst, "krampus_torso")
    MakeLargeFreezableCharacter(inst, "krampus_torso")
    
 --[[   inst:AddComponent("eater")
    inst.components.eater:SetCarnivore()
	inst.components.eater:SetCanEatHorrible()
    inst.components.eater.strongstomach = true -- can eat monster meat!--]]
 
local player = GetPlayer() 
    inst:AddComponent("sleeper")
    inst:AddComponent("health")
		--生命护甲数值
	inst.components.health:SetMaxHealth(240000+player.level*TUNING.ARM_HEALTHUP)
    inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)
    
    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "krampus_torso"
	--攻速攻击力数值
	 inst.components.combat:SetDefaultDamage(400+player.level*20)
	inst.components.combat:SetAttackPeriod(TUNING.ARM_ATKSPEED*0.5)
	
    inst.components.combat:SetRetargetFunction(0, assasin_hunt)
	inst.components.combat:SetKeepTargetFunction(Onhunt)

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('krampus')
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:RecordViews()
    
    inst:ListenForEvent("attacked", OnAttacked)
    inst:ListenForEvent("onhitother", OnHitOther)--击倒
	--成长护甲
	inst.task_always = inst:DoPeriodicTask(2, function()
	local player = GetPlayer()


	
if player.level > 10 and player.level <= 20 then
inst.components.health:SetAbsorptionAmount(0.91)
elseif player.level > 20 and player.level <= 30 then
inst.components.health:SetAbsorptionAmount(0.92)	
elseif player.level > 30 and player.level <= 40 then
inst.components.health:SetAbsorptionAmount(0.93)
elseif player.level > 40 and player.level <= 50 then
inst.components.health:SetAbsorptionAmount(0.94)
elseif player.level > 50 and player.level <= 60 then
inst.components.health:SetAbsorptionAmount(0.95)
elseif player.level > 60 and player.level <= 70 then
inst.components.health:SetAbsorptionAmount(0.96)
elseif player.level > 70 and player.level <= 80 then
inst.components.health:SetAbsorptionAmount(0.97)
elseif player.level > 80 and player.level <= 90 then
inst.components.health:SetAbsorptionAmount(0.98)
elseif player.level > 90 then
inst.components.health:SetAbsorptionAmount(0.99)
else
inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)
end	
	
	end)
    --领域
    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(30, 30)
    inst.components.playerprox:SetOnPlayerNear(on_close)
    inst.components.playerprox:SetOnPlayerFar(far)
	
	inst:DoPeriodicTask(900, function() 
	inst:DoTaskInTime(1.5, function()  SpawnPrefab("lightning").Transform:SetPosition(inst:GetPosition():Get())
	--inst:DoTaskInTime(0.25, function() SpawnPrefab("lightning").Transform:SetPosition(inst:GetPosition():Get()) 
	
	inst:DoTaskInTime(10, function() 
	--SpawnPrefab("lightning").Transform:SetPosition(inst:GetPosition():Get())
	local player = GetPlayer()	
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = player.Transform:GetWorldPosition()	
            --local arm2 = inst
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            inst.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
			inst.SoundEmitter:PlaySound("dontstarve/common/craftable/lightning_rod")
            SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get()) 			
	
	end) 
	end) 
	end)

    return inst
end


return Prefab( "monsters/boss_krampus", fn, assets, prefabs) 
