require "brains/boss_rockybrain"
require "stategraphs/SGboss_rocky"

local assets =
{
	Asset("ANIM", "anim/rocky.zip"),
    Asset("SOUND", "sound/rocklobster.fsb"),
}

local prefabs =
{
	"rocks",
}


local colours =
{
    {1,1,1},
    --{174/255,158/255,151/255},
    {167/255,180/255,180/255},
    {159/255,163/255,146/255}
}

local function LaunchItem(inst, target, item)
    if item.Physics then

        local x, y, z = item:GetPosition():Get()
        y = .1
        item.Physics:Teleport(x,y,z)

        local hp = target:GetPosition()
        local pt = inst:GetPosition()
        local vel = (hp - pt):GetNormalized()     
        local speed = 5 + (math.random() * 2)
        local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
        item.Physics:SetVel(math.cos(angle) * speed, 10, math.sin(angle) * speed)

    end
end

local function on_close(inst)
inst.rocky_lingyu = inst:DoPeriodicTask(15, function()
--if inst:GetDistanceSqToInst(player) < 30 then
  --if not inst:HasTag("fukong") then
    --inst.sg:GoToState("taunt")
	inst.AnimState:PlayAnimation("taunt")




  --end
--end
inst:DoTaskInTime(1.5, function() 
			local player = GetPlayer()  
    if player and player.components.inventory and player.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
	--if math.random() <= 0.3 then
        local item = player.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
        if not item then return end
        player.components.inventory:DropItem(item)
        LaunchItem(inst, player, item)
	--end
    end

end)


end)

end 

local function far(inst)

		if inst and inst.rocky_lingyu then inst.rocky_lingyu:Cancel() inst.rocky_lingyu = nil end


end

local function assasin_hunt(inst)
    --local dist = 40
    return FindEntity(inst, TUNING.ZHUISHAJULI, function(guy)
            return ( guy:HasTag("player") or guy:HasTag("yamche"))
			and not guy:HasTag("toso_arm")
			 and guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end)
		end

local function Onhunt(inst, target)
    return inst.components.combat:CanTarget(target) and not target:HasTag("toso_arm")
end


local function ShouldSleep(inst)

    return inst.components.sleeper:GetTimeAwake() > TUNING.TOTAL_DAY_TIME*2
    --return false
end

local function ShouldWake(inst)
    return inst.components.sleeper:GetTimeAsleep() > TUNING.TOTAL_DAY_TIME*.5
end


local function OnAttacked(inst, data)

    local attacker = data.attacker
    inst.components.combat:SetTarget(attacker)
    inst.components.combat:ShareTarget(attacker, 20, function(dude) return dude.prefab == inst.prefab end, 2)

end


local function grow(inst, dt)

    if inst.components.scaler.scale < TUNING.ROCKY_MAX_SCALE then
        local new_scale = math.min(inst.components.scaler.scale + TUNING.ROCKY_GROW_RATE*dt, TUNING.ROCKY_MAX_SCALE)
        inst.components.scaler:SetScale(new_scale)
    else
        if inst.growtask then
            inst.growtask:Cancel()
            inst.growtask = nil
        end
    end
end

local function applyscale(inst, scale)
    --inst.components.combat:SetDefaultDamage(TUNING.ROCKY_DAMAGE*scale)
    --local percent = inst.components.health:GetPercent()
    --inst.components.health:SetMaxHealth(TUNING.ROCKY_HEALTH*scale)
    --inst.components.health:SetPercent(percent)
    MakeCharacterPhysics(inst, 200*scale, 1*scale)
    --inst.components.locomotor.walkspeed = 20
end


local function ShouldAcceptItem(inst, item)
    if item.components.edible and item.components.edible.foodtype == "ELEMENTAL" then
        return true
    end
end

local function OnGetItemFromPlayer(inst, giver, item)
    if item.components.edible and item.components.edible.foodtype == "ELEMENTAL" then
            if inst.components.combat.target and inst.components.combat.target == giver then
                inst.components.combat:SetTarget(nil)
            elseif giver.components.leader then
                inst.SoundEmitter:PlaySound("dontstarve/common/makeFriend")
                giver.components.leader:AddFollower(inst)
                inst.components.follower:AddLoyaltyTime(TUNING.ROCKY_LOYALTY)
                inst.sg:GoToState("rocklick")
            end
    end

    if inst.components.sleeper:IsAsleep() then
        inst.components.sleeper:WakeUp()
    end
end

local function OnRefuseItem(inst, item)
    if inst.components.sleeper:IsAsleep() then
        inst.components.sleeper:WakeUp()
    end
    inst:PushEvent("refuseitem")
end

local loot = {"rocks", "rocks", "meat", "flint", "flint"}

local function onsave(inst,data)
    data.colour = inst.colour_idx
end

local function onload(inst,data)
    if data and data.colour and data.colour > 0 and data.colour <= #colours then
        inst.colour_idx = data.colour
        inst.AnimState:SetMultColour(colours[inst.colour_idx][1],colours[inst.colour_idx][2],colours[inst.colour_idx][3],1)
    end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()

	--orange(186/255,158/255,139/255,1), blue(159/255,185/255,187/255,1), green(163/255,181/255,128/255,1)
    

    inst.colour_idx = math.random(#colours)
    inst.AnimState:SetMultColour(colours[inst.colour_idx][1],colours[inst.colour_idx][2],colours[inst.colour_idx][3],1)
	inst.Transform:SetFourFaced()

--两栖地 
    MakeAmphibiousCharacterPhysics(inst, 0, .5)

    inst:AddTag("rocky")
    inst:AddTag("character")
    inst:AddTag("animal")

    anim:SetBank("rocky")
	anim:SetBuild("rocky")
	anim:PlayAnimation("idle_loop", true)
local player = GetPlayer() 
    inst:AddComponent("combat")
	--攻速攻击力数值
	 inst.components.combat:SetDefaultDamage(400+player.level*20)
	inst.components.combat:SetAttackPeriod(TUNING.ARM_ATKSPEED*0.5)---min_attack_period
    inst.components.combat:SetRange(4)
    inst.components.combat:SetRetargetFunction(0, assasin_hunt)
	inst.components.combat:SetKeepTargetFunction(Onhunt)


    inst.entity:AddDynamicShadow()
    inst.DynamicShadow:SetSize( 1.75, 1.75 )
    

    inst:AddComponent("knownlocations")
    inst:AddComponent("herdmember")
    inst.components.herdmember.herdprefab = "rockyherd"
    inst:AddComponent("inventory")
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot(loot)



    inst:AddComponent("follower")
    inst.components.follower.maxfollowtime = TUNING.PIG_LOYALTY_MAXTIME    
    
    inst:AddComponent("scaler")
    inst.components.scaler.OnApplyScale = applyscale


    --inst:AddComponent("sleeper")
    --inst.components.sleeper:SetResistance(3)
    --inst.components.sleeper:SetWakeTest(ShouldWake)
    --inst.components.sleeper:SetSleepTest(ShouldSleep)


    inst:AddComponent("health")
		--生命护甲数值
	inst.components.health:SetMaxHealth(240000+player.level*TUNING.ARM_HEALTHUP)
    inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)

	inst:AddComponent("inspectable")

    --inst:AddComponent("eater")
    --inst.components.eater:SetElemental()

    inst:AddComponent("locomotor")
    inst.components.locomotor:SetSlowMultiplier( 1 )
    inst.components.locomotor:SetTriggersCreep(false)
    inst.components.locomotor.pathcaps = { ignorecreep = false }
    inst.components.locomotor.walkspeed = 20



    --inst:AddComponent("trader")
    --inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    --inst.components.trader.onaccept = OnGetItemFromPlayer
    --inst.components.trader.onrefuse = OnRefuseItem
    --inst.components.trader:Enable()
	--成长护甲
	inst.task_always = inst:DoPeriodicTask(2, function()
	local player = GetPlayer()


	
if player.level > 10 and player.level <= 20 then
inst.components.health:SetAbsorptionAmount(0.91)
elseif player.level > 20 and player.level <= 30 then
inst.components.health:SetAbsorptionAmount(0.92)	
elseif player.level > 30 and player.level <= 40 then
inst.components.health:SetAbsorptionAmount(0.93)
elseif player.level > 40 and player.level <= 50 then
inst.components.health:SetAbsorptionAmount(0.94)
elseif player.level > 50 and player.level <= 60 then
inst.components.health:SetAbsorptionAmount(0.95)
elseif player.level > 60 and player.level <= 70 then
inst.components.health:SetAbsorptionAmount(0.96)
elseif player.level > 70 and player.level <= 80 then
inst.components.health:SetAbsorptionAmount(0.97)
elseif player.level > 80 and player.level <= 90 then
inst.components.health:SetAbsorptionAmount(0.98)
elseif player.level > 90 then
inst.components.health:SetAbsorptionAmount(0.99)
else
inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)
end	
	
	end)
    --领域
    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(30, 30)
    inst.components.playerprox:SetOnPlayerNear(on_close)
    inst.components.playerprox:SetOnPlayerFar(far)

	local brain = require "brains/boss_rockybrain"
    inst:SetBrain(brain)
	inst:SetStateGraph("SGboss_rocky")

    inst:ListenForEvent("attacked", OnAttacked)

    local scaleRange = TUNING.ROCKY_MAX_SCALE - TUNING.ROCKY_MIN_SCALE
    local start_scale = TUNING.ROCKY_MIN_SCALE + math.random() * scaleRange

    inst.components.scaler:SetScale(start_scale)
    local dt = 60+math.random()*10
    inst.growtask = inst:DoPeriodicTask(dt, grow, nil, dt)
    inst.components.scaler:SetScale(TUNING.ROCKY_MIN_SCALE)
	
    inst.OnLongUpdate = grow

    inst.OnSave = onsave
    inst.OnLoad = onload

    return inst
end

return Prefab("cave/monsters/boss_rocky", fn, assets, prefabs)
