require "brains/spiderqueenbrain"
require "stategraphs/SGboss_spiderqueen"

local assets =
{
	Asset("ANIM", "anim/spider_queen_build.zip"),
	Asset("ANIM", "anim/spider_queen.zip"),
	Asset("ANIM", "anim/spider_queen_2.zip"),
	--Asset("ANIM", "anim/spider_queen_3.zip"),
	--Asset("SOUND", "sound/spider.fsb"),
}

local prefabs =
{
    "monstermeat",
    "silk",
    "spiderhat",
    "spidereggsack",
}

local loot =
{
    "monstermeat",
    "monstermeat",
    "monstermeat",
    "monstermeat",
    "silk",
    "silk",
    "silk",
    "silk",
    "spidereggsack",
    "spiderhat",
}

local SHARE_TARGET_DIST = 30

local function SpawnIceFx(inst, postarget)
    if not inst or not postarget then return end
    local numFX = 6
    local pos = inst:GetPosition()
    local targetPos = postarget
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = inst:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        inst:DoTaskInTime(math.random() * 0.25, function(inst)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = GetRandomWithVariance(0, .5)
                local z = GetRandomWithVariance(0, .5)
                local offset = (vec * math.random(dist * 0.75, dist * 1.25)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
				fx.Transform:SetScale(1,2,1)
				local player = GetPlayer() 
				----冰柱伤害
				local pt = fx:GetPosition()
				local r = 1.33
				local center_dmg = 200+player.level*10
				local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "groundpoundimmune","toso_arm","shadowboss"})
				for k,v in pairs(ents) do
					if v and v.components.health and not v.components.health:IsDead() and v ~= inst and v.prefab ~= inst.prefab then
						
						--local dst = pt:Dist(v:GetPosition())
						--local dmg_mult = 1 - dst/r
						local dmg_mult = 1
						
						if v.components.combat and not v:HasTag("toso_arm") then
							v.components.combat:GetAttacked(inst, center_dmg)
						end
					end
				end				
				
            end
        end)
    end
end

local function on_close(inst)
inst.spiderqueen_lingyu = inst:DoPeriodicTask(15, function()
--if inst:GetDistanceSqToInst(player) < 30 then
    --inst.sg:GoToState("taunt")
	inst.AnimState:PlayAnimation("taunt")
	inst.SoundEmitter:PlaySound("dontstarve/creatures/spiderqueen/scream")
--end
	inst:DoTaskInTime(1, function()
				inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/ice") 
				if inst.components.combat.target then
					inst._target_pos = inst.components.combat.target:GetPosition()
				end
	end)
	inst:DoTaskInTime(1.5, function()
				if inst.components.combat.target then
					inst._target_pos1 = inst.components.combat.target:GetPosition()
				end				
				SpawnIceFx(inst, inst._target_pos)
	end)
	inst:DoTaskInTime(2, function()
				if inst.components.combat.target then
					inst._target_pos2 = inst.components.combat.target:GetPosition()
				end				
				SpawnIceFx(inst, inst._target_pos1)
	end)
	inst:DoTaskInTime(2.5, function()
				SpawnIceFx(inst, inst._target_pos2)	
	end)

	
end)


			local player = GetPlayer()  
            --player.components.locomotor.walkspeed = player.components.locomotor.walkspeed * 0.5







end 

local function far(inst)
		if inst and inst.spiderqueen_lingyu then inst.spiderqueen_lingyu:Cancel() inst.spiderqueen_lingyu = nil end
			local player = GetPlayer()  
            --player.components.locomotor.walkspeed = player.components.locomotor.walkspeed * 2



end

local function assasin_hunt(inst)
    --local dist = 40
    return FindEntity(inst, TUNING.ZHUISHAJULI, function(guy)
            return ( guy:HasTag("player") or guy:HasTag("yamche"))
			and not guy:HasTag("toso_arm")
			 and guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end)
		end

local function Onhunt(inst, target)
    return inst.components.combat:CanTarget(target) and not target:HasTag("toso_arm")
end

local function Retarget(inst)
    if not inst.components.health:IsDead() and not inst.components.sleeper:IsAsleep() then
        local oldtarget = inst.components.combat.target
        local notags = {"FX", "NOCLICK","INLIMBO", "monster"}
        local newtarget = FindEntity(inst, 10, 
            function(guy) 
                if inst.components.combat:CanTarget(guy) then
                    return (guy:HasTag("character") and not guy:HasTag("monster"))
                end
            end, nil, notags)
        
        if newtarget and newtarget ~= oldtarget then
			inst.components.combat:SetTarget(newtarget)
        end
    end
end

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
    inst.components.combat:ShareTarget(data.attacker, SHARE_TARGET_DIST, function(dude) return dude.prefab == "spiderqueen" and not dude.components.health:IsDead() end, 2)
end


local function SanityAura(inst, observer)

    if observer.prefab == "webber" then
        return 0
    end

    return -TUNING.SANITYAURA_HUGE

end
    
local function fn(Sim)
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddLightWatcher()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 7, 3 )
    inst.Transform:SetFourFaced()
    
    
    ----------
    
    inst:AddTag("monster")
    inst:AddTag("hostile")
    inst:AddTag("epic")    
    inst:AddTag("largecreature")
    inst:AddTag("spiderqueen")    
    inst:AddTag("spider")    
	--所有敌对人形怪
	inst:AddTag("groundpoundimmune")
	inst:AddTag("toso_arm")
    inst:AddTag("toso_armboss")	
local player = GetPlayer() 	
    MakePoisonableCharacter(inst)
--两栖地 
    MakeAmphibiousCharacterPhysics(inst, 0, .5)

    
    inst.AnimState:SetBank("spider_queen")
    inst.AnimState:SetBuild("spider_queen_build")
    inst.AnimState:PlayAnimation("idle", true)
    
    inst:SetStateGraph("SGboss_spiderqueen")
    
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot(loot)
    
    ---------------------        
    MakeLargeBurnableCharacter(inst, "body")
    MakeLargeFreezableCharacter(inst, "body")
    inst.components.burnable.flammability = TUNING.SPIDER_FLAMMABILITY
    ---------------------       
    
    
    ------------------
    inst:AddComponent("health")
		--生命护甲数值
	inst.components.health:SetMaxHealth(240000+player.level*TUNING.ARM_HEALTHUP)
    inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)

    ------------------
    
    inst:AddComponent("combat")
    inst.components.combat:SetRange(TUNING.SPIDERQUEEN_ATTACKRANGE)
	--攻速攻击力数值
	 inst.components.combat:SetDefaultDamage(400+player.level*20)
	inst.components.combat:SetAttackPeriod(TUNING.ARM_ATKSPEED*0.5)---min_attack_period
    inst.components.combat:SetRetargetFunction(0, assasin_hunt)
	inst.components.combat:SetKeepTargetFunction(Onhunt)
    
    ------------------

	inst:AddComponent("sanityaura")
    inst.components.sanityaura.aurafn = SanityAura

   
    ------------------
    
    --inst:AddComponent("sleeper")
    --inst.components.sleeper:SetResistance(4)
    ------------------
    
    inst:AddComponent("locomotor")
	inst.components.locomotor:SetSlowMultiplier( 1 )
	inst.components.locomotor:SetTriggersCreep(false)
	inst.components.locomotor.pathcaps = { ignorecreep = true }
	inst.components.locomotor.walkspeed = 20

    ------------------
    
    inst:AddComponent("eater")
    inst.components.eater:SetCarnivore()
    inst.components.eater:SetCanEatHorrible()
    inst.components.eater.strongstomach = true -- can eat monster meat!
    
    ------------------
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("leader")
    
    ------------------
    
    local brain = require "brains/spiderqueenbrain"
    inst:SetBrain(brain)

    inst:ListenForEvent("attacked", OnAttacked)
	--成长护甲
	inst.task_always = inst:DoPeriodicTask(2, function()
	local player = GetPlayer()


	
if player.level > 10 and player.level <= 20 then
inst.components.health:SetAbsorptionAmount(0.91)
elseif player.level > 20 and player.level <= 30 then
inst.components.health:SetAbsorptionAmount(0.92)	
elseif player.level > 30 and player.level <= 40 then
inst.components.health:SetAbsorptionAmount(0.93)
elseif player.level > 40 and player.level <= 50 then
inst.components.health:SetAbsorptionAmount(0.94)
elseif player.level > 50 and player.level <= 60 then
inst.components.health:SetAbsorptionAmount(0.95)
elseif player.level > 60 and player.level <= 70 then
inst.components.health:SetAbsorptionAmount(0.96)
elseif player.level > 70 and player.level <= 80 then
inst.components.health:SetAbsorptionAmount(0.97)
elseif player.level > 80 and player.level <= 90 then
inst.components.health:SetAbsorptionAmount(0.98)
elseif player.level > 90 then
inst.components.health:SetAbsorptionAmount(0.99)
else
inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)
end	
	
	end)
	
    return inst
end


return Prefab( "forest/monsters/boss_spiderqueen", fn, assets, prefabs) 
    
