--require "stategraphs/SGzg_mo_tentacle"
local brain = require "brains/zg_mo_tentacle"
local assets=
{
	Asset("ANIM", "anim/tentacle.zip"),
    Asset("SOUND", "sound/tentacle.fsb"),
}

local prefabs =
{
    "monstermeat",
    "tentaclespike",
    "tentaclespots",
}

SetSharedLootTable( 'tentacle',
{
    {'monstermeat',   1.0},
    {'monstermeat',   1.0},
    {'tentaclespike', 0.5},
    {'tentaclespots', 0.2},
})

local function assasin_hunt(inst)
    --local dist = 40
    return FindEntity(inst, TUNING.ZHUISHAJULI, function(guy)
            return ( guy:HasTag("player") or guy:HasTag("yamche"))
			and not guy:HasTag("toso_arm")
			 and guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end)
		end

local function Onhunt(inst, target)
    return inst.components.combat:CanTarget(target) and not target:HasTag("toso_arm")
end

--领域
local function OnHitOther(inst, data)
    local v = data.target
	local player = GetPlayer() 
    if v and v:HasTag("player") then
		if v and v.tentacle_lingyu then v.tentacle_lingyu:Cancel() v.tentacle_lingyu = nil end
		v.tentacle_lingyu = v:DoPeriodicTask(1, function()
	    if v and v.components.health and not v.components.health:IsDead() then
	    v.components.health:DoDelta(-player.level*0.5)

		
		end
		end)
		v:DoTaskInTime(5, function()
		if v and v.tentacle_lingyu then v.tentacle_lingyu:Cancel() v.tentacle_lingyu = nil end
		end) 
    end
end

local function retargetfn(inst)
	local invader = nil
    invader = FindEntity(inst, 2 + 6 * 1, function(guy)
        return guy and not guy:HasTag("toso_arm") and guy:HasTag("player") 
			 and guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
    end)
	return invader, true
end

local function shouldKeepTarget(inst, target)
	return inst.components.combat:CanTarget(target) and not target:HasTag("toso_arm")   
end



local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.Transform:SetScale(1.5,1.5,1.5)
	inst.entity:AddAnimState()
    --inst.entity:AddPhysics()
    --inst.Physics:SetCylinder(0.25,2)
    MakeCharacterPhysics(inst, 0, 0.02)

    
    inst.AnimState:SetBank("tentacle")
    inst.AnimState:SetBuild("tentacle")
    inst.AnimState:PlayAnimation("idle")
 	inst.entity:AddSoundEmitter()

    inst:AddTag("monster")    
    inst:AddTag("hostile")
    inst:AddTag("wet")
    inst:AddTag("WORM_DANGER")  
	--所有敌对人形怪
	inst:AddTag("groundpoundimmune")
	inst:AddTag("toso_arm")
    inst:AddTag("toso_armboss")	
	
local player = GetPlayer() 
    inst:AddComponent("health")
		--生命护甲数值
	inst.components.health:SetMaxHealth(60000+player.level*TUNING.ARM_HEALTHUP)
    inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)
    
    
    inst:AddComponent("combat")
    inst.components.combat:SetRange(TUNING.TENTACLE_ATTACK_DIST)
	--攻速攻击力数值
	 inst.components.combat:SetDefaultDamage(400+player.level*20)
	inst.components.combat:SetAttackPeriod(TUNING.ARM_ATKSPEED*0.5)---min_attack_period
    inst.components.combat:SetRetargetFunction(0, assasin_hunt)
	inst.components.combat:SetKeepTargetFunction(Onhunt)
    
    MakeLargeFreezableCharacter(inst)
    
	inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED
 

    
    inst:AddComponent("inspectable")
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('tentacle')
	
    inst:ListenForEvent("onhitother", OnHitOther)--流血  
	
	inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.walkspeed = 3
    --inst.components.locomotor.runspeed = 3
    inst:SetStateGraph("SGzg_mo_tentacle")

    --inst:AddComponent("hiddendanger")

    return inst
end

return Prefab( "marsh/monsters/boss_tentacle", fn, assets, prefabs) 
