local function ontransplantfn(inst)
	inst.components.pickable:MakeBarren()
end

local function makeemptyfn(inst)
	if inst.components.pickable and inst.components.pickable.withered then
		inst.AnimState:PlayAnimation("dead_to_empty")
		inst.AnimState:PushAnimation("empty")
	else
		inst.AnimState:PlayAnimation("empty")
	end
end

local function makebarrenfn(inst)
	if inst.components.pickable and inst.components.pickable.withered then
		if not inst.components.pickable.hasbeenpicked then
			inst.AnimState:PlayAnimation("full_to_dead")
		else
			inst.AnimState:PlayAnimation("empty_to_dead")
		end
		inst.AnimState:PushAnimation("idle_dead")
	else
		inst.AnimState:PlayAnimation("idle_dead")
	end
end

local function pickanim(inst)
	if inst.components.pickable then
		if inst.components.pickable:CanBePicked() then
			local percent = 0
			if inst.components.pickable then
				percent = inst.components.pickable.cycles_left / inst.components.pickable.max_cycles
			end
			if percent >= .9 then
				return "berriesmost"
			elseif percent >= .33 then
				return "berriesmore"
			else
				return "berries"
			end
		else
			if inst.components.pickable:IsBarren() then
				return "idle_dead"
			else
				return "idle"
			end
		end
	end
	return "idle"
end

local function taskplayer(inst)
local player =GetPlayer()
	if inst.components.pickable and inst.components.pickable:CanBeFertilized() then
--		inst.components.talker:Say("我需要施肥~~")
	end
	if inst.components.pickable.withered or inst.components.pickable.shouldwither then
		if inst:HasTag("withered") then
--			inst.components.talker:Say("我枯萎了~~")
		end
	end

	if player and not player.components.sswordcast then
		inst:Remove()
	end
end

local function shake(inst)
    if inst.components.pickable and inst.components.pickable:CanBePicked() then
        inst.AnimState:PlayAnimation("shake")
    else
        inst.AnimState:PlayAnimation("shake_empty")
    end
	inst.AnimState:PushAnimation(pickanim(inst), false)
end

local function spawnimp(inst)
    if inst:IsValid() then
		local imp = SpawnPrefab("bamboo")
		local spawnpos = Vector3(inst.Transform:GetWorldPosition() )
		spawnpos = spawnpos + TheCamera:GetDownVec()
		imp.Transform:SetPosition(spawnpos:Get() )
		shake(inst)
	end
end

local function onpickedfn(inst, picker)
	if inst.components.pickable then
		local old_percent = (inst.components.pickable.cycles_left+1) / inst.components.pickable.max_cycles

		if old_percent >= .9 then
			inst.AnimState:PlayAnimation("berriesmost_picked")
		elseif old_percent >= .33 then
			inst.AnimState:PlayAnimation("berriesmore_picked")
		else
			inst.AnimState:PlayAnimation("berries_picked")
		end

		if inst.components.pickable:IsBarren() then
			inst.AnimState:PushAnimation("idle_dead")
		else
			inst.AnimState:PushAnimation("idle")
		end
	end
	if not picker:HasTag("berrythief") and math.random() < 0.5 then
	    inst:DoTaskInTime(1+math.random()*3, spawnimp)
	end
end

local function getregentimefn(inst)
	if inst.components.pickable then
		local num_cycles_passed = math.min(inst.components.pickable.max_cycles - inst.components.pickable.cycles_left, 0)
		return TUNING.BERRY_REGROW_VARIANCE*0.5 + TUNING.BERRY_REGROW_INCREASE*num_cycles_passed+ math.random()*TUNING.BERRY_REGROW_VARIANCE
	else
		return TUNING.BERRY_REGROW_VARIANCE*0.5
	end
	
end

local function onregenfn(inst)
	inst.AnimState:PlayAnimation(pickanim(inst))
end

local function makefullfn(inst)
	inst.AnimState:PlayAnimation(pickanim(inst))
end

local function createbush(emerald_flower)

	local function dig_up(inst, chopper)	
		if inst.components.pickable and inst.components.lootdropper then
		
			if inst.components.pickable:IsBarren() or inst.components.pickable.withered then
				inst.components.lootdropper:SpawnLootPrefab("twigs")
				inst.components.lootdropper:SpawnLootPrefab("twigs")
			else
				
				if inst.components.pickable and inst.components.pickable:CanBePicked() then
					inst.components.lootdropper:SpawnLootPrefab("bamboo")
				end
			
				inst.components.lootdropper:SpawnLootPrefab("dug_bamboobush")
			end
		end	
		inst:Remove()
	end

	local assets =
	{
	Asset("ANIM", "anim/bamboobush.zip"),	 
	Asset("ATLAS", "images/inventoryimages/bamboobush.xml"),
	Asset("IMAGE", "images/inventoryimages/bamboobush.tex"),
	Asset("SOUND", "sound/common.fsb"),
	}

	local prefabs =
	{
	    "petals",
	    "dug_bamboobush",
	    "twigs",
	    "bamboo",
	}

		local function fn(Sim)
			local inst = CreateEntity()
			local trans = inst.entity:AddTransform()
			local anim = inst.entity:AddAnimState()
			local minimap = inst.entity:AddMiniMapEntity()
			inst:AddTag("yiyuonly")
		    --inst:AddTag("bush")
		    inst:AddTag("burnable")
		    inst:AddTag("emerald_flowerbush")
			minimap:SetIcon( "bamboobush.tex" )

		    MakeObstaclePhysics(inst, 0.05)		    
		    anim:SetBank("berrybush")		    
		    anim:SetBuild("bamboobush")
		    anim:PlayAnimation("berriesmost", false)
		    
			local light = inst.entity:AddLight()
			inst.Light:Enable(true)
			inst.Light:SetRadius(0.5)
			inst.Light:SetFalloff(0.75)
			inst.Light:SetIntensity(.65)
			inst.Light:SetColour(32/255,229/255,153/255)

			inst:AddComponent("talker")
		    inst:AddComponent("pickable")
		    inst.components.pickable.picksound = "dontstarve/wilson/harvest_berries"
		    inst.components.pickable:SetUp("petals", TUNING.BERRY_REGROW_VARIANCE*0.5)

			inst.components.pickable.getregentimefn = getregentimefn
			inst.components.pickable.onregenfn = onregenfn
			inst.components.pickable.onpickedfn = onpickedfn
		    inst.components.pickable.makeemptyfn = makeemptyfn
		    inst.components.pickable.makebarrenfn = makebarrenfn
		    inst.components.pickable.makefullfn = makefullfn
		    inst.components.pickable.ontransplantfn = ontransplantfn
		    inst.components.pickable.max_cycles = TUNING.BERRYBUSH_CYCLES + math.random(2)
		    inst.components.pickable.cycles_left = inst.components.pickable.max_cycles
		    inst.makewitherabletask = inst:DoTaskInTime(TUNING.WITHER_BUFFER_TIME, function(inst) inst.components.pickable:MakeWitherable() end)
		    
		    MakeLargeBurnable(inst)
		    MakeLargePropagator(inst)
		    inst.components.burnable:MakeDragonflyBait(1)    
		    
			inst:AddComponent("lootdropper")
			inst:AddComponent("workable")
		    inst.components.workable:SetWorkAction(ACTIONS.DIG)
		    inst.components.workable:SetOnFinishCallback(dig_up)
			inst.components.workable:SetWorkLeft(1)

		    inst:AddComponent("inspectable")
		    
		    inst:ListenForEvent("onwenthome", shake)
			MakeSnowCovered(inst, .01)
			MakeNoGrowInWinter(inst)
			inst.taskplayer = inst:DoPeriodicTask(2, function() taskplayer(inst) end)

			--inst:DoTaskInTime(2, function()
			--local tile, tileinfo = inst:GetCurrentTileType()
			--local onwater = nil
			--if tile and tileinfo then onwater = IsWater(tile) end
			--if onwater then inst:Remove() end
			--end)
		    return inst
		end
	return Prefab( "common/objects/bamboobush", fn, assets, prefabs)	
end  

return createbush("bamboobush")