local assets=
{
	Asset("ANIM", "anim/flyingaxe.zip"),
	Asset("ANIM", "anim/swap_flyingaxe.zip"),
	
	Asset( "ATLAS", "images/inventoryimages/flyingaxe.xml" ),
	Asset( "IMAGE", "images/inventoryimages/flyingaxe.tex" ),	
}

    
local prefabs =
{
}
local function AutoEquipItem(playercontroller, bufferedaction)
	if not bufferedaction then return end
	if not bufferedaction.invobject then return end
	if not playercontroller.autoequip_lastequipped then
		playercontroller.autoequip_lastequipped = playercontroller.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	end
	playercontroller.inst.components.locomotor:PushAction(BufferedAction(playercontroller.inst, nil, ACTIONS.EQUIP, bufferedaction.invobject), true)
    -- playercontroller.inst.components.inventory:Equip(bufferedaction.invobject)
end


local function OnFinished(inst)
    inst:Remove()
end

local function OnEquip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_flyingaxe", "swap_f")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
	inst.ownerWalkSpeed=owner.components.locomotor.walkspeed
	inst.ownerRunSpeed=owner.components.locomotor.runspeed
end

local function OnDropped(inst)
    inst.AnimState:PlayAnimation("idle")
end

local function OnUnequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function OnThrown(inst, owner, target, playercontroller)
	inst.components.projectile:SetSpeed(20)
	local weapons = owner.components.inventory:FindItems(function(item)
			return item.components.weapon
		end)
	if weapons then
		for k,v in pairs(weapons) do
			if v and v.prefab == "flyingaxe" then
			--c_give("oinc",100)
			--playercontroller.owner.components.locomotor:PushAction(BufferedAction(playercontroller.inst, nil, ACTIONS.EQUIP, v), true)
			owner.components.inventory:Equip(v)
			end
            	end
        end	
    --ƶٶ (ѡ)
	owner.components.locomotor.walkspeed = (owner.components.locomotor.walkspeed+0.25*TUNING.WILSON_WALK_SPEED)
    --ܲٶ
	owner.components.locomotor.runspeed = (owner.components.locomotor.runspeed+0.25*TUNING.WILSON_RUN_SPEED)
    if target ~= owner then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
    end
    inst.AnimState:PlayAnimation("spin_loop", true)
end

local function OnCaught(inst, catcher)
    --ƶٶ (ѡ)
	catcher.components.locomotor.walkspeed = (catcher.components.locomotor.walkspeed-0.5*TUNING.WILSON_WALK_SPEED)
    --ܲٶ
	catcher.components.locomotor.runspeed = (catcher.components.locomotor.runspeed-0.5*TUNING.WILSON_RUN_SPEED)
    if catcher then
        if catcher.components.inventory then
            if inst.components.equippable and not catcher.components.inventory:GetEquippedItem(inst.components.equippable.equipslot) then
				catcher.components.inventory:Equip(inst)
			else
                catcher.components.inventory:GiveItem(inst)
            end
            catcher:PushEvent("catch")
        end
    end
end

local function ReturnToOwner(inst, owner)
    if owner and not (inst.components.finiteuses and inst.components.finiteuses:GetUses() < 1) then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_return")
        inst.components.projectile:Throw(owner, owner)
    end
end

local function OnHit(inst, owner, target,data)
    if owner == target then
	--ƶٶ (ѡ)
	owner.components.locomotor.walkspeed = (owner.components.locomotor.walkspeed-0.5*TUNING.WILSON_WALK_SPEED)
    --ܲٶ
	owner.components.locomotor.runspeed = (owner.components.locomotor.runspeed-0.5*TUNING.WILSON_RUN_SPEED)
        OnDropped(inst)
    else
	if not target:HasTag("prey") 
		and not target:HasTag("veggie") 
		and not target:HasTag("structure")
		and not target:HasTag("wall") then
		--if FLYINGAXE_HEALTH_STEALING then
			--owner.components.health:DoDelta(1)
		--end
	end
	inst.components.projectile:SetSpeed(15)   
        ReturnToOwner(inst, owner)
    end
    local impactfx = SpawnPrefab("impact")
    if impactfx then
	    local follower = impactfx.entity:AddFollower()
	    follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
        impactfx:FacePoint(Vector3(inst.Transform:GetWorldPosition()))
    end
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst .entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank("flyingaxe")
    anim:SetBuild("flyingaxe")
    anim:PlayAnimation("idle")
    anim:SetRayTestOnBB(true);

    inst:AddTag("irreplaceable")
    inst:AddTag("projectile")
    inst:AddTag("thrown")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(10)
    inst.components.weapon:SetRange(20, 20)
    -------

    inst:AddComponent("inspectable")
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(20)
    inst.components.projectile:SetCanCatch(true)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(ReturnToOwner)
    inst.components.projectile:SetOnCaughtFn(OnCaught)
    
    inst:AddComponent("inventoryitem")

    inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
    inst.components.inventoryitem.atlasname = "images/inventoryimages/flyingaxe.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)
	inst.ownerWalkSpeed=TUNING.WILSON_WALK_SPEED * 1
	inst.ownerRunSpeed=TUNING.WILSON_RUN_SPEED * 1

local oldhit = inst.components.projectile.Hit
	
function inst.components.projectile:Hit(target)
		
	if target == self.owner and target.components.catcher then

			target:PushEvent("catch", {projectile = self.inst})
 
			self.inst:PushEvent("caught", {catcher = target})

			self:Catch(target)

			target.components.catcher:StopWatching(self.inst)

		else
			
			oldhit(self, target)
		
	end

end
    return inst
end




return Prefab( "common/inventory/flyingaxe", fn, assets) 
