require "prefabutil"

local assets =
{
Asset("ANIM", "anim/evergreen_living_wood.zip"),
Asset("IMAGE", "images/inventoryimages/gate.tex"),
Asset("ATLAS", "images/inventoryimages/gate.xml"),
}

local prefabs = 
{
	"livinglog",
	"log",	
}

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/forest/treeCrumble")  
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", true)
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", true)
end


local function OnGetItemFromPlayer(inst, giver, item)

	inst.SoundEmitter:PlaySound("dontstarve/creatures/leif/livingtree_hit")
	inst.AnimState:PlayAnimation("chop")
	inst.AnimState:PushAnimation("idle", true)
        inst:DoTaskInTime(20/30, function() 
            --inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingThrowGold")
 	        inst.SoundEmitter:PlaySound("dontstarve/forest/treefall")           
            for k = 1, 5 do
                local nug = SpawnPrefab("log")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
            end
        end)
        inst:DoTaskInTime(1.5, function() 
            --inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingHappy")
            inst.SoundEmitter:PlaySound("dontstarve/creatures/leif/livingtree_die")
        end)



end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	trans:SetScale(1.0, 1.0, 1.0)
	MakeObstaclePhysics(inst, .75)

	local light = inst.entity:AddLight()
	inst.Light:SetRadius(3.5)
	inst.Light:SetFalloff(0.85)
	inst.Light:SetIntensity(.85)
--	inst.Light:SetColour(255/255, 0/255, 255/255)
	inst.Light:Enable(true)

	anim:SetBank("evergreen_living_wood")
	anim:SetBuild("evergreen_living_wood")
	anim:PlayAnimation("idle", true)
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("livingtree.png")
	--传送
	inst:AddTag("transtofight")
	
	inst:AddTag("structure")
	inst:AddComponent("lootdropper")
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)

	inst:AddComponent("inspectable")

	inst:AddComponent("talker")
    inst.components.talker.fontsize = 24
	inst.components.talker.offset = Vector3(0,-800,0)
    inst.components.talker.colour = Vector3(0.75, 0.85, 1, 1)
	
	inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(function(inst, item) 
	return item.prefab=="pinecone" or item.prefab=="spidergland" or item.prefab=="jungletreeseed" end)
	
    inst.components.trader.onaccept=function(inst,giver,item)

        local x,y,z = inst.Transform:GetWorldPosition()	

        if item.prefab=="spidergland" then
                local aaa = SpawnPrefab("livinglog")
                local pop = SpawnPrefab("explode_small")
                pop.Transform:SetScale(1.1, 1.1, 1.1)
                aaa.Transform:SetPosition(inst:GetPosition():Get())
                pop.Transform:SetPosition(aaa:GetPosition():Get())
                SpawnPrefab("statue_transition_2").Transform:SetPosition(aaa:GetPosition():Get())
				
				inst:Remove()
	
        end	
		
		

	end
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse=function(inst,giver,item) 
	--inst.AnimState:PlayAnimation("chop")
	if giver.components.talker then 
	   giver.components.talker:Say("貌似他需要的不是这个") end 
	end		


	MakeSnowCovered(inst, .01) 
	inst:ListenForEvent("onbuilt", onbuilt)
	inst:ListenForEvent( "daytime", function() inst.Light:Enable(false) end , GetWorld() )
	inst:ListenForEvent( "dusktime", function() inst.Light:Enable(true) end , GetWorld() )
--------------------------------------

return inst
end

return Prefab( "common/gate", fn, assets, prefabs ),
       MakePlacer("common/gate_placer", "gate", "gate", "idle",nil ,nil ,nil ,2) 