local assets=
{
	Asset("ANIM", "anim/spider_spit.zip"),
	Asset("ANIM", "anim/bishop_attack.zip"),
	Asset("SOUND", "sound/chess.fsb"),
}

local prefabs ={}

local function OnbutterflyHit(inst, owner, target)
	for i=1,2 do
	if target and target.components.combat and target.components.health and target.components.health.currenthealth > 0 then
		local pt2 = target:GetPosition()
		local ents = TheSim:FindEntities(pt2.x, pt2.y, pt2.z, 10)
		SpawnPrefab("lightning").Transform:SetPosition(pt2.x, 0, pt2.z)
		if target and target == GetPlayer() then
			target.sg:GoToState("electrocute")
			target.components.health:DoDelta(-TUNING.DIFFICULTY*3)
		else
			target.components.combat:GetAttacked(owner, TUNING.DIFFICULTY*3)
		end
	end
	end
	inst:Remove()
end

local function OnHit(inst, owner, target)
	inst:Remove()
end

local function OnMiss(inst, owner, target)
	inst:Remove()
end

local function rpg_butterfly_projectile()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    inst:AddTag("projectile")

	inst:AddComponent("projectile")
	inst.components.projectile:SetSpeed(20)
	inst.components.projectile:SetHoming(false)
	inst.components.projectile:SetHitDist(1.5)
	inst.components.projectile:SetOnHitFn(OnbutterflyHit)
	inst.components.projectile:SetOnMissFn(OnMiss)

    anim:SetBank("bishop_attack")
    anim:SetBuild("bishop_attack")
    anim:PlayAnimation("idle")
	inst.AnimState:SetMultColour(255/255,255/255,0/255,1)
    inst:ListenForEvent("animover", function() inst.AnimState:PlayAnimation("idle", true) end)
	inst:DoTaskInTime(8, function() inst:Remove() end)
    return inst
end

local function rpg_spider_projectile()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
	inst:AddTag("projectile")
	inst.persists = false
    inst:AddComponent("projectile")
	inst.components.projectile:SetSpeed(10)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(2)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnMiss)

--    anim:SetBank("spider_spit")
--    anim:SetBuild("spider_spit")
	anim:SetBank("bishop_attack")
	anim:SetBuild("bishop_attack")
	anim:PlayAnimation("idle")
	inst.AnimState:SetMultColour(0/255,255/255,255/255,1)
	inst:ListenForEvent("animover", function() inst.AnimState:PlayAnimation("idle", true) end)
	inst:DoTaskInTime(8, function() inst:Remove() end)
    return inst
end

return	Prefab( "common/inventory/rpg_butterfly_projectile", rpg_butterfly_projectile, assets, prefabs),
		Prefab( "common/inventory/rpg_spider_projectile", rpg_spider_projectile, assets)
