local assets =
{
    Asset("ANIM", "anim/san.zip"),
	Asset("ANIM", "anim/swap_san.zip"),
	Asset("ANIM", "anim/swap_tosog.zip"),
	Asset("ATLAS", "images/inventoryimages/san.xml"),
}


local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "swap_san", "swap_san")
	owner.SoundEmitter:PlaySound("dontstarve/wilson/use_umbrella_up") 
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	
    --inst.components.armor:SetAbsorption(1)
    if not inst.fx then    
    inst.fx = SpawnPrefab("forcefieldfx")
    inst.fx.entity:SetParent(owner.entity)
    inst.fx.Transform:SetPosition(0, 0.2, 0)
    inst.fx.Transform:SetScale(1, 1, 1)
    inst.fx.AnimState:PlayAnimation("hit")
    inst.fx.AnimState:PushAnimation("idle_loop")
	end

end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
  		        if inst.fx then
                   inst.fx.kill_fx(inst.fx)
				   inst.fx = nil

                end
end




local function onattack(inst, attacker, target)



       
end

local function common_fn(name)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank(name)
    inst.AnimState:SetBuild(name)
    inst.AnimState:PlayAnimation("idle")  
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "san.tex" )
	
	inst.Transform:SetScale(1.8,1.8,1.8)

    inst:AddTag("ssumbrella")

    --waterproofer (from waterproofer component) added to pristine state for optimization
    inst:AddTag("waterproofer")

    inst:AddComponent("waterproofer")
    inst:AddComponent("inspectable")

    inst:AddComponent("equippable")


    return inst
end

local function fn()
    local inst = common_fn("san")

	inst.components.waterproofer:SetEffectiveness(1)	

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
	
    inst:AddComponent("inventoryitem")	
	inst.components.inventoryitem.imagename = "san"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/san.xml"
	
	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(5)
 inst:ListenForEvent("onattacker",onattack)
 inst.components.weapon.onattack = onattack
 
    inst:AddComponent("armor")
    inst.components.armor:InitCondition(10000, 1)
    --inst.components.armor.dontremove = true
 
    return inst
end

return Prefab("san", fn, assets)