require "prefabutil"
require "brains/qiuqiu_brain"
local brain = require "brains/qiuqiu_brain"
require "stategraphs/SGtoso_packim"

local assets =
{
	Asset("ANIM", "anim/packim.zip"),
	Asset("ANIM", "anim/packim_build.zip"),
	Asset("ANIM", "anim/packim_fat_build.zip"),
	Asset("ANIM", "anim/packim_fire_build.zip"),

	Asset("MINIMAP_IMAGE", "packim_fat"),
	Asset("MINIMAP_IMAGE", "packim_fire"),
	
    --Asset("ANIM", "anim/hat_xiang.zip"),
	Asset("SOUND", "sound/tallbird.fsb"),
	Asset("SOUND", "sound/mandrake.fsb"),
	Asset("SOUND", "sound/birds.fsb"),
    Asset( "SOUND" , "sound/dragonling.fsb" ),
    Asset( "SOUNDPACKAGE" , "sound/dragonling.fev" ),
    Asset( "SOUND" , "sound/critterslab.fsb" ),
    Asset( "SOUNDPACKAGE" , "sound/critterslab.fev" ),

	
	--Asset("IMAGE", "images/inventoryimages/hat_xiang.tex"),
	--Asset("ATLAS", "images/inventoryimages/hat_xiang.xml"),
}

local prefabs=
{
	"lightbulb",
    "chester_eyebone",
    "die_fx",
    "chesterlight",
    "sparklefx",
}


local normalsounds =
{
	close = "dontstarve_DLC002/creatures/packim/close",
	death = "dontstarve_DLC002/creatures/packim/death",
	hurt = "dontstarve_DLC002/creatures/packim/hurt",
	land = "dontstarve_DLC002/creatures/packim/land",
	open = "dontstarve_DLC002/creatures/packim/open",
	swallow = "dontstarve_DLC002/creatures/packim/swallow",
	transform = "dontstarve_DLC002/creatures/packim/transform",
	trasnform_stretch = "dontstarve_DLC002/creatures/packim/trasnform_stretch",
	transform_pop = "dontstarve_DLC002/creatures/packim/trasformation_pop",
	fly = "dontstarve_DLC002/creatures/packim/fly",
	fly_sleep = "dontstarve_DLC002/creatures/packim/fly_sleep",
	sleep = "dontstarve_DLC002/creatures/packim/sleep",
	bounce = "dontstarve_DLC002/creatures/packim/fly_bounce",

	-- only fat packim
	fat_death_spin = "dontstarve_DLC002/creatures/packim/fat_death_spin",
	fat_land_empty = "dontstarve_DLC002/creatures/packim/fat_land_empty",
	fat_land_full = "dontstarve_DLC002/creatures/packim/fat_land_full",
}

local fatsounds = 
{
	close = "dontstarve_DLC002/creatures/packim/fat_close",
	death = "dontstarve_DLC002/creatures/packim/fat_death",
	hurt = "dontstarve_DLC002/creatures/packim/fat_hurt",
	land = "dontstarve_DLC002/creatures/packim/land",
	open = "dontstarve_DLC002/creatures/packim/fat_open",
	swallow = "dontstarve_DLC002/creatures/packim/fat_swallow",
	transform = "dontstarve_DLC002/creatures/packim/transform",
	trasnform_stretch = "dontstarve_DLC002/creatures/packim/trasnform_stretch",
	transform_pop = "dontstarve_DLC002/creatures/packim/trasformation_pop",
	fly = "dontstarve_DLC002/creatures/packim/fly",
	fly_sleep = "dontstarve_DLC002/creatures/packim/fly_sleep",
	sleep = "dontstarve_DLC002/creatures/packim/sleep",
	bounce = "dontstarve_DLC002/creatures/packim/fly_bounce",
	
	-- only fat packim
	fat_death_spin = "dontstarve_DLC002/creatures/packim/fat_death_spin",
	fat_land_empty = "dontstarve_DLC002/creatures/packim/fat_land_empty",
	fat_land_full = "dontstarve_DLC002/creatures/packim/fat_land_full",
}

local slotpos_6 = {}

for y = 3, 0, -1 do
    for x = 0, 3 do
        table.insert(slotpos_6, Vector3(60*x-60*2+30, 60*y-60*2+30,0))
    end
end

local slotpos_5 = {}

for y = 3, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos_5, Vector3(75*x-75*2+75, 60*y-60*2+32,0))
    end
end

local slotpos_4 = {}

for y = 2, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos_4, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
    end
end

local slotpos_3 = {}

for y = 2, 0, -1 do
    for x = 0, 1 do
        table.insert(slotpos_3, Vector3(80*x-80*2+78, 80*y-80*2+80,0))
    end
end

local slotpos_2 = {}

for y = 1, 0, -1 do
    for x = 0, 1 do
        table.insert(slotpos_2, Vector3(80*x-80*2+78, 80*y-80*2+80,0))
    end
end

local slotpos_1 = {}

for y = 1, 0, -1 do
        table.insert(slotpos_1, Vector3(74*y-74*2+70, 0))

end



--鹈鹕搬移
local function WeaponDropped(inst)
    inst:Remove()
end

local function MakeWeapon(inst)
	local weapon = SpawnPrefab("firestaff2")
	inst.components.inventory:Equip(weapon)

	weapon:RemoveComponent("finiteuses")
    weapon.persists = false
    weapon.components.inventoryitem:SetOnDroppedFn(WeaponDropped)
--[[
    if inst.components.inventory then
        local weapon = CreateEntity()
        weapon.entity:AddTransform()
        MakeInventoryPhysics(weapon)
        weapon:AddComponent("weapon")
        weapon.components.weapon:SetDamage(2)
        weapon.components.weapon:SetRange(8, 12)
		weapon.components.weapon:SetProjectile("fire_projectile")
		weapon:AddComponent("inventoryitem")
        weapon.persists = false
        weapon:AddComponent("equippable")
        inst.weapon = weapon
        inst.components.inventory:Equip(inst.weapon)
        inst.components.inventory:Unequip(EQUIPSLOTS.HANDS)
    end
]]
end


local function OnOpen(inst)
    if not inst.components.health:IsDead() then
        inst.sg:GoToState("open")
    end
end 

local function OnClose(inst) 
    if not inst.components.health:IsDead() then
        inst.sg:GoToState("idle")
    end
end

local slotpos_3x1 = {}
for y = 0, 0 do
	for x = 0, 2 do
	table.insert(slotpos_3x1, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
	end
end

local slotpos_3x2 = {}
for y = 0, 1 do
    for x = 0, 2 do
	table.insert(slotpos_3x2, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
	end
end

local slotpos_3x3 = {}
for y = 2, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos_3x3, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
    end
end

local function OnStopFollowing(inst) inst:RemoveTag("companion") end

local function OnStartFollowing(inst) inst:AddTag("companion") end
--[[
local function qiuqiu_up1(inst, dofx)
    inst.components.container:SetNumSlots(#slotpos_3x2)
    inst.components.container.widgetslotpos = slotpos_3x2
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "ui_chest_3x3"
    inst.components.container.widgetpos = Vector3(0,200,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.canbeopened = true
end

local function qiuqiu_up2(inst, dofx)
    inst.components.container:SetNumSlots(#slotpos_3x3)
    inst.components.container.widgetslotpos = slotpos_3x3
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "ui_chest_3x3"
    inst.components.container.widgetpos = Vector3(0,200,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.canbeopened = true
end

local function TakeItem1(yiyusword)
	if not yiyusword:HasTag("broken") and yiyusword.components.weapon and yiyusword.weaponexp and yiyusword.weapon_adddmg then
	yiyusword.components.weapon:SetDamage(45+yiyusword.weaponexp/150+yiyusword.weapon_adddmg)
	yiyusword.components.equippable.runspeedmult = TUNING.CANE_SPEED_MULT - 0.1 + yiyusword.weaponexp / 10000
	yiyusword.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT - 0.1 + yiyusword.weaponexp / 10000
	elseif yiyusword:HasTag("broken") then
	yiyusword.components.weapon:SetDamage(45+yiyusword.weaponexp/150+yiyusword.weapon_adddmg)
	yiyusword.components.equippable.runspeedmult = TUNING.CANE_SPEED_MULT - 0.1 + yiyusword.weaponexp / 10000
	yiyusword.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT - 0.1 + yiyusword.weaponexp / 10000
	yiyusword:RemoveTag("broken")
	end
end

local function TakeItem2(guangmang)
	if not guangmang:HasTag("broken") and guangmang.components.weapon and guangmang.weaponexp and guangmang.weapon_adddmg then
    guangmang.components.weapon:SetDamage(35+guangmang.weaponexp/150+guangmang.weapon_adddmg)
    guangmang.components.equippable.runspeedmult = TUNING.CANE_SPEED_MULT - 0.05 + guangmang.weaponexp / 10000
    guangmang.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT - 0.05 + guangmang.weaponexp / 10000
	elseif guangmang:HasTag("broken") then
    guangmang.components.weapon:SetDamage(35+guangmang.weaponexp/150+guangmang.weapon_adddmg)
    guangmang.components.equippable.runspeedmult = TUNING.CANE_SPEED_MULT - 0.05 + guangmang.weaponexp / 10000
    guangmang.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT - 0.05 + guangmang.weaponexp / 10000
	guangmang:RemoveTag("broken")
	end
end

local function TakeItem3(leiting)
	if not leiting:HasTag("broken") and leiting.components.weapon and leiting.weaponexp and leiting.weapon_adddmg then
    leiting.components.weapon:SetDamage(55+leiting.weaponexp/150+leiting.weapon_adddmg)
	elseif leiting:HasTag("broken") then
    leiting.components.weapon:SetDamage(55+leiting.weaponexp/150+leiting.weapon_adddmg)
	leiting:RemoveTag("broken")
	end
end

local function TakeItem4(yiyuhuan)
	if yiyuhuan.components.weapon and yiyuhuan.weaponexp and yiyuhuan.weapon_adddmg then
    yiyuhuan.components.weapon:SetDamage(15 + yiyuhuan.weaponexp/5 +yiyuhuan.weapon_adddmg)
    yiyuhuan.components.equippable.runspeedmult = TUNING.CANE_SPEED_MULT - 0.1 + yiyuhuan.weaponexp / 3000
    yiyuhuan.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT - 0.1 + yiyuhuan.weaponexp / 3000
	end
	if yiyuhuan:HasTag("broken") then yiyuhuan:RemoveTag("broken") end
end
]]
local widgetbuttoninfo = {
    text = "清除",
    position = Vector3(0, -165, 0),
fn = function(inst)

end}

local function OnAttacked(inst, data)
local attacker =data.attacker
	if attacker and attacker.components.combat and inst.components.combat:CanTarget(attacker) and attacker ~= GetPlayer() then
	if inst.combatmode and inst.combatmode == 1 then
		attacker.components.combat:SetTarget(GetPlayer())
	else
		inst.components.combat:SetTarget(data.attacker)
	end
	end
end

local function Retargetfn(inst)
	local notags = {"FX", "NOCLICK","INLIMBO"}
	if inst.combatmode and inst.combatmode == 3 then
	return FindEntity(GetPlayer(), 30, function(guy) return guy.components.combat and inst.components.combat:CanTarget(guy) and not guy.prefab == "slurper" and not guy.components.yiyucast and guy:HasTag("monster") end)
	elseif inst.combatmode and inst.combatmode == 2 then
	return FindEntity(GetPlayer(), 15,
		function(guy) return not guy.prefab == "slurper" and not guy:HasTag("wall") and not guy:HasTag("chester") and
		not guy.components.yiyucast and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy)
		and (guy.components.combat.target == GetPlayer() or GetPlayer().components.combat.target == guy or guy.components.combat.target == inst or inst.components.combat.target == guy or guy:HasTag("monster"))
    end, nil, notags)
	end
end

local function keeptargetfn(inst, target)
	if inst.combatmode and inst.combatmode == 3 then
	if target.components.health and target.components.health.invincible then return false end
	return target and target:IsValid() and not target.components.yiyucast
	elseif inst.combatmode and inst.combatmode == 2 then
	return target and target:IsValid() and not target.components.yiyucast and not target:HasTag("wall")
		and target.components.combat and inst.components.combat:CanTarget(target) and not target:HasTag("chester")
		and target.components.health and not target.components.health:IsDead() and not target:HasTag("chester") and not target:HasTag("myfriend")
	end
end
--[[
local function Specialattack(inst, data)
	local target = data.target
	local chance = math.random()
	if target and target.components.freezable and target.prefab ~= "yiyu_deerclops" and chance <= 0.10 then
		target.components.freezable:AddColdness(1)
	elseif target and target.components.burnable and chance <= 0.20 and target.prefab ~= "yiyu_deerclops" then
		target.components.burnable:Ignite()
	elseif target and chance <= 0.30 then
		if target.components.locomotor then target.components.locomotor:Stop() end
		inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
		SpawnPrefab("lightning_rod_fx").Transform:SetPosition(target.Transform:GetWorldPosition())
	end
	if target and target.components.burnable and target.components.burnable:IsBurning() then
        target.components.burnable:Extinguish()
	end
end

local function upgrade(inst)
    if inst.qiuqiu_level == 2 then
        qiuqiu_up1(inst)
	elseif inst.qiuqiu_level == 3 then
        qiuqiu_up2(inst)
    end
end

local function onpreload(inst, data)
    if not data then return end
	if data and data.qiuqiu_exp then
		inst.qiuqiu_exp = data.qiuqiu_exp
		inst.qiuqiu_level = data.qiuqiu_level
	end
    if data.qiuqiu_level == 2 then
        qiuqiu_up1(inst)
	elseif data.qiuqiu_level == 3 then
        qiuqiu_up2(inst)
    end
end

local function onload(inst, data)
    if not data then return end
	if data and data.qiuqiu_exp then
		inst.qiuqiu_exp = data.qiuqiu_exp
		inst.qiuqiu_level = data.qiuqiu_level
	end
    if data.qiuqiu_level == 2 then
        qiuqiu_up1(inst)
	elseif data.qiuqiu_level == 3 then
        qiuqiu_up2(inst)
    end
end

local function onsave(inst, data)
	data.qiuqiu_exp = inst.qiuqiu_exp
	data.qiuqiu_level = inst.qiuqiu_level
end
]]
local function ondeath(inst, deadthing)
    if inst and deadthing and deadthing.components.yiyucast then
    local apple = TheSim:FindFirstEntityWithTag("yiyu_apple")
	if inst.components.follower.leader ~= apple then
		inst.components.follower:SetLeader(apple)
		inst.components.combat:SetTarget(nil)
		inst.combatmode = 1
	end
	end
end

local function taskleader(inst)
	if not TheSim:FindFirstEntityWithTag("yiyu_apple") then inst:Remove() end
    local apple = TheSim:FindFirstEntityWithTag("yiyu_apple")
	local goodqiuqiu = false
	local pos = Vector3(inst.Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 30)
	for k,v in pairs(ents) do
		if inst.combatmode and inst.combatmode == 3 and inst.components.combat and inst.components.combat.targe == nil then
			if v and v.components.combat and v.prefab ~= "slurper" and not v:HasTag("wall") and not v:HasTag("chester") 
			and not v.components.tosocast and (v.components.combat.target == GetPlayer() or v:HasTag("monster")) then
				inst.components.combat:SuggestTarget(v)
			end
		end
	end

	if apple and apple.components.inventoryitem and apple.components.inventoryitem.owner and apple.components.inventoryitem.owner == GetPlayer() and inst.components.follower and inst.components.follower.leader ~= GetPlayer() then
		inst.components.follower:SetLeader(GetPlayer())
		inst.components.combat.canattack = true
	end
	if inst.components.follower and inst.components.follower.leader ~= apple then
		if apple and apple.components.inventoryitem and apple.components.inventoryitem.owner and apple.components.inventoryitem.owner ~= GetPlayer() then
		inst.components.follower:SetLeader(apple)
		inst.components.combat:SetTarget(nil)
		inst.combatmode = 1
		end
		if apple and apple.components.inventoryitem and apple.components.inventoryitem.owner == nil then
		inst.components.follower:SetLeader(apple)
		inst.components.combat:SetTarget(nil)
		inst.combatmode = 1
		end
	end
end

local function init_prefab()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    --inst.entity:AddSoundEmitter()
    --inst.Transform:SetFourFaced()
	inst.entity:AddSoundEmitter()
	inst.sounds = normalsounds
	inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize( 1.5, .6 )
	
	MakeAmphibiousCharacterPhysics(inst, 75, .5)
	MakePoisonableCharacter(inst)
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "packim.png" )
	
	inst.Transform:SetSixFaced()
	

	
	--if TUNING.YIYUDLC == 1 or TUNING.YIYUDLC == 2 or TUNING.YIYUDLC == 3 then
		MakeAmphibiousCharacterPhysics(inst, 10, .5)
	--else
		--MakeCharacterPhysics(inst, 10, .5)
		--inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
		--inst.Physics:ClearCollisionMask()
		--inst.Physics:CollidesWith(COLLISION.GROUND)
		--inst.Physics:CollidesWith(COLLISION.OBSTACLES)
		--inst.Physics:CollidesWith(COLLISION.CHARACTERS)
	--end

	inst:AddComponent("named")
	inst.components.named:SetName("小鳳")

    anim:SetBank("packim")
    anim:SetBuild("packim_build")

    inst:AddTag("nosteal")
    inst:AddTag("scarytoprey")
    inst:AddTag("notraptrigger")
    inst:AddTag("cattoy")
	inst:AddTag("myfriend")
    inst:AddTag("noauradamage")
	inst:AddTag("amphibious")
	inst:AddTag("qiuqiu")
	inst:AddTag("qiuqiu_box")
	inst:AddTag("NOBLOCK")

	inst:AddComponent("lootdropper")
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed = 9
    inst.components.locomotor.runspeed = 9

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 24
	inst.components.talker.offset = Vector3(0,-800,0)
    inst.components.talker.colour = Vector3(0.75, 0.85, 1, 1)
	
    inst:AddComponent("inventory") 


--[[
	local weapon = SpawnPrefab("firestaff2")
	inst.components.inventory:Equip(weapon)

	weapon:RemoveComponent("finiteuses")
    weapon.persists = true
    weapon.components.inventoryitem:SetOnDroppedFn(WeaponDropped)
]]

    inst:AddTag("fireimmune")
    inst:AddTag("amphibious")
    inst:AddTag("myfriend")	

	inst:AddComponent("health")
	inst.components.health:SetMaxHealth(1000000)
	inst.components.health.fire_damage_scale = 0
	inst.components.health.canmurder = false
	inst.components.health.absorb = 0.999
	inst.components.health:StartRegen(50,1)
	--inst.components.health:SetInvincible(true)
--[[
	inst:AddComponent("container")
	inst.components.container.onopenfn = OnOpen
    inst.components.container.onclosefn = OnClose
    inst.components.container:SetNumSlots(#slotpos_3x3)
    inst.components.container.widgetslotpos = slotpos_3x3
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "ui_chest_3x3"
    inst.components.container.widgetpos = Vector3(0,200,0)
    inst.components.container.side_align_tip = 160
	inst.components.container.widgetbuttoninfo = widgetbuttoninfo
	inst.components.container.canbeopened = true
]]	

	inst:AddComponent("characterspecific")
	inst.components.characterspecific:SetOwner("ssword")
	inst:AddComponent("knownlocations")

	inst:AddComponent("follower")
    inst:ListenForEvent("stopfollowing", OnStopFollowing)
    inst:ListenForEvent("startfollowing", OnStartFollowing)
	if TUNING.YIYUDLC == 2 then inst.components.follower:SetFollowExitDestinations({EXIT_DESTINATION.LAND,EXIT_DESTINATION.WATER}) end

	inst.entity:AddLight()
	inst.Light:SetFalloff(.5)
	inst.Light:SetIntensity(.5)
	inst.Light:SetRadius(.75)
	inst.Light:SetColour(180/255, 195/255, 50/255)
	inst.Light:Enable(false)  

    inst:AddComponent("combat")
	inst.components.combat:SetRange(3)
	inst.components.combat:SetDefaultDamage(5)
	inst.components.combat:SetAttackPeriod(0.1)
	inst.components.combat:SetRetargetFunction(1, Retargetfn)
	inst.components.combat:SetKeepTargetFunction(keeptargetfn)

	--inst.upgrade = upgrade
	--inst.OnSave = onsave
	--inst.OnLoad = onload
	--inst.OnPreLoad = onpreload

	inst.qiuqiu_exp = 0
	inst.qiuqiu_level = 1
	inst:SetStateGraph("SGtoso_packim")
	local brain = require "brains/qiuqiu_brain"
	inst:SetBrain(brain)
	--inst:ListenForEvent("onhitother", Specialattack)
    inst:ListenForEvent("attacked", OnAttacked)
	inst:ListenForEvent( "daytime", function() inst.Light:Enable(false) end , GetWorld() )
	inst:ListenForEvent( "dusktime", function() inst.Light:Enable(true) end , GetWorld() )
    inst:ListenForEvent("entity_death", function(world, data) ondeath(inst, data.inst) end, GetWorld())

	TheInput:AddKeyDownHandler(KEY_3, function()
	local apple = TheSim:FindFirstEntityWithTag("yiyu_apple")
	GetPlayer().components.talker.fontsize = 26
	GetPlayer().components.talker.colour = Vector3(0.7, 0.7, 0.7, 1)
	if apple and apple.components.inventoryitem then
	local appleowner = apple.components.inventoryitem:GetGrandOwner()
	if appleowner and appleowner ~= GetPlayer() then 
		inst.components.talker:Say(TUNING.TALK21)
		inst.components.talker.offset = Vector3(0, -100, 0)
	return end
	if not inst.combatmode then inst.combatmode = 1 end
	if inst.combatmode == 1 then
		inst.AnimState:SetBank("packim")
	    inst.AnimState:SetBuild("packim_fat_build")
		GetPlayer().components.talker:Say("[防御模式]")
		inst.combatmode = 2
		inst.components.combat.canattack = true
	elseif inst.combatmode == 2 then
		inst.AnimState:SetBank("packim")
	    inst.AnimState:SetBuild("packim_fire_build")
		GetPlayer().components.talker:Say("[主动模式]")
		inst.combatmode = 3
		inst.components.combat.canattack = true
	elseif inst.combatmode == 3 then
		inst.components.combat:SetTarget(nil)
		inst.AnimState:SetBank("packim")
	    inst.AnimState:SetBuild("packim_build")
		GetPlayer().components.talker:Say("[闪逃模式]")
		inst.combatmode = 1
		inst.components.combat.canattack = false
	end
	end
	end)
	inst:DoTaskInTime(2, function()
        if not GetClock():IsDay() then
			inst.Light:Enable(true)
        end
		inst:RemoveTag("qiuqiu_box")
	end)
	inst.taskleader = inst:DoPeriodicTask(1, function() taskleader(inst) end)



	return inst
end

return Prefab( "sheath_packim", init_prefab, assets, nil)