
local MakePlayerCharacter = require "prefabs/player_common"
local ImageButton = require "widgets/imagebutton"
local SswordScreen = require "screens/sswordscreen"
local SswordDialogScreen = require "screens/ssworddialogscreen"
local Text = require "widgets/text"
local ModsScreen = require "screens/modsscreen"
local TosoScreen2 = require "screens/sswordscreen_pellets"--丹药屏幕



local assets = {
        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
		--击倒
        Asset("ANIM", "anim/player_hit_spike.zip"),
		--hit_spike_heavy
		--hit_spike_med
		--hit_spike_short
		--hit_spike_tall
		--联机倒地睡觉动作
        Asset("ANIM", "anim/player_knockedout.zip"),
		--dozy
		--sleep_loop		
        --人物动画
        --Asset( "ANIM", "anim/ssword.zip" ),
        Asset( "ANIM", "anim/toso.zip" ),
	    Asset("ANIM", "anim/walani_paddle.zip"),
        Asset("ANIM", "anim/player_wolfgang.zip"),
		
--属性图标
    Asset("IMAGE", "images/ui_you.tex"),
    Asset("ATLAS", "images/ui_you.xml"),
    Asset("IMAGE", "images/ui_zuo.tex"),
    Asset("ATLAS", "images/ui_zuo.xml"),
    Asset("IMAGE", "images/change_elements1.tex"),
    Asset("ATLAS", "images/change_elements1.xml"),
	
	
	Asset( "IMAGE", "images/ssowrdtabs/ssword_tab.tex"),
	Asset( "ATLAS", "images/ssowrdtabs/ssword_tab.xml"),	
	
	Asset( "IMAGE", "images/hud/toso_tab.tex" ),
    Asset( "ATLAS", "images/hud/toso_tab.xml" ),

	Asset( "SOUND" , "sound/ds_toso_yasuo.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/ds_toso_yasuo.fev" ),
	
	Asset( "SOUND" , "sound/ds_toso_huoying.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/ds_toso_huoying.fev" ),
	
	Asset( "SOUND" , "sound/ds_toso_born.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/ds_toso_born.fev" ),
	
	Asset( "SOUND" , "sound/ds_toso_skill.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/ds_toso_skill.fev" ),

}

local swordassets = 
{

	Asset("ANIM", "anim/xuanyuan.zip"),

}
--相关物品代码
local prefabs = {
	--"laser_ring",
	"lighterfire",
	--"laser_explosion",
	--"flyingaxe",
}
--初始自带
local start_inv = {

	"surfboard_item_toso",
	"base_portablecookpot_item",
	--"kid_eyebone",
	"hulu1",
	"bonestew",
	"bonestew",
}



--[[
function GetSpawnPoint(inst, data, pt)

    local theta = math.random() * 2 * PI
    local radius = SPAWN_DIST
    
	local offset = FindWalkableOffset(pt, theta, radius, 12, true)
	if offset then
		return pt+offset
	end
end

function MakeAKrampus(inst, data)
	local pt = Vector3(inst.Transform:GetWorldPosition())
		
	local spawn_pt = self:GetSpawnPoint(pt)
	
	if spawn_pt then
	
		local kramp = SpawnPrefab("arm_bro")
		if kramp then
			kramp.Physics:Teleport(spawn_pt:Get())
			kramp:FacePoint(pt)
		end
	end
end

]]
	


	
			
local SPAWN_DIST = 25
--boss列表
local bossarm =   
{
	[1] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_knight")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
	end,
	
	
	[2] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_hound")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	
	[3] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_crawlingnightmare")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	
	[4] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_nightmarebeak")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	[5] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_krampus")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
						
	
	end,
	[6] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_tigershark")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	[7] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_rocky")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,	
	[8] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_spiderqueen")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,	
	
}

local nofire_person_nothree =    --前期玩家揍不过女武神，沃利，猪妹，老奶奶ban掉
{
	[1] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
	end,
	
	
	[2] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zouwei_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	
	[3] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_webber")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	
	[4] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wilbur")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	[5] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_yuancheng_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
						
	
	end,


	[6] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("assasin_sshw")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	[7] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_woodlegs")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,	

}

local nofire_person = 
{
	[1] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
	end,
	
	
	[2] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zouwei_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	
	[3] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_webber")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	
	[4] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wilbur")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	[5] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_yuancheng_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
						
	
	end,

	[6] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_woodlegs")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[7] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zhumei")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,

	[8] = function(inst, data)

	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_warly")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				

	
	end,
	[9] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro5")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[10] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("assasin_sshw")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	[11] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wickerbottom")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,	
	
	[12] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_qingxue")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	end,
	
	[13] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_meilaoban")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	end,

}

--没有火的生物
local nofire_monster = 
{
	[1] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_spider_warrior")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
	end,
	
	[2] = function(inst, data)
	
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_hound")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				
	end,
	
	[3] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_worm")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	

	[4] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            --local arm2 = SpawnPrefab("arm_spat")  十分恶心，必须搬掉
			 local arm2 = SpawnPrefab("arm_treeguard")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	

	[5] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_perd")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_perd")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	end,	
	
}

local suijishengwuguai = 
{

	[1] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_spider_warrior")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
	end,
	
	[2] = function(inst, data)
	
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_hound")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				
	end,
	
	[3] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_worm")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	
	[4] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_dragoon")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	
	[5] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_mossling")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	
	end,

	[6] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            --local arm2 = SpawnPrefab("arm_spat")  十分恶心，必须搬掉
			 local arm2 = SpawnPrefab("arm_treeguard")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	

	[7] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_perd")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_perd")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	end,	
	
	[8] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_treeguard")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	end,
	
}



local suijiguai = --arm_zhumei
{

	[1] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
	end,
	
	[2] = function(inst, data)
	
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro3")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				
	end,
	
	[3] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zouwei_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	
	[4] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_webber")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	
	[5] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wilbur")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,	
	[6] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_yuancheng_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
						
	
	end,
	[7] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_willow")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[8] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_woodlegs")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[9] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zhumei")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[10] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wes")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[11] = function(inst, data)

	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_warly")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				

	
	end,
	[12] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro5")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	
	end,
	[13] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("assasin_sshw")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	[14] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wickerbottom")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
	end,
	
	[15] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_qingxue")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_qingxue")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 
	end,
	
	[16] = function(inst, data)
	        local downvec = TheCamera:GetDownVec()	
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_meilaoban")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	

	end,

}




local function zhuisha_hunt(inst, data)
	local player = GetPlayer()
	
---dlc1+dlc2	
--if GetWorld():IsCave() then

        --level：1-6
    if inst.level == 1 then
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
    elseif inst.level == 2 then
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				
			
    elseif inst.level == 3 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro3")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	


    elseif inst.level == 4 then
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zouwei_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 

    elseif inst.level == 5 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_webber")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 

    elseif inst.level == 6 then
	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wilbur")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 

    elseif inst.level == 7 then
 	        local downvec = TheCamera:GetDownVec()
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_yuancheng_bro")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 

    elseif inst.level == 8 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_willow")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
    --level：8-10
    elseif inst.level == 9 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_woodlegs")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
    elseif inst.level == 10 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_zhumei")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 
			
    elseif inst.level == 11 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wes")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	

    elseif inst.level == 12 then	
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_warly")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
			
    elseif inst.level == 13 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_bro5")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
    elseif inst.level == 14 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("assasin_sshw")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
			
    elseif inst.level == 15 then
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_wickerbottom")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
				
    elseif inst.level == 16 then

    elseif inst.level == 17 then
			
    elseif inst.level == 18 then
	
    elseif inst.level == 20 then
	
	        inst.components.talker:Say("准备对付~煤老板")
	
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = inst.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("arm_meilaoban")
			local theta = math.random() * 2 * PI
			local radius = SPAWN_DIST
            local offset = FindWalkableOffset(inst:GetPosition(), theta, radius, 12, true) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or FindWaterOffset(inst:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	
    elseif inst.level == 31 then--清空抗热抗寒值，改为攻速和闪避值
	--inst.skillon = 0
	inst.kangleng = 0
	inst.kangre = 0	
    elseif inst.level == 32 then--清空抗热抗寒值，改为攻速和闪避值
	--inst.skillon = 0
	inst.kangleng = 0
	inst.kangre = 0	
    elseif inst.level == 33 then--清空抗热抗寒值，改为攻速和闪避值
	--inst.skillon = 0
	inst.kangleng = 0
	inst.kangre = 0	
    elseif inst.level == 34 then--清空抗热抗寒值，改为攻速和闪避值
	--inst.skillon = 0
	inst.kangleng = 0
	inst.kangre = 0	
	elseif inst.level >= 19 then		

			
	end



    ---dlc1
--elseif not inst.components.poisonable and not SaveGameIndex:IsModeShipwrecked() and not GetWorld():IsCave() then	



	---dlc2		
--elseif inst.components.poisonable or SaveGameIndex:IsModeShipwrecked() and not GetWorld():IsCave() then	


	
--end	
end	

--被动掉血--针对回血--停用

local function on_close(inst)

		--减血buff 

		         inst.task_huixue = inst:DoPeriodicTask(1, function()
				 if v and v:HasTag("toso_arm") and not v.components.health:IsDead() then
				 
	             v.components.health:DoDelta(2)
				 --SpawnPrefab("zhiliao").Transform:SetPosition(player:GetPosition():Get())
				 end
		         end)


end 

local function far(inst)

                if inst and inst.task_huixue then inst.task_huixue:Cancel() inst.task_huixue = nil end
				 

end


--走路值相关的设计
--定义值
local function treasure_hunt(inst,data)
local max_treasure = 100
local treasure = math.min(inst.treasure, max_treasure)
end



--方法以后可能有用，保留
local function toso_egghunt_pass(inst, data)
	if not inst.futou_hunted then
	local x,y,z = inst.Transform:GetWorldPosition()	
	local max_rad = 10000
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"weapon_sword"})
    for k,v in pairs(ents) do 
		if v then 
		--inst.fenji_hunted = true
			end 
				end	
	end				
	if not inst.futou_hunted then
	local x,y,z = inst.Transform:GetWorldPosition()	
	local max_rad = 10000
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"weapon_rude"})
    for k,v in pairs(ents) do 
		if v then 
		inst.futou_hunted = true
		end 
	end	
		
	end	
	
	
end	
	




local function callmonster(inst, data)
inst.components.talker:Say("魔道即将嚣张~")

	inst:DoTaskInTime(5, function()
	inst.components.talker:Say("该来的还是来了~")
	inst.SoundEmitter:PlaySound("dontstarve/common/craftable/lightning_rod")
               --么有火的生物回来
	if inst.level >= 10 then		   
        nofire_person[math.random(12)](inst, data)--加一队友
        nofire_monster[math.random(5)](inst, data)  --加一个怪物	
		
    else
        nofire_person_nothree[math.random(7)](inst, data)--加一队友
        nofire_monster[math.random(5)](inst, data)  --加一个怪物	
		
	end	
			   
			   
	end)

end

local function randommonster(inst)
 
if inst.treasure >= 100 then 

inst.treasure = inst.treasure *0--记录值清零
callmonster(inst)--启动唤醒怪物
--elseif inst.treasure < 100 then

end


end 

--累计记录走路值
local function amount_treasure(inst, data)

if inst.treasure <100 and (inst.sg:HasStateTag("moving") or inst.sg:HasStateTag("rowing") or inst.sg:HasStateTag("sailing")) then 
 --inst.treasure = inst.treasure + 1  --test
  inst.treasure = inst.treasure + 0.05 
--[[
 if inst.level < 10 then
 inst.treasure = inst.treasure + 0.05    --六天来一次  实测0.05第九天来人形怪，饥荒一天三分钟
 elseif inst.level >= 10 and inst.level < 20 then
 inst.treasure = inst.treasure + 0.75     --4-5天一次
 elseif inst.level >= 20 and inst.level < 30 then
 inst.treasure = inst.treasure + 0.1     --2-3天一次 
 elseif inst.level >= 30 and inst.level < 40 then
 inst.treasure = inst.treasure + 0.2     --1-2天一次 
 elseif inst.level >= 40 then
 inst.treasure = inst.treasure + 0.4     --半天多一次 
  elseif inst.level >= 40 then
 inst.treasure = inst.treasure + 0.6     --半天多一次 
 end
]] 
 
end 

end 



--照明
local function applylight(inst)
	--if GetWorld():IsCave() then
	   --if inst.level >=5  then
				--inst.Light:Enable(true)
				--inst.Light:SetRadius(5)
    			--inst.Light:SetFalloff(0.5)
    			--inst.Light:SetIntensity(0.6)
    			--inst.Light:SetColour(128/255,128/255,255/255)
	   --end 
	--elseif not GetWorld():IsCave() then

       if GetClock():IsDay() then
	   	   if inst.level >=5 then
				inst.Light:Enable(false)

           end


 	   elseif GetClock():IsDusk() then
	   	   if inst.level >=5 then
				inst.Light:Enable(true)
				inst.Light:SetRadius(1)
    			inst.Light:SetFalloff(1)
    			inst.Light:SetIntensity(0.3)
    			inst.Light:SetColour(128/255,128/255,255/255)

           end
       elseif GetClock():IsNight() then
	       if inst.level >=5 then
				inst.Light:Enable(true)
				inst.Light:SetRadius(3)
    			inst.Light:SetFalloff(1)
    			inst.Light:SetIntensity(0.5)
    			inst.Light:SetColour(128/255,128/255,255/255)

	       end
	   end	
	   
	--else
	
	   
	--end
end

--跟蹤攻击
local function bingdongattack(inst,data)
local feier = nil
local v = data.target
--35级以后领域灼烧
if inst.level >=35 then
		if v and v.task_lingyu then v.task_lingyu:Cancel() v.task_lingyu = nil end
		v.task_lingyu = v:DoPeriodicTask(1, function()
	    if v and v.components.health and not v.components.health:IsDead() then
	    v.components.health:DoDelta(-inst.zhuoshao)
		--SpawnPrefab("laser_explosion").Transform:SetPosition(v.Transform:GetWorldPosition())
		if v.components.burnable and not v:HasTag("structure") then
			v.components.burnable:Ignite() 
		else
        inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/dixue")			
		end

        if v.components.burnable and v.components.burnable:IsBurning() then
			v.components.burnable:Extinguish() 
		end
        --inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")
	
		
		end
		end)
		v:DoTaskInTime(5, function()
		if v and v.task_lingyu then v.task_lingyu:Cancel() v.task_lingyu = nil end
		end) 
end

--暴击
	  if v and not v:HasTag("wall") and not v.components.health:IsDead() and inst.kangshi and math.random() < inst.kangshi then--
         inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/toso_baoji2")
         v.components.combat:GetAttacked(inst, 1000+20*inst.level)
		 --SpawnPrefab("moose_nest_fx").Transform:SetPosition(v:GetPosition():Get())
		 SpawnPrefab("toso_baoji").Transform:SetPosition(v:GetPosition():Get())


	  end	


	--target.components.combat:GetAttacked(attacker, 2+2*attacker.level)
	--[[
	--穿甲功能关闭 
    --减防御--不减boss防御
      --local v = target--
	  if v and not v:HasTag("wall") and not v:HasTag("toso_armboss") and not v.components.health:IsDead() and inst.weapon_defense and inst.weapon_defense >= 0 and v.components.health.absorb then--
		if not v:HasTag("armorbreakdark") then
			v:AddTag("armorbreakdark")
			local oldabsorb2 = v.components.health.absorb
			v.components.health.absorb = oldabsorb2-inst.weapon_defense
			if v.components.health.absorb <= 0 then v.components.health.absorb = 0 end
			v:DoTaskInTime(5, function() v.components.health.absorb = oldabsorb2 v:RemoveTag("armorbreakdark") end)
		end
	  end	
      ]]


    if inst.shanghai and v            --data.cause == inst.prefab 
        and not v:HasTag("prey")
        and not v:HasTag("veggie") 
        and not v:HasTag("structure")
		and not v:HasTag("wall")
		and v.components.health
		and v.components.health.maxhealth then
	    local xx = v.components.health.maxhealth
			  v.components.health:DoDelta(-xx*inst.shanghai)		

    end

local xxxx = inst.nuqi
--增加怒气

			  inst.components.shaqi:DoDelta(xxxx)				  

--攻击特效
--if inst:HasTag('laserfx') then 			  
			--SpawnPrefab("laser_explosion").Transform:SetPosition(v.Transform:GetWorldPosition())		  
--end		 




 
--攻击减少cd
  if inst.skill_3CD > 0 then 
    inst.skill_3CD = inst.skill_3CD - 0.5
  end 
--被动技能
  if inst.components.shaqi:GetPercent() >= 0.5 then --1
     if v then
     SpawnPrefab("explode_small").Transform:SetPosition(v:GetPosition():Get())
	 end
	 --inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/ribs/green")
	 --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
  end
  --连续攻击
if inst.combo > 8 then 
    inst.combo = 1
	

	

    inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst:DoTaskInTime(0.01, function()
                inst.ss_isInvincible = inst.components.health.invincible   --记录原来的无敌状态 防止误清
                inst.components.health:SetInvincible(true)  --传送期间生命值无敌
	end)
	inst:DoTaskInTime(0.05, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(0.25, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(0.45, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(0.65, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(0.85, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(1.05, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(1.25, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(1.45, function()
	inst.AnimState:PlayAnimation("chop_loop")
	if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
    v.components.combat:GetAttacked(inst, 51+2*inst.level)
	end
	end)
	inst:DoTaskInTime(1.6, function()
            if not inst.ss_isInvincible then
                inst.components.health:SetInvincible(false)
            end
	end)
	

	
end
  
  --吸血
  --if inst.change_elements == 2 then 
      local bloodabsorb = inst.xixue--0.24
	inst.components.health:DoDelta(bloodabsorb)  
  --end
  --冰冻
  if inst.change_elements == 15 then   --3
--------冰冻代码
	if v.components.sleeper and v.components.sleeper:IsAsleep() then
        v.components.sleeper:WakeUp()
    end
    if v.components.burnable then
        if v.components.burnable:IsBurning() then
            v.components.burnable:Extinguish()
        elseif v.components.burnable:IsSmoldering() then
            v.components.burnable:SmotherSmolder()
        end
    end

    --if v.components.combat then
        --v.components.combat:SuggestTarget(attacker)
    --end

    --if v.sg and not v.sg:HasStateTag("frozen") then
        --v:PushEvent("attacked", {attacker = attacker, damage = 0})
    --end
	--冰		 
	if not inst or not v then 
	return end
	
    local numFX = math.random(5,10)
    local pos = inst:GetPosition()
    local targetPos = v:GetPosition()
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = inst:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        inst:DoTaskInTime(math.random() * 0.25, function(inst)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = GetRandomWithVariance(0, 1)
                local z = GetRandomWithVariance(0, 1)
                local offset = (vec * math.random(dist * 0.25, dist)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
            end
        end)
    end
	
	--v.components.health:DoDelta(- 10 - inst.level)
	if v and v.components.health and not v.components.health:IsDead() then
	--v.components.combat:GetAttacked(inst, 20+5*inst.level)
	end
    if not v:HasTag("ant") and not v:HasTag("insect") then	
    if v.components.freezable then
        v.components.freezable:AddColdness(0.4)
        v .components.freezable:SpawnShatterFX()
    end
    end
  end
  
  --真实伤害
  if inst.change_elements == 15 then --4

     v.components.health:DoDelta(- 100 - inst.level)
	 inst.components.health:DoDelta(-5)
  end
  
  --连续爆炸
  if inst.change_elements == 15 then --6
local jilv = 0.05 + inst.level*0.016

if math.random() <= jilv then
  


								
        --inst.SoundEmitter:PlaySound("dontstarve/common/shadowTentacleAttack_1")
        --inst.SoundEmitter:PlaySound("dontstarve/common/shadowTentacleAttack_2")
		inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")     
		if v.components.burnable and not v:HasTag("structure") then
			v.components.burnable:Ignite() 
		end

        if v.components.burnable and v.components.burnable:IsBurning() then
			v.components.burnable:Extinguish() 
		end
		
		if v and v.task_chixu then v.task_chixu:Cancel() v.task_chixu = nil end
		v.task_chixu = v:DoPeriodicTask(0.5, function()
	    --v.components.health:DoDelta(-2)
	    if v and v.components.health and not v.components.health:IsDead() then
	    v.components.health:DoDelta(-inst.level*2)
		SpawnPrefab("laser_explosion").Transform:SetPosition(v.Transform:GetWorldPosition())

        --inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")	
        inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/items/weapon/corkbat") 		
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		                        --if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end			
		end
		end)
		v:DoTaskInTime(2.5, function()
		if v and v.task_chixu then v.task_chixu:Cancel() v.task_chixu = nil end
		end) 
		
end
  end
  


end

--生命值过低时几率晕倒--触发隐身
local function OnHitjidao(inst, data)
--触发隐身
if inst.level >= 31 and math.random() < 0.002*inst.level and inst.skill_4CD == 0 and not inst.components.driver.vehicle then
	inst.skill_4CD = 10
	inst.components.talker:Say("销声匿迹")
	--inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/yinshen")
	--inst.SoundEmitter:PlaySound("dontstarve/wilson/flute_LP", "flute")
	inst:AddTag("shadow")
	inst.components.colourtweener:StartTween({0.35,0.35,0.35,1}, 0)
	local pos = Vector3(inst.Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 8)
	for k,v in pairs(ents) do
		if v and v.components.combat and v.components.combat.target == inst then
			v.components.combat.target = nil
		end
	end
	if inst.shadowtask then inst.shadowtask:Cancel() inst.shadowtask = nil end
	inst.shadowtask = inst:DoTaskInTime(2.5+inst.level/100, function(inst)
	inst:Show()
	inst:RemoveTag("shadow")
	inst.components.colourtweener:StartTween({1,1,1,1}, 0)
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/head/stop")


	end)
end

	if inst.components.health:GetPercent() < 0.2 then
		--if math.random() < 0.2 then
		  --inst:DoTaskInTime(0.2, function() inst.sg:GoToState("death") end)
		  --inst:DoTaskInTime(0.1, function() inst.sg:GoToState("passout") end)
		  --inst:DoTaskInTime(0.1, function() inst.sg:GoToState("idle") end)
		--end
	end


end 

--技能cd
local function skill_cd(inst)
  local inst = GetPlayer()
  if inst.skill_1CD > 0 then 
    inst.skill_1CD = inst.skill_1CD - 0.5
 
  end

  if inst.skill_2CD > 0 then 
    inst.skill_2CD = inst.skill_2CD - 0.5

  end

  if inst.skill_3CD > 0 then 
    inst.skill_3CD = inst.skill_3CD - 0.5

  end  
  
  if inst.skill_4CD > 0 then 
    inst.skill_4CD = inst.skill_4CD - 0.5
 
  end  
  
  if inst.skill_5CD > 0 then 
    inst.skill_5CD = inst.skill_5CD - 0.5

  end  
  
end



--显示经验和等级
local function SetHUDState(inst, data)
	if inst.HUD then
		local nandusize = 35
		
        inst.HUD.xiulian = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, nandusize))
		inst.HUD.xiulian:SetPosition(-600,100,0)
        inst.HUD.xiulian:SetString("修炼进度:"..tostring(inst.practice))
        inst.HUD.xiulian:SetColour(0, 0.9, 1, 1)
		
        inst.HUD.meili = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, nandusize))
		inst.HUD.meili:SetPosition(-600,75,0)
        inst.HUD.meili:SetString("魅力值:"..tostring(inst.treasure))
        inst.HUD.meili:SetColour(0, 0.9, 1, 1)
		
        inst.HUD.dengji = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, nandusize))
		inst.HUD.dengji:SetPosition(-600,50,0)
        inst.HUD.dengji:SetColour(0, 0.9, 1, 1)
        inst.HUD.dengji:SetString("修真等级:"..tostring(inst.level))

		
        inst.HUD.remnant_practice = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, nandusize))
		inst.HUD.remnant_practice:SetPosition(-600,25,0)
        inst.HUD.remnant_practice:SetColour(0, 0.9, 1, 1)
        inst.HUD.remnant_practice:SetString("剩余修炼次数:"..tostring(5*inst.level-inst.count_practice))
		
        --inst.HUD.jingyan = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, nandusize))
		--inst.HUD.jingyan:SetPosition(-600,0,0)
        --inst.HUD.jingyan:SetString("仇恨值:"..tostring(inst.exp))
        --inst.HUD.jingyan:SetColour(0, 0.9, 1, 1)
		
		--local nandusize = 35
        inst.HUD.jinengcd = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, nandusize))
		inst.HUD.jinengcd:SetPosition(-420,100,0)
        inst.HUD.jinengcd:SetString("当前技能CD:"..tostring(inst.skill_3CD))
        inst.HUD.jinengcd:SetColour(0, 0.9, 1, 1)
		

		

		
        inst.HUD.daojishi = inst.HUD.controls.bottom_root:AddChild(Text(BODYTEXTFONT, 35))
		inst.HUD.daojishi:SetPosition(0,500,0)
        inst.HUD.daojishi:SetString("江湖追杀倒计时:"..tostring(inst.zhuishadaojishi))
        inst.HUD.daojishi:SetColour(0, 0.9, 1, 1)	


		local hehe = inst.HUD.controls.bottomright_root:AddChild(ImageButton("images/hud/toso_tab.xml", "toso_tab.tex"))
		hehe:SetPosition(-200,160,0)
		hehe:SetScale(0.4)
		hehe:SetOnClick(function ()
		TheFrontEnd:PushScreen(TosoScreen2())
		end)
		hehe:SetTooltip("屠苏丹药简介")		
--[[
--被动技能ui
		GetPlayer().HUD.change_elements1 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements1:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements1:SetScale(0.6)
        GetPlayer().HUD.change_elements1:SetClickable(true)	
		GetPlayer().HUD.change_elements1:SetTooltip("当前属性：剑意\n被动：攻击带溅射伤害")
		
		GetPlayer().HUD.change_elements2 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements2:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements2:SetScale(0.6)
        GetPlayer().HUD.change_elements2:SetClickable(true)	
		GetPlayer().HUD.change_elements2:SetTooltip("当前属性：夺魂\n被动：攻击吸血")
		
		GetPlayer().HUD.change_elements3 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements3:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements3:SetScale(0.6)
        GetPlayer().HUD.change_elements3:SetClickable(true)
		GetPlayer().HUD.change_elements3:SetTooltip("当前属性：冰刺\n被动：攻击带冰冻效果")		

		GetPlayer().HUD.change_elements4 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements4:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements4:SetScale(0.6)
        GetPlayer().HUD.change_elements4:SetClickable(true)	
		GetPlayer().HUD.change_elements4:SetTooltip("当前属性：破极\n被动：攻击产生真实伤害，自己亦无法跳过")
		
		GetPlayer().HUD.change_elements5 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements5:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements5:SetScale(0.6)
        GetPlayer().HUD.change_elements5:SetClickable(true)	
		GetPlayer().HUD.change_elements5:SetTooltip("当前属性：逐日\n被动：攻击跟踪目标")
		
		GetPlayer().HUD.change_elements6 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements6:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements6:SetScale(0.6)
        GetPlayer().HUD.change_elements6:SetClickable(true)	
		GetPlayer().HUD.change_elements6:SetTooltip("当前属性：星爆\n被动：地方单位连续爆体")
		
		GetPlayer().HUD.change_elements7 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements7:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements7:SetScale(0.6)
        GetPlayer().HUD.change_elements7:SetClickable(true)	
		GetPlayer().HUD.change_elements7:SetTooltip("当前属性：土\n被动：默认")
		
		GetPlayer().HUD.change_elements8 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_elements8:SetPosition(-400,100,0)
		GetPlayer().HUD.change_elements8:SetScale(0.6)
        GetPlayer().HUD.change_elements8:SetClickable(true)	
		GetPlayer().HUD.change_elements8:SetTooltip("当前属性：土\n被动：默认")
]]
		--左切换
        GetPlayer().HUD.ui_zuo = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/ui_zuo.xml", "ui_zuo.tex"))
        GetPlayer().HUD.ui_zuo:SetPosition(-256,100,0)
        GetPlayer().HUD.ui_zuo:SetScale(0.6) 
        GetPlayer().HUD.ui_zuo:SetOnClick(GetPlayer().zuo) 
		GetPlayer().HUD.ui_zuo:SetTooltip("切换技能")
		--右切换
		GetPlayer().HUD.ui_you = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/ui_you.xml", "ui_you.tex"))
		GetPlayer().HUD.ui_you:SetPosition(-168,100,0)
		GetPlayer().HUD.ui_you:SetScale(0.6)
        GetPlayer().HUD.ui_you:SetOnClick(GetPlayer().you) 
		GetPlayer().HUD.ui_you:SetTooltip("切换技能")	
		
		

        --技能
		GetPlayer().HUD.change_skill1 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill1:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill1:SetScale(0.6)
        GetPlayer().HUD.change_skill1:SetClickable(true)	
		GetPlayer().HUD.change_skill1:SetTooltip("当前技能：疾风斩\n消耗：需要120怒气")		

		GetPlayer().HUD.change_skill2 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill2:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill2:SetScale(0.6)
        GetPlayer().HUD.change_skill2:SetClickable(true)	
		GetPlayer().HUD.change_skill2:SetTooltip("当前技能：焰阵陨杀\n消耗：需要100怒气")

		GetPlayer().HUD.change_skill3 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill3:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill3:SetScale(0.6)
        GetPlayer().HUD.change_skill3:SetClickable(true)	
		GetPlayer().HUD.change_skill3:SetTooltip("当前技能：飞天\n消耗：需要180怒气")

		GetPlayer().HUD.change_skill4 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill4:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill4:SetScale(0.6)
        GetPlayer().HUD.change_skill4:SetClickable(true)	
		GetPlayer().HUD.change_skill4:SetTooltip("当前技能：绝息\n消耗：需要150怒气")
		
		GetPlayer().HUD.change_skill5 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill5:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill5:SetScale(0.6)
        GetPlayer().HUD.change_skill5:SetClickable(true)	
		GetPlayer().HUD.change_skill5:SetTooltip("当前技能：三千月斩\n消耗：需要120怒气")

		GetPlayer().HUD.change_skill6 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill6:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill6:SetScale(0.6)
        GetPlayer().HUD.change_skill6:SetClickable(true)	
		GetPlayer().HUD.change_skill6:SetTooltip("当前技能：爱无限\n消耗：需要120怒气")

		GetPlayer().HUD.change_skill7 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill7:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill7:SetScale(0.6)
        GetPlayer().HUD.change_skill7:SetClickable(true)	
		GetPlayer().HUD.change_skill7:SetTooltip("当前技能：由莲剑法\n消耗：需要120怒气")

		GetPlayer().HUD.change_skill8 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill8:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill8:SetScale(0.6)
        GetPlayer().HUD.change_skill8:SetClickable(true)	
		GetPlayer().HUD.change_skill8:SetTooltip("当前技能：隐身\n消耗：需要50怒气")

		GetPlayer().HUD.change_skill9 = GetPlayer().HUD.controls.bottom_root:AddChild(ImageButton("images/change_elements1.xml", "change_elements1.tex"))
		GetPlayer().HUD.change_skill9:SetPosition(-212,100,0)
		GetPlayer().HUD.change_skill9:SetScale(0.6)
        GetPlayer().HUD.change_skill9:SetClickable(true)	
		GetPlayer().HUD.change_skill9:SetTooltip("当前技能：离魂\n消耗：需要100怒气")
		
	end
end

--触发江湖追杀
local function zhuisha(inst)

  --local zhuisha = inst.skill_1 + inst.skill_2 + inst.skill_3 + inst.skill_4 + inst.skill_5
  if inst.level > inst.zhuisha then
     inst.zhuisha = inst.zhuisha + 1
     if inst.HUD then
      inst.HUD.daojishi:Show()
	 end
  else
    if inst.HUD and inst.zhuishadaojishi == 0 then
      inst.HUD.daojishi:Hide()
	end
  end 
end 


local function applyupgrades(inst, data)
--[[
    local heji = TUNING.TOSO_NEEDEXP
	if inst.level <= 3 then
    heji = TUNING.TOSO_NEEDEXP
    elseif inst.level > 3 and inst.level <= 10 then
    heji = TUNING.TOSO_NEEDEXP - 500
    elseif inst.level > 10 and inst.level <= 15 then
    heji = TUNING.TOSO_NEEDEXP - 1000
    elseif inst.level > 15 and inst.level <= 20 then
    heji = TUNING.TOSO_NEEDEXP - 1500
    elseif inst.level > 20 and inst.level <= 25 then
    heji = TUNING.TOSO_NEEDEXP - 2000
    elseif inst.level > 20 then
    heji = 2000
	end
]]	
	if inst.level >= 15 then--自动回血
	local huixue = inst.level*0.2  --10级10秒回2血，100级10秒回20血
	inst.components.health:StartRegen(huixue, 10)

    end	
	

	--15级获取该能力
	if inst.level >= 10 then--建材消耗一半
    inst.components.builder.ingredientmod = 0.5

    end	
	--20级获取该能力
	if inst.level >= 20 then--建材消耗一半
	inst.components.builder.science_bonus = 2	
    end	
	--25级获取该能力
	if inst.level >= 25 then--建材消耗一半
	inst.components.builder.magic_bonus = 2	
    end	
	--30级获取该能力
	if inst.level >= 30 then--建材消耗一半
	inst.components.builder.ancient_bonus = 2	
    end
	--35级获取该能力
	if inst.level >= 35 then--建材消耗一半
	inst.components.builder.obsidian_bonus = 2	
    end	
	--40级获取该能力
	if inst.level >= 40 then--建材消耗一半
	inst.components.builder.city_bonus = 2	
	inst.components.builder.home_bonus = 2	
    end	
	--45级获取该能力
	if inst.level >= 45 then--建材消耗一半
	inst.components.builder.lost_bonus = 2	

    end	
	--30级获取该能力
	if inst.level >= 30 then--恒温	
	       inst.components.temperature.mintemp = 20
	       inst.components.temperature.maxtemp = 40	
    end	

	
    local hunger_percent = inst.components.hunger:GetPercent()
    local health_percent = inst.components.health:GetPercent()
    local sanity_percent = inst.components.sanity:GetPercent()



	if inst.exp >= TUNING.TOSO_NEEDEXP + inst.level*500 and inst.level < 100 then
	inst.exp = math.floor(inst.exp - TUNING.TOSO_NEEDEXP - inst.level*500)
	inst.level = inst.level + 1	
	
	
	--inst.components.talker:Say("升级咯！")
	inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
	inst.SoundEmitter:PlaySound("dontstarve/common/horn_beefalo")
	
--if TUNING.TOSO_KEY21 == 0 then--开启入侵

--暂时关闭追杀

	inst.components.talker:Say("江湖追杀即将来临！")
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/smash")
	inst.zhuishadaojishi = 30
	inst:DoTaskInTime(33, function() 
inst.SoundEmitter:PlaySound("dontstarve/common/craftable/lightning_rod")
	--江湖追杀
	zhuisha_hunt(inst)--依次按照人物等级登场
suijiguai[math.random(15)](inst, data) --加一队友
suijishengwuguai[math.random(8)](inst, data)  --加一个怪物

if inst.level > 5 then
--suijiguai[math.random(15)](inst, data)  --增加两个队友
--suijishengwuguai[math.random(8)](inst, data)  

end
if inst.level > 10 then
suijiguai[math.random(15)](inst, data)  
suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 15 then
--suijiguai[math.random(15)](inst, data)  
--suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 20 then
suijiguai[math.random(15)](inst, data)   
suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 25 then
--suijiguai[math.random(15)](inst, data)   
--suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 30 then
suijiguai[math.random(15)](inst, data)   
suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 35 then
--suijiguai[math.random(15)](inst, data)   
--suijishengwuguai[math.random(8)](inst, data) 
--遠古boss出現
bossarm[math.random(8)](inst, data) 
end
if inst.level > 40 then
suijiguai[math.random(15)](inst, data)   
suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 45 then
--suijiguai[math.random(15)](inst, data)   
--suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 50 then
suijiguai[math.random(15)](inst, data)  
suijishengwuguai[math.random(8)](inst, data) 
--遠古boss出現
bossarm[math.random(8)](inst, data) 
end
if inst.level > 55 then
--suijiguai[math.random(15)](inst, data)   
--suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 60 then
--suijiguai[math.random(15)](inst, data)   
--suijishengwuguai[math.random(8)](inst, data) 

end
if inst.level > 70 then
--suijiguai[math.random(15)](inst, data)   
--suijishengwuguai[math.random(8)](inst, data) 

end
	--inst.components.talker:Say("ok ！")	
	end)
	

--暂时关闭追杀

--end
	--elseif inst.exp >= heji and inst.level >= 25 then
	
	end


	--饥饿
	--local xyz = inst.jie
    inst.components.hunger.hungerrate = inst.jie * TUNING.WILSON_HUNGER_RATE		
	--倍攻
	
    --似乎兼容哈姆后自动加载哈姆的战斗组件
	--inst.components.combat.damagemultiplier = 1 + inst.beigong	
	--if TUNING.SDLC ~= 1 then
	inst.components.combat:AddDamageModifier("ssword", inst.beigong)
	

	--end
	
--移速
	inst.components.locomotor.walkspeed = 5 + inst.yisu--0.12
    inst.components.locomotor.runspeed = 7 + inst.yisu--0.12
	--物抗
	if not inst:HasTag("lihun") then
	inst.components.health.absorb = inst.hujia --0-1
	end
	
--回san
	inst.components.sanity.dapperness = inst.huisan --0/60
	
--攻速
    if inst.level >=35 then
    inst.components.combat.min_attack_period = 0.5-inst.kangre
	end
	

	inst.components.hunger.max = math.ceil(1.5*TUNING.SSWORD_STARTHP+inst.sanwei)
	inst.components.health.maxhealth = math.ceil(TUNING.SSWORD_STARTHP+inst.sanwei)
	inst.components.sanity.max = math.ceil(TUNING.SSWORD_STARTHP+inst.sanwei)
	inst.components.health:DoDelta(50)
	inst.components.hunger:DoDelta(50)
	inst.components.sanity:DoDelta(50)


	inst.components.talker:Say("Level Up! : ".. (inst.level))
--升级提示
    inst.components.talker:Say("修真等级: "..(inst.level))
	if inst.HUD then
	inst.HUD.dengji:SetString("修真等级:"..tostring(inst.level))

	end

	inst.components.health:SetPercent(health_percent)
	inst.components.sanity:SetPercent(sanity_percent)
	inst.components.hunger:SetPercent(hunger_percent)
	inst.components.health:DoDelta(0)
	inst.components.hunger:DoDelta(0)
	inst.components.sanity:DoDelta(0)

end


--修炼值定义
--走路值相关的设计
--定义值
local function practice_hunt(inst,data)
local max_practice = 100
local practice = math.min(inst.practice, max_practice)
end


local function callover(inst, data)
--inst.components.talker:Say("就快到达瓶颈~")

	inst:DoTaskInTime(0, function()
	--inst.components.talker:Say("成功？~")
	--inst.SoundEmitter:PlaySound("dontstarve/common/craftable/lightning_rod")
--结束修炼

if inst:HasTag("juqi_in") then

   inst.sg:GoToState("play_onemanband_stomp") 
   inst:RemoveTag("juqi_in")

  		        if inst.juqiTask then
                   inst.juqiTask:Cancel()
                   inst.juqiTask=nil
				--inst.components.shaqi:DoDelta(0)
                end
   
  inst:DoTaskInTime(2, function() 
  
local success = 0.9  
  
 if inst.level < 5 then
success = 0.9   
 elseif inst.level >= 5 and inst.level < 20 then
success = 0.9  
 elseif inst.level >= 20 and inst.level < 40 then
success = 0.9  
 elseif inst.level >= 40 and inst.level < 60 then
success = 0.9  
 elseif inst.level >= 60 then
success = 0.9  
 
 end  
  
  
  
--灵根
 
  
  
if math.random() <= inst.linggen*0.1 then--后期设置灵根--选择灵根低炼药提升或者灵根高修炼提升

  if TUNING.XIU == 1 then
  
if inst.count_practice < inst.level*5 then  
  if inst.hujia < 0.5 then
  inst.hujia = inst.hujia + 0.025 
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("物理吸收增加0.025")
  else
  inst.hujia = 0.5 
  inst.components.talker:Say("物理吸收最高0.5")  --20
  end

else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 2 then
  
if inst.count_practice < inst.level*5 then  
  if inst.huisan < 1 then
  inst.huisan = inst.huisan + 0.025
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("精神恢复增加0.025每秒") 
  else
  inst.huisan = 1 
  inst.components.talker:Say("精神恢复最高1每秒")--40
  end  
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 3 then
  
if inst.count_practice < inst.level*5 then  
  if inst.sanwei < 400 then
  inst.sanwei = inst.sanwei + 1
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("三维上限增加1") 
  else
  inst.sanwei = 400 
  inst.components.talker:Say("三维上限最高增加400")--400
  end
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 4 then
  
if inst.count_practice < inst.level*5 then  
  if inst.yisu < 3 then
  inst.yisu = inst.yisu + 0.1
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("移动速度增加0.1") 
  else
  inst.yisu = 3 
  inst.components.talker:Say("移动速度最高增加3")--50
  end
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 5 then 
  
if inst.count_practice < inst.level*5 then  
  
  if inst.beigong < 5 then
  inst.beigong = inst.beigong + 0.05
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("攻击倍数增加0.05") --50次
  else
  inst.beigong = 5 
  inst.components.talker:Say("攻击倍数最高6倍")
  end  
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end
  
  elseif TUNING.XIU == 6 then
  
if inst.count_practice < inst.level*5 then  

  if inst.nuqi < 10 then
  inst.nuqi = inst.nuqi + 0.25
    --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("每次攻击怒气多增加0.25")  --40次
  else
  inst.nuqi = 10 
  inst.components.talker:Say("每次攻击怒气最高恢复10")
  end
 
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end
  
  elseif TUNING.XIU == 7 then
  
if inst.count_practice < inst.level*5 then 

  if inst.jie > 0.5 then
  inst.jie = inst.jie - 0.0625
    --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("饥饿速率下降0.0625") 
  else
  inst.jie = 0.5 
  inst.components.talker:Say("饥饿速率最低修炼到0.5倍")--40次
  end
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
 
  elseif TUNING.XIU == 8 then
  
if inst.count_practice < inst.level*5 then
  
  if inst.shanghai < 0.05 then
  inst.shanghai = inst.shanghai + 0.0005
    --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("百分比伤害提升0.0005")
  else
  inst.shanghai = 0.05 
  inst.components.talker:Say("最高每次攻击扣百分比5额外伤害")--20次
  end 

else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end
  
  elseif TUNING.XIU == 9 then--湿度暂时没有
  
if inst.count_practice < inst.level*5 then  
  if inst.kangshi < 0.1 then
  inst.kangshi = inst.kangshi + 0.002
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
    applyupgrades(inst)
  --inst.components.shaqi:DoDelta(-60)  
  inst.components.talker:Say("暴击概率提升0.002")  
  else
  inst.kangshi = 0.1 
  inst.components.talker:Say("攻击暴击最高概率为0.1")--50
  end  
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 10 then
  
if inst.count_practice < inst.level*5 then 
if inst.level <= 30 then 
  if inst.kangleng < 5 then
  inst.kangleng = inst.kangleng + 0.1
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("抗冷体质增加0.1") 
  else
  inst.kangleng = 5 
  inst.components.talker:Say("抗冷体质最高5")--50
  end 
  
end  
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 11 then
  
if inst.count_practice < inst.level*5 then  
if inst.level <= 30 then 
  if inst.kangre < 5 then
  inst.kangre = inst.kangre + 0.1
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("抗热体质增加0.1") 
  else
  inst.kangre = 5 
  inst.components.talker:Say("抗热体质最高5")--50
  end 
end
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 
  elseif TUNING.XIU == 12 then
  
if inst.count_practice < inst.level*5 then  
  if inst.xixue < 2 then
  inst.xixue = inst.xixue + 0.1
  --修炼次数记1
  inst.count_practice = inst.count_practice + 1
  --inst.components.shaqi:DoDelta(-60)
  applyupgrades(inst)
  inst.components.talker:Say("攻击每次吸血增加0.1")  
  else
  inst.xixue = 2 
  inst.components.talker:Say("攻击每次吸血最高2")--20
  end
  
else

  inst.components.talker:Say("请多杀怪提升修真等级后再修炼该项目")
end 

  end
  
inst.practice = inst.practice *0--记录值清零
else
  
inst.components.talker:Say("差一点点，改天再修炼吧")  
inst.practice = inst.practice *0--记录值清零
end
    inst.sg:GoToState("powerup") 
    inst.SoundEmitter:PlaySound("dontstarve/wilson/onemanband") inst.components.playercontroller:Enable(true) end)

end

--结束修炼			   
			   
			   
	end)

end

local function check_practice(inst)
 
if inst.practice >= 100 then 


callover(inst)--启动结束修炼
--elseif inst.practice < 100 then

end


end 

--累计记录修炼值
local function amount_practice(inst, data)

if inst.practice <100 and inst:HasTag("juqi_in") then 
 --inst.practice = inst.practice + 50  --test
 if inst.level <= 10 then
 inst.practice = inst.practice + 5*TUNING.PRACTICE_SPEED    --20s修炼完成
 elseif inst.level > 10 and inst.level <= 30 then
 inst.practice = inst.practice + 5*TUNING.PRACTICE_SPEED    --33s修炼完成
 elseif inst.level > 30 and inst.level <= 50 then
 inst.practice = inst.practice + 5*TUNING.PRACTICE_SPEED    --40s修炼完成 
 elseif inst.level > 50 and inst.level <= 80 then
 inst.practice = inst.practice + 5*TUNING.PRACTICE_SPEED    --50s修炼完成 
 elseif inst.level > 80 then
 inst.practice = inst.practice + 5*TUNING.PRACTICE_SPEED    --100s修炼完成 
  end
  
  
end 

end 

---修炼修炼


local function onpreload(inst, data)
	if data then
		if data.level then
			if data.qiuqiu then inst.qiuqiu = data.qiuqiu end
 
			inst.exp = data.exp
			inst.level = data.level
			inst.skillon = data.skillon
			inst.zhuoshao = data.zhuoshao
			
			--走路
	  		if data.treasure then
			inst.treasure = data.treasure
			treasure_hunt(inst)
			end	 
			--修炼
	  		if data.practice then
			inst.practice = data.practice
			practice_hunt(inst)
			end	 
			
--倒计时相关
      if data.zhuisha then inst.zhuisha = data.zhuisha end
      if data.zhuishadaojishi then inst.zhuishadaojishi = data.zhuishadaojishi end
      if data.lihunshijian then inst.lihunshijian = data.lihunshijian end
      if data.jifengshijian then inst.jifengshijian = data.jifengshijian end		  
	  
			--属性技能切换
      inst.change_elements = data.change_elements
      inst.change_skills = data.change_skills
	  
--修炼
      inst.hujia = data.hujia
      inst.huisan = data.huisan
	  inst.sanwei = data.sanwei
	  inst.yisu = data.yisu
	  inst.beigong = data.beigong
	  inst.nuqi = data.nuqi
	  inst.jie = data.jie
	  inst.shanghai = data.shanghai
	  inst.kangshi = data.kangshi
	  inst.kangleng = data.kangleng
	  inst.kangre = data.kangre
	  inst.xixue = data.xixue
--灵根
      inst.linggen = data.linggen
	  
      inst.count_practice = data.count_practice	  
	--帮武器保存的值
	inst.weapon_adddmg = data.weapon_adddmg
	inst.weapon_defense = data.weapon_defense
	--帮小妾保存的值
    inst.kidadddmg = data.kidadddmg
	  --技能级别保存
      if data.skill_1 then inst.skill_1 = data.skill_1 end
      if data.skill_2 then inst.skill_2 = data.skill_2 end
      if data.skill_3 then inst.skill_3 = data.skill_3 end
      if data.skill_4 then inst.skill_4 = data.skill_4 end
      if data.skill_5 then inst.skill_5 = data.skill_5 end		

      --cd保存
      if data.skill_1CD then inst.skill_1CD = data.skill_1CD end
      if data.skill_2CD then inst.skill_2CD = data.skill_2CD end
      if data.skill_3CD then inst.skill_3CD = data.skill_3CD end
      if data.skill_4CD then inst.skill_4CD = data.skill_4CD end
      if data.skill_5CD then inst.skill_5CD = data.skill_5CD end	
	

			applyupgrades(inst)
			zhuisha(inst)
			


		end
	end
end


--创造球球
local function Spawnqiuqiu(inst)
    local pt = Vector3(inst.Transform:GetWorldPosition())
    local spawn_pt = spawnoffscreen(pt)
    if spawn_pt then
        local qiuqiu = SpawnPrefab("pod")
        if qiuqiu then
            qiuqiu.Physics:Teleport(spawn_pt:Get())
            qiuqiu:FacePoint(pt.x, pt.y, pt.z)
			qiuqiu.components.follower:SetLeader(inst)
			inst.qiuqiu = true
        end
    end
end



local function onload(inst, data)
	if data then
		if data.level then
			if data.qiuqiu then inst.qiuqiu = data.qiuqiu end
			inst.exp = data.exp
			inst.level = data.level
			inst.skillon = data.skillon
			inst.zhuoshao = data.zhuoshao
			
			--元素切换
            inst.change_elements = data.change_elements	
            inst.change_skills = data.change_skills	
--修炼
      inst.hujia = data.hujia
      inst.huisan = data.huisan
	  inst.sanwei = data.sanwei
	  inst.yisu = data.yisu
	  inst.beigong = data.beigong
	  inst.nuqi = data.nuqi
	  inst.jie = data.jie
	  inst.shanghai = data.shanghai
	  inst.kangshi = data.kangshi
	  inst.kangleng = data.kangleng
	  inst.kangre = data.kangre
	  inst.xixue = data.xixue
      inst.count_practice = data.count_practice	

	inst.weapon_adddmg = data.weapon_adddmg
	inst.weapon_defense = data.weapon_defense
	--帮小妾保存的值
    inst.kidadddmg = data.kidadddmg
	  
--灵根
      inst.linggen = data.linggen
			applyupgrades(inst)
			zhuisha(inst)
			



		end
	end
end

local function onsave(inst, data)
	data.qiuqiu = inst.qiuqiu
	data.exp = inst.exp
	data.level = inst.level
	data.skillon = inst.skillon
	data.zhuoshao = inst.zhuoshao
	

	  --走路
    data.treasure = inst.treasure	
	  --修炼
    data.practice = inst.practice
	
--倒计时相关
  data.zhuisha = inst.zhuisha
  data.zhuishadaojishi = inst.zhuishadaojishi  
  data.lihunshijian = inst.lihunshijian
  
  data.jifengshijian = inst.jifengshijian
  
 	--元素切换
  data.change_elements = inst.change_elements 
  data.change_skills = inst.change_skills 

--修炼
      data.hujia = inst.hujia
      data.huisan = inst.huisan
	  data.sanwei = inst.sanwei
	  data.yisu = inst.yisu
	  data.beigong = inst.beigong
	  data.nuqi = inst.nuqi
	  data.jie = inst.jie
	  data.shanghai = inst.shanghai
	  data.kangshi = inst.kangshi
	  data.kangleng = inst.kangleng
	  data.kangre = inst.kangre
	  data.xixue = inst.xixue
      data.count_practice = inst.count_practice	  
	  
--灵根
      data.linggen = inst.linggen
	  
	data.weapon_adddmg = inst.weapon_adddmg
	data.weapon_defense = inst.weapon_defense
	--帮小妾保存的值
    data.kidadddmg = inst.kidadddmg
--技能级别加載
  data.skill_1 = inst.skill_1
  data.skill_2 = inst.skill_2
  data.skill_3 = inst.skill_3
  data.skill_4 = inst.skill_4
  data.skill_5 = inst.skill_5
--技能CD加載
  data.skill_1CD = inst.skill_1CD
  data.skill_2CD = inst.skill_2CD
  data.skill_3CD = inst.skill_3CD
  data.skill_4CD = inst.skill_4CD
  data.skill_5CD = inst.skill_5CD

end

--杀死生物后得掉落
local function onpick(inst,data)

		
		if math.random() <= 0.05 then

			local x,y,z = inst.Transform:GetWorldPosition()
			local stuff1 = SpawnPrefab("yaoshui")
			stuff1.Transform:SetPosition(x,y,z)
			inst.components.talker:Say("掉落回复灵药")

		end

		if math.random() <= 0.02 then
        inst:DoTaskInTime(20/30, function() 
            --inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingThrowGold")
 	        inst.SoundEmitter:PlaySound("dontstarve/forest/treefall")           
            for k = 1, 5 do
                local nug = SpawnPrefab("meat")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
            end
        end)
		end	
		
		if math.random() <= 0.02 then
        inst:DoTaskInTime(20/30, function() 
            --inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingThrowGold")
 	        inst.SoundEmitter:PlaySound("dontstarve/forest/treefall")           
            for k = 1, 5 do
                local nug = SpawnPrefab("nightmarefuel")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
            end
        end)
		end		

		if math.random() <= 0.05 then
        inst:DoTaskInTime(20/30, function() 
            --inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingThrowGold")
 	        inst.SoundEmitter:PlaySound("dontstarve/forest/treefall")           
            for k = 1, 5 do
                local nug = SpawnPrefab("goldnugget")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
            end
        end)
		end

		
end


--击杀获得经验，用翼语的杀怪经验结算（参考翼语代码）
local function onkill(inst, data)
--掉玲草的花
		if inst and inst.level >= 31 and data and data.victim:HasTag("toso_arm") then
			inst.components.talker:Say("掉落玲草的花")
			local x,y,z = inst.Transform:GetWorldPosition()
			local stuff1 = SpawnPrefab("toso_lingcao_flower")
			stuff1.Transform:SetPosition(x,y,z)
        elseif inst and data and data.victim:HasTag("toso_arm") then
			local x,y,z = inst.Transform:GetWorldPosition()
			local stuff1 = SpawnPrefab("dragonpie")
			stuff1.Transform:SetPosition(x,y,z)
		end


--击杀boss增加穿甲
--local vtgt = data.victim
	  if inst and data and data.victim:HasTag("epic") and not data.victim:HasTag("tree") and not data.victim:HasTag("spiderqueen") and inst.weapon_defense < 1 then--史诗怪物leiftreespiderqueen
         inst.weapon_defense = inst.weapon_defense + 0.02--无视防御------
      if inst.weapon_defense >=1 then
	  inst.weapon_defense = 1
	  end

	  end
	--当武器攻击力满级后，击杀人形怪可以增加攻击力上限
	  if inst and data and data.victim:HasTag("toso_arm") and inst.weapon_adddmg > 98 then--人形怪提供额外攻击力
         inst.weapon_adddmg = inst.weapon_adddmg + 0.5--额外攻击力提升------
      --if inst.weapon_defense >=1 then  --暂时 不加上限
	  --inst.weapon_defense = 1
	  --end

	  end

	--击杀人形BOSS可以增加物理吸收上限
	  if inst and data and data.victim:HasTag("toso_armboss") and inst.hujia < 0.9 then--人形BOSS提供额外物理吸收
         inst.hujia = inst.hujia + 0.01--额外hujia提升------
      if inst.hujia >=0.9 then  --上限
	  inst.hujia = 0.9
	  end

	  end
	  
    if inst and data and data.victim             --data.cause == inst.prefab 
        and not data.victim:HasTag("prey")
        and not data.victim:HasTag("veggie") 
        and not data.victim:HasTag("structure")
		and not data.victim:HasTag("wall")
		and not data.victim:HasTag("toso_arm") ---人形怪不加仇恨
		--and not data.victim.prefab == "bramblespike" ---藤蔓
		and data.victim.components.health
		and data.victim.components.health.maxhealth
		and data.victim.components.combat.defaultdamage then
		local expnum = data.victim.components.health.maxhealth/5
    if data.victim.components.health.maxhealth <= 500 then
		expnum = (data.victim.components.health.maxhealth/5)*2.5
	elseif data.victim.components.health.maxhealth > 500 and data.victim.components.health.maxhealth <= 10000 then
		expnum = data.victim.components.health.maxhealth/5
		
	elseif data.victim.components.health.maxhealth > 10000 then
		--expnum = 2000	
		expnum = data.victim.components.health.maxhealth/5
	
	end

--蜜蜂100/10+10   =20 *2=40 = 10
--蜘蛛100/10+20   =30 *2=60 = 15
--猎犬150/10+20   =35 *2=70
--猪人250/10+33   =58 *2=116
--影怪400/10+50   =90 *2=180
--高鸟400/10+50   =90 *2=180
--毛牛500/10+34   =84 *2=168
--触手500/10+34   =84 *2=168
--女王1250/10+80  =205*2=410
--树精2000/10+150 =350*2=700
--巨鹿2000/10+150 =350*2=700
--鸭子3000/10+150 =450*2=900
--龙蝇2750/10+150 =425*2=850
--熊大3000/10+200 =500*2=20
		inst.exp = math.floor(inst.exp + expnum)
		applyupgrades(inst)
				--掉落和怪物
		onpick(inst)
		
	--if inst.level > inst.zhuisha then
		zhuisha(inst)
	--end

	  
	  
	end


end

--属性降温
local function jiangwen(inst, data)


	
	       if inst.components.temperature.current > 65 and inst.level <= 30 then		
		   
		       local fx = SpawnPrefab("baguadun")
    		   fx.entity:AddFollower()
	    	   fx.Follower:FollowSymbol(inst.GUID, "swap_body", 0, 0, 0)
			
		   inst:DoTaskInTime(10, function()
		   if inst.components.temperature.current > 10 then
              inst.components.temperature.current = inst.components.temperature.current - inst.kangre
		   end
		   end)


	       --else


           end



end 

--属性升温
local function shengwen(inst, data)


	       if inst.components.temperature.current < 6 and inst.level <= 30 then	
               local fx = SpawnPrefab("baguadun")
    		   fx.entity:AddFollower()
	    	   fx.Follower:FollowSymbol(inst.GUID, "swap_body", 0, 0, 0)		   
		   inst:DoTaskInTime(10, function()
		   if inst.components.temperature.current < 55 then
              inst.components.temperature.current = inst.components.temperature.current + inst.kangleng
		   end 
		   end)


	       --else


           end



end 

--降低潮湿
local function chaoshi(inst, data)


	       --if inst.components.moisture.moisture > 0 then	
               --local fx = SpawnPrefab("baguadun")
    		   --fx.entity:AddFollower()
	    	   --fx.Follower:FollowSymbol(inst.GUID, "swap_body", 0, 0, 0)		   
		   inst:DoTaskInTime(10, function()
		   if inst.components.moisture.moisture > 30 then
              inst.components.moisture.moisture = inst.components.moisture.moisture - inst.kangshi
		   end 
		   end)


	       --else


           --end



end 

local sswordfn = function(inst)
  inst.ssword_states = 0
  inst.zhuisha = 1 
  inst.zhuishadaojishi = 0 
  inst.lihunshijian = 0
  inst.jifengshijian = 0
  
  --被动值
  inst.change_elements = 1
  inst.change_skills = 8
  
  inst.combo = 1
  --走路相关
  inst.treasure = 0
  inst.practice = 0
  
  
--修炼
      inst.hujia = 0
      inst.huisan = 0
	  inst.sanwei = 0
	  inst.yisu = 0
	  inst.beigong = 0
	  inst.nuqi = 0.25
	  inst.jie = 3
	  inst.shanghai = 0
	  inst.kangshi = 0
	  inst.kangleng = 0
	  inst.kangre = 0
	  inst.xixue = 0

	inst.weapon_adddmg = 0--提升------
	inst.weapon_defense = 0--无视防御------
	--帮小妾保存的值
    inst.kidadddmg = 0
	  
      --inst.linggen = math.random(10)  --随机灵根
      inst.linggen = TUNING.PLAYER_LINGGEN  
	  
--修炼次数统计--修炼伤害和饥饿度必须提升等级，每级10点可修炼次数
	  inst.count_practice = 0

  -----------------------------skilllevel

  inst.skill_1 = 0
  inst.skill_2 = 0
  inst.skill_3 = 0
  inst.skill_4 = 0
  inst.skill_5 = 0
  -----------------------------skillcd
  inst.skill_1CD = 0--58   -- 58-25*2=8
  inst.skill_2CD = 0--60
  inst.skill_3CD = 0--60
  inst.skill_4CD = 0--90
  inst.skill_5CD = 0--70

 
	
inst.cd_task1 = inst:DoPeriodicTask(0.5, function() 

skill_cd(inst) 

--技能cd显示刷新
	if inst.HUD then
        inst.HUD.jinengcd:SetString("当前技能CD:"..tostring(inst.skill_3CD))
		inst.HUD.xiulian:SetString("修炼进度:"..tostring(inst.practice))
		inst.HUD.meili:SetString("魅力值:"..tostring(inst.treasure))
	    inst.HUD.remnant_practice:SetString("剩余修炼次数:"..tostring(5*inst.level-inst.count_practice))

if inst.level > 30 then

GetPlayer().HUD.ui_zuo:Show()
GetPlayer().HUD.ui_you:Show()
else
GetPlayer().HUD.ui_zuo:Hide()
GetPlayer().HUD.ui_you:Hide()
end


	end

end)
	--照明仙灵元素
    --inst.applylight = inst:DoPeriodicTask(0,applylight)	

	-- choose which sounds this character will play
	inst.soundsname = "willow"
	--设定外表
	inst.entity:AddAnimState():SetBank("wilson")
	inst.entity:AddAnimState():SetBuild("toso")
	inst.entity:AddAnimState():PlayAnimation("idle")
	
	inst.Transform:SetScale(1.2,1.2,1.2)


	
	--inst.AnimState:SetBuild("toso")
	--数据初始值
	inst.exp = 0
	inst.level = 1
	inst.skillon = true
--领域
	inst.zhuoshao = 0
	--球球
    inst.qiuqiu = 0
    inst.missatk = false
	
--技能表--

local rpg_jineng = 
{
--金属性
	[1] = function(inst, data)--踏前斩
	local skillconsumemax1 = 20
	
	inst.components.talker:Say("我的疾风已经蓄满")
	inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup") 
	inst:AddTag("jifeng")
	inst.jifengshijian = 15+inst.level/10
	inst.shadowtask = inst:DoTaskInTime(15+inst.level/10, function(inst)
    inst.components.talker:Say("破损的剑刃，破碎的意志")	
	inst:RemoveTag("jifeng")


	end)	
	
	end,
	
	[2] = function(inst, data)--
	local skillconsumemax1 = 20
	
    inst.AnimState:PlayAnimation("powerup")
	local x,y,z = inst:GetPosition():Get()

	local ents = TheSim:FindEntities(x,y,z, 25)

	for k,v in pairs(ents) do
		--if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("ssword") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("companion") and not v:HasTag("toso_helper") then
        
		if v and not v:HasTag("prey")
        and not v:HasTag("veggie") 
        and not v:HasTag("structure")
		and not v:HasTag("wall")
		and v.components.combat
		and v.components.health
		and not v.components.health:IsDead() 
		and not v:HasTag("ssword")
		and not v:HasTag("player")
		and not v:HasTag("bird")
		and not v:HasTag("myfriend")
		and not v:HasTag("companion")
		
		then               
		--之前的灭火特效位置
		--local vpos = Vector3(v.Transform:GetWorldPosition())
		--召唤陨石
				if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end

                inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/firesupressor_shoot")
				

	    v.components.health:DoDelta(-50-2*inst.level)		
		if v and v.task_chixu then v.task_chixu:Cancel() v.task_chixu = nil end
		v.task_chixu = v:DoPeriodicTask(0.5, function()

	    if v and v.components.health and not v.components.health:IsDead() then
	    v.components.health:DoDelta(-2*inst.level)
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		
		        local gujianrain = SpawnPrefab("gujianrain")
                gujianrain.Transform:SetPosition(v.Transform:GetWorldPosition())
                gujianrain:StartStep()

		SpawnPrefab("laser_explosion").Transform:SetPosition(v.Transform:GetWorldPosition())

        inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/swordfish_sword")	
        --inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/items/weapon/corkbat") 
		
		--if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		--if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end	
		
		end
		end)
		v:DoTaskInTime(4, function()
		if v and v.task_chixu then v.task_chixu:Cancel() v.task_chixu = nil end
		end)


		end
	end
			   


	end,
	
	[3] = function(inst, data)--
	local skillconsumemax1 = 20



    inst.sg:GoToState("tosojump")




	end,
--木属性	
	[4] = function(inst, data)
	local skillconsumemax1 = 20
                    inst.components.sswordcast:dilie_attack2(inst)
			   		inst:DoTaskInTime(0.2, function()
                    inst.components.sswordcast:siwangfanzhao_attack2(inst)
		            end)	
	
	end,
	
	[5] = function(inst, data)
	local skillconsumemax1 = 20
	

    inst.sg:GoToState("sanqianyuezhan")

	
	end,
	
	[6] = function(inst, data)
	local skillconsumemax1 = 20
	

    inst.sg:GoToState("hengsao_fx")	

	
	end,
	
	[7] = function(inst, data)
	local skillconsumemax1 = 20
	

    inst.sg:GoToState("swordkill_fx")	

	
	end,

	[8] = function(inst, data)
	local skillconsumemax1 = 20

	   	   	   --if inst.components.shaqi:GetPercent() >= 0.95 then

	inst.components.talker:Say("销声匿迹")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	--inst.SoundEmitter:PlaySound("dontstarve/wilson/flute_LP", "flute")
	inst:AddTag("shadow")
	inst.components.colourtweener:StartTween({0.35,0.35,0.35,1}, 0)
	local pos = Vector3(inst.Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 8)
	for k,v in pairs(ents) do
		if v and v.components.combat and v.components.combat.target == inst and not v:HasTag("toso_armboss") then
			v.components.combat.target = nil
		end
	end
	if inst.shadowtask then inst.shadowtask:Cancel() inst.shadowtask = nil end
	inst.shadowtask = inst:DoTaskInTime(5+inst.level/10, function(inst)
	inst:Show()
	inst:RemoveTag("shadow")
	inst.components.colourtweener:StartTween({1,1,1,1}, 0)
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/head/stop")

	end)
			   --inst.components.shaqi:DoDelta(-180)
			   --else
			   --inst.components.talker:Say("怒气不足")
	           --end

	end,

	[9] = function(inst, data)	
	local skillconsumemax1 = 20



	inst.components.talker:Say("灵魂出窍")
	inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup") 
	local x1, y1, z1 = inst.Transform:GetWorldPosition()
	inst.fire = SpawnPrefab( "lighterfire" )
	inst.fire.Transform:SetPosition(x1, y1, z1)
	inst.fire.Transform:SetScale(3, 3, 3)
	inst:AddTag("lihun")
	--inst.components.health.absorb = 1
		    --inst.ss_isInvincible = inst.components.health.invincible   --记录原来的无敌状态 防止误清
            --inst.components.health:SetInvincible(true)  --传送期间生命值无敌
			inst.ss_missatk = inst.missatk
			inst.missatk = true
    inst.components.combat.min_attack_period = inst.components.combat.min_attack_period / 10
	inst.lihunshijian = 15+inst.level/10
--丢装备函数
--[[
    if inst and inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD) then
        local item = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
        if not item then return end
        inst.components.inventory:DropItem(item)

    end
    if inst and inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) then
        local item = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
        if not item then return end
        inst.components.inventory:DropItem(item)

    end
]]
    --if not inst.lihunshijian == 0 then	
	--inst.Transform:SetPosition(x1, y1, z1)
	--end
	if inst.shadowtask then inst.shadowtask:Cancel() inst.shadowtask = nil end
	inst.shadowtask = inst:DoTaskInTime(15+inst.level/10, function(inst)
    --if inst.lihunshijian == 0 then	
	inst.Transform:SetPosition(x1, y1, z1)
	inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup") 
	--end
    if inst.fire then	
	inst.fire:Remove()
    inst.fire = nil
	end
	inst:RemoveTag("lihun")
	--inst.components.health.absorb = inst.hujia
			--if not inst.ss_isInvincible then
                --inst.components.health:SetInvincible(false)
            --end	
			if not inst.ss_missatk then
			       inst.missatk = false
            end	

			

    inst.components.combat.min_attack_period = inst.components.combat.min_attack_period * 10
--最后一次的离魂--31级后如果再次抽到离魂，将是最后一次，释放后重新置1
          if inst.level > 30 and inst.change_skills  then

             inst.change_skills = 1
          end
	end)



	
	end,
	
}
	
	
	--HUD经验等级
	inst:DoTaskInTime(0, function() SetHUDState(inst) end)	
    inst:DoTaskInTime(1, function() zhuisha(inst) end)

	--技能CD
	inst.task_tosocd = inst:DoPeriodicTask(0.5, function()
	if inst.skill_1CD > 0 then inst.skill_1CD = inst.skill_1CD - 0.5 end
	if inst.skill_2CD > 0 then inst.skill_2CD = inst.skill_2CD - 0.5 end
	if inst.skill_3CD > 0 then inst.skill_3CD = inst.skill_3CD - 0.5 end
	if inst.skill_4CD > 0 then inst.skill_4CD = inst.skill_4CD - 0.5 end
	if inst.skill_5CD > 0 then inst.skill_5CD = inst.skill_5CD - 0.5 end
	
    end)
	
	
	--追杀倒计时
	inst.task_daojishi = inst:DoPeriodicTask(1, function()
    --离魂
	if inst.lihunshijian > 0 then 
	inst.lihunshijian = inst.lihunshijian - 1 
	end
--疾风
	if inst.jifengshijian > 0 then 
	inst.jifengshijian = inst.jifengshijian - 1 
		if inst.jifengshijian <= 0 then inst.jifengshijian = 0 end
	end
	--追杀
	if inst.zhuishadaojishi > 0 then 
	inst.zhuishadaojishi = inst.zhuishadaojishi - 1 
	  if inst.HUD then
	     --inst.HUD.dengji:SetString("等级:"..tostring(inst.level))
	     --inst.HUD.jingyan:SetString("经验:"..tostring(inst.exp).."/"..tostring(inst.level*500+TUNING.TOSO_NEEDEXP))
         inst.HUD.daojishi:SetString("江湖追杀倒计时:"..tostring(inst.zhuishadaojishi))
	  end
	--zhuisha(inst)
	else
	    if inst.HUD then
           inst.HUD.daojishi:Hide()
	    end
	
	end
     --if inst.HUD then
	     --if not inst.zhuishadaojishi == 0 then
                --inst.HUD.daojishi:Show()
	     --else 
                --inst.HUD.daojishi:Hide()	 
	     --end
	 --end
    end)
	--一些时刻需要判断切换的状态
	inst.task_always = inst:DoPeriodicTask(0, function()
if inst.level > 5 and inst.level <= 10 then
TUNING.ARM_ARMOR = 0.7	
elseif inst.level > 10 and inst.level <= 15 then
TUNING.ARM_ARMOR = 0.8
elseif inst.level > 15 and inst.level <= 20 then
TUNING.ARM_ARMOR = 0.9
elseif inst.level > 20 and inst.level <= 30 then
TUNING.ARM_ARMOR = 0.92
elseif inst.level > 30 and inst.level <= 40 then
TUNING.ARM_ARMOR = 0.93
elseif inst.level > 40 and inst.level <= 50 then
TUNING.ARM_ARMOR = 0.94
elseif inst.level > 50 and inst.level <= 60 then
TUNING.ARM_ARMOR = 0.95
elseif inst.level > 60 and inst.level <= 70 then
TUNING.ARM_ARMOR = 0.96
elseif inst.level > 70 and inst.level <= 80 then
TUNING.ARM_ARMOR = 0.97
elseif inst.level > 80 and inst.level <= 90 then
TUNING.ARM_ARMOR = 0.98
elseif inst.level > 90 then
TUNING.ARM_ARMOR = 0.99
else
TUNING.ARM_ARMOR = 0.6	
end

	
	
	--aoe
  if inst.components.shaqi:GetPercent() >= 0.5 then --1
			inst.components.combat.areahitrange = 3
		    inst.components.combat.areahitdamagepercent = 0.5  
			--inst.components.combat:SetAreaDamage(3, 0.5)
			
function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
	local hitcount = 0
	local pt = Vector3(target.Transform:GetWorldPosition() )
	local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, range, nil, {"falling", "FX", "NOCLICK", "DECOR", "INLIMBO","companion","wall"})
	for i,ent in ipairs(ents) do
		if ent.components.combat 
			and ent ~= target 
			and ent ~= self.inst 
			and self:CanAreaHitTarget(ent) 
			and (not validfn or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", {target = target, weapon = weapon, stimuli = stimuli})
				ent.components.combat:GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
		end
	end
	return hitcount
end
			
--[[			
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"companion"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end
]]			



	--------------防止范围攻击误伤中立monster生物
	--local oldDoAreaAttack = inst.components.combat.DoAreaAttack
	--inst.components.combat.DoAreaAttack = function(self,target, range, weapon, validfn, stimuli, excludetags,...)
		--local old_validfn = validfn
		--validfn = function(enemy,me)
			--return (old_validfn == nil or old_validfn(enemy,me)) and OnikiriUtil.HostileCanAttack(self.inst,target)
		--end
		--return oldDoAreaAttack(self,target, range, weapon, validfn, stimuli, excludetags,...)
	--end


----			
  else
  			--inst.components.combat:SetAreaDamage(0, 0)
		    inst.components.combat.areahitrange = 0
		    inst.components.combat.areahitdamagepercent = 0  
  end
    --真实
  if inst.change_elements == 15 then --4
		  	inst.components.combat.damagemultiplier = 3
			if IsDLCInstalled(CAPY_DLC) then
			inst.components.combat:AddDamageModifier("wilson", 2)
			end
  else
		  	inst.components.combat.damagemultiplier = 1
			if IsDLCInstalled(CAPY_DLC) then
			inst.components.combat:AddDamageModifier("wilson", 0)
			end 
  end
    end)	
	--击杀加经验
	inst:ListenForEvent("killed",onkill)
	
	--inst.components.combat.damagemultiplier = 1
	--if SaveGameIndex:IsModeShipwrecked() then
		--inst.components.combat:AddDamageModifier("ssword", 0)
	--end	
	--设置饥饿度
	--inst.components.hunger.hungerrate = TUNING.SSWORD_HUNGERRATE * TUNING.WILSON_HUNGER_RATE	
	inst:AddTag("ssword")
	inst:AddTag("player")
	--添加各种组件
	inst:AddComponent("reader")
	inst:AddComponent("sswordcast")
	inst:AddComponent("colourtweener")
    inst:AddComponent("shaqi")
	--领域功能暂时不写
    --inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(5, 5)
    --inst.components.playerprox:SetOnPlayerNear(on_close)
    --inst.components.playerprox:SetOnPlayerFar(far)
	---------------------

	--local sswordtab = {str = "SSWORDTAB", sort=999, icon = "ssword_tab.tex", icon_atlas = "images/ssowrdtabs/ssword_tab.xml"}
	--inst.components.builder:AddRecipeTab(sswordtab)
--local yiyutab =  {str = "YIYUTAB" , sort=999, icon = "yiyutab.tex"       , icon_atlas = "images/yiyutabs/yiyutab.xml"}
--inst.components.builder:AddRecipeTab(yiyutab)	
	--免疫中毒
	--inst:AddComponent("poisonhealer")
--攻击被动设置	
	--跟踪攻击
	inst:ListenForEvent("onhitother", bingdongattack)
	--血量过低会被打倒
	inst:ListenForEvent("attacked",OnHitjidao)
	
--检测剑魂，若有多余，删除目标
inst.jianling = inst:DoPeriodicTask(1, function()


if inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS).prefab  == "surfboard_item_toso" then

      if inst.components.inventory:Has("surfboard_item_toso", 1) then
      inst.components.inventory:ConsumeByName("surfboard_item_toso", 1)
	
	  end

end

      if inst.components.inventory:Has("surfboard_item_toso", 2) then
      inst.components.inventory:ConsumeByName("surfboard_item_toso", 1)
	
	  end


if inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS).prefab  == "surfboard_item_toso" then

	if inst.components.leader:CountFollowers("jianling") > 0 then
	local jianling = TheSim:FindFirstEntityWithTag("jianling")
		if jianling then
			jianling:Remove()
		end
	end

end

if inst.components.inventory:Has("surfboard_item_toso", 1) then
	if inst.components.leader:CountFollowers("jianling") > 0 then
	local jianling = TheSim:FindFirstEntityWithTag("jianling")
		if jianling then
			jianling:Remove()
		end
	end
	
else	
	
	if inst.components.leader:CountFollowers("jianling") > 1 then
	local jianling = TheSim:FindFirstEntityWithTag("jianling")
		if jianling then
			jianling:Remove()
		end
	end
end
	
end)
	
	--关于球球
inst.task2 = inst:DoPeriodicTask(5, function()


	if inst.components.leader:CountFollowers("qiuqiu") > 1 then
	local qiuqiu = TheSim:FindFirstEntityWithTag("qiuqiu")
		if qiuqiu then
			--qiuqiu.components.container:Close()
			--qiuqiu.components.container:DropEverything()
			qiuqiu:Remove()
		end
	end


end)

	--随机技能
inst.task_jineng = inst:DoPeriodicTask(1, function()
--if inst.level <= 30 then
--判断
if inst.change_skills == 1 then

    --切换到剑意
		GetPlayer().HUD.change_skill1:Show()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()

elseif inst.change_skills == 2 then

    --切换到木属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Show()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 3 then

    --切换到水属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Show()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 4 then

    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Show()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 5 then

    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Show()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 6 then

    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Show()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 7 then

    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Show()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 8 then

    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Show()
		GetPlayer().HUD.change_skill9:Hide()
		
elseif inst.change_skills == 9 then

    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Show()
		
end--属性切换显示结束

--end

end)

inst.zuo = function()
          if inst.change_skills > 1 then
             inst.change_skills = inst.change_skills - 1
          else 
             inst.change_skills = 7
          end

--判断
if inst.change_skills == 1 then
    inst.components.talker:Say("当前技能：疾风斩\n消耗：需要120怒气")
    --切换到剑意
		GetPlayer().HUD.change_skill1:Show()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 2 then
    inst.components.talker:Say("当前技能：焰阵陨杀\n消耗：需要100怒气")
    --切换到木属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Show()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()	
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 3 then
    inst.components.talker:Say("当前技能：飞天\n消耗：需要180怒气")
    --切换到水属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Show()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 4 then
    inst.components.talker:Say("当前技能：绝息\n消耗：需要150怒气")
    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Show()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 5 then
    inst.components.talker:Say("当前技能：三千月斩\n消耗：需要120怒气")
    --切换到土属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Show()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 6 then
    inst.components.talker:Say("当前技能：爱无限\n消耗：需要120怒气")
    --切换到土属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Show()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 7 then
    inst.components.talker:Say("当前技能：由莲剑法\n消耗：需要120怒气")
    --切换到土属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Show()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
end--属性切换显示结束
end

inst.you = function()
          if inst.change_skills < 7 then
             inst.change_skills = inst.change_skills + 1
          else 
             inst.change_skills = 1
          end

--判断
if inst.change_skills == 1 then
    inst.components.talker:Say("当前技能：疾风斩\n消耗：需要120怒气")
    --切换到剑意
		GetPlayer().HUD.change_skill1:Show()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 2 then
    inst.components.talker:Say("当前技能：焰阵陨杀\n消耗：需要100怒气")
    --切换到木属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Show()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()	
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 3 then
    inst.components.talker:Say("当前技能：飞天\n消耗：需要180怒气")
    --切换到水属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Show()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 4 then
    inst.components.talker:Say("当前技能：绝息\n消耗：需要150怒气")
    --切换到火属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Show()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 5 then
    inst.components.talker:Say("当前技能：三千月斩\n消耗：需要120怒气")
    --切换到土属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Show()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 6 then
    inst.components.talker:Say("当前技能：爱无限\n消耗：需要120怒气")
    --切换到土属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Show()
		GetPlayer().HUD.change_skill7:Hide()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
elseif inst.change_skills == 7 then
    inst.components.talker:Say("当前技能：由莲剑法\n消耗：需要120怒气")
    --切换到土属性
		GetPlayer().HUD.change_skill1:Hide()
		GetPlayer().HUD.change_skill2:Hide()
		GetPlayer().HUD.change_skill3:Hide()
		GetPlayer().HUD.change_skill4:Hide()
		GetPlayer().HUD.change_skill5:Hide()
		GetPlayer().HUD.change_skill6:Hide()
		GetPlayer().HUD.change_skill7:Show()
		GetPlayer().HUD.change_skill8:Hide()
		GetPlayer().HUD.change_skill9:Hide()
end--属性切换显示结束
end 



	--闪避
	inst.components.combat.oldAttacked = inst.components.combat.GetAttacked
	function inst.components.combat:GetAttacked(...)
	
		if inst.level >=35 and math.random() < inst.kangleng then 
		  if math.random() <= 0.3 then
		    inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/hudun")
			inst.components.talker:Say("格挡")
			local fx = SpawnPrefab("dunconsume2")			
    		fx.entity:SetParent(inst.entity)
            fx.Transform:SetPosition(0, -0.8, 0)
		  else
		    inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/hudun")
			inst.components.talker:Say("格挡")
			local fx = SpawnPrefab("dunconsume")			
    		fx.entity:SetParent(inst.entity)
            fx.Transform:SetPosition(0, -0.8, 0)		  
		  end	
	
		elseif inst.missatk then

			
			
	
			local fx = SpawnPrefab("baguadun")
    		fx.entity:AddFollower()
	    	fx.Follower:FollowSymbol(inst.GUID, "swap_body", 0, 0, 0)
			
			


			

			
		else
			return inst.components.combat:oldAttacked(...)
		end
	end
------技能-------


--幽步
TheInput:AddKeyUpHandler(TUNING.TOSO_KEY14, function()
if not IsPaused() then
if not inst:HasTag("juqi_in") then
TheFrontEnd:PushScreen(SswordScreen())
inst.SoundEmitter:PlaySound("ds_toso_skill/sfx/toso_haotingjs")
elseif inst:HasTag("juqi_in") then

   inst.sg:GoToState("play_onemanband_stomp") 
   inst:RemoveTag("juqi_in")

  		        if inst.juqiTask then
                   inst.juqiTask:Cancel()
                   inst.juqiTask=nil
				--inst.components.shaqi:DoDelta(0)
                end
   
    inst:DoTaskInTime(2, function() 
---这里不再进行升级函数，放到监听里自动升级就好

    inst.sg:GoToState("powerup") 
    inst.SoundEmitter:PlaySound("dontstarve/wilson/onemanband") inst.components.playercontroller:Enable(true) 
	end)

end

end
end)

--传送至树--TUNING.SHIJIESHUTRANS
TheInput:AddKeyUpHandler(TUNING.TOSO_KEY16, function()
if not IsPaused() then
--if not inst.components.driver.vehicle then
    --
	local x,y,z = inst.Transform:GetWorldPosition()	
	local max_rad = 10000
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"transtofight"})
    for k,v in pairs(ents) do 
		if v then 
        --inst.components.inventory:Equip(v)--GiveItem(item)
		--inst.components.inventory:GiveItem(v)
		inst.Transform:SetPosition(v.Transform:GetWorldPosition())
		
		local fxhuo = SpawnPrefab("ssdilie")
		fxhuo.Transform:SetScale(1.3, 1.3, 1.3)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
		inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")
		end 
	end	


--end
end
end)




--天外飞仙
TheInput:AddKeyUpHandler(TUNING.TOSO_KEY13, function()
if not IsPaused() then

 

if inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS).prefab  == "surfboard_item_toso" 

then
local otherequipped = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)

	local board = otherequipped.components.pocket:RemoveItem("toso_surfboard") or SpawnPrefab("toso_surfboard") 
	if board then

	--之前是0
	    local pt = Vector3(inst.Transform:GetWorldPosition())
		pt = Vector3(pt.x, 0, pt.z)
		board.Physics:SetCollides(false)--设置碰撞
		board.Physics:Teleport(pt.x, pt.y, pt.z) 
		board.Physics:SetCollides(true)--设置碰撞
		
		--deployer.sg:GoToState("jumpboatland")
		--deployer.components.driver:OnDismount(false, nil, true)
		otherequipped:Remove()
		--return board
	end

		local fxhuo = SpawnPrefab("ssdilie")
		fxhuo.Transform:SetScale(1.3, 1.3, 1.3)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
		inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")

elseif inst.components.inventory:Has("surfboard_item_toso", 1) then

local IsWeapon = function (item)
return item.prefab  == "surfboard_item_toso"
end
local zz = inst.components.inventory:FindItem(IsWeapon)
inst.components.inventory:Equip(zz)

--inst.components.inventory:ConsumeByName("surfboard_item_toso", 1)
--inst.components.inventory:Equip("surfboard_item_toso")
		local fxhuo = SpawnPrefab("ssdilie")
		fxhuo.Transform:SetScale(1.3, 1.3, 1.3)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
		inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")
		
--		


else
    --当剑是剑形态时
	local x,y,z = inst.Transform:GetWorldPosition()	
	local max_rad = 10000
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"shanggushenjian"})
    for k,v in pairs(ents) do 
		if v then 
	       if not inst.components.inventory:IsFull() then 
        inst.components.inventory:Equip(v)--GiveItem(item)
		--inst.components.inventory:GiveItem(v)
		
		local fxhuo = SpawnPrefab("ssdilie")
		fxhuo.Transform:SetScale(1.3, 1.3, 1.3)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
		inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")
	       else
           inst.components.talker:Say("负重竟如此糟糕")
           end
	
		end 
	end	
	
	
    --仅仅当剑是御剑形态时
	local x,y,z = inst.Transform:GetWorldPosition()	
	local max_rad = 10000
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"shanggushenjianboat"})
    for k,v in pairs(ents) do 
		if v then 
	if v.components.drivable.driver then--剑上如果有人且不是在海里
	
if not v.components.drivable.driver:GetIsOnWater() and not inst.components.inventory:IsFull() then
		local driver = v.components.drivable.driver
		driver.components.driver:OnDismount(nil, v:GetPosition())

			local board = SpawnPrefab("surfboard_item_toso")
			inst.components.inventory:Equip(board)
	        board.components.pocket:GiveItem("toso_surfboard", v)
            --如果有，就把开船的声音关闭
            if inst.SoundEmitter:PlayingSound("sail_loop") then 
               inst.SoundEmitter:KillSound( "sail_loop")
            end 
		local fxhuo = SpawnPrefab("ssdilie")
		fxhuo.Transform:SetScale(1.3, 1.3, 1.3)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
		inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")
		
else
inst.components.talker:Say("负重如此糟糕！")
end
    else  --剑上无人
if not inst.components.inventory:IsFull() then
			local board = SpawnPrefab("surfboard_item_toso")
			inst.components.inventory:Equip(board)
	        board.components.pocket:GiveItem("toso_surfboard", v)


		local fxhuo = SpawnPrefab("ssdilie")
		fxhuo.Transform:SetScale(1.3, 1.3, 1.3)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
		inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")
else
inst.components.talker:Say("负重如此糟糕呀！")
end	
		
	end


	

		end 
	end



end	










end

end)              
--技能释放
TheInput:AddKeyUpHandler(TUNING.TOSO_KEY12, function()
if not IsPaused() then
--释放疾风斩
if inst.jifengshijian == 0 then

if inst.skill_3CD == 0 and not inst.components.driver.vehicle then


 		   



			   --local x5 = math.random(5)
if inst.change_skills == 1 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.5 and not inst:HasTag("lihun") then-- and not inst:HasTag("laserfx")
               rpg_jineng[1](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-100)
			   else
			   inst.components.talker:Say("怒气不足")
	           end		
elseif inst.change_skills == 2 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.5 and not inst:HasTag("lihun") then
               rpg_jineng[2](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-100)
			   else
			   inst.components.talker:Say("怒气不足")
	           end		
elseif inst.change_skills == 3 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.9 and not inst:HasTag("lihun") then
               rpg_jineng[3](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-180)
			   else
			   inst.components.talker:Say("怒气不足")
	           end	
elseif inst.change_skills == 4 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.75 and not inst:HasTag("lihun") then
               rpg_jineng[4](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-150)
			   else
			   inst.components.talker:Say("怒气不足")
	           end	
elseif inst.change_skills == 5 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.6 and not inst:HasTag("lihun") then
               rpg_jineng[5](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-100)
			   else
			   inst.components.talker:Say("怒气不足")
	           end
elseif inst.change_skills == 6 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.6 and not inst:HasTag("lihun") then
               rpg_jineng[6](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-100)
			   else
			   inst.components.talker:Say("怒气不足")
	           end
elseif inst.change_skills == 7 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.6 and not inst:HasTag("lihun") then
               rpg_jineng[7](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-100)
			   else
			   inst.components.talker:Say("怒气不足")
	           end
elseif inst.change_skills == 8 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.25 and not inst:HasTag("lihun") then
               rpg_jineng[8](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-50)
			   else
			   inst.components.talker:Say("怒气不足")
	           end
elseif inst.change_skills == 9 then
	   	   	   if inst.components.shaqi:GetPercent() >= 0.5 and not inst:HasTag("lihun") and not inst:HasTag("shadow") then
               rpg_jineng[9](inst)
			   inst.skill_3CD = 60
			   if inst.level <= 30 then
               inst.change_skills = math.random(9)
			   end
			   inst.components.shaqi:DoDelta(-100)
			   else
			   inst.components.talker:Say("怒气不足")
	           end
			   
end
			





else
inst.components.talker:Say("技能CD中!"..inst.skill_3CD)
end
--释放疾风斩后
else
    inst.components.talker:Say("面对疾风吧")
    inst.sg:GoToState("sswindatk")
end

end
end)



--月牙
TheInput:AddKeyUpHandler(TUNING.TOSO_KEY11, function()
if not IsPaused() then
	--if inst.skill_3 > 0 then 
		
	   if inst.skill_1CD > 0 and inst.ssword_states == 0 and not inst.missatk then
	      inst.components.talker:Say("月牙CD中!"..inst.skill_1CD)
	   elseif inst.skill_1CD == 0 then
	           if inst.components.hunger.current >  5 then
			   inst.skill_1CD = 5
inst.components.sswordcast:youying(inst)
			   --inst.components.hunger:DoDelta(-5)

			   else
			   inst.components.talker:Say("体力不足")
	           end

       end
    --else
       --inst.components.talker:Say("尚未学习万剑诀!")
    --end


end
end)


TheInput:AddKeyUpHandler(TUNING.TOSO_KEY15, function()
if not IsPaused() then
if inst.level >= 35 then
--inst.skillon = 0.005
		inst.components.talker:Say(
		"\n灵根[修炼成功率]["..(inst.linggen*0.1)*100 .."%]"..
		"\n世界boss休眠时间["..(inst.skill_2CD).."]"..
		"\n领域-攻击灼烧伤害["..(inst.zhuoshao).."]"..
		"\n攻击速度["..(inst.kangre).."]"..
		"\n闪避几率["..(inst.kangleng)*100 .."%]"..
		"\n物理吸收["..(inst.hujia)*100 .."%]"..		
		"\n回复精神["..(inst.huisan).."]"..
		"\n三维增加上限["..(inst.sanwei).."]"..
		"\n走路速度["..(inst.components.locomotor.walkspeed).."]"..
		"\n攻击倍数["..(1+inst.beigong)*100 .."%]"..
		"\n攻击每次增加怒气["..(inst.nuqi).."]"..
		"\n饥饿速度["..(inst.jie).."]"..
		"\n百分比伤害系数["..(inst.shanghai)*100 .."%]"..
		--"\n抗冷恢复温度["..(0.5*inst.kangleng).."]"..
		--"\n抗热恢复温度["..(0.5*inst.kangre).."]"..
		"\n暴击概率["..(inst.kangshi).."]"..
		"\n每次攻击吸血["..(inst.xixue).."]")
else
		inst.components.talker:Say(
		"\n灵根[修炼成功率]["..(inst.linggen*0.1)*100 .."%]"..
		"\n世界boss休眠时间["..(inst.skill_2CD).."]"..
		"\n物理吸收["..(inst.hujia)*100 .."%]"..		
		"\n回复精神["..(inst.huisan).."]"..
		"\n三维增加上限["..(inst.sanwei).."]"..
		"\n走路速度["..(inst.components.locomotor.walkspeed).."]"..
		"\n攻击倍数["..(1+inst.beigong)*100 .."%]"..
		"\n攻击每次增加怒气["..(inst.nuqi).."]"..
		"\n饥饿速度["..(inst.jie).."]"..
		"\n百分比伤害系数["..(inst.shanghai)*100 .."%]"..
		"\n抗冷恢复温度["..(0.5*inst.kangleng).."]"..
		"\n抗热恢复温度["..(0.5*inst.kangre).."]"..
		"\n暴击概率["..(inst.kangshi).."]"..
		"\n每次攻击吸血["..(inst.xixue).."]")
end

		  --"\n技能-技能-霜漫苍穹-O")

end
end)

TheInput:AddKeyUpHandler(KEY_0, function()
if not IsPaused() then
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/smash")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/head/servo")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/ribs/servo")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/laser_pre")--渐变快
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/head/attack")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/arm/servo")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/arm/green")--电流声
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/head/green")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/leg/green")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/enemy/metal_robot/ribs/green")
--inst.components.shaqi:DoDelta(100)
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/city_pig/scream")
--inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/pangolden/ball_hit")
    --inst.sg:GoToState("tosofallpost")
                --inst.SoundEmitter:PlaySound("dontstarve_DLC003/movement/iron_armor/hit")
				--inst.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")

--inst.SoundEmitter:PlaySound("dontstarve/creatures/rocklobster/hurt")
--inst.SoundEmitter:PlaySound("dontstarve/creatures/rocklobster/foley")
--inst.sg:GoToState("swordkill_fx")
            --inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")
            --inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/shoot")
                --inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/hum_LP","hum") 
                --inst.SoundEmitter:KillSound("hum") 
--inst.SoundEmitter:PlaySound("ds_toso_huoying/sfx/huoying")

--rpg_jineng[2](inst)

end
end)

--初始化
	--灵力降温buff
	inst.jiangwen = inst:DoPeriodicTask(2,jiangwen)
	--灵力降温buff
	inst.shengwen = inst:DoPeriodicTask(2,shengwen)
    --潮湿
	--inst.chaoshi = inst:DoPeriodicTask(2,chaoshi)--取消该功能

	applyupgrades(inst)
	--SetHUDState(inst)
	--zhuisha(inst)
	--bianhua(inst)


	inst.OnSave = onsave
	inst.OnLoad = onload
    inst.OnPreLoad = onpreload

	
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "ssword.tex" )
	
	-- Stats	
	inst.components.health:SetMaxHealth(TUNING.SSWORD_STARTHP)
	inst.components.hunger:SetMax(1.5*TUNING.SSWORD_STARTHP)
	inst.components.sanity:SetMax(TUNING.SSWORD_STARTHP)

	--随机怪物--只要走路就会累计
	inst.amount_treasure = inst:DoPeriodicTask(1, amount_treasure)
	inst.randommonster = inst:DoPeriodicTask(0, randommonster)
	inst:ListenForEvent("treasure", treasure_hunt)
	--修炼--只要修炼就会累计
	inst.amount_practice = inst:DoPeriodicTask(1, amount_practice)
	inst.check_practice = inst:DoPeriodicTask(0, check_practice)
	inst:ListenForEvent("practice", practice_hunt)

end


local function fn_swordwind()--TUNING.ARM_RPGDAMAGE + 2*inst.level
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.5, 1.5, 1.5)
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()


    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("xuanyuan")
    inst.AnimState:SetBuild("xuanyuan")
    inst.AnimState:PlayAnimation("spin_loop", true)


    inst:AddTag("fx")



    inst:AddComponent("combat")
	
	----冰风暴
	local period = .1
	inst._tick = 0
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		--伤害
		local pt = inst:GetPosition()	
		local r = 2.5
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "ssword","companion","shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
				    local player = GetPlayer()
					local demage = TUNING.ARM_RPGDAMAGE + 2*player.level
					v.components.combat:GetAttacked(inst, demage)
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
		--发射
		local rot = inst.Transform:GetRotation()
		rot = rot + inst._tick * 360 / (1/period)
		while (rot > 360) do
			rot = rot - 360
		end
		inst._tick = inst._tick + 1
		
		local fx = SpawnPrefab("swordwind2")
		if fx then
			fx.Transform:SetPosition( pt:Get() )
			fx.Transform:SetRotation( rot )
			fx.Physics:SetMotorVelOverride(15, 0, 0)
		end
		
	end)
	
	----冰风暴的生命周期
	inst.zg_lifetime = 3
	inst:DoTaskInTime(inst.zg_lifetime, function()
		if inst then
			inst:Remove()
		end
	end)

	return inst
end

local function fn_swordwind2()
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.2, 1.2, 1.2)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("xuanyuan")
    inst.AnimState:SetBuild("xuanyuan")
    inst.AnimState:PlayAnimation("spin_loop", true)

    inst:AddTag("fx")


    inst:AddComponent("combat")
	
	local period = .1
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		--伤害
		local pt = inst:GetPosition()	
		local r = 3
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "ssword","companion","shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					local player = GetPlayer()
					local demage = TUNING.ARM_RPGDAMAGE + 2*player.level
					v.components.combat:GetAttacked(inst, demage)
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
	end)
	
	----小风暴的生命周期
	inst.zg_lifetime = 3
	inst:DoTaskInTime(inst.zg_lifetime, function()
		if inst then
			inst:Remove()
		end
	end)

	return inst
end

local function fn_sswind()
	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()


    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("tornado")
    inst.AnimState:SetBuild("tornado")
    inst.AnimState:PlayAnimation("tornado_pre")
    inst.AnimState:PushAnimation("tornado_loop")

    inst:AddTag("fx")



    inst:AddComponent("combat")
	
	----冰风暴
			inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/tornado", "spinLoop")
	local period = .1
	inst._tick = 0
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		--伤害
		local pt = inst:GetPosition()	
		local r = 2.5
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "companion","ssword"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
									local player = GetPlayer()
					local demage = TUNING.ARM_RPGDAMAGE + 2*player.level
					v.components.combat:GetAttacked(inst, demage)
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
		--发射
		local rot = inst.Transform:GetRotation()
		rot = rot + inst._tick * 360 / (1/period)
		while (rot > 360) do
			rot = rot - 360
		end
		inst._tick = inst._tick + 1
		
		--local fx = SpawnPrefab("zg_fx_wickerwind2")
		--if fx then
			--fx.Transform:SetPosition( pt:Get() )
			--fx.Transform:SetRotation( rot )
			--fx.Physics:SetMotorVelOverride(15, 0, 0)
		--end
		
	end)
	
	----冰风暴的生命周期
	inst.zg_lifetime = 1.5
	inst:DoTaskInTime(inst.zg_lifetime, function()
		if inst then
			inst.SoundEmitter:KillSound("spinLoop")
			inst:Remove()
		end
	end)

	return inst
end

return 
Prefab ("sswind", fn_sswind),
	   Prefab ("swordwind", fn_swordwind, swordassets),
	   Prefab ("swordwind2", fn_swordwind2, swordassets),
MakePlayerCharacter("ssword", prefabs, assets, sswordfn, start_inv)
