require "prefabutil"


	local assets=
	{
		Asset("ANIM", "anim/toso_danlu.zip"),
		Asset("ANIM", "anim/toso_danlu_on.zip"),

		Asset("ATLAS", "images/inventoryimages/toso_danlu_item.xml"),
		Asset("IMAGE", "images/inventoryimages/toso_danlu_item.tex"),
	}

local prefabs = {
	"collapse_small",
	"musha_ovenfire",
	--"musha_ovenfire_cold",
}
	
	
	
local function cooked(inst)

	local container = inst.components.container

	if not inst.on_cold then
		for i = 1, container:GetNumSlots() do
	        local item = container:GetItemInSlot(i)
	     	if item then 
	     		local replacement = nil 
				if item.components.cookable or item.prefab == "log" then 
				inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel") 
						local fx = SpawnPrefab("collapse_small")
					local pos = Vector3(inst.Transform:GetWorldPosition())
					fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
        local fx2 = SpawnPrefab("small_puff")
        fx2.entity:SetParent(inst.entity)
	    fx2.Transform:SetPosition(0, 3, 0)
		
				end
				
		     	if item.components.cookable then 
		     		replacement = item.components.cookable:GetProduct()
		     	elseif item.prefab == "log" then 
		     		replacement = "charcoal"
					
		     	elseif item.components.burnable and not item.prefab == "log" then 
		     		replacement = "ash"				
		     	end  
		     	if replacement then 
	     			local stacksize = 1 
	     			if item.components.stackable then 
	     				stacksize = item.components.stackable:StackSize()
	     			end 
	     			local newprefab = SpawnPrefab(replacement)
	     			if newprefab.components.stackable then 
	     				newprefab.components.stackable:SetStackSize(stacksize)
	     			end 
	     			container:RemoveItemBySlot(i)
	     			item:Remove()
	     			container:GiveItem(newprefab, i)
	     		end 
		     end 
		end 
		return false 
	end 
	
end	

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
	inst:Remove()
end
--
local function onhit(inst, worker)
	inst.components.container:DropEverything()
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("idle",true)

	--inst.AnimState:PushAnimation("idle_empty")

end
--查看状态
local function getstatus(inst)
	if inst.open_judge then
		return "COOKING_SHORT"
	else
		return "DONE"
	end
end

--打开炉子判断
local function open_judge(inst)
	if inst.open_judge then
       inst.components.container.canbeopened = true
	else
       inst.components.container.canbeopened = false
	end
end

local slotpos = {	Vector3(0,64+32+8+4,0), 
					Vector3(0,32+4,0),
					Vector3(0,-(32+4),0), 
					Vector3(0,-(64+32+8+4),0)}

local widgetbuttoninfo = {
	text = "炼制",
	position = Vector3(0, -165, 0),
	fn = function(inst)
		local player = GetPlayer()
		local min_time = 2
        local item = inst.components.container.slots[1] or inst.components.container.slots[2] or inst.components.container.slots[3] or inst.components.container.slots[4]
local radomfood = 
{
	[1] = function(inst)
--player.components.inventory:GiveItem("lobsterdinner")
        SpawnPrefab("lobsterdinner").Transform:SetPosition(inst:GetPosition():Get())
	end,
	
	[2] = function(inst)
--player.components.inventory:GiveItem("waffles")
        SpawnPrefab("waffles").Transform:SetPosition(inst:GetPosition():Get())
	end,
	
	[3] = function(inst)
--player.components.inventory:GiveItem("icecream")
        SpawnPrefab("icecream").Transform:SetPosition(inst:GetPosition():Get())
	end,
	
	[4] = function(inst)
--player.components.inventory:GiveItem("surfnturf")
        SpawnPrefab("surfnturf").Transform:SetPosition(inst:GetPosition():Get())
	end,
	
	[5] = function(inst)
--player.components.inventory:GiveItem("bonestew")
        SpawnPrefab("bonestew").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[6] = function(inst)
--player.components.inventory:GiveItem("dragonpie")
        SpawnPrefab("dragonpie").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[7] = function(inst)
--player.components.inventory:GiveItem("honeyham")
        SpawnPrefab("honeyham").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[8] = function(inst)
--player.components.inventory:GiveItem("seafoodgumbo")
        SpawnPrefab("seafoodgumbo").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[9] = function(inst)
--player.components.inventory:GiveItem("fishsticks")
        SpawnPrefab("fishsticks").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[10] = function(inst)
--player.components.inventory:GiveItem("jellyopop")
        SpawnPrefab("jellyopop").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[11] = function(inst)
--player.components.inventory:GiveItem("honeynuggets")
        SpawnPrefab("lobsterdinner").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[12] = function(inst)
--player.components.inventory:GiveItem("bananapop")
        SpawnPrefab("bananapop").Transform:SetPosition(inst:GetPosition():Get())
	end,
	[13] = function(inst)
--player.components.inventory:GiveItem("meatballs")
        SpawnPrefab("meatballs").Transform:SetPosition(inst:GetPosition():Get())
	end,
}		

if inst.burning then
	if not item then
		GetPlayer().components.talker:Say("没有东西")
	--这里转换各种怪物精元，不用关闭格子
	--elseif item.prefab == "掉落物件" then
		
	elseif item.prefab == "flower_hua" then
		     --加上所有食材进行判断，没有就提醒加入其他食材
	         --if not inst.components.container:Has("meat", 1) then
		       --GetPlayer().components.talker:Say("请放入大肉或者其他材料！")
	       --1朵灵花
		   if item and inst.components.container:Has("cookedmeat", 1) then
		       inst.components.container:ConsumeByName("flower_hua", 1)
		       inst.components.container:ConsumeByName("cookedmeat", 1)
			   --生成食物
			   inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(5 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)			   
			       radomfood[math.random(#radomfood)](inst)
			       GetPlayer().components.talker:Say("看看是什么好吃的")
			       inst.components.container:Close()
               inst.open_judge = false				   
			   end)

	--elseif item.prefab == "papyrus" then
--荨麻卷
		   elseif item and inst.components.container:Has("cutnettle", 1) and inst.components.container:Has("flower_hua", 2) then
		       inst.components.container:ConsumeByName("flower_hua", 2)--2灵花
		       inst.components.container:ConsumeByName("cutnettle", 1)--荨麻		
               --生成 
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
                inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")			
                   --SpawnPrefab("pellet_hujia").Transform:SetPosition(inst:GetPosition():Get())	
            for k = 1, 5 do
                local nug = SpawnPrefab("nettlelosange")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
            end				   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)				   


           --10朵花灵花--护甲丹 
		   elseif item and inst.components.container:Has("pigskin", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)--莎草纸
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("pigskin", 5)--猪皮
               --生成 
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
                inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")			
                   --SpawnPrefab("pellet_hujia").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_hujia")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
           --10朵花灵花--回san丹 
		   elseif item and inst.components.container:Has("green_cap_cooked", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("green_cap_cooked", 5)--熟绿蘑菇
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_huisan").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_huisan")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
           --10朵花灵花--三维
		   elseif item and inst.components.container:Has("berries_cooked", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("berries_cooked", 5)--熟浆果
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_sanwei").Transform:SetPosition(inst:GetPosition():Get())	

                local nug = SpawnPrefab("pellet_sanwei")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
				   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
           --10朵花灵花--移速 
		   elseif item and inst.components.container:Has("butterflywings", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("butterflywings", 5)--蝴蝶翅膀
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_yisu").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_yisu")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
           --10朵花灵花--倍攻 
		   elseif item and inst.components.container:Has("stinger", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("stinger", 5)--蜂刺
               --生成
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_beigong").Transform:SetPosition(inst:GetPosition():Get())
                local nug = SpawnPrefab("pellet_beigong")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
           --10朵花灵花--怒气 
		   elseif item and inst.components.container:Has("petals", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("petals", 5)--花瓣
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_nuqi").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_nuqi")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
           --10朵花灵花--辟谷
		   elseif item and inst.components.container:Has("rope", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("rope", 5)--绳子
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_jie").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_jie")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
           --10朵花灵花--伤害
		   elseif item and inst.components.container:Has("venomgland", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("venomgland", 5)--毒腺
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")	
		   
                   --SpawnPrefab("pellet_shanghai").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_shanghai")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))				   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
           --10朵花灵花--穿心
		   elseif item and inst.components.container:Has("cutstone", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("cutstone", 5)--石砖
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_kangshi").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_kangshi")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
           --10朵花灵花--抗冷
		   elseif item and inst.components.container:Has("fireflies", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("fireflies", 1)--萤火虫
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_kangleng").Transform:SetPosition(inst:GetPosition():Get())
                local nug = SpawnPrefab("pellet_kangleng")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
           --10朵花灵花--抗热
		   elseif item and inst.components.container:Has("ice", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("ice", 5)--冰
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_kangre").Transform:SetPosition(inst:GetPosition():Get())		
                local nug = SpawnPrefab("pellet_kangre")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
           --10朵花灵花--吸血
		   elseif item and inst.components.container:Has("honey", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("honey", 5)--蜂蜜
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_xixue").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_xixue")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
           --10朵花灵花--避世
		   elseif item and inst.components.container:Has("nightmarefuel", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 1) then
		       inst.components.container:ConsumeByName("papyrus", 1)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("nightmarefuel", 5)--噩梦燃料
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_meili")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
		   elseif item and inst.components.container:Has("jiucai", 10) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("bird_egg", 10) then
		       inst.components.container:ConsumeByName("bird_egg", 10)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("jiucai", 10)--
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("jiucaijidan")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
		   elseif item and inst.components.container:Has("toso_lingcao_flower", 5) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("hotchili", 2) then
		       inst.components.container:ConsumeByName("hotchili", 2)--咖喱
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("toso_lingcao_flower", 5)--玲草花
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_shanbi")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
		   elseif item and inst.components.container:Has("lightninggoathorn", 1) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("fruitmedley", 5) then
		       inst.components.container:ConsumeByName("fruitmedley", 5)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("lightninggoathorn", 1)--电羊
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_atktime")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
		   elseif item and inst.components.container:Has("dragoonheart", 1) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 5) then
		       inst.components.container:ConsumeByName("papyrus", 5)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("dragoonheart", 1)--龙心，琅琊，蚂蚁 
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_lingyu")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
		   elseif item and inst.components.container:Has("tentaclespike", 1) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 5) then
		       inst.components.container:ConsumeByName("papyrus", 5)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("tentaclespike", 1)--龙心，琅琊，蚂蚁 
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_lingyu")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
		   elseif item and inst.components.container:Has("chitin", 1) and inst.components.container:Has("flower_hua", 5) and inst.components.container:Has("papyrus", 5) then
		       inst.components.container:ConsumeByName("papyrus", 5)
		       inst.components.container:ConsumeByName("flower_hua", 5)--10灵花
			   inst.components.container:ConsumeByName("chitin", 1)--龙心，琅琊，蚂蚁 
               --生成 	
               inst.AnimState:PlayAnimation("hit", true)
			   inst.open_judge = true
			   inst:DoTaskInTime(10 * min_time, function() 
                   inst.AnimState:PlayAnimation("idle", true)	
inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/thunderbird/attack_swipe")				   
                   --SpawnPrefab("pellet_meili").Transform:SetPosition(inst:GetPosition():Get())	
                local nug = SpawnPrefab("pellet_lingyu")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			       inst.components.container:Close()
               inst.open_judge = false					   
			   end)	
			   
			   
		   end
		   
	end
else
GetPlayer().components.talker:Say("需要把炉火烧旺起来")	--
end--燃烧结束
	
	
	end
}
--[[
local function itemtest(inst, item, slot)
	if cooking.IsCookingIngredient(item.prefab) then
		return true
	end
end
]]

local function itemtest(inst, item, slot)
if not inst.on_cold then 
if not item:HasTag("frozen") then
			return true
				end
elseif inst.on_cold then 
if not item:HasTag("nothing") then
			return true
				end 
	end 
end
--anim and sound callbacks

----
local function startcookfn(inst)
	inst.AnimState:PlayAnimation("cooking_loop", true)
	--play a looping sound
	inst.SoundEmitter:KillSound("snd")
	inst.SoundEmitter:PlaySound("dontstarve/common/cookingpot_rattle", "snd")
	inst.Light:Enable(true)
end


local function onopen(inst)
	--inst.fire = true
	
    if not inst.burning then
    inst.AnimState:SetBuild("toso_danlu_on")
    end

	--inst.AnimState:PlayAnimation("cooking_pre_loop", true)
	inst.SoundEmitter:PlaySound("dontstarve/common/cookingpot_open", "open")
	inst.SoundEmitter:PlaySound("dontstarve/common/cookingpot", "snd")
end

local function onclose(inst)
		local player = GetPlayer()
        local item = inst.components.container.slots[1] or inst.components.container.slots[2] or inst.components.container.slots[3] or inst.components.container.slots[4]
	  --公主
      if inst.burning then
      cooked(inst)
      end
      if not inst.burning then
	  inst.AnimState:SetBuild("toso_danlu")
      end	
--[[	  
	if not item then
	inst.fire = false
	inst.AnimState:SetBuild("toso_danlu")
	GetPlayer().components.talker:Say("没放入任何东西")
	else
	inst.fire = true	
	inst.AnimState:SetBuild("toso_danlu_on")
	end

	if not inst.cooking then
	    inst.AnimState:SetBuild("toso_danlu")
		--inst.AnimState:PlayAnimation("idle_empty")
		inst.SoundEmitter:KillSound("snd")
	end
]]
	inst.SoundEmitter:PlaySound("dontstarve/common/cookingpot_close", "close")
end

local function onignite(inst)
inst.burning = true
inst.AnimState:SetBuild("toso_danlu_on")
    if not inst.components.cooker then
        inst:AddComponent("cooker")
    end
end

local function onextinguish(inst)
inst.burning = false
inst.AnimState:SetBuild("toso_danlu")
    if inst.components.cooker then
        inst:RemoveComponent("cooker")
    end
    if inst.components.fueled then
        inst.components.fueled:InitializeFuelLevel(0)
    end
end

----
local function donecookfn(inst)
	inst.AnimState:PlayAnimation("cooking_pst")
	inst.AnimState:PushAnimation("idle_full")

	inst.SoundEmitter:KillSound("snd")
	inst.SoundEmitter:PlaySound("dontstarve/common/cookingpot_finish", "snd")
	inst.Light:Enable(false)
	--play a one-off sound
end
----
local function continuedonefn(inst)
	inst.AnimState:PlayAnimation("idle_full")

end
----
local function continuecookfn(inst)
	inst.AnimState:PlayAnimation("cooking_loop", true)
	--play a looping sound
	inst.Light:Enable(true)

	inst.SoundEmitter:PlaySound("dontstarve/common/cookingpot_rattle", "snd")
end
----
local function harvestfn(inst)
	inst.AnimState:PlayAnimation("idle_empty")
end

local function getstatus(inst)
	if inst.cooking then
		return "COOKING_SHORT"
	else
		return "EMPTY"
	end
end

local function onfar(inst)
	if inst.components.container then
		inst.components.container:Close()
	end
end

local function onbuilt(inst)
	inst.AnimState:SetBuild("toso_danlu")
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("idle",true)
end

local function ondeploy(inst, pt, deployer)
	local pot = SpawnPrefab("toso_danlu") 
	if pot then 
		pt = Vector3(pt.x, 0, pt.z)
		pot.Physics:SetCollides(false)
		pot.Physics:Teleport(pt.x, pt.y, pt.z) 
		pot.Physics:SetCollides(true)
		pot.SoundEmitter:PlaySound("dontstarve/common/place_structure_stone")
		pot.AnimState:PlayAnimation("place")
		pot.AnimState:PushAnimation("idle", true)
		inst:RemoveComponent("inventoryitem")
		inst:Remove()
	end
end

local function pickupfn(inst)
	local player = GetPlayer()
	if player.components and player.components.inventory then
		--print("pickupfn true")
		local potitem = SpawnPrefab("toso_danlu_item")
		player.components.inventory:GiveItem(potitem)
		inst:Remove()
		return true
	end
	--print("pickupfn false")
	inst.components.machine.ison = true
end

local function item_deploytest(inst, pt)
	local ground = GetWorld()
	local tile = GROUND.GRASS

	if ground and ground.Map then
		tile = ground.Map:GetTileAtPoint(pt:Get())
	end

	local onWater = ground.Map:IsWater(tile)

	return not onWater
end

local function item_droppedfn(inst)
	--If this is a valid place to be deployed, auto deploy yourself.
	if inst.components.deployable and inst.components.deployable:CanDeploy(inst:GetPosition()) then
		inst.components.deployable:Deploy(inst:GetPosition(), inst)
	end
end

local function itemfn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	MakeInventoryPhysics(inst)

	inst:AddTag("irreplaceable")

	inst.AnimState:SetBank("toso_danlu")
	inst.AnimState:SetBuild("toso_danlu")
	inst.AnimState:PlayAnimation("idle",true)
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "toso_danlu_item"
		inst.components.inventoryitem.atlasname = "images/inventoryimages/toso_danlu_item.xml"
	inst.components.inventoryitem:SetOnDroppedFn(item_droppedfn)

	inst:AddComponent("deployable")
	inst.components.deployable.ondeploy = ondeploy
	inst.components.deployable.placer = "toso_danlu_placer"
	inst.components.deployable.test = item_deploytest


	return inst
end

local function canpickup(inst)
	--local stewer = inst.components.stewer
	local container = inst.components.container

	if not container then
		--Something has gone very wrong...
		return false
	end

	return container:IsEmpty()
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "base_portablecookpot.tex" )

	local light = inst.entity:AddLight()
	inst.Light:Enable(false)
	inst.Light:SetRadius(.6)
	inst.Light:SetFalloff(1)
	inst.Light:SetIntensity(.5)
	inst.Light:SetColour(235/255,62/255,12/255)

	
	inst.open_judge = false
	inst:AddTag("structure")
	MakeObstaclePhysics(inst, .5)

	inst.AnimState:SetBank("toso_danlu")
	inst.AnimState:SetBuild("toso_danlu")
	inst.AnimState:PlayAnimation("idle",true)

	
    inst:AddComponent("burnable")
    --inst.components.burnable:SetFXLevel(2)
    inst.components.burnable:AddBurnFX("musha_ovenfire", Vector3(0,0,0) )

	
local player = GetPlayer()
    if player:HasTag("DLC")then
	inst.DLC = true
	end
	
    if player:HasTag("DLC2")then
	inst.DLC2 = true
	end		
	
	if inst.DLC or inst.DLC2 then
    inst.components.burnable:MakeNotWildfireStarter()
	end
	
    inst:ListenForEvent("onextinguish", onextinguish)
    inst:ListenForEvent("onignite", onignite)	

    -------------------------
    inst:AddComponent("fueled")
    inst.components.fueled.maxfuel = TUNING.FIREPIT_FUEL_MAX
    inst.components.fueled.accepting = true
    
    inst.components.fueled:SetSections(5)
    inst.components.fueled.bonusmult = 5
    inst.components.fueled.ontakefuelfn = 
	function() inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")  
	local fx2 = SpawnPrefab("small_puff")
        fx2.entity:SetParent(inst.entity)
	    fx2.Transform:SetPosition(0, 3, 0)
		end
    inst.components.fueled.rate = 1

    inst.components.fueled:SetUpdateFn( function()
        if inst.components.burnable and inst.components.fueled then
            inst.components.burnable:SetFXLevel(inst.components.fueled:GetCurrentSection(), inst.components.fueled:GetSectionPercent())
        end
    end)
        
    inst.components.fueled:SetSectionCallback( function(section)
        if section == 0 then
            inst.components.burnable:Extinguish() 
        else
            if not inst.components.burnable:IsBurning() then
                inst.components.burnable:Ignite()
            end
            
            inst.components.burnable:SetFXLevel(section, inst.components.fueled:GetSectionPercent())
            
        end
    end)
    inst.components.fueled:InitializeFuelLevel(TUNING.FIREPIT_FUEL_START) 
    
    -----------------------------	
	
	inst:AddComponent("container")
	--inst.components.container.itemtestfn = itemtest
	inst.components.container:SetNumSlots(4)
	inst.components.container.widgetslotpos = slotpos
	inst.components.container.widgetanimbank = "ui_cookpot_1x4"
	inst.components.container.widgetanimbuild = "ui_cookpot_1x4"
	inst.components.container.widgetpos = Vector3(200,0,0)
	inst.components.container.side_align_tip = 100
	inst.components.container.widgetbuttoninfo = widgetbuttoninfo
	--inst.components.container.acceptsstacks = false
	--inst.components.container.type = "cooker"

	inst.components.container.onopenfn = onopen
	inst.components.container.onclosefn = onclose

	inst:AddComponent("playerprox")
	inst.components.playerprox:SetDist(3,5)
	inst.components.playerprox:SetOnPlayerFar(onfar)

	MakeSnowCovered(inst, .01)
	
    inst:AddComponent("inspectable")
	--inst.components.inspectable.getstatus = getstatus
    
    inst:ListenForEvent( "onbuilt", function()
        anim:PlayAnimation("place")
        anim:PushAnimation("idle",true)
        inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
    end)

	inst:AddComponent("machine")
	inst.components.machine.ison = true
	inst.components.machine.turnofffn = pickupfn
	inst.components.machine.caninteractfn = canpickup
	--inst.open_judge = inst:DoPeriodicTask(0,open_judge)
	
	return inst
end



return Prefab( "common/toso_danlu", fn, assets, prefabs),
			 MakePlacer( "common/toso_danlu_placer", "toso_danlu", "toso_danlu", "idle" ),
			 Prefab("common/toso_danlu_item", itemfn, assets, prefabs)
