local assets =
{
    Asset("ANIM", "anim/ghostflower.zip"),
		Asset("ATLAS", "images/inventoryimages/toso_lingcao_flower.xml"),
		Asset("IMAGE", "images/inventoryimages/toso_lingcao_flower.tex"),
}

local prefabs =
{
	--"ghostflower_spirit1_fx",
	--"ghostflower_spirit2_fx",
}

local function dofx(inst)
	if not inst.inlimbo then
		local fx = SpawnPrefab("ghostflower_spirit"..tostring(math.random(2)).."_fx")
		fx.Transform:SetPosition(inst.Transform:GetWorldPosition())

		inst:DoTaskInTime(3 + math.random() * 6, dofx) -- the min delay needs to be greater than the grow animation + it's delay
	end
end

local function DoGrow(inst)
	inst:Show()
    inst.AnimState:PlayAnimation("grow")
    inst.AnimState:PushAnimation("idle", true)
end

local function DelayedGrow(inst)
	inst:Hide()
	inst:DoTaskInTime(0.25 + math.random() * 0.25, DoGrow)
end

local function toground(inst)
    inst.AnimState:PlayAnimation("idle", true)
	inst.AnimState:SetTime(math.random() * inst.AnimState:GetCurrentAnimationLength())

	--inst:DoTaskInTime(3 + math.random() * 6, dofx)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()


    MakeInventoryPhysics(inst)

    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
    inst.AnimState:SetBank("ghostflower")
    inst.AnimState:SetBuild("ghostflower")
    inst.AnimState:PlayAnimation("idle", true)
	
    inst.Transform:SetScale(1.2,1.2,1.2)	

    MakeInventoryFloatable(inst)


    inst:AddComponent("fuel")
    inst.components.fuel.fueltype = "NIGHTMARE"
    inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL*10


    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "toso_lingcao_flower"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/toso_lingcao_flower.xml"

    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 1000

    inst:ListenForEvent("ondropped", toground)

	inst.DelayedGrow = DelayedGrow

	toground(inst)

    return inst
end

return Prefab("toso_lingcao_flower", fn, assets, prefabs)
