local assets =
{
    Asset("ANIM", "anim/fire.zip"),
    Asset("SOUND", "sound/common.fsb"),
}

local heats = { 30, 70, 120, 180, 220 }

local function GetHeatFn(inst)
    return 180--heats[inst.components.firefx.level] or 20
end

local firelevels =
{
    {anim="level1", sound="dontstarve/common/campfire", radius=2, intensity=.75, falloff=.33, colour = {197/255,197/255,170/255}, soundintensity=.1},
    {anim="level2", sound="dontstarve/common/campfire", radius=3, intensity=.8, falloff=.33, colour = {255/255,255/255,192/255}, soundintensity=.3},
    {anim="level3", sound="dontstarve/common/campfire", radius=4, intensity=.8, falloff=.33, colour = {255/255,255/255,192/255}, soundintensity=.6},
    {anim="level4", sound="dontstarve/common/campfire", radius=5, intensity=.9, falloff=.25, colour = {255/255,190/255,121/255}, soundintensity=1},
    {anim="level4", sound="dontstarve/common/forestfire", radius=6, intensity=.9, falloff=.2, colour = {255/255,190/255,121/255}, soundintensity=1},
}

local function fnred()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddLight()

    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
    inst.AnimState:SetBank("fire")
    inst.AnimState:SetBuild("fire")
    inst.AnimState:SetRayTestOnBB(true)
    inst.AnimState:SetFinalOffset(-1)
	--inst.AnimState:SetAddColour(1, .75, .75, 0)

    inst:AddTag("FX")

    --HASHEATER (from heater component) added to pristine state for optimization
    inst:AddTag("HASHEATER")

--计入伤害
    inst:AddComponent("combat")
	
	----冰风暴
			--inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/tornado", "spinLoop")
	local period = 1
	--inst._tick = 0
	--inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		--伤害
		local pt = inst:GetPosition()	
		local r = 2.5
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "groundpoundimmune","toso_arm","shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				--if not table.contains(inst.collide_task_table, v.GUID) then
									local player = GetPlayer()
					local demage = 15 + 1*player.level
					v.components.combat:GetAttacked(inst, demage)
					--table.insert(inst.collide_task_table, v.GUID)
				--end
				
			end
		end
	end)
------

    inst:AddComponent("firefx")
    inst.components.firefx.levels = firelevels

    inst.components.firefx.extinguishsoundtest = function() 
        local x,y,z = inst.Transform:GetWorldPosition()
        local ents = TheSim:FindEntities(x,y,z, 5) 
        local fireyness = 0
        for k,v in pairs(ents) do
            if v ~= inst and v.components.firefx and v.components.firefx.level then
                fireyness = fireyness + v.components.firefx.level
            end
        end

        return fireyness < 5
    end

    inst:AddComponent("heater")
    inst.components.heater.heatfn = GetHeatFn

    return inst
end

local function fn()	
	local inst = fnred()
	inst.AnimState:SetAddColour(.25, 0, 0, 0)
	
	return inst
end

return Prefab("zg_fx_truefire_red", fnred, assets),
	Prefab("zg_fx_truefire", fn, assets)
	