require "prefabutil"

local assets =
{
Asset("ANIM", "anim/zhongxin.zip"),
Asset("IMAGE", "images/inventoryimages/zhongxin.tex"),
Asset("ATLAS", "images/inventoryimages/zhongxin.xml"),

	Asset( "SOUND" , "sound/ds_toso_bgm.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/ds_toso_bgm.fev" ),
}

local prefabs = 
{
}

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	inst.components.container:DropEverything()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", true)
	inst.components.container:DropEverything()
	inst.components.container:Close()
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", true)
end



local function check_music(inst)
	if inst:IsValid() then
		local distsq = inst:GetDistanceSqToInst(GetPlayer())

		if distsq < 4 then
		
           inst.SoundEmitter:PlaySound("ds_toso_bgm/sfx/yonghenghuiyi", "bgmxianjian")		
			--if math.random() > 0.75 then
				--local perd = SpawnPrefab("snake")
				--local spawnpos = Vector3(inst.Transform:GetWorldPosition() )
				--spawnpos = spawnpos + TheCamera:GetDownVec()
				--perd.Transform:SetPosition(spawnpos:Get() )
				--shake(inst)
			
			--end
		end

		--inst:DoTaskInTime(260+(math.random()*2), check_music)
	end
end

local function on_close(inst)


end 

local function far(inst)

            if inst.SoundEmitter:PlayingSound("bgmxianjian") then 
               inst.SoundEmitter:KillSound( "bgmxianjian")
            end 


end

local slotpos = {}
		for y = 4, 0, -1 do
			for x = 0, 15 do
				table.insert(slotpos, Vector3(80*x-346*2+91, 80*y-100*2+42,0))
			end
		end

local function itemtest(inst, item, slot)
       return not item.components.health
end



local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	trans:SetScale(2.0, 2.0, 2.0)
	MakeObstaclePhysics(inst, 0)

	local light = inst.entity:AddLight()
	inst.Light:SetRadius(3.5)
	inst.Light:SetFalloff(0.85)
	inst.Light:SetIntensity(.85)
	inst.Light:SetColour(188/255, 188/255, 188/255)
	inst.Light:Enable(false)

	anim:SetBank("jianzhong")
	anim:SetBuild("zhongxin")
	anim:PlayAnimation("idle", true)

	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "zhongxin.tex" )
	
	inst:AddTag("structure")
	inst:AddComponent("lootdropper")
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)

	inst:AddComponent("inspectable")

    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetpos = Vector3(0,190,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.itemtestfn = itemtest
    inst.components.container.widgetanimbank = "ui_chest_5x16"
    inst.components.container.widgetanimbuild = "ui_chest_5x16"
    inst.components.container.onopenfn = function(inst) GetPlayer().SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open") 	inst:DoTaskInTime(1+(math.random()*2), check_music)end
    inst.components.container.onclosefn = function(inst) GetPlayer().SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open") end
	--inst.SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open")
	MakeSnowCovered(inst, .01) 
	inst:ListenForEvent("onbuilt", onbuilt)
	inst:ListenForEvent( "daytime", function() inst.Light:Enable(false) end , GetWorld() )
	inst:ListenForEvent( "dusktime", function() inst.Light:Enable(false) end , GetWorld() )
	inst:ListenForEvent( "nighttime", function() inst.Light:Enable(true) end , GetWorld() )

    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(4, 4)
    inst.components.playerprox:SetOnPlayerNear(on_close)
    inst.components.playerprox:SetOnPlayerFar(far)
	

--------------------------------------

return inst
end

return Prefab( "common/zhongxin", fn, assets),
       MakePlacer("common/zhongxin_placer", "jianzhong", "zhongxin", "idle" ) 