local Screen = require "widgets/screen"
local Button = require "widgets/button"
local AnimButton = require "widgets/animbutton"
local ImageButton = require "widgets/imagebutton"
local Menu = require "widgets/menu"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local SswordDialogScreen = require "screens/popupdialog"
local Grid = require "widgets/grid"
local Spinner = require "widgets/spinner"
local SswordDialogScreen = require "screens/ssworddialogscreen"
require "util"
require "strings"
local TextEdit = require "widgets/textedit"
local textfont = UIFONT
local fontsize1 = 34
local fontsize2 = 30

for _, moddir in ipairs(KnownModIndex:GetModsToLoad()) do
if KnownModIndex:GetModInfo(moddir).name == "Chinese" or KnownModIndex:GetModInfo(moddir).name == "Chinese_support" then fontsize1 = 34 fontsize2 = 32 end
end

local SswordScreen = Class(Screen, function(self)

    Screen._ctor(self, "SswordScreen")
    self.active = true
    SetPause(true,"pause")

    --darken everything behind the dialog
    self.proot = self:AddChild(Widget("ROOT"))
    self.proot:SetVAnchor(ANCHOR_MIDDLE)
    self.proot:SetHAnchor(ANCHOR_MIDDLE)
    self.proot:SetPosition(0,0,0)
    self.proot:SetScaleMode(SCALEMODE_PROPORTIONAL)

    --throw up the background
    local shield = self.proot:AddChild( Image( "images/images_ui/UI_total_two.xml", "UI_total_two.tex" ) )
    shield:SetPosition( 30,45,0 )
    shield:SetSize( 900, 750 )
    local label = self.proot:AddChild( Text( textfont, fontsize1, "选择修炼的体质" ))
    label:SetPosition( 0, 250, 0 )
    label:SetRegionSize( 200, 40 )
    label:SetHAlign( ANCHOR_MIDDLE )
    label:SetColour(20,240,150,1)


    local player = GetPlayer()
	
--打坐
local function on_sleep(inst)
local inst = GetPlayer()
local lingli_percent = inst.components.shaqi:GetPercent() 
--local bedroll = inst.sg:GoToState("bedroll")

inst.components.talker:Say("看我汇聚天地灵力")
inst.sg:GoToState("jumpin")
inst:DoTaskInTime(0.5, function() inst:AddTag("juqi_in") end)

    if not inst.juqiTask then
        inst.juqiTask = inst:DoPeriodicTask(1.5,function()
		--inst.components.shaqi:DoDelta(1)
		inst.components.sanity:DoDelta(1.5)
		inst.components.health:DoDelta(0.5)
		inst.components.hunger:DoDelta(-1)
		inst.AnimState:PlayAnimation("emote_loop_sit2",false)
		SpawnPrefab("zhiliao").Transform:SetPosition(inst:GetPosition():Get())
		   

        end)
    end
end 

local function dazuoing_toso()
	
--dazuoing_toso = function()
local inst = GetPlayer()
local lingli_percent = inst.components.shaqi:GetPercent() 

--if inst.yuansu_guang > 0 then

if inst:HasTag("juqi_in") then
--inst.components.talker:Say("正在打坐聚集灵力")
   inst.sg:GoToState("play_onemanband_stomp") 
   inst:RemoveTag("juqi_in")

  		        if inst.juqiTask then
                   inst.juqiTask:Cancel()
                   inst.juqiTask=nil
				--inst.components.shaqi:DoDelta(0)
                end
   
  inst:DoTaskInTime(2, function() inst.components.talker:Say("暂时先结束下修炼")
    inst.sg:GoToState("powerup") 
    inst.SoundEmitter:PlaySound("dontstarve/wilson/onemanband") inst.components.playercontroller:Enable(true) end)


--test
elseif inst.components.hunger.current > 20 and not inst:HasTag("juqi_in") and not inst:HasTag("aquatic") then
--and (inst.sg:HasStateTag("moving") or inst.sg:HasStateTag("attack") or inst.sg:HasStateTag("chopping") or inst.sg:HasStateTag("mining") or  inst.sg:HasStateTag("hammering") or inst.sg:HasStateTag("digging") or inst.sg:HasStateTag("netting") or inst.sg:HasStateTag("fishing") or inst.sg:HasStateTag("boating") ) then
inst.components.playercontroller:Enable(false)
inst.components.locomotor:Stop()
on_sleep(inst)


end--打坐函数结束

--else
--inst.components.talker:Say("还未开通打通仙骨，请食用仙灵丹开启仙骨")
--end--仙灵元素结束
end 
	
	
	local yiyu_absorball = 0
	local yuyi_weapondmg = 0
	local absorb1 = 0--护甲头
	local absorb2 = 0--护甲胸
	local absorb3 = 0--护吸收
	local corselet = player.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
	local weapon = player.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	if weapon and weapon.components.weapon and weapon.components.weapon.damage then
		yuyi_weapondmg = weapon.components.weapon.damage
	end
	local helmet = player.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
	if corselet and corselet.components.armor and corselet.components.armor.absorb_percent then
		absorb1 = corselet.components.armor.absorb_percent
	end
	if helmet and helmet.components.armor and helmet.components.armor.absorb_percent then
		absorb2 = helmet.components.armor.absorb_percent
	end
	if player and player.components.health then
		absorb3 = player.components.health.absorb
	end
	local yiyu_absorball1 = 100-(100*absorb3)
	local yiyu_absorball2 = yiyu_absorball1-(yiyu_absorball1*absorb2)
	local yiyu_absorball3 = yiyu_absorball2-(yiyu_absorball2*absorb1)
	yiyu_absorball = 100-yiyu_absorball3

    self.grid1 = self.proot:AddChild(Grid())
    self.grid1:InitSize(1, 15, 700, -70)
    self.grid1:SetPosition(-170, 200, 0)
    self.grid1:SetScale(0.9, 0.6, 0.9)

    local spinners1 = {}
	local yiyulevels = GetPlayer().yiyulevel
    table.insert(spinners1, {"修炼护甲", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"修炼精神", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"修炼三维", nil, "hh" ,false ,nil}) 
    table.insert(spinners1, {"修炼移速", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"修炼倍攻", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"修炼怒气", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"世界boss", nil, "hh" ,false ,nil})
	--table.insert(spinners1, {"冰之丹", string.format("%.0f/%.0f", 1, 5) , "hh" ,false ,nil})
	--table.insert(spinners1, {"暗影丹", string.format("%.0f/%.0f", 1, 5) , "hh" ,false ,nil})
    for k,v in ipairs(spinners1) do self.grid1:AddItem(self:CreateSpinnerGroup(v[1], v[2], v[3], v[4]), 1, k) end

    self.grid2 = self.proot:AddChild(Grid())
    self.grid2:InitSize(1, 15, 700, -70)
    self.grid2:SetPosition(130, 200, 0)
    self.grid2:SetScale(0.9, 0.6, 0.9)
    local spinners2 = {}
    table.insert(spinners2, {"修炼辟谷", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"修炼伤害", nil, "hh" ,false ,nil}) 
    table.insert(spinners2, {"修炼暴击", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"修炼抗冷", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"修炼抗热", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"修炼吸血", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"修真等级获益", nil, "hh" ,false ,nil})
    --table.insert(spinners2, {"反馈群542905985",nil, "hh" ,false ,nil})
    for k,v in ipairs(spinners2) do self.grid2:AddItem(self:CreateSpinnerGroup(v[1], v[2], v[3], v[4]), 1, k) end


	
	local function tosoclosescreen()
		TheFrontEnd:PopScreen()
	end

	self.skillbutton1 = self.proot:AddChild(ImageButton())
	self.skillbutton1:SetText("修炼")
    self.skillbutton1:SetPosition(-80, 200, 0)
    self.skillbutton1:SetScale(0.4)
    self.skillbutton1:SetOnClick(
	function()
	TUNING.XIU = 1--护甲
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

	self.skillbutton2 = self.proot:AddChild(ImageButton())
	self.skillbutton2:SetText("修炼")
    self.skillbutton2:SetPosition(-80, 160, 0)
    self.skillbutton2:SetScale(0.4)
    self.skillbutton2:SetOnClick(
	function()
	TUNING.XIU = 2--精神
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

	self.skillbutton3 = self.proot:AddChild(ImageButton())
	self.skillbutton3:SetText("修炼")
    self.skillbutton3:SetPosition(-80, 115, 0)
    self.skillbutton3:SetScale(0.4)
    self.skillbutton3:SetOnClick(
	function()
	TUNING.XIU = 3--三维
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

	self.skillbutton4 = self.proot:AddChild(ImageButton())
	self.skillbutton4:SetText("修炼")
    self.skillbutton4:SetPosition(-80, 75, 0)
    self.skillbutton4:SetScale(0.4)
    self.skillbutton4:SetOnClick(
	function()
	TUNING.XIU = 4--移速
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

	self.skillbutton5 = self.proot:AddChild(ImageButton())
	self.skillbutton5:SetText("修炼")
    self.skillbutton5:SetPosition(-80, 30, 0)
    self.skillbutton5:SetScale(0.4)
    self.skillbutton5:SetOnClick(
	function()
	TUNING.XIU = 5--倍攻
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

	self.skillbutton6 = self.proot:AddChild(ImageButton())
	self.skillbutton6:SetText("修炼")
    self.skillbutton6:SetPosition(-80, -10, 0)
    self.skillbutton6:SetScale(0.4)
    self.skillbutton6:SetOnClick(
	function()
	TUNING.XIU = 6--怒气
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

	self.skillbutton7 = self.proot:AddChild(ImageButton())
	self.skillbutton7:SetText("挑战")
    self.skillbutton7:SetPosition(-80, -50, 0)
    self.skillbutton7:SetScale(0.4)
    self.skillbutton7:SetOnClick(
	function()
    --关闭
    self:Close()
    local player = GetPlayer()		
			if TheSim:FindFirstEntityWithTag("toso_armboss") then			
				--local doer = player
				local target = TheSim:FindFirstEntityWithTag("toso_armboss")			
                if target then
				player.components.talker:Say("当前已经有一个世界boss")	
						
			
				
	            end	
            else
			if player.skill_2CD  == 0 then
						local player = GetPlayer()
						if player.level > 20 and player.level <= 30 then
						player.skill_2CD  = 4800
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = player.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_sesshoumaru")
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(player:GetPosition(), theta, radius, 12, true) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 
		
						elseif player.level > 30 and player.level <= 40 then
						player.skill_2CD  = 4800
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = player.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_sesshoumaru")
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(player:GetPosition(), theta, radius, 12, true) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
						elseif player.level > 40 and player.level <= 50 then
						player.skill_2CD  = 4800
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = player.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_sesshoumaru")
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(player:GetPosition(), theta, radius, 12, true) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 		
						--elseif player.level > 50 and player.level <= 60 then
						--player.skill_2CD  = 4800		
						
						--elseif player.level > 60 and player.level <= 70 then
						--player.skill_2CD  = 4800	
						
						--elseif player.level > 70 and player.level <= 80 then
						--player.skill_2CD  = 4800
						
						elseif player.level > 40 then
						player.skill_2CD  = 4800
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = player.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_sesshoumaru")
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(player:GetPosition(), theta, radius, 12, true) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 	

	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = player.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_sesshoumaru")
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(player:GetPosition(), theta, radius, 12, true) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 				
						else
						player.skill_2CD  = 4800
	        local downvec = TheCamera:GetDownVec()			
            local x,y,z = player.Transform:GetWorldPosition()	
            local arm2 = SpawnPrefab("boss_sesshoumaru")
			local theta = math.random() * 2 * PI
			local radius = 25
            local offset = FindWalkableOffset(player:GetPosition(), theta, radius, 12, true) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or FindWaterOffset(player:GetPosition(), theta, radius, 36, false) or downvec:Normalize()
            arm2.Transform:SetPosition(x + offset.x, y + offset.y, z + offset.z)
            SpawnPrefab("statue_transition_2").Transform:SetPosition(arm2:GetPosition():Get()) 
                        
						end

			else
            player.components.talker:Say("世界boss休眠剩余时间:"..tostring(player.skill_2CD))		            
            end
			
			end



	end

	)
--[[
    --冰之丹
	self.skillbutton8 = self.proot:AddChild(ImageButton())
	self.skillbutton8:SetText("修炼")
    self.skillbutton8:SetPosition(-80, -90, 0)
    self.skillbutton8:SetScale(0.4)
    self.skillbutton8:SetOnClick(
	function()
	local yuyi_doalog = SswordDialogScreen(
		"冰之丹",
		"功能：开通元素中的冰属性\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【西瓜冰*1】\n第三格【巨鹿眼球*1】\n第四格【冰*1】\n特殊条件：自身温度<5度",
	{ { text = "我知道了", cb = tosoclosescreen } })
	yuyi_doalog:SetTitleTextSize(36)
	yuyi_doalog:SetButtonTextSize(30)
	yuyi_doalog.title:SetPosition(0, 250, 0)
	yuyi_doalog.text:SetSize(25)
	yuyi_doalog.text:SetRegionSize(900, 600)
	yuyi_doalog.text:SetPosition(150, 170, 0)
	yuyi_doalog.text:SetHAlign(ANCHOR_LEFT)
	yuyi_doalog.bg:SetScale(1.7, 1.5, 1.2)
	yuyi_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(yuyi_doalog)
	end
	)
    --暗影丹
	self.skillbutton9 = self.proot:AddChild(ImageButton())
	self.skillbutton9:SetText("修炼")
    self.skillbutton9:SetPosition(-80, -135, 0)
    self.skillbutton9:SetScale(0.4)
    self.skillbutton9:SetOnClick(
	function()
	local yuyi_doalog = SswordDialogScreen(
		"暗影丹",
		"功能：开通元素中的暗影属性\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【怪物千层饼*1】\n第三格【噩梦燃料*10】\n第四格【空】\n特殊条件：自身脑残低于一半",
	{ { text = "我知道了", cb = tosoclosescreen } })
	yuyi_doalog:SetTitleTextSize(36)
	yuyi_doalog:SetButtonTextSize(30)
	yuyi_doalog.title:SetPosition(0, 250, 0)
	yuyi_doalog.text:SetSize(25)
	yuyi_doalog.text:SetRegionSize(900, 600)
	yuyi_doalog.text:SetPosition(150, 170, 0)
	yuyi_doalog.text:SetHAlign(ANCHOR_LEFT)
	yuyi_doalog.bg:SetScale(1.7, 1.5, 1.2)
	yuyi_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(yuyi_doalog)
	end
	)
]]
	--仙灵丹
	self.skillbutton10 = self.proot:AddChild(ImageButton())
	self.skillbutton10:SetText("修炼")
    self.skillbutton10:SetPosition(200, 200, 0)
    self.skillbutton10:SetScale(0.4)
    self.skillbutton10:SetOnClick(
	function()
	TUNING.XIU = 7--辟谷
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)

    --速成丹
	self.skillbutton11 = self.proot:AddChild(ImageButton())
	self.skillbutton11:SetText("修炼")
    self.skillbutton11:SetPosition(200, 160, 0)
    self.skillbutton11:SetScale(0.4)
    self.skillbutton11:SetOnClick(
	function()
	TUNING.XIU = 8--百分比伤害
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)
    --灵子球
	self.skillbutton12 = self.proot:AddChild(ImageButton())
	self.skillbutton12:SetText("修炼")
    self.skillbutton12:SetPosition(200, 115, 0)
    self.skillbutton12:SetScale(0.4)
    self.skillbutton12:SetOnClick(
	function()
	TUNING.XIU = 9--暴击
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)
    --小灵丹
	self.skillbutton14 = self.proot:AddChild(ImageButton())
	self.skillbutton14:SetText("修炼")
    self.skillbutton14:SetPosition(200, 75, 0)
    self.skillbutton14:SetScale(0.4)
    self.skillbutton14:SetOnClick(
	function()
	TUNING.XIU = 10--抗冷
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)	
    --小阿翔蛋
	self.skillbutton15 = self.proot:AddChild(ImageButton())
	self.skillbutton15:SetText("修炼")
    self.skillbutton15:SetPosition(200, 30, 0)
    self.skillbutton15:SetScale(0.4)
    self.skillbutton15:SetOnClick(
	function()
	TUNING.XIU = 11--抗热
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)
    --高级阿翔蛋
	self.skillbutton16 = self.proot:AddChild(ImageButton())
	self.skillbutton16:SetText("修炼")
    self.skillbutton16:SetPosition(200, -10, 0)
    self.skillbutton16:SetScale(0.4)
    self.skillbutton16:SetOnClick(
	function()
	TUNING.XIU = 12--吸血
    dazuoing_toso()
	self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
	end
	)
	
    --查看修真等级获得的被动属性
	self.skillbutton17 = self.proot:AddChild(ImageButton())
	self.skillbutton17:SetText("查看")
    self.skillbutton17:SetPosition(200, -50, 0)
    self.skillbutton17:SetScale(0.4)
    self.skillbutton17:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"修真等级获益介绍",
		"功能：随着修真等级提高，将会获得不同层次的被动\n等级5：技艺熟练，收草，收锅等动作加快\n等级10：消耗材料减少一半\n等级15：基于等级缓慢回血\n等级20：自带二本科技\n等级25：自带魔法科技\n等级30：自带远古科技\n等级31：可自由切换自己的技能，但离魂和隐身技能被远古boss封印无法使用，获得获得被动技能：隐身，恒温-无惧寒热\n等级35：自带黑曜石科技，解锁新丹药闪避丹和攻速丹（请查看丹药列表），远古神boss将于36级来临\n等级40：自带猪镇科技\n等级50：攻击几率触发破绽打断对方技能，僵直",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 300, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
	--此处尚有空余空间
--[[	
	
    --常规
	self.skillbutton = self.proot:AddChild(ImageButton())
	self.skillbutton:SetText("丹炉用法")
    self.skillbutton:SetPosition(200, -80, 0)
    self.skillbutton:SetScale(0.4)
    self.skillbutton:SetOnClick(
	function()
	local yuyi_doalog = SswordDialogScreen(
		"丹炉用法说明",
		"功能：炼制丹药和宠物蛋\n使用方法：加火使炉子保持燃烧，不同丹药需要不同温度，适当加火\n未放入任何东西时右键可回收",
	{ { text = "我知道了", cb = tosoclosescreen } })
	yuyi_doalog:SetTitleTextSize(36)
	yuyi_doalog:SetButtonTextSize(30)
	yuyi_doalog.title:SetPosition(0, 250, 0)
	yuyi_doalog.text:SetSize(25)
	yuyi_doalog.text:SetRegionSize(900, 600)
	yuyi_doalog.text:SetPosition(150, 170, 0)
	yuyi_doalog.text:SetHAlign(ANCHOR_LEFT)
	yuyi_doalog.bg:SetScale(1.7, 1.5, 1.2)
	yuyi_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(yuyi_doalog)
	end
	)



	self.skillbutton12 = self.proot:AddChild(ImageButton())
	self.skillbutton12:SetText("修炼")
    self.skillbutton12:SetPosition(200, 30, 0)
    self.skillbutton12:SetScale(0.4)
    self.skillbutton12:SetOnClick(
	function()
	local yuyi_doalog = SswordDialogScreen(
		STRINGS.YUYISCREEN_JIESHAO12,
		STRINGS.YUYISCREEN_JS_BX1.."植物与建筑"..STRINGS.YUYISCREEN_JS_BX2,
	{ { text = "我知道了", cb = tosoclosescreen } })
	yuyi_doalog:SetTitleTextSize(36)
	yuyi_doalog:SetButtonTextSize(30)
	yuyi_doalog.title:SetPosition(0, 250, 0)
	yuyi_doalog.text:SetSize(25)
	yuyi_doalog.text:SetRegionSize(900, 600)
	yuyi_doalog.text:SetPosition(150, 170, 0)
	yuyi_doalog.text:SetHAlign(ANCHOR_LEFT)
	yuyi_doalog.bg:SetScale(1.7, 1.5, 1.2)
	yuyi_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(yuyi_doalog)
	end
	)

	self.skillbutton13 = self.proot:AddChild(ImageButton())
	self.skillbutton13:SetText("修炼")
    self.skillbutton13:SetPosition(200, -10, 0)
    self.skillbutton13:SetScale(0.4)
    self.skillbutton13:SetOnClick(
	function()
	local yuyi_doalog = SswordDialogScreen(
		STRINGS.YUYISCREEN_JIESHAO13,
		STRINGS.YUYISCREEN_JS_ZH1.."植物与建筑"..")*0.5+0.5",
	{ { text = "我知道了", cb = tosoclosescreen } })
	yuyi_doalog:SetTitleTextSize(36)
	yuyi_doalog:SetButtonTextSize(30)
	yuyi_doalog.title:SetPosition(0, 250, 0)
	yuyi_doalog.text:SetSize(25)
	yuyi_doalog.text:SetRegionSize(900, 600)
	yuyi_doalog.text:SetPosition(150, 170, 0)
	yuyi_doalog.text:SetHAlign(ANCHOR_LEFT)
	yuyi_doalog.bg:SetScale(1.7, 1.5, 1.2)
	yuyi_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(yuyi_doalog)
	end
	)

	self.textbutton = self.proot:AddChild(ImageButton())
	self.textbutton:SetText("修炼")
    self.textbutton:SetPosition(-80, -135, 0)
    self.textbutton:SetScale(0.4)
    self.textbutton:SetOnClick(
	function()
	if GetPlayer().HUD and GetPlayer().HUD.yuyi_nandu then
	if GetPlayer():HasTag("yiyucharacter") then
		GetPlayer():RemoveTag("yiyucharacter")
		GetPlayer().HUD.yuyi_nandu:Hide()
		GetPlayer().HUD.yuyi_buff:Hide()
	else
	GetPlayer():AddTag("yiyucharacter")
		GetPlayer().HUD.yuyi_nandu:Show()
		GetPlayer().HUD.yuyi_buff:Show()
	end
	end
	end)

	self.vistbutton = self.proot:AddChild(ImageButton())
	self.vistbutton:SetText("贴吧留言")
    self.vistbutton:SetPosition(65, -95, 0)
    self.vistbutton:SetScale(0.4)
    self.vistbutton:SetOnClick( function() VisitURL("https://tieba.baidu.com/p/5216202271?pn=1") end)

	self.vistbutton = self.proot:AddChild(ImageButton())
	self.vistbutton:SetText("角色信息")
    self.vistbutton:SetPosition(65, -135, 0)
    self.vistbutton:SetScale(0.4)
    self.vistbutton:SetOnClick( function() VisitURL("http://steamcommunity.com/sharedfiles/filedetails/?id=642704851") end)

	self.vistbutton = self.proot:AddChild(ImageButton())
	self.vistbutton:SetText("MOD定做")
    self.vistbutton:SetPosition(155, -95, 0)
    self.vistbutton:SetScale(0.4)
    self.vistbutton:SetOnClick( function() self:Close() player.components.talker:Say("人懒,再说吧.") end)
]]
    self.menu = self.proot:AddChild(Menu(nil, 200, true))
    self.menu:SetPosition(300, -135 ,0)
    self.menu:SetScale(0.4)
    self.menu:AddItem("返回", function() self:Close() end)
end)

function SswordScreen:CreateSpinnerGroup( text, text2 , text3 ,button,fn)
    local label_width = 290
    local group = Widget("SpinnerGroup")
    local label = group:AddChild( Text( textfont, fontsize2, text ) )
    label:SetPosition( 0, 0, 0 )
    label:SetRegionSize( label_width, fontsize2 )
    label:SetHAlign( ANCHOR_LEFT )
    label:SetColour(0,0.75,1,1)
	
    local label2 = group:AddChild( Text( textfont, fontsize2, text2 ) )
    label2:SetPosition( 0, 0, 0 )
    label2:SetRegionSize( label_width, fontsize2 )
    label2:SetHAlign( ANCHOR_MIDDLE )
    label2:SetColour(0,0.75,1,1)

    if button then
        local label3 = group:AddChild(Menu(nil, 200, true))
        label3:SetPosition( 100, 0, 0 )
        label3:SetScale(0.6)
        label3:SetHRegPoint(ANCHOR_RIGHT)
        label3:AddItem(text3, function()
            if fn then
                fn()

            end
         end)
    end

    return group
end

function SswordScreen:Close()
    self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
end 

function SswordScreen:OnControl(control, down)
    if SswordScreen._base.OnControl(self, control, down) then return true end
    if not down and  control == CONTROL_CANCEL then
        self:Close()
        return true
    end
    return false
end


return SswordScreen