local Screen = require "widgets/screen"
local Button = require "widgets/button"
local AnimButton = require "widgets/animbutton"
local ImageButton = require "widgets/imagebutton"
local Menu = require "widgets/menu"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local SswordDialogScreen = require "screens/popupdialog"
local Grid = require "widgets/grid"
local Spinner = require "widgets/spinner"
local SswordDialogScreen = require "screens/ssworddialogscreen"
require "util"
require "strings"
local TextEdit = require "widgets/textedit"
local textfont = UIFONT
local fontsize1 = 34
local fontsize2 = 30

for _, moddir in ipairs(KnownModIndex:GetModsToLoad()) do
if KnownModIndex:GetModInfo(moddir).name == "Chinese" or KnownModIndex:GetModInfo(moddir).name == "Chinese_support" then fontsize1 = 34 fontsize2 = 32 end
end

local TosoScreen2 = Class(Screen, function(self)

    Screen._ctor(self, "TosoScreen2")
    self.active = true
    SetPause(true,"pause")

    --darken everything behind the dialog
    self.proot = self:AddChild(Widget("ROOT"))
    self.proot:SetVAnchor(ANCHOR_MIDDLE)
    self.proot:SetHAnchor(ANCHOR_MIDDLE)
    self.proot:SetPosition(0,0,0)
    self.proot:SetScaleMode(SCALEMODE_PROPORTIONAL)

    --throw up the background
    local shield = self.proot:AddChild( Image( "images/images_ui/UI_total_two.xml", "UI_total_two.tex" ) )
    shield:SetPosition( 30,45,0 )
    shield:SetSize( 900, 750 )
    local label = self.proot:AddChild( Text( textfont, fontsize1, "丹药资料库" ))
    label:SetPosition( 0, 250, 0 )
    label:SetRegionSize( 200, 40 )
    label:SetHAlign( ANCHOR_MIDDLE )
    label:SetColour(20,240,150,1)


    local player = GetPlayer()


    self.grid1 = self.proot:AddChild(Grid())
    self.grid1:InitSize(1, 15, 700, -70)
    self.grid1:SetPosition(-170, 200, 0)
    self.grid1:SetScale(0.9, 0.6, 0.9)

    local spinners1 = {}
	--local yiyulevels = GetPlayer().yiyulevel
    table.insert(spinners1, {"护甲丹", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"回san丹", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"三维丹", nil, "hh" ,false ,nil}) 
    table.insert(spinners1, {"移速丹", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"倍攻丹", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"怒气丹", nil, "hh" ,false ,nil})
    table.insert(spinners1, {"辟谷丹", nil, "hh" ,false ,nil})
	table.insert(spinners1, {"伤害丹", nil, "hh" ,false ,nil})
	table.insert(spinners1, {"暴击丹", nil, "hh" ,false ,nil})
    for k,v in ipairs(spinners1) do self.grid1:AddItem(self:CreateSpinnerGroup(v[1], v[2], v[3], v[4]), 1, k) end

    self.grid2 = self.proot:AddChild(Grid())
    self.grid2:InitSize(1, 15, 700, -70)
    self.grid2:SetPosition(130, 200, 0)
    self.grid2:SetScale(0.9, 0.6, 0.9)
    local spinners2 = {}
    table.insert(spinners2, {TUNING.DANKANGLENG, nil, "hh" ,false ,nil})
    table.insert(spinners2, {TUNING.DANKANGRE, nil, "hh" ,false ,nil}) 
    table.insert(spinners2, {"噬血丹", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"韭菜鸡蛋", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"上古锻造攻击", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"穿甲已被封印", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"避世丹", nil, "hh" ,false ,nil})
    table.insert(spinners2, {"领域丹", nil, "hh" ,false ,nil})
    --table.insert(spinners2, {"反馈群542905985",nil, "hh" ,false ,nil})
    for k,v in ipairs(spinners2) do self.grid2:AddItem(self:CreateSpinnerGroup(v[1], v[2], v[3], v[4]), 1, k) end

	local function tosoclosescreen()
		TheFrontEnd:PopScreen()
	end

	self.skillbutton1 = self.proot:AddChild(ImageButton())
	self.skillbutton1:SetText("介绍")
    self.skillbutton1:SetPosition(-80, 200, 0)
    self.skillbutton1:SetScale(0.4)
    self.skillbutton1:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"护甲丹介绍",
		"功能：提升自身物理吸收\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【猪皮*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton2 = self.proot:AddChild(ImageButton())
	self.skillbutton2:SetText("介绍")
    self.skillbutton2:SetPosition(-80, 160, 0)
    self.skillbutton2:SetScale(0.4)
    self.skillbutton2:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
	"回san丹介绍",
	"功能：提升脑残回复速度\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【熟绿蘑菇*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton3 = self.proot:AddChild(ImageButton())
	self.skillbutton3:SetText("介绍")
    self.skillbutton3:SetPosition(-80, 115, 0)
    self.skillbutton3:SetScale(0.4)
    self.skillbutton3:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"三维丹介绍",
		"功能：提升三维上限\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【熟浆果*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton4 = self.proot:AddChild(ImageButton())
	self.skillbutton4:SetText("介绍")
    self.skillbutton4:SetPosition(-80, 75, 0)
    self.skillbutton4:SetScale(0.4)
    self.skillbutton4:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"移速丹介绍",
		"功能：提升人物基础移速\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【蝴蝶翅膀*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton5 = self.proot:AddChild(ImageButton())
	self.skillbutton5:SetText("介绍")
    self.skillbutton5:SetPosition(-80, 30, 0)
    self.skillbutton5:SetScale(0.4)
    self.skillbutton5:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"倍攻丹介绍",
		"功能：提升基础攻击力倍数（继承武器伤害）\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【蜂刺*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton6 = self.proot:AddChild(ImageButton())
	self.skillbutton6:SetText("介绍")
    self.skillbutton6:SetPosition(-80, -10, 0)
    self.skillbutton6:SetScale(0.4)
    self.skillbutton6:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"怒气丹介绍",
		"功能：提升每次攻击增加的怒气，更快使出技能\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【花瓣*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton7 = self.proot:AddChild(ImageButton())
	self.skillbutton7:SetText("介绍")
    self.skillbutton7:SetPosition(-80, -50, 0)
    self.skillbutton7:SetScale(0.4)
    self.skillbutton7:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"辟谷丹介绍",
		"功能：降低自身饥饿速率\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【绳子*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
    --冰之丹
	self.skillbutton8 = self.proot:AddChild(ImageButton())
	self.skillbutton8:SetText("介绍")
    self.skillbutton8:SetPosition(-80, -90, 0)
    self.skillbutton8:SetScale(0.4)
    self.skillbutton8:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"伤害丹",
		"功能：提升每次攻击附加的额外最大生命值伤害\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【毒腺*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
    --暗影丹
	self.skillbutton9 = self.proot:AddChild(ImageButton())
	self.skillbutton9:SetText("介绍")
    self.skillbutton9:SetPosition(-80, -135, 0)
    self.skillbutton9:SetScale(0.4)
    self.skillbutton9:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"暴击丹",
		"功能：提高攻击击中破绽的概率，打断敌人当前动作或者技能\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【石砖*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
	--仙灵丹
	self.skillbutton10 = self.proot:AddChild(ImageButton())
	self.skillbutton10:SetText("介绍")
    self.skillbutton10:SetPosition(200, 200, 0)
    self.skillbutton10:SetScale(0.4)
    self.skillbutton10:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		TUNING.DANKANGLENG,
		TUNING.DANKANGLENGINTRO,
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
    --速成丹
	self.skillbutton11 = self.proot:AddChild(ImageButton())
	self.skillbutton11:SetText("介绍")
    self.skillbutton11:SetPosition(200, 160, 0)
    self.skillbutton11:SetScale(0.4)
    self.skillbutton11:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		TUNING.DANKANGRE,
		TUNING.DANKANGREINTRO,
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
    --灵子球
	self.skillbutton12 = self.proot:AddChild(ImageButton())
	self.skillbutton12:SetText("介绍")
    self.skillbutton12:SetPosition(200, 110, 0)
    self.skillbutton12:SetScale(0.4)
    self.skillbutton12:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"吸血丹介绍",
		"功能：提高每次攻击吸血量\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【蜂蜜*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
    --食物丹
	self.skillbutton14 = self.proot:AddChild(ImageButton())
	self.skillbutton14:SetText("介绍")
    self.skillbutton14:SetPosition(200, 75, 0)
    self.skillbutton14:SetScale(0.4)
    self.skillbutton14:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"韭菜鸡蛋介绍",
		"功能：回复100生命值，20san，20饱食度\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【韭菜*10】\n第三格【鸡蛋*10】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)	
    --小阿翔蛋
	self.skillbutton15 = self.proot:AddChild(ImageButton())
	self.skillbutton15:SetText("介绍")
    self.skillbutton15:SetPosition(200, 30, 0)
    self.skillbutton15:SetScale(0.4)
    self.skillbutton15:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"锻造上古神剑攻击力介绍",
		"功能：增加上古的基础攻击力\n炼制所需材料：在剑冢中放入\n第一格【上古神剑*1】\n第二格【火龙果派*5】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

    --高级阿翔蛋
	self.skillbutton16 = self.proot:AddChild(ImageButton())
	self.skillbutton16:SetText("介绍")
    self.skillbutton16:SetPosition(200, -10, 0)
    self.skillbutton16:SetScale(0.4)
    self.skillbutton16:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"上古神剑如何穿甲介绍--该功能现已停用",
		"功能：增加上古神剑的穿甲\n击杀史诗型怪物可以获得穿甲提升\n怪物列表：所有dlc的boss生物",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	--此处尚有空余空间
	
	self.skillbutton17 = self.proot:AddChild(ImageButton())
	self.skillbutton17:SetText("介绍")
    self.skillbutton17:SetPosition(200, -50, 0)
    self.skillbutton17:SetScale(0.4)
    self.skillbutton17:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"避世丹介绍",
		"功能：清除魅力值，隐匿气息\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*1】\n第三格【噩梦燃料*5】\n第四格【空】\n特殊条件：无",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton18 = self.proot:AddChild(ImageButton())
	self.skillbutton18:SetText("介绍")
    self.skillbutton18:SetPosition(200, -90, 0)
    self.skillbutton18:SetScale(0.4)
    self.skillbutton18:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"领域丹介绍",
		"功能：攻击后对敌人的生命灼烧\n炼制所需材料：在四格丹炉中放入\n第一格【灵花*5】\n第二格【莎草纸*5】\n第三格【龙骑士之心或者狼牙棒或者蚂蚁甲壳*1】\n第四格【空】\n特殊条件：角色35级食用有效",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)
	
    --常规
	self.skillbutton = self.proot:AddChild(ImageButton())
	self.skillbutton:SetText("丹炉用法")
    self.skillbutton:SetPosition(200, -135, 0)
    self.skillbutton:SetScale(0.4)
    self.skillbutton:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		"丹炉用法说明",
		"功能：炼制丹药和宠物蛋\n使用方法：加火使炉子保持燃烧，不同丹药需要不同温度，适当加火\n未放入任何东西时右键可回收",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)


--[[
	self.skillbutton12 = self.proot:AddChild(ImageButton())
	self.skillbutton12:SetText("介绍")
    self.skillbutton12:SetPosition(200, 30, 0)
    self.skillbutton12:SetScale(0.4)
    self.skillbutton12:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		STRINGS.tosoSCREEN_JIESHAO12,
		STRINGS.tosoSCREEN_JS_BX1.."植物与建筑"..STRINGS.tosoSCREEN_JS_BX2,
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.skillbutton13 = self.proot:AddChild(ImageButton())
	self.skillbutton13:SetText("介绍")
    self.skillbutton13:SetPosition(200, -10, 0)
    self.skillbutton13:SetScale(0.4)
    self.skillbutton13:SetOnClick(
	function()
	local toso_doalog = SswordDialogScreen(
		STRINGS.tosoSCREEN_JIESHAO13,
		STRINGS.tosoSCREEN_JS_ZH1.."植物与建筑"..")*0.5+0.5",
	{ { text = "我知道了", cb = tosoclosescreen } })
	toso_doalog:SetTitleTextSize(36)
	toso_doalog:SetButtonTextSize(30)
	toso_doalog.title:SetPosition(0, 250, 0)
	toso_doalog.text:SetSize(25)
	toso_doalog.text:SetRegionSize(900, 600)
	toso_doalog.text:SetPosition(150, 170, 0)
	toso_doalog.text:SetHAlign(ANCHOR_LEFT)
	toso_doalog.bg:SetScale(1.7, 1.5, 1.2)
	toso_doalog.menu:SetPosition(0, -100, 0)
	TheFrontEnd:PushScreen(toso_doalog)
	end
	)

	self.textbutton = self.proot:AddChild(ImageButton())
	self.textbutton:SetText("介绍")
    self.textbutton:SetPosition(-80, -135, 0)
    self.textbutton:SetScale(0.4)
    self.textbutton:SetOnClick(
	function()
	if GetPlayer().HUD and GetPlayer().HUD.toso_nandu then
	if GetPlayer():HasTag("yiyucharacter") then
		GetPlayer():RemoveTag("yiyucharacter")
		GetPlayer().HUD.toso_nandu:Hide()
		GetPlayer().HUD.toso_buff:Hide()
	else
	GetPlayer():AddTag("yiyucharacter")
		GetPlayer().HUD.toso_nandu:Show()
		GetPlayer().HUD.toso_buff:Show()
	end
	end
	end)

	self.vistbutton = self.proot:AddChild(ImageButton())
	self.vistbutton:SetText("贴吧留言")
    self.vistbutton:SetPosition(65, -95, 0)
    self.vistbutton:SetScale(0.4)
    self.vistbutton:SetOnClick( function() VisitURL("https://tieba.baidu.com/p/5216202271?pn=1") end)

	self.vistbutton = self.proot:AddChild(ImageButton())
	self.vistbutton:SetText("角色信息")
    self.vistbutton:SetPosition(65, -135, 0)
    self.vistbutton:SetScale(0.4)
    self.vistbutton:SetOnClick( function() VisitURL("http://steamcommunity.com/sharedfiles/filedetails/?id=642704851") end)

	self.vistbutton = self.proot:AddChild(ImageButton())
	self.vistbutton:SetText("MOD定做")
    self.vistbutton:SetPosition(155, -95, 0)
    self.vistbutton:SetScale(0.4)
    self.vistbutton:SetOnClick( function() self:Close() player.components.talker:Say("人懒,再说吧.") end)
]]
    self.menu = self.proot:AddChild(Menu(nil, 200, true))
    self.menu:SetPosition(300, -135 ,0)
    self.menu:SetScale(0.4)
    self.menu:AddItem("返回", function() self:Close() end)
end)

function TosoScreen2:CreateSpinnerGroup( text, text2 , text3 ,button,fn)
    local label_width = 290
    local group = Widget("SpinnerGroup")
    local label = group:AddChild( Text( textfont, fontsize2, text ) )
    label:SetPosition( 0, 0, 0 )
    label:SetRegionSize( label_width, fontsize2 )
    label:SetHAlign( ANCHOR_LEFT )
    label:SetColour(0,0.75,1,1)
	
    local label2 = group:AddChild( Text( textfont, fontsize2, text2 ) )
    label2:SetPosition( 0, 0, 0 )
    label2:SetRegionSize( label_width, fontsize2 )
    label2:SetHAlign( ANCHOR_MIDDLE )
    label2:SetColour(0,0.75,1,1)

    if button then
        local label3 = group:AddChild(Menu(nil, 200, true))
        label3:SetPosition( 100, 0, 0 )
        label3:SetScale(0.6)
        label3:SetHRegPoint(ANCHOR_RIGHT)
        label3:AddItem(text3, function()
            if fn then
                fn()

            end
         end)
    end

    return group
end

function TosoScreen2:Close()
    self.active = false
    SetPause(false)
    TheFrontEnd:PopScreen()
end 

function TosoScreen2:OnControl(control, down)
    if TosoScreen2._base.OnControl(self, control, down) then return true end
    if not down and  control == CONTROL_CANCEL then
        self:Close()
        return true
    end
    return false
end


return TosoScreen2