require("stategraphs/commonstates")

local function SpawnFireFx(inst, target)
    if not inst or not target then return end
    local numFX = math.random(9, 12)
    local pos = inst:GetPosition()
    local targetPos = target:GetPosition()
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = inst:GetAngleToPoint(targetPos:Get())

    for i = 1, math.ceil(numFX * 1) do
        inst:DoTaskInTime(0, function(inst)
            --local prefab = "icespike_fx_"..math.random(1,4)
			local prefab = "zg_fx_willowfire"
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = GetRandomWithVariance(0, 3)
                local z = GetRandomWithVariance(0, 3)
                local offset = (vec * math.random(dist * 0.25, dist)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
				if fx.components.burnable then
					fx.components.burnable:SetBurnTime(9 * 1)
				end
				fx._output = .75  * 1
            end
        end)
    end
end


local actionhandlers =
{    
    ActionHandler(ACTIONS.CHOP, 
        function(inst)
            if not inst.sg:HasStateTag("prechop") then 
                if inst.sg:HasStateTag("chopping") then
                    return "chop"
                else
                    return "chop_start"
                end
            end 
        end),
    ActionHandler(ACTIONS.MINE, 
        function(inst) 
            if not inst.sg:HasStateTag("premine") then 
                if inst.sg:HasStateTag("mining") then
                    return "mine"
                else
                    return "mine_start"
                end
            end 
        end),
}

local events = 
{
    CommonHandlers.OnLocomote(true, false),
   -- CommonHandlers.OnAttacked(),
    CommonHandlers.OnDeath(),
    CommonHandlers.OnAttack(),
	--穿心机制
    EventHandler("attacked", function(inst)
        inst.SoundEmitter:PlaySound("dontstarve_DLC003/movement/iron_armor/hit")	
        if not inst.components.health:IsDead() and not inst:HasTag("pound") then
		local player = GetPlayer()
		if math.random() < 0.05 and player.level > 50 then
		inst.components.talker:Say("啊啊，打中要害啦")
        inst.sg:GoToState("hit")
		end

            --inst.sg:GoToState("hit")
      --  elseif not inst.components.health:IsDead() and inst.hide then
        end
    end),
		EventHandler("ontalk", function(inst, data)
        if inst.sg:HasStateTag("idle") then
            if inst.prefab == "wes" then
				inst.sg:GoToState("mime")
            else
				inst.sg:GoToState("talk", data.noanim)
			end
        end
        end),
		
	EventHandler("zhumei_sanqian", function(inst, data)
		if not inst.components.health:IsDead() and not inst.sg:HasStateTag("skill") then
			local target=data.target or inst.components.combat.target
			if target then
				inst.sg:GoToState("sanqian",target)
			end
		end
	end),
		
        EventHandler("doattack", function(inst, data) 
        if not inst.components.health:IsDead() then
			if not (inst.canpound or inst.components.timer:TimerExists("pound")) then
				inst.components.timer:StartTimer("pound", 5)
			end
            if not (inst.canreblood or inst.components.timer:TimerExists("reblood")) then
				inst.components.timer:StartTimer("reblood", 20)
			end
            if not (inst.canchuo or inst.components.timer:TimerExists("chuo")) then
				inst.components.timer:StartTimer("chuo", 15)
			end			
            if not (inst.canshaokaotan or inst.components.timer:TimerExists("shaokaotan")) then
				inst.components.timer:StartTimer("shaokaotan", 18)
			end	
			if inst.canpound then
				inst.sg:GoToState("pound")
		    elseif inst.canchuo then
				inst.sg:GoToState("chuo")	
		    elseif inst.canshaokaotan then
				inst.sg:GoToState("shaokaotan")	
		    elseif inst.canreblood and inst.components.health:GetPercent() <= 0.2 then
				inst.sg:GoToState("reblood")
			else
				inst.sg:GoToState("attack")
			end
        end
        end),
	
}

local states =
{
	State{
		name = "shaokaotan",
		tags = {"busy", "pound"},

		onenter = function(inst)
			inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			inst.components.talker:Say("看来只有用烧烤摊了")
			inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("idle_shiver_loop", false)
			
			
		end,
		
		timeline = 
		{
			--跳起结束
			TimeEvent(36*FRAMES, function(inst)
				inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") 
				if inst.components.combat.target then
					inst._target_pos = inst.components.combat.target
				end
				--SpawnFireFx(inst, inst._target_pos)
				
			end),
			
			--pose结束
			TimeEvent(46*FRAMES, function(inst)
				if inst.components.combat.target then
					inst._target_pos1 = inst.components.combat.target
				end				
				SpawnFireFx(inst, inst._target_pos)
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp_voice")
				
			end),
			TimeEvent(56*FRAMES, function(inst)
				if inst.components.combat.target then
					inst._target_pos2 = inst.components.combat.target
				end				
				SpawnFireFx(inst, inst._target_pos1)
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp_voice")
				
			end),
			TimeEvent(66*FRAMES, function(inst)
			
				SpawnFireFx(inst, inst._target_pos2)	
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp_voice")				

				
			end),
		},

		events=
		{
			EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		},
		
		onexit = function(inst)
		
			--技能结束
			inst.canshaokaotan = false
			if not inst.components.timer:TimerExists("shaokaotan") then
				inst.components.timer:StartTimer("shaokaotan", 18)
			end
		end
	},
--[[
--烧烤摊
	State{
		name = "shaokaotan",
		tags = {"busy", "pound"},

		onenter = function(inst)
			inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			inst.components.talker:Say("看来只有用烧烤摊了")
			inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("idle_shiver_loop", false)
			
			
		end,
		
		timeline = 
		{
			--跳起结束
			TimeEvent(36*FRAMES, function(inst)
				--inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/ice") 
				if inst.components.combat.target then
					--local x,y,z = inst.components.combat.target.Transform:GetWorldPosition()
				else
					--local x,y,z = inst.Transform:GetWorldPosition()
				end
				--SpawnIceFx(inst, inst._target_pos)
				
			end),
			
			--pose结束
			TimeEvent(46*FRAMES, function(inst)
				if inst.components.combat.target then
			local tauntfx = SpawnPrefab("tauntfire_fx")
			tauntfx.Transform:SetPosition(inst.components.combat.target.Transform:GetWorldPosition())
			tauntfx.Transform:SetRotation(inst.Transform:GetRotation())
				end				

				
			end),
			TimeEvent(56*FRAMES, function(inst)
				if inst.components.combat.target then
			local tauntfx = SpawnPrefab("tauntfire_fx")
			tauntfx.Transform:SetPosition(inst.components.combat.target.Transform:GetWorldPosition())
			tauntfx.Transform:SetRotation(inst.Transform:GetRotation())
				end				

				
			end),
			TimeEvent(66*FRAMES, function(inst)
				if inst.components.combat.target then
			local tauntfx = SpawnPrefab("tauntfire_fx")
			tauntfx.Transform:SetPosition(inst.components.combat.target.Transform:GetWorldPosition())
			tauntfx.Transform:SetRotation(inst.Transform:GetRotation())
				end				
		

				
			end),
		},

		events=
		{
			EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		},
		
		onexit = function(inst)
		
			--技能结束
			inst.canshaokaotan = false
			if not inst.components.timer:TimerExists("shaokaotan") then
				inst.components.timer:StartTimer("shaokaotan", 18)
			end
		end
	},
	
]]




--召唤
	State{
		name = "summon_gongjuren",
        tags = {"busy", "nointerrupt"},
		onenter = function(inst)
            inst.components.locomotor:Stop()
			inst.components.talker:Say("帮我打死他，给你们发工资!")
			
            local pt = Vector3(inst.Transform:GetWorldPosition())

						local pos = pt 
						local perd = SpawnPrefab("arm_krampus")
						perd.Transform:SetPosition(pos:Get())
						perd.components.follower:SetLeader(inst)
						SpawnPrefab("statue_transition_2").Transform:SetPosition(pos:Get())


			
			--inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon01")
			inst.SoundEmitter:PlaySound("dontstarve/creatures/spiderqueen/givebirth_voice")
			--inst.AnimState:PlayAnimation("emote_hands")
			inst.AnimState:PlayAnimation("idle_onemanband1_loop")
        end, 
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
	},
--可以打断的回血技能
	State{
        name = "reblood_pre",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
		    --inst.components.health:SetInvincible(true)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
			inst.components.talker:Say("吃一个秘制小汉堡!")
            inst.AnimState:PlayAnimation("give")
            --inst.last_target_spit_time = nil -- Aggro, no longer care about spit timing
            --inst.last_spit_time = nil -- Aggro, no longer care about spit timing
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("reblood") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/blink") end),
            TimeEvent(6*FRAMES, function(inst)
                --inst.AnimState:SetBuild("dragonfly_fire_build")
                inst.SoundEmitter:KillSound("fireflying")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/firedup", "fireflying")
                ---inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
                --inst.Light:Enable(true)
                --inst.components.propagator:StartSpreading()
                --inst.fire_build = true
            end),
        },
        onexit= function(inst)
            --inst.SoundEmitter:KillSound("eating")    
			--技能结束
			inst.canreblood = false
			if not inst.components.timer:TimerExists("reblood") then
				inst.components.timer:StartTimer("reblood", 20)
			end
        end,
    },

    State{
        name = "reblood",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("eat")
			--inst.SoundEmitter:PlaySound("dontstarve/wilson/eat", "eating") 
			local theplayer = GetPlayer()
			local xxx = theplayer.level*140 + 200
            inst.components.health:DoDelta(xxx)
            SpawnPrefab("zhiliao").Transform:SetPosition(inst.Transform:GetWorldPosition())
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) 
			--inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup") 

			
			end),

        },
    },
--戳戳
	State{
        name = "chuo_pre",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
		    --inst.components.health:SetInvincible(true)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("give")
			inst.components.talker:Say("你要上天啊你？!")
            --inst.last_target_spit_time = nil -- Aggro, no longer care about spit timing
            --inst.last_spit_time = nil -- Aggro, no longer care about spit timing
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("chuo") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/blink") end),
            TimeEvent(6*FRAMES, function(inst)
                --inst.AnimState:SetBuild("dragonfly_fire_build")
                inst.SoundEmitter:KillSound("fireflying")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/firedup", "fireflying")
                ---inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
                --inst.Light:Enable(true)
                --inst.components.propagator:StartSpreading()
                --inst.fire_build = true
            end),
        },
        onexit= function(inst)
            --inst.SoundEmitter:KillSound("eating")    
			--技能结束
			inst.canchuo = false
			if not inst.components.timer:TimerExists("chuo") then
				inst.components.timer:StartTimer("chuo", 15)
			end
        end,
    },

    State{
        name = "chuo",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("jump")
            SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("chuo_post") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) 
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup") 

			
			end),

        },
    },

    State{
        name = "chuo_post",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("run_pre")
			--inst.components.health:SetInvincible(false)
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("chuo_attack") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) 
						local p = GetPlayer()
			inst.Transform:SetPosition(p.Transform:GetWorldPosition())
			SpawnPrefab("collapse_small").Transform:SetPosition(p.Transform:GetWorldPosition())
			inst.components.talker:Say("你这还是太年轻啊？")
			end),
        },
    },
	
    State{
        name = "chuo_attack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst)
          --  inst.equipfn(inst, inst.items["SWORD"])        

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.Physics:Stop()
			inst.components.talker:Say("煤老板之戳!")
            inst.AnimState:PlayAnimation("give")
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
            
            if inst.components.combat.target then
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
				    inst.components.combat.target.sg:GoToState("electrocute")
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end
            
        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),
            TimeEvent(12*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("busy")
            end),               
            TimeEvent(13*FRAMES, function(inst)
                if not inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),
            TimeEvent(24*FRAMES, function(inst)
                if inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),           
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("attack")
            end ),
        },
    },  
	--转转
	State{
		name = "pound",
		tags = {"busy", "pound"},

		onenter = function(inst)
			inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			
			--inst.AnimState:PlayAnimation("powerup")
			inst.components.talker:Say("大家好我是踏雪")
			inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("chop_loop", false)
			
			--特效
			--local fx = SpawnPrefab("mossling_spin_fx")
			--fx.entity:SetParent(inst.entity)
			--fx.Transform:SetPosition(0,0.1,0)
			
			inst.sg:SetTimeout(6)
			
		end,
		
		ontimeout = function(inst)
			inst.sg:GoToState("idle")
		end,

		--[[
		events=
		{
			EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		},]]

		timeline=
		{
		
			----手部动作结束
			--TimeEvent(61*FRAMES, function(inst)
			
			--end),
			
			TimeEvent(65*FRAMES, function(inst)
			
				--inst.AnimState:SetPercent("chop_loop", 0.155)	--手伸最长时
			
				--旋风状态实体攻击
				--inst["zg_inh_anti_physics"] = .95
			
				--锁定前进方向
				if inst.components.combat.target then
					inst._target_pos = inst.components.combat.target:GetPosition()
				end
			
				----特效
				--[[
				if inst._spin_fx == nil then
					inst._spin_fx = SpawnPrefab("zg_fx_woodiefx")
					inst._spin_fx.entity:SetParent(inst.entity)
					inst._spin_fx.Transform:SetPosition(0, 0, 0)
					inst._spin_fx.Transform:SetScale(1, .75, 1)
					inst._spin_fx.AnimState:SetMultColour(1, 1, 1, .25)
				end]]
			
				----向前推进的单位向量
				local vec
				if inst._target_pos then
					vec = inst._target_pos - inst:GetPosition()
					vec = vec:Normalize()
				else
					local theta = - inst.Transform:GetRotation()
					vec = Vector3( math.cos(theta), 0, math.sin(theta) )
				end
				
				if vec and inst._spintask == nil then
				
					----开始旋转
					local period = 1/30
					local velocity = inst.components.locomotor.runspeed or 4
					local w = 360 * 8
					inst._spintick = 0
					inst._spintask = inst:DoPeriodicTask( period, function()
					
						----动画
						inst.AnimState:SetPercent("chop_loop", 0.078 + math.random() * 0.078)	--手伸最长时
						
						----持续前进
						local pos = inst:GetPosition()
						inst.Transform:SetPosition( (pos + vec * period * velocity):Get() )
						
						----持续旋转
						local rot = inst.Transform:GetRotation()
						rot = rot + period * w
						while rot > 360 do
							rot = rot - 360
						end
						inst.Transform:SetRotation( rot )
						
						----判定伤害, 转一圈就是一次伤害
						local ticknum = math.ceil( 360/ w / period )
						if ticknum > 0 and inst._spintick % ticknum == 0 then
							
							----范围攻击
							local pt = inst:GetPosition()
							local r = 3
							local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "groundpoundimmune","toso_arm","shadowboss"})
							for k,v in pairs(ents) do
								if v and v.components.health and not v.components.health:IsDead() and v.components.combat then	
									v.components.combat:GetAttacked(inst, TUNING.ARM_RPGDAMAGE)
								end
							end
							
						end
						inst._spintick = inst._spintick + 1
						
					end)
					
				end
				
			end),
			
			----第一次砍伐判定(砍伐共27帧)
			--[[
			TimeEvent(65*FRAMES, function(inst)
			
			end),
			
			TimeEvent(92*FRAMES, function(inst)
			
			end),
				
			TimeEvent(119*FRAMES, function(inst)
			
			end),]]
			
			
		},
		
		onexit = function(inst)
		
			if inst._spin_fx then
				inst._spin_fx:Remove()
				inst._spin_fx = nil
			end
		
			if inst._spintask then
				inst._spintask:Cancel()
				inst._spintask = nil
			end
		
			--
			--inst["zg_inh_anti_physics"] = inst.mem_anti_physics or .5
			
			inst.canpound = false
			if not inst.components.timer:TimerExists("pound") then
				inst.components.timer:StartTimer("pound", 5)
			end
		end,
		
	},

	State{
        name = "sanqian",
        tags = {"busy", "skill", "jumping"},
		
		onenter = function(inst,target)
            inst.components.locomotor:StopMoving()
			inst.AnimState:PlayAnimation("pickaxe_loop")
			inst.sg:SetTimeout(FRAMES*25)
			if inst.components.talker then
				inst.components.talker:Say("今天晚点开播，因为我要去交水电费")
			end
			inst.sg.statemem.target=target
			--面朝目标
			inst:ForceFacePoint( target.Transform:GetWorldPosition() )
			
			inst.moonstep_dist = inst:GetPosition():Dist(target:GetPosition())
        end,
		
		ontimeout=function(inst)
			--wy_spawn(inst,"maxwell_smoke")
			SpawnPrefab("maxwell_smoke").Transform:SetPosition(inst.Transform:GetWorldPosition())
			--fx.SoundEmitter:PlaySound("dontstarve/common/destroy_smoke")
			local x,y,z=inst:GetPosition():Get()
			inst.Transform:SetPosition(x,0,z)
			inst.sg:GoToState("idle")
		end,
		
		timeline = 
		{
			TimeEvent(1 * FRAMES, function(inst)
				--inst.components.locomotor:Clear()
				local vel=(inst.moonstep_dist or 10)*7--0/17.5*7
				--local vel=50
				inst.Physics:SetMotorVelOverride(vel, 0, 0)
				--wy_spawn(inst,"maxwell_smoke")
				SpawnPrefab("maxwell_smoke").Transform:SetPosition(inst.Transform:GetWorldPosition())
				--fx.SoundEmitter:PlaySound("dontstarve/common/destroy_smoke")
			end),
			TimeEvent(10 * FRAMES, function(inst)
				--local vel=(inst.moonstep_dist or 10)*30/17.5*7
				--inst.Physics:SetMotorVel(vel, 0, 0) 
				--wy_spawn(inst,"maxwell_smoke")
				SpawnPrefab("maxwell_smoke").Transform:SetPosition(inst.Transform:GetWorldPosition())
				--inst.SoundEmitter:PlaySound("zg_ch3_mihawk/zg_ch3_mihawk/jq")
			end),
			
			TimeEvent(15 * FRAMES, function(inst)
				----范围攻击
				local pt = inst:GetPosition()
				local r = 3
				local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","groundpoundimmune","toso_arm"})
				for k,v in pairs(ents) do
					if v and v.components.health and not v.components.health:IsDead() and v.components.combat then	
						v.components.combat:GetAttacked(inst, 2*TUNING.ARM_RPGDAMAGE)
					end
				end
			end),
		},
		onexit = function(inst)
			
		end
	},


    State{
        name = "idle",
        tags = {"idle", "canrotate"},
        onenter = function(inst, pushanim)    
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("idle_loop", true)
        end,
    },

 State{
        name = "talk",
        tags = {"idle", "talking"},
        
        onenter = function(inst, noanim)
            inst.components.locomotor:Stop()
            if not noanim then
                inst.AnimState:PlayAnimation("dial_loop", true)
            end
            inst.SoundEmitter:PlaySound("dontstarve/woodie/talk")
			if inst.talksoundoverride then
                inst.SoundEmitter:PlaySound(inst.talksoundoverride, "talk")
            else
				
                inst.SoundEmitter:PlaySound("dontstarve/characters/woodie/talk_LP", "talk")
				
				--inst.SoundEmitter:PlaySound("dontstarve/characters/webber/talk_LP", "talk")
            end 
			--end
            
   
            inst.sg:SetTimeout(1.5 + math.random()*.5)
        end,
        
        ontimeout = function(inst)
            inst.SoundEmitter:KillSound("talk")
            inst.sg:GoToState("idle")
        end,
        
        onexit = function(inst)
            inst.SoundEmitter:KillSound("talk")
        end,
        
        events=
        {
            EventHandler("donetalking", function(inst) inst.sg:GoToState("idle") end),
        },
    }, 
	
    State{
        name = "run_start",
        tags = {"moving", "running", "canrotate"},
        
        onenter = function(inst)
			inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_pre")
            inst.sg.mem.foosteps = 0
        end,

        onupdate = function(inst)
            inst.components.locomotor:RunForward()
        end,

        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
        
        timeline=
        {        
            TimeEvent(4*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_step")
            end),
        },        
        
    },

	  
    State{
    
        name = "run_stop",
        tags = {"canrotate", "idle"},
        
        onenter = function(inst) 
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("run_pst")
        end,
        
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),        
        },
        
    },

	 State{
        name = "run",
        tags = {"moving", "running", "canrotate"},
        
        onenter = function(inst) 
            inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_loop")
            
        end,
        
        onupdate = function(inst)
            inst.components.locomotor:RunForward()
        end,

        timeline=
        {
            TimeEvent(7*FRAMES, function(inst)
				inst.sg.mem.foosteps = inst.sg.mem.foosteps + 1
                inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_step")
            end),
            TimeEvent(15*FRAMES, function(inst)
				inst.sg.mem.foosteps = inst.sg.mem.foosteps + 1
                inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_step")
            end),
        },
        
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
    },
    

    State{
        name = "attack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst)
          --  inst.equipfn(inst, inst.items["SWORD"])        

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("atk")
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
            
            if inst.components.combat.target then
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end
            
        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),
            TimeEvent(12*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("busy")
            end),               
            TimeEvent(13*FRAMES, function(inst)
                if not inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),
            TimeEvent(24*FRAMES, function(inst)
                if inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),           
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    },  

    State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:Hide("swap_arm_carry")
            inst.AnimState:PlayAnimation("death")
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst:DoTaskInTime(1, function() 
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
                    inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_despawn")
                    inst:Remove()
                end)
            end ),
        },
    },  
   
    State{
        name = "hit",
        tags = {"busy"},
        
        onenter = function(inst)
            inst:ClearBufferedAction()
            inst.AnimState:PlayAnimation("hit")
            inst.Physics:Stop()            
		 --inst.SoundEmitter:PlaySound("dontstarve/characters/woodie","/hit")   
		 --inst.SoundEmitter:PlaySound("dontstarve/characters/woodie","/hurt")   
		end,
   
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        }, 
        
        timeline =
        {
            TimeEvent(3*FRAMES, function(inst)
                inst.sg:RemoveStateTag("busy")
            end),
        },               
    },

    State{
        name = "stunned",
        tags = {"busy", "canrotate"},

        onenter = function(inst)
            inst:ClearBufferedAction()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("idle_sanity_pre")
            inst.AnimState:PushAnimation("idle_sanity_loop", true)
            inst.sg:SetTimeout(5)
        end,

        ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end,
    },

        State{ name = "chop_start",
        tags = {"prechop", "chopping", "working"},
        onenter = function(inst)
            inst.equipfn(inst, inst.items["AXE"])
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("chop_pre")

        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("chop") end),
        },
    },
    
    State{
        name = "chop",
        tags = {"prechop", "chopping", "working"},
        onenter = function(inst)
            inst.AnimState:PlayAnimation("chop_loop")        
        end,

        timeline=
        {
            TimeEvent(5*FRAMES, function(inst) 
                    inst:PerformBufferedAction() 
            end),

            TimeEvent(9*FRAMES, function(inst)
                    inst.sg:RemoveStateTag("prechop")
            end),

            TimeEvent(16*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("chopping")
            end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) 
                inst.sg:GoToState("idle")
            end ),            
        },        
    },

    State{ 
        name = "mine_start",
        tags = {"premine", "working"},
        onenter = function(inst)
            inst.equipfn(inst, inst.items["PICK"])
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("pickaxe_pre")
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("mine") end),
        },
    },
    
    State{
        name = "mine",
        tags = {"premine", "mining", "working"},
        onenter = function(inst)
            inst.AnimState:PlayAnimation("pickaxe_loop")
        end,

        timeline=
        {
            TimeEvent(9*FRAMES, function(inst) 
                inst:PerformBufferedAction() 
                inst.sg:RemoveStateTag("premine") 
                inst.SoundEmitter:PlaySound("dontstarve/wilson/use_pick_rock")
            end),
            
            -- TimeEvent(14*FRAMES, function(inst)
            --     if  inst.sg.statemem.action and 
            --         inst.sg.statemem.action.target and 
            --         inst.sg.statemem.action.target:IsActionValid(inst.sg.statemem.action.action) and 
            --         inst.sg.statemem.action.target.components.workable then
            --             inst:ClearBufferedAction()
            --             inst:PushBufferedAction(inst.sg.statemem.action)
            --     end
            -- end),            
        },
        
        events=
        {
            EventHandler("animover", function(inst) 
                inst.AnimState:PlayAnimation("pickaxe_pst") 
                inst.sg:GoToState("idle", true)
            end ),            
        },        
    },
--增加的state	
    State{
        name = "leap_attack",
        tags = {"attack", "canrotate", "busy", "jumping"},
        
        onenter = function(inst, target)
            inst.components.locomotor:Stop()
            inst.components.locomotor:EnableGroundSpeedMultiplier(false)

            inst.components.combat:StartAttack()
            inst.AnimState:PlayAnimation("pickaxe_loop")
            inst.sg.statemem.target = target
        end,

        onexit = function(inst)
            inst.components.locomotor:Stop()
            inst.components.locomotor:EnableGroundSpeedMultiplier(true)
        end,
        
        timeline =
        {
            --TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound(SoundPath(inst, "attack_grunt")) end),
            --TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound(SoundPath(inst, "Jump")) end),
            TimeEvent(8*FRAMES, function(inst) inst.Physics:SetMotorVelOverride(20,0,0) end),
            --TimeEvent(9*FRAMES, function(inst) inst.SoundEmitter:PlaySound(SoundPath(inst, "Attack")) end),
            TimeEvent(19*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) end),
            TimeEvent(20*FRAMES,
				function(inst)
                    inst.Physics:ClearMotorVelOverride()
					inst.components.locomotor:Stop()
				end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
	
}

return StateGraph("SGarm_zhumei", states, events, "idle", actionhandlers)