require("stategraphs/commonstates")

--跳跃定义数值
local JUMP_SPEED = 75
local JUMP_LAND_OFFSET = 3

local function SpawnIceFx(inst, postarget)
    if not inst or not postarget then return end
    local numFX = 6
    local pos = inst:GetPosition()
    local targetPos = postarget
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = inst:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        inst:DoTaskInTime(math.random() * 0.25, function(inst)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = GetRandomWithVariance(0, .5)
                local z = GetRandomWithVariance(0, .5)
                local offset = (vec * math.random(dist * 0.75, dist * 1.25)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
				fx.Transform:SetScale(1,2,1)
				
				----冰柱伤害
				local pt = fx:GetPosition()
				local r = 1.33
				local center_dmg = 2*TUNING.ARM_RPGDAMAGE 
				local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "groundpoundimmune","toso_arm","shadowboss"})
				for k,v in pairs(ents) do
					if v and v.components.health and not v.components.health:IsDead() and v ~= inst and v.prefab ~= inst.prefab then
						
						--local dst = pt:Dist(v:GetPosition())
						--local dmg_mult = 1 - dst/r
						local dmg_mult = 1
						
						if v.components.combat and not v:HasTag("toso_arm") then
							v.components.combat:GetAttacked(inst, center_dmg)
						end
					end
				end				
				
            end
        end)
    end
end

local actionhandlers =
{    
    ActionHandler(ACTIONS.CHOP, 
        function(inst)
            if not inst.sg:HasStateTag("prechop") then 
                if inst.sg:HasStateTag("chopping") then
                    return "chop"
                else
                    return "chop_start"
                end
            end 
        end),
    ActionHandler(ACTIONS.MINE, 
        function(inst) 
            if not inst.sg:HasStateTag("premine") then 
                if inst.sg:HasStateTag("mining") then
                    return "mine"
                else
                    return "mine_start"
                end
            end 
        end),
}

local events = 
{
    CommonHandlers.OnLocomote(true, false),
   -- CommonHandlers.OnAttacked(),
    CommonHandlers.OnDeath(),
    CommonHandlers.OnAttack(),
	--穿心机制
    EventHandler("attacked", function(inst)
        inst.SoundEmitter:PlaySound("dontstarve_DLC003/movement/iron_armor/hit")	
        if not inst.components.health:IsDead() and not inst:HasTag("pound") then
		local player = GetPlayer()
		--if math.random() < player.kangshi*0.1 then
		--inst.components.talker:Say("此招甚妙")
        --inst.sg:GoToState("hit")
		--end

            --inst.sg:GoToState("hit")
      --  elseif not inst.components.health:IsDead() and inst.hide then
        end
    end),
	
	EventHandler("sha_sanqian", function(inst, data)
		if not inst.components.health:IsDead() and not inst.sg:HasStateTag("pound") then
			local target=data.target or inst.components.combat.target
			--if target then
				--inst.sg:GoToState("sanqian",target)  --
				inst.sg:GoToState("taunt_pre")
			--end
		end
	end),
	
		EventHandler("ontalk", function(inst, data)
        if inst.sg:HasStateTag("idle") then
            if inst.prefab == "wes" then
				inst.sg:GoToState("mime")
            else
				inst.sg:GoToState("talk", data.noanim)
			end
        end
        end),
--[[		
        EventHandler("doattack", function(inst, data) 
        if not inst.components.health:IsDead() and not inst.sg:HasStateTag("busy") and data and data.target  then 
            if inst:GetDistanceSqToInst(data.target) > 3 then
                --Do leap attack
                inst.sg:GoToState("leap_attack", data.target) 
            else
                inst.sg:GoToState("attack", data.target) 
            end
        end 
        end),
]]		
        EventHandler("doattack", function(inst, data) 
        if not inst.components.health:IsDead() then
            if not (inst.canpound or inst.components.timer:TimerExists("pound")) then
				inst.components.timer:StartTimer("pound", 8)
			end
            if not (inst.canshaquickeat or inst.components.timer:TimerExists("shaquickeat")) then
				inst.components.timer:StartTimer("shaquickeat", 11)
			end
            if not (inst.canfengzhinu or inst.components.timer:TimerExists("fengzhinu")) then
				inst.components.timer:StartTimer("fengzhinu", 16)
			end
            if not (inst.canfengzhiren or inst.components.timer:TimerExists("fengzhiren")) then
				inst.components.timer:StartTimer("fengzhiren", 21)
			end
--[[
--防止被群殴				
	local x,y,z = inst.Transform:GetWorldPosition()	
	local max_rad = 30
	local ents = TheSim:FindEntities(x,y,z, max_rad, {"toso_helpers"})
    for k,v in pairs(ents) do 
		if v then 
		
        inst.sg:GoToState("attack2", data.target)
	
		end 
	end				
]]





		local player = GetPlayer()

			
		    if inst.canfengzhinu then
			if math.random() < 0.5 then
			inst.SoundEmitter:PlaySound("ds_sha_skill/sfx/ha_sha")
				inst.sg:GoToState("fengzhinu")	--
			else
			inst.SoundEmitter:PlaySound("ds_sha_skill/sfx/ha_sha")
				inst.sg:GoToState("sha_bingdong")
            end			
		    elseif inst.canfengzhiren then
			inst.SoundEmitter:PlaySound("ds_sha_skill/sfx/ha_sha")
				inst.sg:GoToState("fengzhiren")	

		    elseif inst.canshaquickeat and inst.components.health:GetPercent() <= 0.5 then
				inst.sg:GoToState("shaquickeat")	
				
			elseif inst.canpound then	
			inst.SoundEmitter:PlaySound("ds_sha_skill/sfx/ha_sha")
				inst.sg:GoToState("sha_pound")			

				
			else
			--if math.random() < 0.5 then
			    inst.SoundEmitter:PlaySound("ds_sha_skill/sfx/leap_sha")
				inst.sg:GoToState("leap_attack", data.target)
			--else
			    --if not player:HasTag("ssjump") then            --v:HasTag("ssjump")防止飞天带走boss
				--inst.sg:GoToState("taunt_pre")
				--end
            --end	

			end
        end
        end),	
	
}

local states =
{   
--火女技能变态版
	State{
        name = "taunt_pre",
        tags = {"busy","specialatk"},
        
        onenter = function(inst)
		    --inst.components.health:SetInvincible(true)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("jump")
            --inst.last_target_spit_time = nil -- Aggro, no longer care about spit timing
            --inst.last_spit_time = nil -- Aggro, no longer care about spit timing
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("taunt") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/blink") end),
            TimeEvent(6*FRAMES, function(inst)
                --inst.AnimState:SetBuild("dragonfly_fire_build")
                inst.SoundEmitter:KillSound("fireflying")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/firedup", "fireflying")
                ---inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
                --inst.Light:Enable(true)
                --inst.components.propagator:StartSpreading()
                --inst.fire_build = true
            end),
        },
    },

    State{
        name = "taunt",
        tags = {"busy","specialatk"},
        
        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
			inst.components.talker:Say("白嫖之人必接受制裁")
            inst.AnimState:PlayAnimation("give")
            local tauntfx = SpawnPrefab("tauntfire_fx")
            tauntfx.Transform:SetPosition(inst.Transform:GetWorldPosition())
            tauntfx.Transform:SetRotation(inst.Transform:GetRotation())
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("taunt_post") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) 
                inst.components.groundpounder:GroundPound()
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp_voice")
                -- local fire = SpawnPrefab("firesplash_fx")
                -- fire.Transform:SetPosition(inst.Transform:GetWorldPosition())
            end),
            TimeEvent(9*FRAMES, function(inst) 
                inst.components.groundpounder:GroundPound()
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp_voice")
                -- local fire = SpawnPrefab("firesplash_fx")
                -- fire.Transform:SetPosition(inst.Transform:GetWorldPosition())
            end),
            TimeEvent(20*FRAMES, function(inst) 
                inst.components.groundpounder:GroundPound()
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/buttstomp_voice")
                -- local fire = SpawnPrefab("firesplash_fx")
                -- fire.Transform:SetPosition(inst.Transform:GetWorldPosition())
            end),
        },
    },

    State{
        name = "taunt_post",
        tags = {"busy","specialatk"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("run_pre")
			--inst.components.health:SetInvincible(false)
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },

        timeline=
        {
            TimeEvent(1*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/blink") end),
        },
		
		onexit = function(inst)

				
			--技能结束
			--inst.canpound = false
			--if not inst.components.timer:TimerExists("pound") then
				--inst.components.timer:StartTimer("pound", 5)
			--end

		end,
    },

--未能击杀，走人

--跳跃开始
    -- jump > fallwarn > fall > fallpost

    State{
        name = "jump",
        tags = {"busy", "pound"},

        onenter = function(inst)
            inst.Physics:Stop()
--[[
--开启	
local fx = SpawnPrefab("forcefieldfx")
fx.entity:SetParent(inst.entity)
fx.Transform:SetScale(0.7, 0.7, 0.7)
fx.Transform:SetPosition(0, 0.2, 0)			
fx.AnimState:PlayAnimation("hit")
fx.AnimState:PushAnimation("idle_loop")

--关闭
fx.kill_fx(fx)
]]
            inst.AnimState:PlayAnimation("give")
			inst.components.health:SetInvincible(true)
            inst.AnimState:PushAnimation("jump", true)
			inst:ClearBufferedAction()
        end,

        timeline =
        {
            -- TimeEvent(0*FRAMES, function(inst)
            --     inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
            -- end),

            TimeEvent(23*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/jump_attack")
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/roar")
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/launch_land")
	            inst.components.locomotor.disable = true
	            inst.Physics:SetMotorVelOverride(0,JUMP_SPEED,0)
    		end),

            TimeEvent(38*FRAMES, function(inst)
                --local tar = inst:GetTarget()

                --if tar and not inst:GroundTypesMatch(tar) then
                    --inst:MakeWater() --GoToWaterState
                --end

                --inst.sg:GoToState("fallwarn")
				inst.sg:GoToState("idle")
				inst:Remove()
            end),
        },
    },

    State{
        name = "fallwarn",
        tags = {"busy", "pound"},

        onenter = function(inst)
            inst.sg:SetTimeout(34*FRAMES)

            inst.Physics:Stop()
			
            local theplayer = GetPlayer()
            --local tar = inst:GetTarget()
            local pos = theplayer:GetPosition()


            pos.y = 45
            inst.Transform:SetPosition(pos:Get())

            local shadow = SpawnPrefab("tigersharkshadow")
            shadow:Ground_Fall()
            local heading = TheCamera:GetHeading()
            local rotation = 180 - heading

            if inst.AnimState:GetCurrentFacing() == FACING_LEFT then
                rotation = rotation + 180
            end

            if rotation < 0 then
                rotation = rotation + 360
            end

            shadow.Transform:SetRotation(rotation)
            local x,y,z = inst:GetPosition():Get()
            shadow.Transform:SetPosition(x,0,z)
        end,

        ontimeout = function(inst)
            inst:Show()

            if inst:GetIsOnWater() then
                --inst:MakeWater()
                local pos = inst:GetPosition()
                pos.y = 45
                inst.Transform:SetPosition(pos:Get())
            end

            inst.sg:GoToState("fall")
        end,
    },

    State{
        name = "fall",
        tags = {"busy", "pound"},

        onenter = function(inst)
            ChangeToCharacterPhysics(inst)
	        inst.components.locomotor.disable = true
            inst.Physics:SetMotorVel(0,-JUMP_SPEED,0)
            inst.AnimState:PlayAnimation("pickaxe_loop", true)
            inst.Physics:SetCollides(false)
            inst.sg:SetTimeout(JUMP_SPEED/45 + 0.2)
            inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/dive_attack")
        end,

        timeline =
        {
            TimeEvent(20*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/roar") end)
        },

        ontimeout = function(inst)
            local pt = Point(inst.Transform:GetWorldPosition())
            local vx, vy, vz = inst.Physics:GetMotorVel()
            if pt.y <= .1 then
                pt.y = 0
                inst.Physics:Stop()
                inst.Physics:Teleport(pt.x,pt.y,pt.z)
                inst.CanFly = false
                inst.Physics:SetCollides(true)
                inst.sg:GoToState("fallpost")
            end
        end,

        onupdate = function(inst)
            inst.Physics:SetMotorVel(0,-JUMP_SPEED,0)
            local pt = Point(inst.Transform:GetWorldPosition())
            if pt.y <= .1 then
                pt.y = 0
                inst.Physics:Stop()
                inst.Physics:Teleport(pt.x,pt.y,pt.z)
                inst.CanFly = false
                inst.Physics:SetCollides(true)
                inst.sg:GoToState("fallpost")
            end
        end,
    },

    State{
        name = "fallpost",
        tags = {"busy", "pound"},

        onenter = function(inst)
            inst.Physics:Stop()
            inst.components.locomotor.disable = false
            inst.AnimState:PlayAnimation("chop_loop")
            inst.components.groundpounder:GroundPound()
            inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
        end,

        onexit = function(inst)

            inst:Show()
        end,

        events=
        {
            EventHandler("animover", function(inst) 
			inst.sg:GoToState("idle") 
			            inst.components.health:SetInvincible(false)
			end),
        },
    },
--跳跃结束


--血量低时触发群体技能
    State{
        name = "attack2",
        tags = {"attack", "notalking", "abouttoattack", "busy","pound"},
        
        onenter = function(inst)
          --  inst.equipfn(inst, inst.items["SWORD"])        
                inst.components.talker:Say("年轻人不讲武德")
                --inst.AnimState:PlayAnimation("give")
            inst.AnimState:PlayAnimation("book")
            inst.AnimState:OverrideSymbol("book_open", "book_uniqueitem_swap", "book_open")
            inst.AnimState:OverrideSymbol("book_closed", "book_uniqueitem_swap", "book_closed")
            inst.AnimState:OverrideSymbol("book_open_pages", "book_uniqueitem_swap", "book_open_pages")
			

			
            inst.AnimState:Show("ARM_normal")
            if inst.components.inventory.activeitem and inst.components.inventory.activeitem.components.instrument then
                inst.components.inventory:ReturnActiveItem()
            end				
			inst.SoundEmitter:PlaySound("dontstarve/common/use_book")
    	inst:DoTaskInTime(2, function()
            if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
                inst.AnimState:Show("ARM_carry") 
                inst.AnimState:Hide("ARM_normal")
            end
                inst.sg:GoToState("light")

	    end) 



            
            if inst.components.combat.target then
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end
			

        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),
            TimeEvent(12*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("busy")
            end),               
            TimeEvent(13*FRAMES, function(inst)
                if not inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),
            TimeEvent(24*FRAMES, function(inst)
                if inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),           
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    },  


    State{
        name = "light",
        tags = {"doing", "playing","pound"},
        
        onenter = function(inst)
            inst.components.locomotor:Stop()

			
        local boomice = SpawnPrefab("ice")
        local pt1 = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,3,0)
        boomice.Transform:SetPosition(pt1:Get())
		
            local pt = inst:GetPosition()
            local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 10)
                for k,v in pairs(ents) do
                    if v.components.combat and v ~= inst and not v:HasTag("toso_arm") and not v:HasTag("monster") and not v:HasTag("spat") then--spat
						            	local son = SpawnPrefab("jianyu")
	  	                                son.Transform:SetPosition(v:GetPosition():Get())
                  --inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")				  
                        local damage = TUNING.ARM_RPGDAMAGE/25
                       --v.components.combat:GetAttacked(inst, damage)
					   if v:HasTag("player") then
					   v.components.health:DoDelta(-damage)	
                       v.components.combat:GetAttacked(inst, damage)					   
					   else
					   if v.components.combat and v.components.health and not v.components.health:IsDead() and not (v.components.inventoryitem and v.components.inventoryitem.owner) then 
					   v.components.health:DoDelta(-9*TUNING.ARM_RPGDAMAGE)
					   end
					   end
					   if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.missatk and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		               if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
                    end
                end 

			
            --inst.AnimState:Hide("ARM_carry") 

        end,
        
        onexit = function(inst)

			
							--技能结束
			inst.canpound = false
			if not inst.components.timer:TimerExists("pound") then
				inst.components.timer:StartTimer("pound", 10)
			end
        end,
        
        timeline=
        {
            TimeEvent(21*FRAMES, function(inst)
                --inst.SoundEmitter:PlaySound("dontstarve/common/horn_beefalo")
                inst:PerformBufferedAction()
            end),
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    },
--
--增加的暗杀船长技能
	State{
        name = "c_taunt_pre",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
		    --inst.components.health:SetInvincible(true)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("give")
            --inst.last_target_spit_time = nil -- Aggro, no longer care about spit timing
            --inst.last_spit_time = nil -- Aggro, no longer care about spit timing
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("c_taunt") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/blink") end),
            TimeEvent(6*FRAMES, function(inst)
                --inst.AnimState:SetBuild("dragonfly_fire_build")
                inst.SoundEmitter:KillSound("fireflying")
                inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/dragonfly/firedup", "fireflying")
                ---inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
                --inst.Light:Enable(true)
                --inst.components.propagator:StartSpreading()
                --inst.fire_build = true
            end),
        },
    },

    State{
        name = "c_taunt",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("jump")
            SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("c_taunt_post") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) 
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup") 

			
			end),

        },
    },

    State{
        name = "c_taunt_post",
        tags = {"busy", "pound"},
        
        onenter = function(inst)
            inst.AnimState:PlayAnimation("run_pre")
			--inst.components.health:SetInvincible(false)
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("attack") end),
        },

        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) 
						local p = GetPlayer()
			inst.Transform:SetPosition(p.Transform:GetWorldPosition())
			SpawnPrefab("collapse_small").Transform:SetPosition(p.Transform:GetWorldPosition())
			inst.components.talker:Say("要一览美景吗？")
			end),
        },
    },
--突击一铲子
	State{
		name = "sha_pound",
		tags = {"busy", "pound"},

		onenter = function(inst)
			inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			inst.components.talker:Say("凡人就应当有自知")
			inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("shovel_loop")
			inst.AnimState:PushAnimation("chop_loop")
			inst.AnimState:PushAnimation("idle", false)
			
			----现在瞄准目标位置
			local target = inst.components.combat and inst.components.combat.target
			if target then
				inst._target_pos = target:GetPosition()
				--inst._current_pos = inst:GetPosition()
				--inst._pos = inst._current_pos + (inst._target_pos - inst._current_pos) * 5
				
				--inst.Transform:SetRotation( inst:GetAngleToPoint( inst._pos:Get() ) )
			end
			
			--if inst._fx ~= nil then
			--	inst._fx:kill_fx()
			--end
			--inst._fx = SpawnPrefab("forcefieldfx")
			--if inst._fx then
			--	inst._fx.entity:SetParent(inst.entity)
			--	inst._fx.Transform:SetPosition(0, 0.2, 0)
			--end
			--inst["zg_inh_anti_physics"] = 1
			
		end,

		events=
		{
			EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		},

		timeline=
		{
			TimeEvent(36*FRAMES, function(inst)
			
				local fx = SpawnPrefab("maxwell_smoke")
				fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			
				--开始突击
				--inst.Transform:SetRotation( inst:GetAngleToPoint( inst._pos:Get() ) )
				--inst.Physics:SetMotorVelOverride(120,0,0)
				--inst.Physics:SetMotorVel(160,0,0)
				
				----向前推进的单位向量
				local vec
				if inst._target_pos then
					vec = inst._target_pos - inst:GetPosition()
					vec = vec:Normalize()
				else
					local theta = - inst.Transform:GetRotation()
					vec = Vector3( math.cos(theta), 0, math.sin(theta) )
				end
				
				if vec and inst.collide_task == nil then
				
					local period = 1/10
					local velocity = (inst.components.locomotor.runspeed or 4) --* 2
					inst.collide_task_table = {}
					inst.collide_task = inst:DoPeriodicTask( period, function()
					
						----持续前进
						local pos = inst:GetPosition()
						inst.Transform:SetPosition( (pos + vec * period * velocity):Get() )
					
						local r = 2.5
						local pt = inst:GetPosition()
						local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "groundpoundimmune","toso_arm","shadowboss"})
						for k, v in pairs(ents) do 
							if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
								
								--	突击+200%物理伤害
								if not table.contains(inst.collide_task_table, v.GUID) then
									v.components.combat:GetAttacked(inst, 4*TUNING.ARM_RPGDAMAGE)
									table.insert(inst.collide_task_table, v.GUID)
								
									--击退
									--if v.Physics and v.Transform and v.components.locomotor then
									
										--if v.components.playercontroller ~= nil then
										--	v.components.playercontroller:Enable(false)
										--end
									
										--v.Physics:ClearMotorVelOverride()
										--v.components.locomotor:Stop()
										--v.Transform:SetRotation( v:GetAngleToPoint( pt:Get() ) )
										
										--v.Transform:SetRotation( -inst.Transform:GetRotation() )
										--v.Physics:SetMotorVelOverride(-40,0,0)
										
										--v:DoTaskInTime(.5, function()
										--	if v.Physics and v.Transform and v.components.locomotor and v.components.combat then
												--v.Physics:ClearMotorVelOverride()
												--v.components.locomotor:Stop()
												--v.components.combat:Zg_GetAttacked(inst, .01)
												
												--if v.components.playercontroller ~= nil then
												--	v.components.playercontroller:Enable(true)
												--end
												
												--v:DoTaskInTime(.5, function()
												--	if v and v:HasTag("player") and not ( v.components.health and v.components.health:IsDead() ) then									
												--		v:PushEvent("zg_buff_knockout")									
												--	end
												--end)
												
											--end
										--end)
									--end
									
								end
								
							end
						end
					end)
				end
				
			end),
			TimeEvent(54*FRAMES, function(inst)
				--inst.Physics:SetMotorVelOverride(120,0,0)
				local fx = SpawnPrefab("maxwell_smoke")
				fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			end),
			TimeEvent(72*FRAMES, function(inst)
				--inst.Physics:SetMotorVelOverride(120,0,0)
				local fx = SpawnPrefab("maxwell_smoke")
				fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			end),
			
		},
		
		onexit = function(inst)
			local fx = SpawnPrefab("maxwell_smoke")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			
			--if inst._fx then
			--	inst._fx:kill_fx()
			--	inst._fx:Remove()
			--	inst._fx = nil
			--end
			
			--inst["zg_inh_anti_physics"] = inst.mem_anti_physics or .5
				
			--技能结束
			inst.canpound = false
			if not inst.components.timer:TimerExists("pound") then
				inst.components.timer:StartTimer("pound", 8)
			end
			--inst.Physics:ClearMotorVelOverride()
			--inst.components.locomotor:Stop()
			
			if inst.collide_task ~= nil then
				inst.collide_task:Cancel()
				inst.collide_task = nil
			end
		end,
	},

--冰冻
	State{
		name = "sha_bingdong",
		tags = {"busy", "pound"},

		onenter = function(inst)
			inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			inst.components.talker:Say("我可是饥荒大陆的终极大妖怪！")
			inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("pickaxe_loop", false)
			
			
			
		end,
		
		timeline = 
		{
			--跳起结束
			TimeEvent(36*FRAMES, function(inst)
				inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/ice") 
				if inst.components.combat.target then
					inst._target_pos = inst.components.combat.target:GetPosition()
				end
				--SpawnIceFx(inst, inst._target_pos)
				
			end),
			
			--pose结束
			TimeEvent(46*FRAMES, function(inst)
				if inst.components.combat.target then
					inst._target_pos1 = inst.components.combat.target:GetPosition()
				end				
				SpawnIceFx(inst, inst._target_pos)
				
			end),
			TimeEvent(56*FRAMES, function(inst)
				if inst.components.combat.target then
					inst._target_pos2 = inst.components.combat.target:GetPosition()
				end				
				SpawnIceFx(inst, inst._target_pos1)
				
			end),
			TimeEvent(66*FRAMES, function(inst)
			
				SpawnIceFx(inst, inst._target_pos2)			

				
			end),
		},

		events=
		{
			EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		},
		
		onexit = function(inst)
		
			--技能结束
			inst.canfengzhinu = false
			if not inst.components.timer:TimerExists("fengzhinu") then
				inst.components.timer:StartTimer("fengzhinu", 16)
			end
		end
	},


--召唤狗
	State{
		name = "summon_hound",
        tags = {"busy", "nointerrupt"},
		onenter = function(inst)
            inst.components.locomotor:Stop()
			inst.components.talker:Say("先和我的朋友们打一架吧!")
			
            local pt = Vector3(inst.Transform:GetWorldPosition())
            local player = GetPlayer()
						local pos = pt 
if inst:IsValid() then                    
						
						local perd = SpawnPrefab("arm_hound")
						if math.random()<0.6 and player.level >= 20 then
						perd = SpawnPrefab("arm_qingxue")
						else
						perd = SpawnPrefab("arm_hound")
						end
						
						perd.Transform:SetPosition(pos:Get())
						perd.components.follower:SetLeader(inst)
						SpawnPrefab("statue_transition_2").Transform:SetPosition(pos:Get())
                        


			
			--inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon01")
			inst.SoundEmitter:PlaySound("dontstarve/creatures/spiderqueen/givebirth_voice")
end
			--inst.AnimState:PlayAnimation("emote_hands")
			inst.AnimState:PlayAnimation("idle_onemanband1_loop")
        end, 
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
	},

--大跳斩

	State{
        name = "sanqian",
        tags = {"busy", "pound", "jumping"},
		
		onenter = function(inst,target)
            inst.components.locomotor:StopMoving()
			inst.AnimState:PlayAnimation("pickaxe_loop")
			inst.sg:SetTimeout(FRAMES*25)
			if inst.components.talker then
				inst.components.talker:Say("此时就是你暴毙身亡之时")
			end
			inst.sg.statemem.target=target
			--面朝目标
			inst:ForceFacePoint( target.Transform:GetWorldPosition() )
			
			inst.moonstep_dist = inst:GetPosition():Dist(target:GetPosition())
        end,
		
		ontimeout=function(inst)
			--wy_spawn(inst,"maxwell_smoke")
			SpawnPrefab("maxwell_smoke").Transform:SetPosition(inst.Transform:GetWorldPosition())
			--fx.SoundEmitter:PlaySound("dontstarve/common/destroy_smoke")
			local x,y,z=inst:GetPosition():Get()
			inst.Transform:SetPosition(x,0,z)
			inst.sg:GoToState("idle")
		end,
		
		timeline = 
		{
			TimeEvent(1 * FRAMES, function(inst)
				--inst.components.locomotor:Clear()
				local vel=(inst.moonstep_dist or 10)*7--0/17.5*7
				--local vel=50
				inst.Physics:SetMotorVelOverride(vel, 0, 0)
				--wy_spawn(inst,"maxwell_smoke")
				SpawnPrefab("maxwell_smoke").Transform:SetPosition(inst.Transform:GetWorldPosition())
				--fx.SoundEmitter:PlaySound("dontstarve/common/destroy_smoke")
			end),
			TimeEvent(10 * FRAMES, function(inst)
				--local vel=(inst.moonstep_dist or 10)*30/17.5*7
				--inst.Physics:SetMotorVel(vel, 0, 0) 
				--wy_spawn(inst,"maxwell_smoke")
				SpawnPrefab("maxwell_smoke").Transform:SetPosition(inst.Transform:GetWorldPosition())
				--inst.SoundEmitter:PlaySound("zg_ch3_mihawk/zg_ch3_mihawk/jq")
			end),
			
			TimeEvent(15 * FRAMES, function(inst)
				----范围攻击
				local pt = inst:GetPosition()
				local r = 3
				local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","groundpoundimmune","toso_arm"})
				for k,v in pairs(ents) do
					if v and v.components.health and not v.components.health:IsDead() and v.components.combat then	
						v.components.combat:GetAttacked(inst, TUNING.ARM_RPGDAMAGE)
					end
				end
			end),
		},
		onexit = function(inst)
			
		end
	},
	
	----风之怒
	State{
        name = "fengzhinu",
        tags = {"busy", "pound"},
		
		onenter = function(inst)
            inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			
			inst.AnimState:PlayAnimation("powerup")
			--inst.AnimState:PushAnimation("atk", false)
			
			inst.AnimState:PushAnimation("chop_loop", false)
			
			inst.sg:SetTimeout(6)
			
        end,
		
		ontimeout = function(inst)
			inst.sg:GoToState("idle")
		end,
		
		timeline = 
		{
			--跳起结束
			TimeEvent(36*FRAMES, function(inst)
				--inst.SoundEmitter:PlaySound("zg_ch1_zoro/zg_ch1_zoro/fannao")
				if inst.components.talker then
					inst.components.talker:Say("【这样的实力不配和我战斗】")
				end
			end),
			
			--发动
			TimeEvent(45*FRAMES, function(inst)
			
				--旋风状态实体攻击
				--inst["zg_inh_anti_physics"] = .95
			
				--锁定前进方向
				if inst.components.combat.target then
					inst._target_pos = inst.components.combat.target:GetPosition()
				end
				
				----向前推进的单位向量
				local vec
				if inst._target_pos then
					vec = inst._target_pos - inst:GetPosition()
					vec = vec:Normalize()
				else
					local theta = - inst.Transform:GetRotation()
					vec = Vector3( math.cos(theta), 0, math.sin(theta) )
				end
				
				----比伐木工过之而无不及
				if vec and inst._spintask == nil then
				
					----开始旋转
					local period = 1/30
					local velocity = inst.components.locomotor.runspeed or 4
					local w = 360 * 8
					inst._spintick = 0
					inst._spintask = inst:DoPeriodicTask( period, function()
					
						----动画
						inst.AnimState:SetPercent("chop_loop", 0.078 + math.random() * 0.078)	--手伸最长时
						
						----持续前进
						local pos = inst:GetPosition()
						inst.Transform:SetPosition( (pos + vec * period * velocity):Get() )
						
						----持续旋转
						local rot = inst.Transform:GetRotation()
						rot = rot + period * w
						while rot > 360 do
							rot = rot - 360
						end
						inst.Transform:SetRotation( rot )
						
						----判定伤害, 转一圈就是一次伤害
						local ticknum = math.ceil( 360/ w / period )
						if ticknum > 0 and inst._spintick % ticknum == 0 then
							
							----范围攻击
							local pt = inst:GetPosition()
							local r = 3
							local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "groundpoundimmune","toso_arm","shadowboss"})
							for k,v in pairs(ents) do
								if v and v.components.health and not v.components.health:IsDead() and v.components.combat then	
									v.components.combat:GetAttacked(inst, TUNING.ARM_RPGDAMAGE)
								end
							end
							
							----释放半月
							local moon = SpawnPrefab("sha_fengzhinu")
							if moon then
								moon.Transform:SetPosition(pt.x, pt.y, pt.z)
								moon.Transform:SetRotation( math.random() * 360 )
								moon.Physics:SetMotorVelOverride(13, 0, 0)
							end
							
						end
						inst._spintick = inst._spintick + 1
						
						
					end)
					
				end
				
			end),
		},
		
		--events=
		--{
		--	EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		--},
		
		onexit = function(inst)
		
			if inst._spintask then
				inst._spintask:Cancel()
				inst._spintask = nil
			end
		
			--
			--inst["zg_inh_anti_physics"] = inst.mem_anti_physics or .5
			--技能结束
			inst.canfengzhinu = false
			if not inst.components.timer:TimerExists("fengzhinu") then
				inst.components.timer:StartTimer("fengzhinu", 16)
			end
		end
		
	},

	----烦恼风
	State{
        name = "fengzhiren",
        tags = {"busy", "pound"},
		
		onenter = function(inst)
            inst.components.locomotor:StopMoving()
			inst.Physics:Stop()
			
			inst.AnimState:PlayAnimation("powerup")
			inst.AnimState:PushAnimation("atk", false)
        end,
		
		timeline = 
		{
			--跳起结束
			TimeEvent(36*FRAMES, function(inst)
				--inst.SoundEmitter:PlaySound("zg_ch1_zoro/zg_ch1_zoro/fannao")
				if inst.components.talker then
					inst.components.talker:Say("【好好活着是你接下来最重要的事】")
				end
			end),
			
			--发动烦恼风
			TimeEvent(45*FRAMES, function(inst)
			
				----位置
				local x, y, z = inst:GetPosition():Get()
				
				----面向目标
				if inst.components.combat and inst.components.combat.target then
					inst.Transform:SetRotation( inst:GetAngleToPoint( inst.components.combat.target:GetPosition():Get() ) )
				end
				
				local angle_offset = 
				{
					-7.5,
					0,
					7.5
				}	
				----定义烦恼风
				for k, v in pairs(angle_offset) do
				
					for i = 1, 3 do
						inst:DoTaskInTime( i * .1, function()
							local fx = SpawnPrefab("sha_fengzhiren")
							if fx then
								fx.Transform:SetPosition(x, y, z)
								----烦恼风推进
								fx.Transform:SetRotation( inst.Transform:GetRotation() + v )
								fx.Physics:SetMotorVelOverride( 6, 0, 0)
							end
						end)
						
					end
				end
				
			end),
		},
		
		events=
		{
			EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
		},
		
		onexit = function(inst)
		
			--技能结束
			inst.canfengzhiren = false
			if not inst.components.timer:TimerExists("fengzhiren") then
				inst.components.timer:StartTimer("fengzhiren", 21)
			end
		end
		
	},

--回复
   State{
        name = "shaquickeat",
        tags ={"busy", "pound"},
        onenter = function(inst)
            inst.components.locomotor:Stop()
			inst.components.talker:Say("玲的食物随身带")
            local theplayer = GetPlayer()
			local xxx = theplayer.level*20 + 350
            inst.components.health:DoDelta(xxx)
                inst.SoundEmitter:PlaySound("dontstarve/wilson/eat", "eating")    

            inst.AnimState:PlayAnimation("quick_eat")
        end,

        timeline=
        {
            TimeEvent(12*FRAMES, function(inst) 
                inst:PerformBufferedAction() 
                inst.sg:RemoveStateTag("busy")
            end),
        },        
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
        
        onexit= function(inst)
            inst.SoundEmitter:KillSound("eating")    
			--技能结束
			inst.canshaquickeat = false
			if not inst.components.timer:TimerExists("shaquickeat") then
				inst.components.timer:StartTimer("shaquickeat", 11)
			end
        end,
    },  


    State{
        name = "idle",
        tags = {"idle", "canrotate"},
        onenter = function(inst, pushanim)    
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("idle_loop", true)
        end,
    },

 State{
        name = "talk",
        tags = {"idle", "talking"},
        
        onenter = function(inst, noanim)
            inst.components.locomotor:Stop()
            if not noanim then
                inst.AnimState:PlayAnimation("dial_loop", true)
            end
            inst.SoundEmitter:PlaySound("dontstarve/woodie/talk")
			if inst.talksoundoverride then
                inst.SoundEmitter:PlaySound(inst.talksoundoverride, "talk")
            else
				
                inst.SoundEmitter:PlaySound("dontstarve/characters/woodie/talk_LP", "talk")
				
				--inst.SoundEmitter:PlaySound("dontstarve/characters/webber/talk_LP", "talk")
            end 
			--end
            
   
            inst.sg:SetTimeout(1.5 + math.random()*.5)
        end,
        
        ontimeout = function(inst)
            inst.SoundEmitter:KillSound("talk")
            inst.sg:GoToState("idle")
        end,
        
        onexit = function(inst)
            inst.SoundEmitter:KillSound("talk")
        end,
        
        events=
        {
            EventHandler("donetalking", function(inst) inst.sg:GoToState("idle") end),
        },
    }, 
	
    State{
        name = "run_start",
        tags = {"moving", "running", "canrotate"},
        
        onenter = function(inst)
			inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_pre")
            inst.sg.mem.foosteps = 0
        end,

        onupdate = function(inst)
            inst.components.locomotor:RunForward()
        end,

        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
        
        timeline=
        {        
            TimeEvent(4*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_step")
            end),
        },        
        
    },

	  
    State{
    
        name = "run_stop",
        tags = {"canrotate", "idle"},
        
        onenter = function(inst) 
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("run_pst")
        end,
        
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),        
        },
        
    },

	 State{
        name = "run",
        tags = {"moving", "running", "canrotate"},
        
        onenter = function(inst) 
            inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_loop")
            
        end,
        
        onupdate = function(inst)
            inst.components.locomotor:RunForward()
        end,

        timeline=
        {
            TimeEvent(7*FRAMES, function(inst)
				inst.sg.mem.foosteps = inst.sg.mem.foosteps + 1
                inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_step")
            end),
            TimeEvent(15*FRAMES, function(inst)
				inst.sg.mem.foosteps = inst.sg.mem.foosteps + 1
                inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_step")
            end),
        },
        
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
    },
    

    State{
        name = "attack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst)
          --  inst.equipfn(inst, inst.items["SWORD"])        

            inst.sg.statemem.target = inst.components.combat.target
            inst.components.combat:StartAttack()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("atk")
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_nightsword")
            
            if inst.components.combat.target then
                if inst.components.combat.target and inst.components.combat.target:IsValid() then
                    inst:FacePoint(Point(inst.components.combat.target.Transform:GetWorldPosition()))
                end
            end
            
        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) inst.sg:RemoveStateTag("abouttoattack") end),
            TimeEvent(12*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("busy")
            end),               
            TimeEvent(13*FRAMES, function(inst)
                if not inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),
            TimeEvent(24*FRAMES, function(inst)
                if inst.sg.statemem.slow then
                    inst.sg:RemoveStateTag("attack")
                end
            end),           
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    },  

    State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:Hide("swap_arm_carry")
            inst.AnimState:PlayAnimation("death")
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst:DoTaskInTime(1, function() 
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
                    inst.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_despawn")
                    inst:Remove()
                end)
            end ),
        },
    },  
   
    State{
        name = "hit",
        tags = {"busy"},
        
        onenter = function(inst)
            inst:ClearBufferedAction()
            inst.AnimState:PlayAnimation("hit")
            inst.Physics:Stop()            
		 --inst.SoundEmitter:PlaySound("dontstarve/characters/woodie","/hit")   
		 --inst.SoundEmitter:PlaySound("dontstarve/characters/woodie","/hurt")   
		end,
   
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        }, 
        
        timeline =
        {
            TimeEvent(3*FRAMES, function(inst)
                inst.sg:RemoveStateTag("busy")
            end),
        },               
    },

    State{
        name = "stunned",
        tags = {"busy", "canrotate"},

        onenter = function(inst)
            inst:ClearBufferedAction()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("idle_sanity_pre")
            inst.AnimState:PushAnimation("idle_sanity_loop", true)
            inst.sg:SetTimeout(5)
        end,

        ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end,
    },

        State{ name = "chop_start",
        tags = {"prechop", "chopping", "working"},
        onenter = function(inst)
            inst.equipfn(inst, inst.items["AXE"])
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("chop_pre")

        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("chop") end),
        },
    },
    
    State{
        name = "chop",
        tags = {"prechop", "chopping", "working"},
        onenter = function(inst)
            inst.AnimState:PlayAnimation("chop_loop")        
        end,

        timeline=
        {
            TimeEvent(5*FRAMES, function(inst) 
                    inst:PerformBufferedAction() 
            end),

            TimeEvent(9*FRAMES, function(inst)
                    inst.sg:RemoveStateTag("prechop")
            end),

            TimeEvent(16*FRAMES, function(inst) 
                inst.sg:RemoveStateTag("chopping")
            end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) 
                inst.sg:GoToState("idle")
            end ),            
        },        
    },

    State{ 
        name = "mine_start",
        tags = {"premine", "working"},
        onenter = function(inst)
            inst.equipfn(inst, inst.items["PICK"])
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("pickaxe_pre")
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("mine") end),
        },
    },
    
    State{
        name = "mine",
        tags = {"premine", "mining", "working"},
        onenter = function(inst)
            inst.AnimState:PlayAnimation("pickaxe_loop")
        end,

        timeline=
        {
            TimeEvent(9*FRAMES, function(inst) 
                inst:PerformBufferedAction() 
                inst.sg:RemoveStateTag("premine") 
                inst.SoundEmitter:PlaySound("dontstarve/wilson/use_pick_rock")
            end),
            
            -- TimeEvent(14*FRAMES, function(inst)
            --     if  inst.sg.statemem.action and 
            --         inst.sg.statemem.action.target and 
            --         inst.sg.statemem.action.target:IsActionValid(inst.sg.statemem.action.action) and 
            --         inst.sg.statemem.action.target.components.workable then
            --             inst:ClearBufferedAction()
            --             inst:PushBufferedAction(inst.sg.statemem.action)
            --     end
            -- end),            
        },
        
        events=
        {
            EventHandler("animover", function(inst) 
                inst.AnimState:PlayAnimation("pickaxe_pst") 
                inst.sg:GoToState("idle", true)
            end ),            
        },        
    },
--增加的state	
    State{
        name = "leap_attack",
        tags = {"attack", "canrotate", "busy", "jumping", "pound"},
        
        onenter = function(inst, target)
		    inst.components.talker:Say("阁下的命我拿走了")
			
            inst.components.locomotor:Stop()
            inst.components.locomotor:EnableGroundSpeedMultiplier(false)

            inst.components.combat:StartAttack()
            inst.AnimState:PlayAnimation("pickaxe_loop")
            inst.sg.statemem.target = target
        end,

        onexit = function(inst)
            inst.components.locomotor:Stop()
            inst.components.locomotor:EnableGroundSpeedMultiplier(true)
			
								--技能结束
			inst.canpound = false
			if not inst.components.timer:TimerExists("pound") then
				inst.components.timer:StartTimer("pound", 8)
			end
        end,
        
        timeline =
        {
            --TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound(SoundPath(inst, "attack_grunt")) end),
            --TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound(SoundPath(inst, "Jump")) end),
            TimeEvent(8*FRAMES, function(inst) inst.Physics:SetMotorVelOverride(20,0,0) end),
            --TimeEvent(9*FRAMES, function(inst) inst.SoundEmitter:PlaySound(SoundPath(inst, "Attack")) end),
            TimeEvent(19*FRAMES, function(inst) 
			inst.components.combat:DoAttack(inst.sg.statemem.target) 
			inst.components.arm_groundpounder:GroundPound()
            inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/bearger/groundpound",nil,.5)
			SpawnWaves(inst, 12, 360, 4)
			end),
            TimeEvent(20*FRAMES,
				function(inst)
                    inst.Physics:ClearMotorVelOverride()
					inst.components.locomotor:Stop()
				end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
	
}

return StateGraph("SGarm_bro", states, events, "idle", actionhandlers)