require("stategraphs/commonstates")

local events=
{
    EventHandler("attacked", function(inst) 
		--if math.random() < .5 then
			--inst.SoundEmitter:PlaySound("dontstarve/zg/cr_tentacle/hit")
		--end
	end),
    EventHandler("death", function(inst) inst.sg:GoToState("death") end),
    
	CommonHandlers.OnLocomote(false,true),
	
	EventHandler("doattack", function(inst, data) 
        if not inst.components.health:IsDead() then 
			inst.sg:GoToState("attack", data.target)
        end 
    end),
}

local states=
{
	State{
        name = "walk_start",
        tags = {"moving","canrotate"},

        onenter = function(inst) 
			inst.AnimState:PlayAnimation("breach_pre")
        end,

        events =
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("walk") end ),        
        },
    },
        
    State{            
        name = "walk",
        tags = {"moving", "canrotate"},
        
        onenter = function(inst) 
            inst.components.locomotor:WalkForward()
			inst.AnimState:PlayAnimation("breach_pre")
			

			
        end,
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("walk") end ),        
        },
        
    },      
    
    State{            
        name = "walk_stop",
		tags = {"canrotate"},
        
        onenter = function(inst) 
            inst.components.locomotor:StopMoving()
			inst.AnimState:PlayAnimation("breach_pre")
        end,

        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),        
        },
    },

	State{
        name = "idle",
        tags = {"idle", "canrotate"},

        onenter = function(inst)
            inst.components.locomotor:StopMoving()
			inst.AnimState:PlayAnimation("breach_pre")
        end,

        events = 
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
    State{ 
        name = "attack",
        tags = {"attack","busy"},
        onenter = function(inst)
			--if math.random() < .2 then
			--	inst.SoundEmitter:PlaySound("dontstarve/zg/cr_tentacle/call")
			--end
			inst.components.locomotor:Stop()
			inst.components.combat:StartAttack()
            inst.AnimState:PlayAnimation("atk_loop")
            inst.AnimState:PushAnimation("atk_idle", false)
			--inst.sg:SetTimeout(20*FRAMES)
        end,
        
        timeline=
        {
            TimeEvent(2*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") end),
			
			TimeEvent(7*FRAMES, function(inst)
				inst.components.combat:DoAttack() 
			end),
            TimeEvent(15*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") end),
			
            TimeEvent(17*FRAMES, function(inst)
				inst.components.combat:DoAttack() 
			end),
            TimeEvent(18*FRAMES, function(inst) inst.sg:RemoveStateTag("attack") inst.sg:RemoveStateTag("busy") end),
        },
		
		--ontimeout = function(inst)
        --    inst.sg:GoToState("idle")
        --end,
		
		events =
        {
            EventHandler("animqueueover", function(inst) 
				--inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_splat")
				inst.sg:GoToState("idle")
			end),
        },  
        
		--[[
		onupdate = function(inst)         
			inst.components.locomotor:WalkForward()		--直接冲过去抽玩家
        end,]]
		
    },
 
------------------------------------------------------------------------------------------------------- 
    
	State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.SoundEmitter:PlaySound("dontstarve/zg/cr_tentacle/die")
			
            inst.AnimState:PlayAnimation("death")
            RemovePhysicsColliders(inst)            
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition()))            
        end,
        
        
        events =
        {
            EventHandler("animover", function(inst) 
				inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_splat")
			end ),
        },        
    },
 
}

    
return StateGraph("tentacle", states, events, "idle")

