--参考猪哥联机版智能敌对，欢迎百度下载


--反复用到的函数


--生成物品
function wy_spawn(inst, other, offset, mode, scale, phys, sound, fn_tar, fn_inst)

	if not inst then return end
	--local mode = mode or 0
	local tar
	
	if type(other) == "string" then
		tar = SpawnPrefab(other)
	elseif type(other) == "table" then
	
		--获取权重
		local weight = 0
		for k,v in pairs(other) do
			weight = weight + v
		end
		
		--选取物体
		local t = 0
		local ran = math.random()
		for k,v in pairs(other) do
			t = t + v
			if ran <= t/weight then
				tar = SpawnPrefab(k)
				break
			end
		end
	else
		return
	end
	
	if not tar then return end
		
	--物体的父子位置关系
	if mode == 1 then
		
		tar.entity:SetParent(inst.entity)
		if type(offset) == "table" then
			tar.Transform:SetPosition(offset[1],offset[2],offset[3])
		else
			tar.Transform:SetPosition(0,0,0)
		end
	
	--Follow Symbol的关系
	elseif type(mode) == "string" then
		
		tar.entity:SetParent(inst.entity)
		tar.entity:AddFollower()
		if type(offset) == "table" then
			tar.Follower:FollowSymbol(inst.GUID, mode, offset[1],offset[2],offset[3])
		else
			tar.Follower:FollowSymbol(inst.GUID, mode, 0,0,0)
		end
	
	--普通生成模式
	else
		local x,y,z = inst.Transform:GetWorldPosition()
		local x1,y1,z1 = x,y,z
		if type(offset) == "table" then
			x1,y1,z1 = x+offset[1], y+offset[2], z+offset[3]
		end
		tar.Transform:SetPosition(x1,y1,z1)
	end
	
	--新事物的体积,多用于调试特效
	if scale then
		tar.Transform:SetScale(scale,scale,scale)
	end
	
	--新事物飞出的速度,多用于弹道类物体,也可用于掉落物
	if type(phys) == "table" and tar.Physics then

		--获取方向, 以自己为起点的方向
		if phys[1] then
			local angle = tar:GetAngleToPoint( phys[1]:Get() )	
			
			--偏离角度
			local angel_d = phys[2] or 0
			angle = angle + angel_d
			
			--获得最终面向角度
			while (angle < 0) do
				angle = angle + 360
			end
			while (angle >= 360) do
				angle = angle - 360
			end
			
			--设置最终面向
			tar.Transform:SetRotation(angle)
		end
		
		--获取速度, 如果速度小于0则倒退方向运行
		local vel = phys[3]
		if vel then
			tar.Physics:SetMotorVelOverride(vel[1],vel[2],vel[3])
		end
		
	end
	
	--新事物的音效,用于生成时的声音效果
	if type(sound) == "table" then
		if not tar.SoundEmitter then
			tar.entity:AddSoundEmitter()
		end
		tar:DoTaskInTime(sound[2] or 0, function()
			tar.SoundEmitter:PlaySound(sound[1])
		end)
	elseif type(sound) == "string" then
		if not tar.SoundEmitter then
			tar.entity:AddSoundEmitter()
			tar.SoundEmitter:PlaySound(sound)
		end
	end
	
	-------------------------------------------一般情况是用不着的----------------
	--新事物的其他初始化
	if type(fn_tar) == "function" then
		fn_tar(tar)
	end
	
	--旧事物的操作
	if type(fn_inst) == "function" then
		fn_inst(inst)
	end

	return tar
end





